#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
const int MAXN = 5 * (1 << 20);
const int64_t Maxv = (int64_t)1e12 + 17;

string s;
random_device rd;
mt19937_64 mt(rd());

void read()
{
    cin >> s;
}

int64_t psum[MAXN];

bool check(int x)
{
    int64_t beg = psum[x - 1];
    for(int i = x; i < (int)s.size(); i += x)
        if(psum[i + x - 1] - psum[i - 1] != beg)
            return false;

    return true;
}

int64_t c[256];

void solve()
{
    for(int i = 'a'; i <= 'z'; i++)
        c[i] = mt() % Maxv;

    for(int i = 0; i < (int)s.size(); i++)
        psum[i] = (i ? psum[i - 1] : 0) + c[s[i]];

    for(int d = 1; d <= (int)s.size(); d++)
        if(s.size() % d == 0)
        {
            if(!check(d)) continue;
            cout << s.size() / d << endl;
            return;
        }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
