# include <cstdio>
# include <ctime>
# include <algorithm>

using namespace std;

long long cross (pair <long long, long long> a, pair <long long, long long> b)
{
	return a.first * b.second - a.second * b.first;
}

int main ()
{
	int i, n;
	pair <int, int> a, b, c;
	scanf ("%d", &n);
	scanf ("%d%d", &a.first, &a.second);
	scanf ("%d%d", &b.first, &b.second);
	
	while ((double)clock () < 4.5 * CLOCKS_PER_SEC)
	{
		c.first = rand ();
		c.second = rand ();
		if (cross ({a.first - c.first, a.second - c.second}, {b.first - c.first, b.second - c.second}) == 0)
		{
			printf ("Yes\n%d %d\n", c.first, c.second);
			return 0;
		}
	}
	
	printf ("No\n");
	return 0;
}