#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 5e6 + 5;

int prefSums[MAX_N][26], totalCnt[26];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	string s;
	cin >> s;
	
	int n = s.size();
	for(int i = 0; i < n; i++) {
		if(i != 0) {
			for(int j = 0; j < 26; j++) {
				prefSums[i][j] = prefSums[i - 1][j];
			}
		}

		totalCnt[s[i] - 'a']++;
		prefSums[i][s[i] - 'a']++;
	}

	int sq = sqrt(n);
	vector< int > divs;
	for(int i = 1; i <= sq; i++) {
		if(n % i == 0) {
			divs.push_back(i);
			if(i * i != n) {
				divs.push_back(n / i);
			}
		}
	}

	sort(divs.begin(), divs.end());
	
	for(int i = divs.size() - 1; i >= 0; i--) {
		int aux = divs[i];
		int partSize = n / aux;

		bool isPossible = true;
		for(int i = partSize - 1; i < n; i += partSize) {
			bool isOk = true;
			for(int j = 0; j < 26; j++) {
				if(totalCnt[j] % aux != 0) {
					isOk = false;
					break;
				}

				int currCnt = prefSums[i][j] - (i == aux - 1 ? 0 : prefSums[i - partSize][j]);

				if(currCnt != totalCnt[j] / aux) {
					isOk = false;
					break;
				}
			}

			if(!isOk) {
				isPossible = false;
				break;
			}
		}

		if(isPossible) {
			cout << aux << endl;
			return 0;
		}
	}

	return 0;
}
