#include<iostream>
#include<map>

using namespace std;

const int MAXN = 405;

struct point
{
    double x, y;
};

int n;
point p[MAXN];

point moon;
map < pair <double, double> , int > lineCount;
map < pair <double, double> , int >:: iterator it;

int oops = 0;

double a, a1, b, b1;

bool check(double x)
{
    if( double( x - int(x) ) > 0 ) return false;
    return true;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    bool fail = false;

    cin >> n;
    n *= 2;

    for(int i = 0;i<n;i++)
    {
        cin >> p[i].x >> p[i].y;
    }

    for(int i = 0;i<n;i++)
    {
        for(int i1 = i + 1;i1<n;i1++)
        {
            for(int i2 = 0;i2<n;i2++)
            {

                if(i2==i || i2==i1) continue;
                for(int i3 = i2+1;i3<n;i3++)
                {
                    if(i3==i || i3==i1 || i3==i2) continue;
                    if((p[i1].x - p[i].x)==0 && p[i3].x - p[i2].x!=0)
                    {
                        a1 = (p[i3].y - p[i2].y)/(p[i3].x - p[i2].x);
                        b1 = p[i2].y - p[i2].x*a1;

                        moon.x = a1*p[i].x;
                        moon.y = b1;
                    }
                    else if(p[i3].x - p[i2].x==0 && (p[i1].x - p[i].x)!=0)
                    {
                        a = (p[i1].y - p[i].y)/(p[i1].x - p[i].x);
                        b = p[i].y - p[i].x*a;

                        moon.x = a*p[i2].x;
                        moon.y = b;
                    }
                    else if(p[i3].x - p[i2].x!=0 && (p[i1].x - p[i].x)!=0)
                    {
                        a = (p[i1].y - p[i].y)/(p[i1].x - p[i].x);
                        b = p[i].y - p[i].x*a;

                        a1 = (p[i3].y - p[i2].y)/(p[i3].x - p[i2].x);
                        b1 = p[i2].y - p[i2].x*a1;

                        if(a-a1==0) continue;

                        moon.x = (b1 - b)/(a - a1);
                        moon.y = a*moon.x + b;
                    }
                    else continue;

                    if(check(moon.x)==true && check(moon.y)==true)
                    {
                        //cout << "OK " << i << " " << i1 << " " << i2 << " " << i3 << '\n';

                        oops = 0;
                        fail = false;

                        lineCount.clear();
                        for(int j = 0;j<n;j++)
                        {
                            if(moon.x==p[j].x && moon.y==p[j].y)
                            {
                                fail = true;
                                break;
                            }
                            if(j==i || j==i1 || j==i2 || j==i3) continue;
                            //cout << j << '\n';

                            if(p[j].x - moon.x==0)
                            {
                                oops++;
                                continue;
                            }

                            a = (p[j].y - moon.y)/(p[j].x - moon.x);
                            b = moon.y - moon.x*a;

                            lineCount[make_pair(a, b)]++;
                        }

                        //cout << "OK" << '\n';


                        for(it = lineCount.begin();it!=lineCount.end();it++)
                        {
                            if((*it).second%2!=0)
                            {
                                fail = true;
                                break;
                            }
                        }

                        if(fail==false && oops%2==0)
                        {
                            cout << "Yes" << '\n';
                            cout << moon.x << " " << moon.y << '\n';

                            return 0;
                        }
                    }
                }
            }
        }
    }

    cout << "No" << '\n';
}
/*
2
1 1
1 3
3 1
3 3
*/
