#include <iostream>
#include <string>

using namespace std;

const int MAX_N = 5e6 + 1;
const int SGM = 26;
long long f[MAX_N];
long long p;

long long primes[] = { 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139 };

long long hsh( char c ) {
    return primes[c - 'a'] << ( ( c - 'a' ) * 2 );
}

int main() {
    freopen( "input.txt", "r", stdin );
    string s;
    cin >> s;
    int i = 0, n = s.size();
    for ( int i = 0; i < n; i ++ ) {
        f[i + 1] = f[i] + hsh( s[i] );
    }

    int d;
    for ( d = 1; d < n; d ++ ) {
        if ( n % d != 0 )
            continue;

        int i = 0;

        p = f[d];

        i = d * 2;
        while ( i <= n && f[i] - f[i - d] == p ) {
            i += d;
        }

        if ( i > n )
            break;
    }
    cout << n / d;
    return 0;
}
