#include <cstdio>

FILE *fin = fopen("input.txt", "r"), *fout = fopen("output.txt", "w");

#define MAXN 5000009

int n, val[MAXN], fr[26];
char s[MAXN + 10];

inline bool ok(int a) {
    for (int i = a; i <= n; i += a)
        if (a % val[i])
            return 0;
    return 1;
}

inline void gcd(int &a, int b) {
    int r;
    while (b) {
        r = a % b;
        a = b;
        b = r;
    }
}

int main() {
    fgets(s, MAXN, fin);
    int sigma = -1, lim = 0;
    while ('a' <= s[n] && s[n] <= 'z') {
        fr[s[n] - 'a']++;
        if (fr[s[n] - 'a'] == 1)
            lim = n + 1;
        if (s[n] - 'a' > sigma)
            sigma = s[n] - 'a';
        int d = fr[0];
        for (int i = 1; d != 1 && i <= sigma; i++)
            gcd(d, fr[i]);
        n++;
        val[n] = n / d;
    }

    int a = val[n];
    while (a <= n && (a % val[n] || a < lim || !ok(a)))
        a += val[n];

    fprintf(fout, "%d", n / a);
    fclose(fin);
    fclose(fout);
    return 0;
}
