#include <cstdio>
#include <algorithm>

FILE *fin = fopen("input.txt", "r"), *fout = fopen("output.txt", "w");

#define INF 1000000000

#define MAXN 200009

int t[MAXN], c[MAXN], cnt[MAXN], urm[MAXN];
struct myc {
    int x, y;
} best[MAXN], adev[MAXN];
long long suma[MAXN];

int main() {
    int n;
    fscanf(fin, "%d", &n);

    best[1].x = urm[1] = INF;
    for (int i = 2; i <= n; i++) {
        fscanf(fin, "%d", &t[i]);
        best[i].x = urm[i] = INF;
    }

    for (int i = 2; i <= n; i++)
        fscanf(fin, "%d", &c[i]);

    long long ans = 0;
    for (int i = n; i > 0; i--) {
        if (cnt[i]) {
            if (adev[i].x == cnt[i])
                return 1;
            ans += suma[i];
            if (2 * adev[i].x > cnt[i]) {
                if (best[i].y == adev[i].y)
                    ans += 1LL * (2 * adev[i].x - cnt[i]) * urm[i];
                else
                    ans += 1LL * (2 * adev[i].x - cnt[i]) * best[i].x;
            } else if (cnt[i] % 2 == 1)
                ans += best[i].x;
        }

        cnt[i]++;
        best[i].x = std::min(best[i].x, c[i]);
        suma[i] += c[i];

        suma[t[i]] += suma[i];
        cnt[t[i]] += cnt[i];
        if (cnt[i] > adev[t[i]].x)
            adev[t[i]].x = cnt[i], adev[t[i]].y = i;
        if (best[i].x < best[t[i]].x)
            best[t[i]].x = best[i].x, best[t[i]].y = i;
        else if (best[i].x < urm[t[i]])
            urm[t[i]] = best[i].x;
    }

    fprintf(fout, "%lld\n", ans);

    fclose(fin);
    fclose(fout);
    return 0;
}
