#include <bits/stdc++.h>
using namespace std;

const int N = int(5e6) + 5;

char s[N];
int n, cnt[26];
vector<int> arr, t;

void update(int v, int tl, int tr, int pos, int val)
{
    if(tl == tr)
    {
        t[v] = val;
    } else
    {
        int tm = (tl + tr) / 2;
        if(pos <= tm)
        {
            update(2 * v + 1, tl, tm, pos, val);
        } else
        {
            update(2 * v + 2, tm + 1, tr, pos, val);
        }

        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }
}

int get(int v, int tl, int tr, int l, int r)
{
    if(l > r)
    {
        return 0;
    } else if(tl == l && tr == r)
    {
        return t[v];
    } else
    {
        int tm = (tl + tr) / 2;

        return get(2 * v + 1, tl, tm, l, min(tm, r)) + get(2 * v + 2, tm + 1, tr, max(tm + 1, l), r);
    }
}

void check(int num, int k)
{
    int m = arr[num];
    for(int i = 0; i < n; i += m)
    {
        int l = i,
            r = i + m - 1;
        int u = get(0, 0, n - 1, l, r);
        if(u * (n / m) != cnt[k])
        {
            arr[num] = -1;
            return;
        }
    }
}

int main()
{
    memset(cnt, 0, sizeof(cnt));
    scanf("%s", s);
    for(int i = 0; s[i]; ++i)
    {
        cnt[s[i] - 'a']++;
    }
    n = int(strlen(s));
    for(int i = 1; i <= n; ++i)
    {
        if(n % i == 0)
        {
            arr.push_back(i);
        }
    }
    for(int k = 0; k < 26; ++k)
    {
        t.assign(4 * n, 0);
        for(int j = 0; j < n; ++j)
        {
            if(s[j] - 'a' == k)
            {
                update(0, 0, n - 1, j, 1);
            }
        }
        for(int j = 0; j < arr.size(); ++j)
        {
            if(arr[j] != -1)
            {
                check(j, k);
            }
        }
    }
    for(int i = 0; i < arr.size(); ++i)
    {
        if(arr[i] != -1)
        {
            printf("%d", n / arr[i]);
            break;
        }
    }

    return 0;
}
