#include<bits/stdc++.h>

using namespace std;
#define x first
#define y second
#define int long long
const int MAXN = 40000, MAXX = 1e6;
pair<int, int> dot[MAXN];
int q[MAXN];
int n;
pair<int, int> star = {-1, -1};
pair<int, int> operator - (pair<int, int> a, pair<int, int> b)
{
    return {a.x - b.x, a.y - b.y};
}
pair<int, int> operator + (pair<int, int> a, pair<int, int> b)
{
    return {a.x + b.x, a.y + b.y};
}
int operator * (pair<int, int> a, pair<int, int> b)
{
    return a.x * b.y - a.y * b.x;
}
struct line
{
    long double a, b, c;
};
pair<int, int> inter(line a, line b)
{
    long double y, x;
    if (a.a != 0)
    {
        y = (b.c - b.a * a.c / a.a) / (b.a * a.b / a.a - b.b);
    }
    else
    {
        y = -a.c / a.b;
    }
    if (a.a != 0)
    {
        x = -(a.c + a.b * y) / a.a;
    }
    else
    {
        x = -(b.c + b.b * y) / b.a;
    }
    return {(int)round(x), (int)round(y)};
}
line get(pair<int, int> a, pair<int, int> b)
{
    line res = {0, 0, 0};
    if (a.y == b.y)
    {
        res.b = 1;
        res.c = -a.y;
    }
    else
    {
        res.a = 1;
        res.b = (a.x - b.x) / (b.y - a.y);
        res.c = -(res.a * a.x + res.b * a.y);
    }
    return res;
}
bool check()
{
    for (int i = 0; i < n; ++i) q[i] = 0;
    if (abs(star.x) > MAXX || abs(star.y) > MAXX) return false;
    for (int i = 0; i < n; ++i)
    {
        if (dot[i] == star) return false;
        for (int j = i + 1; j < n; ++j)
        {
            if ((dot[i] - star) * (dot[j] - star) == 0)
            {
                q[i]++;
                q[j]++;
            }
        }
    }
    for (int i = 0; i < n; ++i)
    {
        if (q[i] != 1) return false;
    }
    return true;
}
signed main()
{
    std::chrono::time_point<std::chrono::system_clock> start, en;
    start = std::chrono::system_clock::now();
    cin >> n;
    for (int i = 0; i < 2 * n; ++i)
    {
        cin >> dot[i].x >> dot[i].y;
    }
    n = 2 * n;
    if (n == 2)
    {
        cout << "Yes\n";
        cout << (dot[1] + dot[1] - dot[0]).x << " " << (dot[1] + dot[1] - dot[0]).y;
        return 0;
    }
    if ((dot[1] - dot[0]) * (dot[2] - dot[3]) != 0)
    {
        line A = get(dot[0], dot[1]);
        line B = get(dot[2], dot[3]);
        star = inter(A, B);
        if (star * (dot[1] - dot[0]) != 0 || star * (dot[3] - dot[2]) != 0) while (true);
        if (check())
        {
            cout << "Yes\n";
            cout << star.x << " " << star.y << endl;
            return 0;
        }
    }
    if ((dot[0] - dot[2]) * (dot[1] - dot[3]) != 0)
    {
        line A = get(dot[0], dot[2]);
        line B = get(dot[1], dot[3]);
        star = inter(A, B);
        if (star * (dot[2] - dot[0]) != 0 || star * (dot[3] - dot[1]) != 0) while (true);
        if (check())
        {
            cout << "Yes\n";
            cout << star.x << " " << star.y << endl;
            return 0;
        }
    }
    if ((dot[3] - dot[0]) * (dot[2] - dot[1]) != 0)
    {
        line A = get(dot[0], dot[3]);
        line B = get(dot[2], dot[1]);
        star = inter(A, B);

        if (star * (dot[3] - dot[0]) != 0 || star * (dot[2] - dot[1]) != 0) while (true);
        if (check())
        {
            cout << "Yes\n";
            cout << star.x << " " << star.y << endl;
            return 0;
        }
    }
    while (true)
    {
        en = std::chrono::system_clock::now();
        std::chrono::duration<double> elapsed_seconds = en-start;
        //cout << elapsed_seconds.count() << endl;
        if (elapsed_seconds.count() > 1) break;
    }
    cout << "No";
}
