#include<bits/stdc++.h>
using namespace std;
typedef long long coord;

int gcd(int a, int b){
    if(b == 0) return a;
    return gcd(b, a % b);
}

struct V{
    coord x, y;
};

coord operator *(V a, V b){
    return a.x * b.x + a.y * b.y;
}

coord operator ^(V a, V b){
    return a.x * b.y - a.y * b.x;
}

struct L{
    coord a, b, c;
    L(V f, V s){
        a = s.y - f.y;
        b = f.x - s.x;
        c = -1 * (1ll*a * f.x + 1ll*b * f.y);
    }
};

V operator ^(L f, L s){
    if(1ll*f.a * s.b == 1ll*s.a * f.b || (1ll*s.c * f.b - 1ll*f.c * s.b) % (1ll*f.a * s.b - 1ll*s.a * f.b) != 0 || (1ll*f.a * s.c - 1ll*f.c * s.a) % (1ll*f.b * s.a - 1ll*s.b * f.a) != 0) return {(int)-1e9, (int)-1e9};
    return{
        (1ll*s.c * f.b - 1ll*f.c * s.b) / (1ll*f.a * s.b - 1ll*s.a * f.b),
        (1ll*f.a * s.c - 1ll*f.c * s.a) / (1ll*f.b * s.a - 1ll*s.b * f.a)
    };
}

signed main(){
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    n *= 2;
    vector<V> q(n);
    for(int i = 0; i < n; i++){
        cin >> q[i].x >> q[i].y;
    }
    random_shuffle(q.begin(), q.end());
    for(int j = 1; j < n; j++){
        L a(q[0], q[j]);
        if(a.b != 0){
            int g = gcd(q[0].x, q[j].x);
            int len = abs(q[j].x - q[0].x) / g;
            for(int x = q[0].x; x >= -1e6; x -= len){
                V cross;
                cross.x = x;
                cross.y = (-a.c - a.a * x) / a.b;
                map<pair<int, int>, int> cnt;
                bool ok = 1;
                for(int m = 0; m < n; m++){
                    V cur = {q[m].x - cross.x, q[m].y - cross.y};
                    if(cur.x < 0) {
                        cur.x *= -1;
                        cur.y *= -1;
                    }
                    if(cur.x == 0 && cur.y == 0) {
                        ok = 0;
                        break;
                    }
                    if(cur.x == 0) cur.y = 1;
                    if(cur.y == 0) cur.x = 1;
                        int g = gcd(cur.x, cur.y);
                    cur.x /= g;
                    cur.y /= g;
                    if(cnt[{cur.x, cur.y}] == 2){
                        ok = 0;
                        break;
                    }
                    cnt[{cur.x, cur.y}]++;
                }
                if(!ok) continue;
                for(auto it : cnt){
                    if(it.second != 2) ok = 0;
                }
                if(ok){
                    cout << "Yes\n";
                    cout << cross.x << ' ' << cross.y;
                    return 0;
                }
            }
            for(int x = q[0].x; x <= 1e6; x += len){
                V cross;
                cross.x = x;
                cross.y = (-a.c - a.a * x) / a.b;
                map<pair<int, int>, int> cnt;
                bool ok = 1;
                for(int m = 0; m < n; m++){
                    V cur = {q[m].x - cross.x, q[m].y - cross.y};
                    if(cur.x < 0) {
                        cur.x *= -1;
                        cur.y *= -1;
                    }
                    if(cur.x == 0 && cur.y == 0) {
                        ok = 0;
                        break;
                    }
                    if(cur.x == 0) cur.y = 1;
                    if(cur.y == 0) cur.x = 1;
                        int g = gcd(cur.x, cur.y);
                    cur.x /= g;
                    cur.y /= g;
                    if(cnt[{cur.x, cur.y}] == 2){
                        ok = 0;
                        break;
                    }
                    cnt[{cur.x, cur.y}]++;
                }
                if(!ok) continue;
                for(auto it : cnt){
                    if(it.second != 2) ok = 0;
                }
                if(ok){
                    cout << "Yes\n";
                    cout << cross.x << ' ' << cross.y;
                    return 0;
                }
            }
        }
        else {
            int g = gcd(q[0].y, q[j].y);
            int len = abs(q[j].y - q[0].y) / g;
            for(int x = q[0].y; x >= -1e6; x -= len){
                V cross;
                cross.y = x;
                cross.x = (-a.c - a.b * x) / a.a;
                map<pair<int, int>, int> cnt;
                bool ok = 1;
                for(int m = 0; m < n; m++){
                    V cur = {q[m].x - cross.x, q[m].y - cross.y};
                    if(cur.x < 0) {
                        cur.x *= -1;
                        cur.y *= -1;
                    }
                    if(cur.x == 0 && cur.y == 0) {
                        ok = 0;
                        break;
                    }
                    if(cur.x == 0) cur.y = 1;
                    if(cur.y == 0) cur.x = 1;
                        int g = gcd(cur.x, cur.y);
                    cur.x /= g;
                    cur.y /= g;
                    if(cnt[{cur.x, cur.y}] == 2){
                        ok = 0;
                        break;
                    }
                    cnt[{cur.x, cur.y}]++;
                }
                if(!ok) continue;
                for(auto it : cnt){
                    if(it.second != 2) ok = 0;
                }
                if(ok){
                    cout << "Yes\n";
                    cout << cross.x << ' ' << cross.y;
                    return 0;
                }
            }
            for(int x = q[0].y; x <= 1e6; x += len){
                V cross;
                cross.y = x;
                cross.x = (-a.c - a.b * x) / a.a;
                map<pair<int, int>, int> cnt;
                bool ok = 1;
                for(int m = 0; m < n; m++){
                    V cur = {q[m].x - cross.x, q[m].y - cross.y};
                    if(cur.x < 0) {
                        cur.x *= -1;
                        cur.y *= -1;
                    }
                    if(cur.x == 0 && cur.y == 0) {
                        ok = 0;
                        break;
                    }
                    if(cur.x == 0) cur.y = 1;
                    if(cur.y == 0) cur.x = 1;
                        int g = gcd(cur.x, cur.y);
                    cur.x /= g;
                    cur.y /= g;
                    if(cnt[{cur.x, cur.y}] == 2){
                        ok = 0;
                        break;
                    }
                    cnt[{cur.x, cur.y}]++;
                }
                if(!ok) continue;
                for(auto it : cnt){
                    if(it.second != 2) ok = 0;
                }
                if(ok){
                    cout << "Yes\n";
                    cout << cross.x << ' ' << cross.y;
                    return 0;
                }
            }
        }
    }
    cout << "No";
    return 0;
}
