#include <bits/stdc++.h>
using namespace std;

int n;
vector<pair<int, int>> a;
const int INF = 1000000000;
const int MAXX = 1000000;

pair<int, int> inters(pair<int, int> &a, pair<int, int> &b, pair<int, int> &c, pair<int, int> &d) {
    long long a1 = b.second - a.second;
    long long b1 = a.first - b.first;
    long long c1 = -(a.first * a1 + a.second * b1);

    long long a2 = d.second - c.second;
    long long b2 = c.first - d.first;
    long long c2 = -(c.first * a2 + c.second * b2);

    long long dd = a1 * b2 - b1 * a2;
    if (dd == 0) {
        return {INF, INF};
    }
    long long d1 = (-c1) * b2 - b1 * (-c2);
    long long d2 = a1 * (-c2) - (-c1) * a2;

    if (d1 % dd != 0 || d2 % dd != 0 || abs(d1 / dd) > MAXX || abs(d2 / dd) > MAXX) {
        return {INF, INF};
    } else {
        return {d1 / dd, d2 / dd};
    }
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    n *= 2;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }

    auto aa = a;
    sort(aa.begin(), aa.end());

    for (int i = 1; i < n; i++) {
        vector<pair<int, int>> pts;
        for (int j = 1; j < n; j++) {
            if (j == i) continue;
            for (int k = j + 1; k < n; k++) {
                if (k == i) continue;
                auto p = inters(a[0], a[i], a[j], a[k]);
                if (p.first != INF) {
                    pts.push_back(p);
                }
            }
        }
        sort(pts.begin(), pts.end());

        int it = 0;
        int cur = 0;
        for (int j = 0; j < pts.size(); j++) {
            if (j == 0 || pts[j] != pts[j - 1]) {
                cur = 1;
            } else {
                cur++;
            }

            while (it < aa.size() && aa[it] < pts[j]) {
                it++;
            }

            if ((it >= aa.size() || aa[it] != pts[j]) && cur == n / 2 - 1) {
                cout << "Yes" << endl;
                cout << pts[j].first << " " << pts[j].second << endl;
                return 0;
            }
        }
    }

    cout << "No" << endl;

    return 0;
}
