#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <string>
#include <ctime>
#include <cassert>
#include <cstring>

using namespace std;
const int MAXN = 5e5 + 100;
const int MAXN2 = 6e5 + 100;
const int ALPHA = 26;
const int ALPHA2 = 2;

int n;
char str[MAXN];
int pr[ALPHA][MAXN];
int pr2[ALPHA2][MAXN2];

vector<int> dl(int n){
    vector<int> ans;
    for (int i = 1; i * i <= n; ++i){
        if ((n % i) == 0){
            if (i * i == n){
                ans.push_back(i);
            } else {
                ans.push_back(i);
                ans.push_back(n / i);
            }
        }
    }
    sort(ans.begin(), ans.end());
    return ans;
}

bool f(int d){
    for (int b = 0; b < ALPHA; ++b){
        int k = pr[b][d] - pr[b][0];
        for (int i = d; i < n; i += d){
            if (pr[b][i + d] - pr[b][i] != k){
                return false;
            }
        }
    }
    return true;
}

bool g(int d){
    for (int b = 0; b < ALPHA2; ++b){
        int k = pr2[b][d] - pr2[b][0];
        for (int i = d; i < n; i += d){
            if (pr2[b][i + d] - pr2[b][i] != k){
                return false;
            }
        }
    }
    return true;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    scanf("%s", str);
    n = strlen(str);
    vector<int> d = dl(n);

    if (n < MAXN){
        for (int i = 0; i < ALPHA; ++i){
            pr[i][0] = 0;
            for (int j = 1; j <= n; ++j){
                if (str[j - 1] - 'a' == i){
                    pr[i][j] = pr[i][j - 1] + 1;
                } else {
                    pr[i][j] = pr[i][j - 1];
                }
            }
        }

        for (auto e : d){
            if (f(e)){
                printf("%d\n", n / e);
                return 0;
            }
        }
    } else {
        for (int i = 0; i < ALPHA2; ++i){
            pr2[i][0] = 0;
            for (int j = 1; j <= n; ++j){
                if (str[j - 1] - 'a' == i){
                    pr2[i][j] = pr2[i][j - 1] + 1;
                } else {
                    pr2[i][j] = pr2[i][j - 1];
                }
            }
        }

        for (auto e : d){
            if (g(e)){
                printf("%d\n", n / e);
                return 0;
            }
        }
    }

    return 0;
}
