#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <string>
#include <ctime>
#include <cassert>
#include <cstring>

using namespace std;
const int MAXN = 5000000 + 100;
const int ALPHA = 26;
const long long MAXKEK = 1e16;

int n;
char str[MAXN];
long long pr[MAXN];
long long cnt[ALPHA];
long long b[ALPHA];

vector<int> dl(int n){
    vector<int> ans;
    for (int i = 1; i * i <= n; ++i){
        if ((n % i) == 0){
            if (i * i == n){
                ans.push_back(i);
            } else {
                ans.push_back(i);
                ans.push_back(n / i);
            }
        }
    }
    sort(ans.begin(), ans.end());
    return ans;
}

bool f(int d){
    int k = pr[d] - pr[0];
    for (int i = d; i < n; i += d){
        if (pr[i + d] - pr[i] != k){
            return false;
        }
    }
    return true;
}

long long borb(long long a){
    long long b = 1;
    while (a > 0){
        b *= 10;
        a /= 10;
    }
    return b;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    scanf("%s", str);
    n = strlen(str);

    vector<int> d = dl(n);
    vector<bool> fa((int)d.size(), true);

    for (int i = 0; i < n; ++i){
        cnt[str[i] - 'a']++;
    }

    for (int i = 0; i < ALPHA; ++i){
        cnt[i] = borb(cnt[i]);
    }

    int l = 0;
    int r = 0;

    while (l < n){
        long long cur = 1;

        while ((r < ALPHA) && (cur < MAXKEK / cnt[r])){
            b[r] = cur;
            cur *= cnt[r];
            r++;
            //cout << r << ' ' << cur << endl;
        }

        pr[0] = 0;
        for (int j = 1; j <= n; ++j){
            if ((l <= str[j - 1] - 'a') && (str[j - 1] - 'a' < r)){
                pr[j] = pr[j - 1] + b[str[j - 1] - 'a'];
            } else {
                pr[j] = pr[j - 1];
            }
        }

        l = r;

        for (int i = 0; i < (int)d.size(); ++i){
            if (fa[i]){
                fa[i] = f(d[i]);
            }
        }
    }

    for (int i = 0; i < (int)d.size(); ++i){
        if (fa[i]){
            printf("%d", n / d[i]);
            return 0;
        }
    }

    return 0;
}
