#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <string>
#include <ctime>
#include <cassert>

using namespace std;
const int MAXN = 2e5 + 100;
const int INF = 1e9;

int n;
vector<int> g[MAXN];
int mas[MAXN];
long long ans = 0;
pair<int, vector<int>> fa[MAXN];

long long dfs(int v){
    fa[v].first = mas[v];
    fa[v].second.push_back(mas[v]);

    if (g[v].size() == 0){
        return mas[v];
    }

    int sum_sz = 0;
    int max_sz = 0;
    long long min_ch = INF;
    long long cur_s = 0;

    for (auto to : g[v]){
        cur_s += dfs(to);
        sum_sz += fa[to].second.size();
        max_sz = max(max_sz, (int)fa[to].second.size());
        min_ch = min(min_ch, (long long)fa[to].first);
    }

    sum_sz -= max_sz;

    if (max_sz > sum_sz){
        min_ch = INF;
        for (auto to : g[v]){
            if ((int)fa[to].second.size() != max_sz) min_ch = min(min_ch, (long long)fa[to].first);
        }

        ans += cur_s;
        ans += ((long long)(max_sz - sum_sz)) * min_ch;
    } else {
        sum_sz += max_sz;
        ans += cur_s;
        if (sum_sz % 2 == 1){
            ans += min_ch;
        }
    }

    for (auto to : g[v]){
        if (fa[to].second.size() > fa[v].second.size()){
            swap(fa[to].second, fa[v].second);
        }

        fa[v].first = min(fa[v].first, fa[to].first);
        for (auto e : fa[to].second){
            fa[v].second.push_back(e);
        }
    }

    /*cout << v << endl;
    cout << cur_s << endl;
    cout << fa[v].first << endl;
    for (auto e : fa[v].second){
        cout << e << ' ';
    }
    cout << endl << endl;*/
    return cur_s + mas[v];
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;
    for (int i = 1; i < n; ++i){
        int p;
        cin >> p;
        g[p - 1].push_back(i);
    }

    for (int i = 1; i < n; ++i){
        cin >> mas[i];
    }

    dfs(0);

    cout << ans << endl;

    return 0;
}
