#include <iostream>
#include <vector>
#include <unordered_set>
#include <algorithm>

using namespace std;
typedef long long ll;

#define all(v) v.begin(), v.end()
#define size(v) ((int)v.size())

ll n, q, m;

ll query(ll x) {
    if (x & 1)
        return x + 1 >> 1;
    ll cnt = n - x / 2;
    while (cnt % 2 == 0)
        cnt >>= 1;
    return 2 * n - cnt + 1 >> 1;
}

int main() {
    //freopen("inp2.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> q;
    m = n * 2 - 1;
    while (q--) {
        ll x;
        cin >> x;
        cout << query(x) << endl;
    }
    return 0;
}