#include <iostream>
#include <vector>
#include <unordered_set>
#include <algorithm>
#include <string>

using namespace std;
typedef long long ll;

#define all(v) v.begin(), v.end()
#define size(v) ((int)v.size())

vector<vector<int>> p;
int n;
string s;

int cnt = 0;

vector<int> g(int l, int r) {
    if (!l)
        return p[r];
    vector<int> res = p[r];
    for (int i = 0; i < cnt; ++i)
        res[i] -= p[l - 1][i];
    return res;
}

int ind[26];

int main() {
    //freopen("inp2.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> s;
    n = size(s);
    auto w = s;
    sort(all(w));
    w.erase(unique(all(w)), w.end());
    cnt = size(w);
    for (int i = 0; i < cnt; ++i)
        ind[w[i] - 'a'] = i;
    p.resize(n, vector<int>(cnt));
    p[0][ind[s[0] - 'a']] = 1;
    for (int i = 1; i < n; ++i) {
        p[i][ind[s[i] - 'a']] = 1;
        for (int j = 0; j < cnt; ++j)
            p[i][j] += p[i - 1][j];
    }
    for (int len = 1; len <= n; ++len) {
        if (n % len)
            continue;
        bool f = true;
        auto x = g(0, len - 1);
        for (int i = len; f && i < n; i += len)
            f = x == g(i, i + len - 1);
        if (f) {
            cout << n / len;
            return 0;
        }
    }
    return 0;
}