#include <iostream>
#include <vector>
#include <unordered_set>
#include <algorithm>
#include <cassert>
#include <bitset>

using namespace std;
typedef long long ll;

#define all(v) v.begin(), v.end()
#define size(v) ((int)v.size())

const int maxn = 1000;
int tin[maxn], tout[maxn], _t = 0, ver[maxn + 1];
vector<int> g[maxn];
int n, sz[maxn], c[maxn];

ll ans = 0;

void dfs(int v) {
    sz[v] = 1;
    tin[v] = _t++;
    ver[tin[v]] = v;
    for (auto u : g[v]) {
        dfs(u);
        sz[v] += sz[u];
    }
    tout[v] = _t;
}

int main() {
 //   freopen("inp3.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int x; cin >> x;
        g[x - 1].push_back(i + 1);
    }
    for (int i = 1; i < n; ++i)
        cin >> c[i];
    dfs(0);
    for (int i = 0; i < n; ++i) {
        if (g[i].empty())
            continue;
        bitset<maxn> us;
        for (auto u : g[i]) {
            for (int t = tin[u]; t < tout[u]; ++t) {
                if (us[ver[t]])
                    continue;
                us[ver[t]] = 1;
                int mn = -1;
                for (int t1 = tin[i] + 1; t1 < tin[u]; ++t1)
                    if (mn == -1 || (c[mn] > c[ver[t1]]))
                        mn = ver[t1];
                for (int t1 = tout[u]; t1 < tout[i]; ++t1)
                    if (mn == -1 || (c[mn] > c[ver[t1]]))
                        mn = ver[t1];
                us[ver[mn]] = 1;
                ans += c[ver[t]] + c[ver[mn]];
            }
        }
    }
    cout << ans;
    return 0;
}