#include <iostream>
#include <vector>
#include <unordered_set>
#include <algorithm>
#include <bitset>

using namespace std;
typedef long long ll;

#define all(v) v.begin(), v.end()
#define size(v) ((int)v.size())

const int maxn = 1000;
vector<int> g[maxn];
int n, sz[maxn];

ll ans = 0;

void dfs(int v) {
    sz[v] = 1;
    if (g[v].empty())
        return;
    for (auto u : g[v]) {
        dfs(u);
        sz[v] += sz[u];
    }
    bitset<maxn + 1> f;
    f[0] = 1;
    for (auto u : g[v])
        f |= f << sz[u];
    int t = sz[v] / 2;
    while (!f[t])
        ++t;
    ans += sz[v];
}

int main() {
    //freopen("inp2.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n; cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int x; cin >> x;
        g[x - 1].push_back(i + 1);
    }
    dfs(0);
    cout << ans;
    return 0;
}