#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef double db;
typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

typedef pair < ll, ll > pll;
typedef pair < int, ll > pil;
typedef pair < ll, int > pli;
typedef pair < int, int > pii;

typedef pair < db, db > pdd;
typedef pair < db, ld > pdl;
typedef pair < ld, db > pld;
typedef pair < ld, ld > ldp;

#define F first
#define S second

#define en end()
#define bg begin()

#define mp make_pair
#define pb push_back

#define rev reverse
#define y1 y0123456789
#define um unordered_map

#define all(x) x.bg, x.en
#define sz(x) (int)x.size()
#define len(x) (int)strlen(x)

#define sqr(x) ((x) * 1ll * (x))
#define sqrd(x) ((x) * 1.0 * (x))

#define forn(i, x) for (int i = 1; i <= x; i++)

const int dx[] = {0, 0, 1, 0, -1};
const int dy[] = {0, 1, 0, -1, 0};

const ll inf = (ll)1e18;
const ll mod = (ll)1e9 + 7;

const db eps = (db)1e-9;
const db pi = acos(-1.0);

const int N = 100500;

char c[5000005];
vector < int > pos[26];
int n, lim, cnt[26], need[26], prv[26];

inline void upd(int pref) {
	for (int i = 0; i < 26; i++) {
		int l = 0, r = cnt[i] - 1, res = -1;
		while (l <= r) {
			int mid = (l + r) >> 1;
			if (pos[i][mid] <= pref) {
				res = mid;
				l = mid + 1;
			}
			else
				r = mid - 1;
		}
		need[i] = res + 1;
		prv[i] = res;
	}
}

inline bool check(int pref) {
	for (int i = 0; i < 26; i++) {
		int l = prv[i] + 1, r = cnt[i] - 1, res = -1;
		while (l <= r) {
			int mid = (l + r) >> 1;
			if (pos[i][mid] <= pref) {
				res = mid;
				l = mid + 1;
			}
			else
				r = mid - 1;
		}
		if (res - prv[i] != need[i])
			return 0;
		prv[i] = res;
	}
	return 1;
}

int main() {
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	//freopen(".err", "w", stderr);

	//srand(time(NULL));
	
	//cin.tie(NULL);
	//cout.tie(NULL);
	//ios_base::sync_with_stdio(false);

	//cout << setprecision(10) << fixed;

	gets(c);

	n = strlen(c);

	for (int i = 0; i < n; ++i)
		cnt[c[i] - 'a']++;

	for (int i = 0; i < 26; ++i)
		pos[i].reserve(cnt[i]);

	for (int i = 0; i < n; ++i)
		pos[c[i] - 'a'].pb(i);

	for (int i = 1; i <= n; ++i) {
		if (n % i)
			continue;
		bool ok = 1;
		upd(i - 1);
		for (int j = i + i - 1; j < n; j += i) {
			if (!check(j)) {
				ok = 0;
				break;
			}
		}
		if (ok) {
			printf("%d", n / i);
			return 0;
		}
	}

	//cerr << (clock() + 0.0) / CLOCKS_PER_SEC;

	return 0;
}
