#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef double db;
typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

typedef pair < ll, ll > pll;
typedef pair < int, ll > pil;
typedef pair < ll, int > pli;
typedef pair < int, int > pii;

typedef pair < db, db > pdd;
typedef pair < db, ld > pdl;
typedef pair < ld, db > pld;
typedef pair < ld, ld > ldp;

#define F first
#define S second

#define en end()
#define bg begin()

#define mp make_pair
#define pb push_back

#define rev reverse
#define y1 y0123456789
#define um unordered_map

#define all(x) x.bg, x.en
#define sz(x) (int)x.size()
#define len(x) (int)strlen(x)

#define sqr(x) ((x) * 1ll * (x))
#define sqrd(x) ((x) * 1.0 * (x))

#define forn(i, x) for (int i = 1; i <= x; i++)

const int dx[] = {0, 0, 1, 0, -1};
const int dy[] = {0, 1, 0, -1, 0};

const ll inf = (ll)1e18;
const ll mod = (ll)1e9 + 7;

const db eps = (db)1e-9;
const db pi = acos(-1.0);

const int N = 5000005;

const ll p = 29;
const ull pr = 31;

int n;
char c[N];
ll h[N], pw[26];
ull hu[N], pwu[26];

inline ll get(int l, int r) {
	ll res = h[r] - h[l - 1];
	if (res < 0)
		res += mod;
	return res;
}

inline ull getu(int l, int r) {
	return hu[r] - hu[l - 1];
}

int main() {
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	//freopen(".err", "w", stderr);

	//srand(time(NULL));
	
	//cin.tie(NULL);
	//cout.tie(NULL);
	//ios_base::sync_with_stdio(false);

	//cout << setprecision(10) << fixed;

	gets(c + 1);

	n = strlen(c + 1);

	pw[0] = 1;

	for (int i = 1; i < 26; ++i) {
		pw[i] = pw[i - 1] * p % mod;
		pwu[i] = pwu[i - 1] * pr % mod;
	}

	for (int i = 1; i <= n; ++i) {
		int id = c[i] - 'a';
		h[i] = (h[i - 1] + pw[id]) % mod;
		hu[i] = hu[i - 1] + pwu[id];
	}

	for (int i = 1; i <= n; ++i) {
		if (n % i)
			continue;
		bool ok = 1;
		ll hn = get(1, i);
		ull hun = getu(1, i);
		for (int j = i + i; j <= n; j += i) {
			if (get(j - i + 1, j) != hn || getu(j - i + 1, j) != hun) {
				ok = 0;
				break;
			}
		}
		if (ok) {
			printf("%d", n / i);
			return 0;
		}
	}

	//cerr << (clock() + 0.0) / CLOCKS_PER_SEC;

	return 0;
}
