#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef double db;
typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

typedef pair < ll, ll > pll;
typedef pair < int, ll > pil;
typedef pair < ll, int > pli;
typedef pair < int, int > pii;

typedef pair < db, db > pdd;
typedef pair < db, ld > pdl;
typedef pair < ld, db > pld;
typedef pair < ld, ld > ldp;

#define F first
#define S second

#define en end()
#define bg begin()

#define mp make_pair
#define pb push_back

#define rev reverse
#define y1 y0123456789
#define um unordered_map

#define all(x) x.bg, x.en
#define sz(x) (int)x.size()
#define len(x) (int)strlen(x)

#define sqr(x) ((x) * 1ll * (x))
#define sqrd(x) ((x) * 1.0 * (x))

#define forn(i, x) for (int i = 1; i <= x; i++)

const int dx[] = {0, 0, 1, 0, -1};
const int dy[] = {0, 1, 0, -1, 0};

const ll inf = (ll)1e18;
const ll mod = (ll)1e9 + 7;

const db eps = (db)1e-9;
const db pi = acos(-1.0);

const int N = 51;

int n;
bool u[N];

inline ll gcd(ll a, ll b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

struct pt {
	ll x, y;
	pt(){};
	pt(ll a, ll b) : x(a), y(b) {};
	inline void in() {
		cin >> x >> y;
	}
	inline void out() {
		cout << x << " " << y << endl;
	}
} p[N];

struct ln {
	ll a, b, c;
	ln(){};
	ln(ll x, ll y, ll z) : a(x), b(y), c(z) {};
	ln(pt p1, pt p2) {
		a = p2.y - p1.y;
		b = p1.x - p2.x;
		c = -b * p1.y - a * p1.x;
	}
	inline bool par(ln l) {
		return (a * l.b - b * l.a == 0);
	}
	inline pt cross(ln l) {
		pt res;
		ll A = b * l.c - c * l.b;
		ll B = c * l.a - a * l.c;
		ll C = a * l.b - b * l.a;
		res.x = A / C;
		res.y = B / C;
		if (res.x * C != A || res.y * C != B)
			return pt(inf, inf);
		return res;
	}
	inline bool check(pt p) {
		return (a * p.x + b * p.y + c == 0);
	}
	inline bool operator ==(ln l) {
		return (a == l.a && b == l.b && c == l.c);
	}
	inline bool operator !=(ln l) {
		return (a != l.a || b != l.b || c != l.c);
	}
	inline bool operator <(ln l) {
		if (a == l.a) {
			if (b == l.b)
				return (c < l.c);
			return (b < l.b);
		}
		return (a < l.a);
	}
} L[N];

int main() {
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	//freopen(".err", "w", stderr);

	//srand(time(NULL));
	
	//cin.tie(NULL);
	//cout.tie(NULL);
	//ios_base::sync_with_stdio(false);

	//cout << setprecision(10) << fixed;

	cin >> n;

	n <<= 1;

	for (int i = 1; i <= n; i++)
		p[i].in();

	/*for (int i = 1; i <= n; i++)
		cerr << p[i].x << " " << p[i].y << endl;
	cerr << endl;*/

	for (int i = 1; i < n; i++) {
		for (int j = i + 1; j <= n; j++) {
			if (j == i)
				continue;
			for (int k = i + 1; k < n; k++) {
				if (k == i || k == j)
					continue;
				for (int f = k + 1; f <= n; f++) {
					if (f == i || f == j || f == k)
						continue;
					ln l1 = ln(p[i], p[j]);
					ln l2 = ln(p[k], p[f]);
					if (l1.par(l2))
						continue;
					pt moon = l1.cross(l2);
					if (max(abs(moon.x), abs(moon.y)) > (ll)1e6)
						continue;
					bool ok = 1;
					memset(u, 0, sizeof(u));
					for (int I = 1; I < n; I++) {
						if (u[I])
							continue;
						u[I] = 1;
						int cnt = 0;
						ln cur = ln(moon, p[I]);
						for (int J = I + 1; J <= n; J++) {
							if (u[J])
								continue;
							if (cur.check(p[J])) {
								cnt++;
								u[J] = 1;
								if (cnt > 1) {
									ok = 0;
									break;
								}
							}
						}
						if (!ok)
							break;
						if (cnt != 1) {
							ok = 0;
							break;
						}
					}
					/*cerr << moon.x << " " << moon.y << " : " << i << " " << j << " " << k << " " << f << endl;
					for (int it = 1; it <= n; it++) {
						L[it] = ln(moon, p[it]);
						if (L[it].a == 0) {
							if (L[it].b == 0)
								L[it].c = abs(L[it].c);
							else if (L[it].b < 0) {
								L[it].b = 0 - L[it].b;
								L[it].c = 0 - L[it].c;
								ll g = gcd(abs(L[it].b), abs(L[it].c));
								if (g) {
									L[it].b /= g;
									L[it].c /= g;
								}
							}
						}
						else if (L[it].a < 0) {
							L[it].a = 0 - L[it].a;
							L[it].b = 0 - L[it].b;
							L[it].c = 0 - L[it].c;
							ll g = gcd(gcd(abs(L[it].a), abs(L[it].b)), abs(L[it].c));
							if (g) {
								L[it].a /= g;
								L[it].b /= g;
								L[it].c /= g;
							}
						}
					}
					bool ok = 1;
					sort(L + 1, L + 1 + n);
					if (i == 1 && j == 2 && k == 3 && f == 4) {
						cerr << endl;
						for (int it = 1; it <= n; it++)
							cerr << L[it].a << " " << L[it].b << " " << L[it].c << endl;
						cerr << endl;
					}
					for (int it = 1; it < n; it++) {
						if (((it & 1) && L[it] != L[it + 1]) || (!(it & 1) && L[it] == L[it + 1])) {
							ok = 0;
							break;							
						}
					}*/
					if (ok) {
						cout << "Yes" << endl;
						moon.out();
						return 0;
					}
					//cerr << "FAIL" << endl;
				}
			}
		}
	}

	cout << "No";
	
	//cerr << (clock() + 0.0) / CLOCKS_PER_SEC;

	return 0;
}
