#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef long double ld;

#define endl "\n"
#define mp make_pair
#define pb push_back

const int mod = 1000000007;
const int INF = 1000000000;
const int MAX = 200005; // 200005;

int n, used[MAX];
ll c[MAX], mn[MAX][3], val[MAX], sum[MAX], cnt[MAX];
vector <int> e[MAX];
ll result = 0;

void dfs(int v);
void getResult(int v);
void get30(int v);

int main()
{
    int p, group30 = 1;

    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    cin >> n;

    for (int i = 2; i <= n; i++) {
        cin >> p;

        e[p].push_back(i);
    }

    for (int i = 2; i <= n; i++) {
        cin >> c[i];

        if (c[i] > 1)
            group30 = 0;
    }

    dfs(1);

    for (int i = 1; i <= n; i++)
        used[i] = 0;

        get30(1);

    cout << result << endl;

    return 0;
}

void dfs(int v) {
    used[v] = 1;
    sum[v] = c[v];
    cnt[v] = 1;

    for (auto nxt : e[v]) {
        if (!used[nxt])
            dfs(nxt);

        sum[v] += sum[nxt];
        cnt[v] += cnt[nxt];

        if (!mn[v][0] || (val[mn[nxt][0]] < val[mn[v][0]])) {
            mn[v][1] = mn[v][0];
            mn[v][0] = nxt;
        }
        else if (mn[nxt][0] && (!mn[v][1] || (val[mn[nxt][0]] < val[mn[v][1]])))
            mn[v][1] = nxt;
    }

    if (mn[v][0])
        val[v] = val[mn[v][0]];
    else {
        mn[v][0] = v;
        val[v] = c[v];
    }
}

void getResult(int v) {
    used[v] = 1;

    for (auto nxt : e[v]) {
        if (!used[nxt])
            getResult(nxt);

        if (mn[v][0] == nxt)
            result += sum[nxt] + cnt[nxt] * val[mn[v][1]];
        else
            result += sum[nxt] + cnt[nxt] * val[mn[v][0]];
    }

    if (mn[v][1])
        result -= val[mn[v][0]] + val[mn[v][1]];
}

void get30(int v) {
    vector <ll> cur;
    ll s = 0;

    used[v] = 1;

    for (auto nxt : e[v]) {
        if (!used[nxt])
            get30(nxt);

        cur.push_back(cnt[nxt]);
    }

    if (cur.size() < 1)
        return;
    s = cur[0];

    for (int i = 1; i < cur.size(); i++) {
        result += min(cur[i], s) * 2LL;
        s = max(cur[i], s) - min(cur[i], s);
    }

    result += s * 2LL;
}

