#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 5000005;
const int SQRT = 2500;

int n;
string s;
vector<int> d;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> s;
    n = s.size();

    for (int i = 1; i <= SQRT; ++ i)
    {
        if (i * i > n) break;
        if (n % i == 0)
        {
            d.push_back(i);
            d.push_back(n / i);
        }
    }

    sort(d.begin(), d.end());
}

int main()
{
    Init();

    for (int i = 0; i < d.size(); ++ i)
    {
        int j = 0, pr[26], sm[26];
        bool fl = true;

        while (j < s.size())
        {
            if (!fl) break;
            for (int k = 0; k < 26; ++ k)
            {
                sm[k] = 0;
            }
            for (int k = 0; k < d[i]; ++ k)
            {
                sm[s[j] - 'a']++;
                j++;
            }
            for (int k = 0; k < 26; ++ k)
            {

                if (j != d[i] and pr[k] != sm[k])
                {
                    fl = false;
                    break;
                }
                else pr[k] = sm[k];
            }
        }
        if (fl)
        {
            cout << n / d[i] << endl;
            return 0;
        }
    }
}
