#include <bits/stdc++.h>


using namespace std;
#define int int64_t

typedef pair<int, int> pii;
const int INF = 1e18;
typedef long long ll;

vector<int> alldel(int n) {
    vector<int> ans;
    ans.push_back(1);
    int p = 2;
    while (p * p <= n) {
        if (n % p == 0) {
            ans.push_back(p);
            if (n / p != p) {
                ans.push_back(n / p);
            }
        }
        p++;
    }
    ans.push_back(n);
    sort(ans.begin(), ans.end());
    return ans;
}

signed main() {

    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    srand(time(NULL));

    string s;
    cin >> s;
    int n = s.size();
    vector<int> cnt(26);
    vector<vector<int>> pr(n, vector<int>(26));
    for (auto el : s) {
        cnt[el - 'a']++;
    }
    pr[0][s[0] - 'a']++;
    for (int i = 1; i < n; ++i) {
        for (int ch = 0; ch < 26; ++ch) {
            pr[i][ch] = pr[i - 1][ch];
        }
        pr[i][s[i] - 'a']++;
    }
    int gcd = cnt[0];
    for (int i = 1; i < 26; ++i) {
        gcd = __gcd(gcd, cnt[i]);
    }
    if (gcd == 1) {
        cout << 1;
        return 0;
    }

    gcd = n / gcd;

    vector<int> fact = alldel(gcd);
    for (auto deli : fact) {
        bool ok = true;
        vector<int> pat(26);
        int part = gcd / deli;
        pat = pr[part - 1];
        for (int i = part; i < n; i+= part) {
            vector<int> curr(26);
            for (int j = 0; j < part; ++j) {
                curr[s[i + j] - 'a']++;
            }
            if (curr != pat) {
                ok = false;
                break;
            }
        }
        if (ok) {
            cout << n / part << endl;
            return 0;
        }
    }
    cout << 1 << endl;
    return 0;
}


/*
tests

 abbabbbab

 aabb







 9
1 1 2 2 2 3 3 3
1 1 1 1 1 1 1 1

5
1 2 3 4
1 1 1 1



5
1 2 2 1
1 1 1 1

 */