#include <bits/stdc++.h>

using namespace std;

int cnt[26];
int cur[26];

template<typename T>
T gcd(T a, T b) {
    while(a && b) (a > b ? a %= b : b %= a);
    return a + b;
}

set<int> lengths;

int main() {
#ifndef ONLINE_JUDJE
    freopen("input.txt", "r", stdin);
#endif

    string s;
    cin >> s;
    int n = s.size();

    for(int i = 0; i < n; ++i) {
        cnt[s[i] - 'a']++;
    }

    int maxSize = 0;
    for(int i = 0; i < 26; ++i)
        maxSize = gcd(maxSize, cnt[i]);

    for(int i = 1; 1ll * i * i <= n; ++i) {
        if(n % i == 0 && lengths.count(i) == 0) {
            for(int j = i; j <= n; j += i)
                lengths.insert(i);
        }
    }
    lengths.insert(n);

    for(int x : lengths) {
        int blockCnt = n / x;
        if(maxSize % blockCnt == 0) {
            bool can = true;
            for(int j = 0; can && j < blockCnt; ++j) {
                bool block = true;
                for(int k = 0; k < 26; ++k)
                    cur[k] = 0;
                for(int k = 0; k < x; ++k)
                    cur[s[j * x + k] - 'a']++;
                for(int k = 0; k < 26; ++k)
                    block &= (cur[k] == cnt[k] / blockCnt);
                can &= block;
            }
            if(can) {
                cout << blockCnt << "\n";
                return 0;
            }
        }
    }

    return 1;
}