#include <iostream>
#include <vector>
#include <string>
#include <cmath>
using namespace std;

const int mod = 1e9 + 7;

int main()
{
    string s;
    cin >> s;
    int n = s.length(), ans = 0;
    bool t = 1;
    char cur_s = s[0];
    for(int i = 0; i < n; i++)
        if(s[i] != cur_s)
        {
            t = 0;
            break;
        }
    if(t)
        return cout << n, 0;
    int p = 5000011;
    vector <long long> pow(26);
    pow[0] = p;
    for(int i = 1; i < 26; i++)
    {
        pow[i] = pow[i - 1] * p;
        pow[i] %= mod;
    }
    vector <long long> prf(n);
    prf[0] = pow[s[0] - 'a'];
    for(int i = 1; i < n; i++)
        prf[i] = prf[i - 1] + pow[s[i] - 'a'];
    for(int i = 1; i < n; i++)
    {
        if(n % i != 0)
            continue;
        t = 1;
        for(int j = 2; j <= n / i; j++)
        {
            long long cur;
            if(j > 2)
                cur = prf[i * (j - 1) - 1] - prf[i * (j - 2) - 1];
            else
                cur = prf[i * (j - 1) - 1];
            if(prf[i * j - 1] - prf[i * (j - 1) - 1]  != cur)
            {
                t = 0;
                break;
            }
        }
        if(t)
            ans = max(ans, i);
    }
    cout << max(ans, 1);
}

/*
abcddcbaacbd
*/
/*
zxyzxyzxyzxyzxyzxyzxyzxyzxyzxy
*/
