#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

typedef long long ll;

mt19937 rnd(228);

const int N = 2e5 + 7;

int c[N];
int sz[N];
ll sum[N];
vector <int> g[N];

ll ans = 0;

void dfs(int v)
{
    int a = 1e9, b = 1e9;
    sz[v] = 1;
    sum[v] = c[v];
    for (int to : g[v])
    {
        dfs(to);
        sum[v] += sum[to];
        sz[v] += sz[to];
        c[v] = min(c[v], c[to]);
        int x = c[to];
        if (x < a)
        {
            swap(a, x);
        }
        if (x < b)
        {
            swap(b, x);
        }
    }
    if (a != 1e9)
    {
        ll best = 1e18;
        {
            sort(g[v].begin(), g[v].end(), [] (int a, int b)
            {
                return sz[a] > sz[b];
            });
            int kek = 1e9;
            int cur = 0;
            for (int to : g[v])
            {
                if (sz[to] <= cur)
                {
                    cur -= sz[to];
                    if (cur == 0) kek = 1e9;
                }
                else
                {
                    cur = sz[to] - cur;
                    kek = c[to];
                }
                ans += sum[to];
            }
            best = min(best, cur * (ll) (kek == a ? b : a));
        }
        {
            sort(g[v].begin(), g[v].end(), [&a] (int x, int y)
            {
                if (c[x] == a)
                {
                    return (c[y] > c[x]);
                }
                else
                {
                    return sz[x] > sz[y];
                }
            });
            int kek = 1e9;
            int cur = 0;
            for (int to : g[v])
            {
                if (sz[to] <= cur)
                {
                    cur -= sz[to];
                    if (cur == 0) kek = 1e9;
                }
                else
                {
                    cur = sz[to] - cur;
                    kek = c[to];
                }
            }
            best = min(best, cur * (ll) (kek == a ? b : a));
        }
        ans += best;
    }
}

int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
   // freopen("a.out", "w", stdout);
#endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i < n; i++)
    {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
    }
    for (int i = 1; i < n; i++) cin >> c[i];
    dfs(0);
    cout << ans << '\n';
}
