#include <bits/stdc++.h>
#pragma GCC optimize("O3")


typedef long long ll;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define x first
#define y second
#define point pair<double, double>

using namespace std;

const int N = 1e5 + 3, BIG = 1e9 + 7, MOD = 1e9 + 7, P = 'z' - 'a' + 1, K = 9;
const double EPS = 1e-8;

struct line{
	double a, b, c;
	line(point p1, point p2) {
		a = p1.y - p2.y;
		b = p2.x - p1.x;
		c = -1 * a * p1.x - b * p1.y;
		// c = p1.x * p2.y - p1.y * p2.x;
	}
};


double determinator(line l1, line l2) {
	return l1.a * l2.b - l2.a * l1.b;
}

point line_crossing(line l1, line l2) {
	point ans;
	double det = determinator(l1, l2);
	// cout << det << " - det\n";
	ans.x = -(l1.c * l2.b - l1.b * l2.c) / det;
	ans.y = -(l1.a * l2.c - l1.c * l2.a) / det;
	return ans;
}


int n;
vector<point> a;
point ans = {1234, 1234};
point ans0 = ans;


void check(point p1, point p2, point p3, point p4) { 
	line l1 = line(p1, p2), l2 = line(p3, p4);
	vector<bool> used(n);
	forn(i, n) 
		if (a[i] == p1 || a[i] == p2 || a[i] == p3 || a[i] == p4)
			used[i] = true;
	if (abs(determinator(l1, l2)) < EPS)
		return;
	point moon = line_crossing(l1, l2);

	/*/
	cout << p1.x <<  " " << p1.y << ", " << p2.x << " " << p2.y 
		<< ", " << p3.x << " " << p3.y << ", " << p4.x << " " << p4.y << "\n";
	cout << moon.x << " " << moon.y << " - moon" << endl;
	//*/
	if (abs(moon.x - int(moon.x)) > EPS 
			|| abs(moon.y - int(moon.y)) > EPS)
		return;

	forn(i, n) {
		if (abs(moon.x - a[i].x) < EPS 
				&& abs(moon.y - a[i].y) < EPS)
			return;
	}

	forn(i, n)
		if (!used[i]) {
			line l3 = line(a[i], moon);
			used[i] = true;
			vector<int> inds;
			forn(j, n)
				if (!used[j] || l3.a * a[j].x + l3.b * a[j].y == l3.c)
					inds.push_back(j);
			if (inds.size() == 1) {
				used[inds[0]] = true;
			} else
				return;
		}
	ans = moon;
}



int main() {
	// freopen("a.in", "r", stdin), freopen("a.out", "w", stdout);
	ios_base:: sync_with_stdio(0), cin.tie(0), cout.tie(0);	
	cin >> n;
	
	n *= 2;
	a.resize(n);
	forn(i, n)
		cin >> a[i].x >> a[i].y;

	forn(i1, n)
		forn(i2, n)
			forn(j1, n)
				forn(j2, n) {
					if (i1 != i2 && i1 != j1 && i1 != j2
							&& i2 != j1 && i2 != j2 && j1 != j2)
						check(a[i1], a[i2], a[j1], a[j2]);
					if (ans != ans0)
						break;
				}
	if (ans == ans0) {
		cout << "No";
		return 0;
	}
	cout << "Yes\n" << ans.x << " " << ans.y;
	return 0;
} 