#include <fstream>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <math.h>
#include <map>
#include <set>

using namespace std;

ifstream cin("input.txt"); ofstream cout("output.txt");

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
    ll n;
    cin >> n;
    vector <int> a(n * 2, 0);
    for (int i = 1; i <= n; i++)
        a[i * 2 - 2] = i;
    for (int i = n * 2 - 2; i >= 0; i--) {
        if (a[i] == 0)
            continue;
        bool t = true;
        for (int j = i; j >= 0; j--) {
            if (a[j] == 0) {
                a[j] = a[i];
                a[i] = 0;
                t = false;
            }
        }
        if (t)
            break;
    }
    int q;
    cin >> q;
    while (q--) {
        int x;
        cin >> x;
        cout << a[--x] << "\n";
    }
	return 0;
}

