#include <fstream>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <math.h>
#include <map>
#include <set>

using namespace std;

ifstream cin("input.txt"); ofstream cout("output.txt");

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    string s;
    cin >> s;
    vector <int> w(26, 0);
    for (int i = 0; i < s.size(); i++)
        w[s[i] - 'a']++;
    int k = -1;
    for (int i = 0; i < 26; i++) {
        if (w[i] == 0)
            continue;
        if (k == -1) {
            k = w[i];
            continue;
        }
        int a = k, b = w[i];
        while (a != 0 && b != 0) {
            if (a > b)
                a %= b;
            else
                b %= a;
        }
        k = max(a, b);
    }
    for (int j = 1; j*j<=k; j++) {
        if (k%j != 0)
            continue;
        int k0 = k / j;
        vector <int> must(26);
        for (int i = 0; i < 26; i++)
            must[i] = w[i] / k0;
        bool t = true;
        for (int h = 0; h < k0; h++) {
            vector <int> n(26, 0);
            for (int i = h*k0; i < h*k0+ s.size() / k0; i++)
                n[s[i] - 'a']++;
            for (int i = 0; i < 26; i++) {
                if (must[i] != n[i]) {
                    t = false;
                    break;
                }
            }
            if (!t)
                break;
        }
        if (t) {
            cout << k0;
            return 0;
        }
    }
    cout << "1";
    return 0;
}

