#include <iostream>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <math.h>
#include <map>
#include <set>

using namespace std;

//ifstream cin("input.txt"); ofstream cout("output.txt");

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    string s;
    cin >> s;
    vector <int> w(26, 0);
    for (int i = 0; i < s.size(); i++)
        w[s[i] - 'a']++;
    int k = -1;
    for (int i = 0; i < 26; i++) {
        if (w[i] == 0)
            continue;
        if (k == -1) {
            k = w[i];
            continue;
        }
        int a = k, b = w[i];
        while (a != 0 && b != 0) {
            if (a > b)
                a %= b;
            else
                b %= a;
        }
        k = max(a, b);
    }
    vector <int> d;
    for (int i = 1; i*i <= k; i++) {
        if (k%i == 0) {
            d.push_back(i);
            if (k / i != i)
                d.push_back(k / i);
        }
    }
    sort(d.rbegin(), d.rend());
    for (int j = 0; j<d.size(); j++) {
        int k0 = d[j];
        //vector <int> must(26, 0);
        int must = 0;
        for (int i = 0; i < 26; i++)
            must+= (w[i] / k0)*(int)('a'+i);
        bool t = true;
        int siz = s.size() / k0;
        for (int h = 0; h < k0; h++) {
            //vector <int> n(26, 0);
            int n = 0;
            for (int i = h * siz; i < h*siz + siz; i++)
                n += (int)s[i];
            if (must != n) {
                t = false;
                break;
            }
        }
        if (t) {
            cout << k0;
            return 0;
        }
    }
    cout << "1";
    return 0;
}

