#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimaze("Ofast");
#pragma target("sse3,sse4");

#define int long long
#define ll long long
#define ld long double
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define pb push_back
#define pii pair<int, int>

const int INF = 1e18;
const int MAXN = 1e6;
const int MOD = 1e9 + 7;
const int P = 1336177;

ll power(int a, int n, int MOD = INF) {
    if (n == 0) return 1;
    if (n & 1) {
        return (a * power(a, n - 1, MOD)) % MOD;
    } else {
        int b = power(a, n >> 1, MOD);
        return (b * b) % MOD;
    }
}

ll gcd(int a, int b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}

vector<vector<int>> g;
vector<int> h;

int ans = 0;

int dfs(int v) {
    h[v] = 1;
    if (g[v].size() == 0) return h[v];
    for (auto u: g[v]) {
        h[v] += dfs(u);
    }
    vector<int> a;
    for (auto u: g[v]) {
        a.pb(h[u]);
    }
    sort(all(a), greater<int>());
    int l = 0; int r = a.size() - 1;
    while (r > l && a[l] != 0) {
        int d = min(a[l], a[r]);
        a[l] -= d;
        a[r] -= d;
        ans += 2 * d;
        if (a[r] == 0) r--;
        if (a[l] == 0) l++;
    }
    for (auto x: a) ans += x * 2;
    return h[v];
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    //srand(time(NULL));
//-------------------------------------------------------------
    int n;
    cin >> n;
    cout << (n - 1) * 2 << "\n";
    return 0;
    g.resize(n); h.resize(n);
    for (int i = 1; i < n; i++) {
        int p; cin >> p; p--;
        g[p].pb(i);
    }
    dfs(0);
    cout << ans << '\n';
}