#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimaze("Ofast");
#pragma target("sse3,sse4");

#define int long long
#define ll long long
#define ld long double
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define pb push_back
#define pii pair<int, int>

const int INF = 1e18;
const int MAXN = 1e18 / 5e6;
const int MOD = 1e9 + 7;
const int P = 1336177;

ll power(int a, int n, int MOD = INF) {
    if (n == 0) return 1;
    if (n & 1) {
        return (a * power(a, n - 1, MOD)) % MOD;
    } else {
        int b = power(a, n >> 1, MOD);
        return (b * b) % MOD;
    }
}

ll gcd(int a, int b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}

struct line {
    int A, B, C;

    line(pii a1, pii a2) {
        A = a2.S - a1.S;
        B = a1.F - a2.F;
        C = -(A * a1.F + B * a1.S);
    }
    line();
};

pii line_to_point(line A, line B) {
    int x = INF; int y = INF;
    int U = A.C * B.B - B.C * A.B;
    int D = A.A * B.B - B.A * A.B;
    if (D == 0) return {INF, INF};
    if (U % D != 0) {
        return {INF, INF};
    } else {
        x = U / D;
    }
    U = A.A * B.C - B.A * A.C;
    if (U % D != 0) {
        return {INF, INF};
    } else {
        y = U / D;
    }
    return {-x, -y};
}

vector<pii> p;
set<pii> points_input;
vector<line> L;

signed main() {
    cin.tie(0);
    cout.tie(0);
    //srand(time(NULL));
//-------------------------------------------------------------
    int n;
    cin >> n;
    for (int i = 0; i < 2 * n; i++) {
        int x, y;
        cin >> x >> y;
        p.pb({x, y});
        points_input.insert({x, y});
    }
    set<pii> used;
    for (int i = 0; i < p.size(); i++) {
        for (int j = 0; j < p.size(); j++) {
            if (i != j && !used.count({i, j}) && !used.count({j, i})) {
                L.pb({p[i], p[j]});
                used.insert({i, j});
            }
        }
    }
    map<pii, int> ans;
    for (int i = 0; i < L.size(); i++) {
        for (int j = 0; j < L.size(); j++) {
            if (i != j) {
                pii abs = line_to_point(L[i], L[j]);
                if (abs.F == INF) continue;
                if (!points_input.count(abs)) ans[abs]++;
            }

        }
    }
    for (auto x: ans) {
        if (x.S >= n) {
            cout << "Yes\n";
            if (x.F.F >= INF / 2 || x.F.S >= INF / 2) throw new exception;
            cout << x.F.F << " " << x.F.S << '\n';
            return 0;
        }
    }
    cout << "No\n";
    return 0;

}