#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;
typedef long long ll;

const int maxn = 300000, inf = 1e9;
int p[maxn];
ll c[maxn], answer[maxn];
int sz[maxn];
vector <int> v [maxn];

void dfs(int k) {
	answer[k] = 0;
	sz[k] = 1;
	int maxsz = 0;
	for (int i = 0; i < v[k].size(); i++) {
		dfs(v[k][i]);
		sz[k] += sz[v[k][i]];
		answer[k] += answer[v[k][i]];
		maxsz = max(maxsz, sz[v[k][i]]);
	}
	if (2 * maxsz <= sz[k] - 1) {
		answer[k] += sz[k] - 1 + (sz[k] - 1) % 2;
	}
	else {
		answer[k] += 2 * maxsz;
	}
}

int main() {
	int n;
	scanf("%d", &n);
	for (int i = 1; i <= n - 1; i++) {
		scanf("%d", &p[i]); p[i]--;
		v[p[i]].push_back(i);
	}
	for (int i = 1; i <= n - 1; i++) {
		scanf("%d", &c[i]);
	}
	dfs(0);
	printf("%lld", answer[0]);
	return 0;
}