#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string.h>
using namespace std;
typedef long long ll;

vector <pair<int, int> > v;
set <pair<int, int> > s;
vector <pair<pair<ll, ll>, ll> > pr, dif;
vector <pair<ll, ll> > poi;

ll gcd(ll a, ll b) {
	if (!b) return a;
	return gcd(b, a % b);
}

int main() {
	int n;
	scanf("%d", &n);
	for (int i = 0; i < 2 * n; i++) {
		int x, y;
		scanf("%d %d", &x, &y);
		v.push_back({ x, y });
		s.insert({ x, y });
	}
	for (int i = 0; i < 2 * n; i++) {
		for (int j = 0; j < i; j++) {
			ll a = v[i].second - v[j].second;
			ll b = v[j].first - v[i].first;
			ll c = -a * v[i].first - b * v[i].second;
			ll gd = gcd(gcd(a, b), c); a /= gd; b /= gd; c /= gd;
			pr.push_back({ { a, b }, c });
		}
	}
	sort(pr.begin(), pr.end());
	for (int i = 0; i < pr.size(); i++) {
		if (i == 0 || pr[i] != pr[i - 1]) {
			dif.push_back(pr[i]);
		}
	}
	for (int i = 0; i < dif.size(); i++) {
		for (int j = 0; j < i; j++) {
			ll q = dif[i].first.first * dif[j].second - dif[j].first.first * dif[i].second;
			ll r = dif[i].first.second * dif[j].second - dif[j].first.second * dif[i].second;
			ll w = dif[j].first.first * dif[i].first.second - dif[i].first.first * dif[j].first.second;
			if (w != 0 && q % w == 0 && r % w == 0) {
				pair <int, int> pnt = { -r / w, q / w };
				if (s.find(pnt) == s.end()) {
					poi.push_back(pnt);
				}
			}
		}
	}
	sort(poi.begin(), poi.end());
	int cur = 0;
	for (int i = 0; i < poi.size(); i++) {
		cur++;
		if (i == poi.size() - 1 || poi[i] != poi[i + 1]) {
			if (cur == n * (n - 1) / 2 && abs(poi[i].first) <= 1000000 && abs(poi[i].second) <= 1000000) {
				printf("Yes\n%lld %lld", poi[i].first, poi[i].second);
				return 0;
			}
			cur = 0;
		}
	}
	printf("No");
	return 0;
}