//#pragma gcc optimize("OFast")
//#pragma target("sse,sse2,sse3,sse4,tune=native")
//#pragma gcc optimize("unroll-loops")

#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <string>
#include <cassert>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef long double ld;

ll solve(ll n, ll k, ll add = 0)
{
	if (n == 1)
	{
		return add + 1;
	}
	if (k % 2 == 0)
	{
		return (k + 1) / 2 + add;
	}
	else if (n % 2 == 0)
	{
		return solve(n / 2, (k + 1) / 2, add + n / 2);
	}
	else
	{
		if (k == n)
		{
			return solve(n - n / 2, 1, add + n / 2);
		}
		else
		{
			return solve(n - n / 2, (k + 1) / 2 + 1, add + n / 2);
		}
	}
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, q;
	cin >> n >> q;
	for (int i = 0; i < q; i++)
	{
		ll pos;
		cin >> pos;
		if (pos % 2 == 1)
		{
			cout << (pos + 1) / 2 << "\n";
		}
		else if (n % 2 == 0)
		{
			if (pos == n)
			{
				cout << solve(n / 2, 1, n - n / 2) << "\n";
			}
			else
			{
				cout << solve(n / 2, pos / 2 + 1, n - n / 2) << "\n";
			}
		}
		else
		{
			cout << solve(n / 2, pos / 2, n - n / 2) << "\n";
		}
	}
	

#ifdef _DEBUG
	while (1);
#endif
}