#include <bits/stdc++.h>

using namespace std;

#define double long double

const int MOD = 1000000007;
const double eps = 1e-14;

struct tchk{
    int x, y;
};

struct line{
    long long a, b, c;
};

bool findans = false;
int xa, ya, n, x[2606], y[2606];
vector < pair < int , int >  > ord;
bool mark[2606];

bool lez( line a, int nom){
    long long ur = a.a * x[nom] + a.b * y[nom] + a.c;
    if ( ur == 0 )
        return true;
    return false;
}

tchk per( line a , line b){
    long long a1 = a.a, b1 = a.b, c1 = a.c;
    long long a2 = b.a, b2 = b.b, c2 = b.c;
    if ( a1 != 0 ){
        long long del = -1ll * a2 * b1 + b2 * a1;
        if ( del == 0 )
            return { -MOD, -MOD};
        long long yy = a2 * c1 - c2 * a1;
        double cyy = (double)yy / (double)del;
        double cyint = (double)((int)cyy);
        if ( fabs(cyint-cyy) > eps )
            return { -MOD, -MOD};
        long long xx = -1ll * b1 * (int)cyint - c1;
        double cxx = (double)xx / (double)(a1);
        double cxint = (double)((int)cxx);
        if ( fabs(cxint - cxx) > eps )
            return {-MOD, -MOD};
        tchk res;
        res.x = (int)cxint;
        res.y = (int)cyint;
        return res;
    }
    long long del = a2 * b1 - b2 * a1;
    if ( del == 0 )
        return { -MOD, -MOD};
    long long xx = c1 * b2 - c2 * b1;
    double cxx = (double)xx / (double)del;
    double cxint = (double)((int)cxx);
    if ( fabs(cxint - cxx) > eps )
        return { -MOD, -MOD};
    long long yy = -1ll * a1 * (int)cxint - c1;
    double cyy = (double)yy / (double)(b1);
    double cyint = (double)((int)cyy);
    if ( fabs(cyint - cyy) > eps )
        return { -MOD, -MOD};
    tchk res;
    res.x = (int)cxint;
    res.y = (int)cyint;
    return res;
}

void check(){
    vector < line > a;
    for (int i = 0; i < ord.size(); i++){
        int s = ord[i].first, f = ord[i].second;
        long long a1 = y[s] - y[f];
        long long b1 = x[f] - x[s];
        long long c1 = -1ll * a1 * x[s] - b1 * y[s];
        line cur;
        cur.a = a1, cur.b = b1, cur.c = c1;
        a.push_back( cur);
    }
    for (int i = 0; i < a.size() - 1; i++)
        for (int j = i + 1; j < a.size(); j++)
            if ( a[i].a == a[j].a && a[i].b == a[j].b && a[i].c == a[j].c )
                return;
    tchk cs = per( a[0], a[1]);
    if ( cs.x == -MOD )
        return;
    for (int i = 0; i < 2 * n; i++)
        if ( cs.x == x[i] && cs.y == y[i] )
            return;
    for (int i = 0; i < a.size() - 1; i++)
        for (int j = i + 1; j < a.size(); j++){
            tchk comp = per( a[i], a[j]);
            if ( comp.x != cs.x || comp.y != cs.y )
                return;
        }
    findans = true;
    xa = cs.x, ya = cs.y;
}

void rec( int nom){
    if ( nom == n ){
        check();
        return;
    }
    int st;
    for (int i = 0; i < 2 * n; i++)
        if ( !mark[i] ){
            st = i;
            break;
        }
    for (int i = 0; i < 2*n; i++){
        if ( mark[i] || i == st )
            continue;
        mark[i] = true;
        mark[st] = true;
        ord.push_back( make_pair( st, i));
        rec( nom + 1);
        if ( findans )
            return;
        ord.pop_back();
        mark[i] = false;
        mark[st] = false;
    }
}

int main()
{
    cin >> n;
    for (int i = 0; i < 2 * n; i++)
        cin >> x[i] >> y[i];
    for (int i = 1; i < 2 * n; i++){
        mark[i] = true;
        mark[0] = true;
        ord.push_back(make_pair( 0, i));
        rec( 1);
        if ( findans )
            break;
        ord.pop_back();
        mark[i] = false;
        mark[0] = false;
    }
    if ( findans ){
        cout << "Yes\n";
        cout << xa << " " << ya;
        return 0;
    }
    cout << "No";
    return 0;
}
