#include <bits/stdc++.h>

#define int long long

using namespace std;

struct vec {
	int x, y;
	vec(int xx = 0, int yy = 0) {
		x = xx; y = yy;
	}
	vec operator - (vec a) {
		return vec(x - a.x, y - a.y);
	}
	vec operator + (vec a) {
		return vec(x + a.x, y + a.y);
	}
	long long operator * (vec a) {
		return (long long)x * a.x + (long long)y * a.y;
	}
	long long operator % (vec a) {
		return (long long)x * a.y - (long long)y * a.x;
	}
	bool operator < (const vec a) const {
		return make_pair(x, y) < make_pair(a.x, a.y);
	}
	bool operator != (vec a) {
		return *this < a || a < *this;
	}
};

struct lin {
	vec x;
	int c;
	lin (vec a, vec b) {
		x = vec((a - b).y, (b - a).x);
		c = a * x;
	}
	vec operator & (lin a) {
		if (x % a.x == 0) {
			return vec(-1e9, -1e9);
		}
		int d, da, db;
		d = x % a.x;
		da = c * a.x.y - a.c * x.y;
		db = x.x * a.c - a.x.x * c;
		// cout << da << ' ' << db << ' ' << d << '\n';
		if (da % d != 0 || db % d != 0) {
			return vec(-1e9, -1e9);
		}
		return vec(da / d, db / d);
	}
};

signed main() {
	int n;
	cin >> n;
	vec a, b, c, d;
	cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y >> d.x >> d.y;
	lin ab = lin(a, b);
	lin cd = lin(c, d);
	vec x = ab & cd;
	if (abs(x.x) <= 1e6 && abs(x.y) <= 1e6 && x != a && x != b && x != c && x != d) {
		cout << "Yes\n" << x.x << ' ' << x.y << '\n';
		return 0;
	}
	ab = lin(a, c);
	cd = lin(b, d);
	x = ab & cd;
	if (abs(x.x) <= 1e6 && abs(x.y) <= 1e6 && x != a && x != b && x != c && x != d) {
		cout << "Yes\n" << x.x << ' ' << x.y << '\n';
		return 0;
	}
	ab = lin(a, d);
	cd = lin(c, b);
	x = ab & cd;
	if (abs(x.x) <= 1e6 && abs(x.y) <= 1e6 && x != a && x != b && x != c && x != d) {
		cout << "Yes\n" << x.x << ' ' << x.y << '\n';
		return 0;
	}
	cout << "No";
}