#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <string>
#include <set>
#include <map>
#define ll long long
using namespace std;

struct vec {
	ll x, y;
	vec(ll a = 0, ll b = 0) : x(a), y(b) {}
	ll operator%(vec v) {
		return x * v.y - v.x * y;
	}
	ll operator*(vec v) {
		return x * v.x + v.y * y;
	}
	vec operator-(vec v) {
		return vec(x - v.x, y - v.y);
	}
	vec ort() {
		return vec(y, -x);
	}
};

vector <vec> p1, p;
int n;


int check(vec c) {
	p = p1;
	for (int i = 0; i < n; i++) {
		p[i] = p[i] - c;
		if ((p[i].x == 0) && (p[i].y == 0))
			return 0;
	}
	vector <int> k(n, 0);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i == j)
				continue;
			if (p[i] % p[j] == 0)
				k[i]++;
		}
	}
	int k1 = 0;
	for (int i = 0; i < n; i++)
		if (k[i] == 1)
			k1++;
	return (k1 == n);
}

int answer(int g, int h) {
	vec v1 = p1[g] - p1[0], v2 = p1[h] - p1[1];
	if (v1 % v2 == 0)
		return 0;
	vec n1 = v1.ort(), n2 = v2.ort();
	ll a1 = n1.x, b1 = n1.y, c1 = -(n1 * p1[0]);
	ll a2 = n2.x, b2 = n2.y, c2 = -(n2 * p1[1]);
	if ((((a2*c1 - c2 * a1) % (b2 * a1 - a2 * b1)) != 0) || (((b1 * c2 - c1 * b2) % (a1 * b2 - a2 * b1)) != 0))
		return 0;
	ll y = (a2*c1 - c2 * a1) / (b2 * a1 - a2 * b1);
	ll x = (b1 * c2 - c1 * b2) / (a1 * b2 - a2 * b1);
	if (check(vec(x, y))) {
		cout << "YES" << "\n" << x << " " << y;
		return 1;
	}
	return 0;
}


int answer2(int g, int h) {
	vec v1 = p1[1] - p1[0], v2 = p1[g] - p1[h];
	if (v1 % v2 == 0)
		return 0;
	vec n1 = v1.ort(), n2 = v2.ort();
	ll a1 = n1.x, b1 = n1.y, c1 = -(n1 * p1[0]);
	ll a2 = n2.x, b2 = n2.y, c2 = -(n2 * p1[h]);
	if ((((a2*c1 - c2 * a1) % (b2 * a1 - a2 * b1)) != 0) || (((b1 * c2 - c1 * b2) % (a1 * b2 - a2 * b1)) != 0))
		return 0;
	ll y = (a2*c1 - c2 * a1) / (b2 * a1 - a2 * b1);
	ll x = (b1 * c2 - c1 * b2) / (a1 * b2 - a2 * b1);
	if (check(vec(x, y))) {
		cout << "YES" << "\n" << x << " " << y;
		return 1;
	}
	return 0;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	n *= 2;
	p1.resize(n);
	for (int i = 0; i < n; i++)
		cin >> p1[i].x >> p1[i].y;

	for (int i = 2; i < n; i++) {
		for (int j = 2; j < n; j++) {
			if (i == j)
				continue;
			if (answer(i, j)) {
				return 0;
			}
		}
	}

	for (int i = 2; i < n; i++) {
		for (int j = 2; j < n; j++) {
			if (i == j)
				continue;
			if (answer2(i, j)) {
				return 0;
			}
		}
	}
	cout << "NO";
	return 0;
}