#include <bits/stdc++.h>

using namespace std;

#define sz(x) ((int)(x).size())


const int INF = 1228228228;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    #ifdef ONLINE_JUDGE
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    string s;

    getline(cin, s);
    int n = sz(s);

    vector<int> ch(26, 0);
    for(int i = 0; i < n; ++i)
        ch[s[i] - 'a']++;

    int lol = 0;
    for(int i = 0; i < 26; ++i)
        if(ch[i]) lol++;

    if(lol == 1) {
        cout << n << endl;
        return 0;
    }

    int mind = INF;
    for(int i = 0; i < sz(ch); ++i)
        mind = min(mind, (ch[i] ? ch[i] : INF));

    vector<int> d;

    int g = (int) sqrt((double) mind);
    for(int i = 2; i <= mind; ++i) {
        bool flag = true;
        int k = i;
        for(int j = 0; j < 26; ++j)
            if(ch[j] % k != 0) flag = false;
        if(flag && n % k == 0)
            d.push_back(k);
        /*
        flag = true;
        if(n % k) flag = false;
        k = n / k;
        if(k == g) flag = false;
        for(int j = 0; j < 26; ++j)
            if(ch[j] % k != 0) flag = false;
        if(flag && n % k == 0)
            d.push_back(k); */
    }
    /*
    if(n % mind == 0)
        d.push_back(mind); */

    int ans = INF;

    vector<int> num;

    sort(d.begin(), d.end());
    reverse(d.begin(), d.end());

    for(auto p = d.begin(); p != d.end(); ++p) {
        int parts = *p;

        int k = n / parts;

        bool flag = true;

        for(int i = 0; i < n; ) {
            num.assign(26, 0);
            for(int j = i; j < i + k; ++j)
                num[s[j] - 'a']++;
            i += k;
            for(int j = 0; j < 26; ++j) {
                if(ch[j] == 0) continue;

                if(num[j] == 0) {
                    flag = false;
                    break;
                }

                if(ch[j] % num[j] != 0) {
                    flag = false;
                    break;
                }

                if((double) ch[j] / num[j] != (double) parts) {
                    flag = false;
                    break;
                }
            }

            if(!flag) break;
        }

        if(flag) {
            ans = k;
            break;
        }
    }

    if(ans == INF) cout << 1 << endl;
    else cout << (n / ans) << endl;


    return 0;
}
