#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define ll long long
using namespace std;

vector<vector<int> > g;
vector<int> mn;
vector<int> sum;
vector<int> p;
vector<int> size1;

int ans = 0;

void dfs(int v){
    mn[v] = p[v];
    size1[v] = 1;
    set<pair<int, int> > sz;
    for (auto i : g[v]){
        dfs(i);
        size1[v] += size1[i];
        sz.insert(make_pair(size1[i], i));
        mn[v] = min(mn[v], mn[i]);
        sum[v] += sum[i];
    }
    if (sz.size() >= 2){
        auto it = sz.end();
        it--;
        it--;
        while (it -> first){
            auto mx = sz.end();
            mx--;
            auto cur = sz.end();
            cur--;
            cur--;
            auto c = *mx;
            auto q = *cur;
            c.first -= cur -> first;
            sz.erase(*mx);
            sz.insert(c);
            sz.erase(q);
            q.first = 0;
            sz.insert(q);
            it = sz.end();
            it--;
            it--;
        }
    }
    ans += sum[v];
    if (g[v].size() == 1){
        ans -= sum[v];
        sum[v] += p[v];
        return;
    }
    if (sz.size() && sz.rbegin() -> first){
        int mn1 = 1e9;
        for (auto i : g[v]){
            if (i != sz.rbegin() -> second){
                mn1 = min(mn1, mn[i]);
            }
        }
        ans += sz.rbegin() -> first * mn1;
    }
    //cout << v << ' ' << ans << endl;
    sum[v] += p[v];
}

int main()
{
    int n;
    cin >> n;
    g.resize(n);
    size1.resize(n);
    mn.resize(n);
    sum.resize(n);
    p.resize(n);
    int a;
    for (int i = 1; i < n; i++){
        cin >> a;
        g[a - 1].push_back(i);
    }
    for (int i = 1; i < n; i++){
        cin >> p[i];
    }
    dfs(0);
    cout << ans << endl;
    return 0;
}
