#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <array>
#include <set>
#include <map>
#include <math.h>
#include <iomanip>
#include <string>
#include <algorithm>

#define ll long long 
#define fi(n) for (int i = 0; i < (n); i++) 
#define FOR(i, k, n) for (int i = (k); i < (n); i++) 
#define all(v) v.begin(), v.end()

const int INF = 1e6 + 10;

using namespace std;

const int ALP = 'z' - 'a' + 1;

ll gcd(int a, int b)
{
    while (a > 0 && b > 0)
        if (a > b)
            a %= b;
        else
            b %= a;
    return a + b;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);

    string s;
    cin >> s;
    
    vector<int> v(ALP);
    FOR(i, 0, (int)s.length())
        v[s[i] - 'a']++;

    int st1 = 0;
    int dc = ALP;
    FOR(j, 0, ALP)
    {
        st1 = gcd(st1, v[j]);
        if (v[j] == 0)
            dc--;
    }
    for (int i = 1; i <= st1; i++)
    {
        if (st1 % i != 0)
            continue;
        st1 /= i;
        bool answ = true;
        vector<int> b(ALP);
        for (int j = 0; j < s.length(); j++)
        {
            b[s[j] - 'a']++;
            if (b[s[j] - 'a'] / ((j) / (s.length() / st1) + 1) > v[s[j] - 'a'] / st1)
            {
                answ = false;
                break;
            }
            if (((j + 1) / (s.length() / st1)) != 0 && b[s[j] - 'a'] / ((j + 1) / (s.length() / st1)) < v[s[j] - 'a'] / st1)
            {
                answ = false;
                break;
            }
        }
        if (answ)
            return cout << st1 << endl, 0;
        st1 *= i;
    }
    return 0;
}

