#include <iostream>
#include <vector>

using namespace std;

vector <vector <int> > p;
int n, w = 0;
int a[5000001];

const int INF = 1e9;

bool check(int k) {
    bool f = true;
    for (int i = k; i <= n; i+= k) {
        for (int j = 0; j < w; j++) {
            f &= (p[i][j] - p[i - k][j] == p[k][j]);
        }
    }
    return f;
}

bool check1(int k) {
    bool f = true;
    for (int i = k; i <= n; i+= k) {
        f &= (a[i] - a[i - k] == a[k]);
    }
    return f;
}

int main()
{
    string s;
    cin >> s;
    n = s.size();
    for (char c : s) {
        w = max(w, c - 'a');
    }
    p.resize(n + 1, vector <int>(w, 0));
    if (w == 0) {
        cout << n;
        return 0;
    }
    if (w == 1) {
        for (int i = 1; i <= n; i++) {
            a[i] = a[i - 1] + (s[i - 1] == 'a');
        }
        int mn = INF;
        /*for (int i = 0; i <= n; i++) {
            cout << a[i] << " ";
        }
        cout << endl;*/
        for (int i = 1; i * i <= n; i++) {
            if (n % i) continue;
            if (check1(i)) {
                mn = min(mn, i);
            }
            if (check1(n / i)) {
                mn = min(mn, n / i);
            }
        }
        cout << n / mn;
        return 0;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < w; j++) {
            p[i][j] = p[i - 1][j] + (s[i - 1] - 'a' == j);
        }
    }
    int mn = INF;
    for (int i = 1; i * i <= n; i++) {
        if (n % i) continue;
        if (check(i)) {
            mn = min(mn, i);
        }
        if (check(n / i)) {
            mn = min(mn, n / i);
        }
    }
    cout << n / mn;
    return 0;
}
