#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector <vector <int> > p;
int n, w = 0;


const int INF = 1e9;

bool check(int k) {
    bool f = true;
    for (int j = 0; j < 26; j++) {
        int t = upper_bound(p[j].begin(), p[j].end(), k) - p[j].begin();
        for (int i = k + 1; i < n; i+= k) {
            int t1 = upper_bound(p[j].begin(), p[j].end(), i + k - 1) - lower_bound(p[j].begin(), p[j].end(), i);
            //cout << j << " " << k << " " << t << " " << t1 << endl;
            f &= (t == t1);
        }
        //cout << endl;
    }
    //cout << endl;
    return f;
}


int main()
{
    string s;
    cin >> s;
    n = s.size();
    p.resize(26);
    for (int i = 0; i < n; i++) {
        p[s[i] - 'a'].push_back(i + 1);
    }
    int mn = INF;
    for (int i = 1; i * i <= n; i++) {
        if (n % i) continue;
        if (check(i)) {
            mn = min(mn, i);
        }
        if (check(n / i)) {
            mn = min(mn, n / i);
        }
    }
    cout << n / mn;
    return 0;
}
