#include <iostream>
#include <vector>

using namespace std;

vector <long long> sum;
vector <int> sz, mn;
vector <vector <int> > g;
vector <int> a;

const int INF = 1e9;

long long dfs(int v) {
    sz[v] = 0;
    mn[v] = INF;
    long long ans = 0;
    int m = INF;
    for (int u : g[v]) {
        ans += dfs(u);
        sum[v] += sum[u];
        sz[v] += sz[u];
        mn[v] = min(mn[v], mn[u]);
    }
    ans += sum[v];
    int id = -1;
    for (int u : g[v]) {
        if (2 * sz[u] > sz[v]) {
            id = u;
        }
        else {
            m = min(m, mn[u]);
        }
    }
    if (id != -1) {
        int d = 2 * sz[id] - sz[v];
        ans += m * d;
    }
    else if (sz[v] % 2) {
        ans += m;
    }
    sz[v]++;
    sum[v] += a[v];
    mn[v] = min(mn[v], a[v]);
    return ans;
}

int main()
{
    int n;
    cin >> n;
    a.resize(n);
    sum.resize(n);
    sz.resize(n);
    mn.resize(n);
    g.resize(n);
    for (int i = 1; i < n; i++) {
        int v;
        cin >> v;
        v--;
        g[v].push_back(i);
    }
    for (int i = 1; i < n; i++) {
        cin >> a[i];
    }
    cout << dfs(0);
    return 0;
}
