#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define fi first
#define se second
#define endl '\n'
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

int alph = 26;

bool check(string s, int n) {
    //cout << "s = " << s << " n = " << n << endl;
    vector <int> cnt(alph);
    for (auto c : s)
        cnt[c - 'a']++;
    int cntt = 0;
    int k = s.size() / n;
    for (int i = 0; i < s.size(); i += n) {
        vector <int> cnt2(alph);
        for (int j = i; j < i + n; ++j) {
            cnt2[s[j] - 'a']++;
        }
        for (int j = 0; j < alph; ++j) {
            if (cnt[j] / k != cnt2[j]) {
                return false;
            }
        }
    }
    //cout << "n = " << n << endl;
    return true;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    string s;
    cin >> s;
    int n = s.size();
    vector <int> cnt(alph);
    bool flag = true;
    for (auto c : s) {
        cnt[c - 'a']++;
    //mapa[cnt]++;
        if (c != 'a' && c != 'b')
            flag = false;
    }
    if (flag)
        alph = 2;
    int a = n;
    for (auto x : cnt) {
        a = __gcd(a, x);
    }
    int p = 1;
    int ans = 1;
    while (p * p <= a) {
        if (a % p == 0) {
            if (check(s, n / p)) {
                ans = max(ans, p);
            }
            if (p * p != a) {
                if (check(s, n / (a / p))) {
                    ans = max(ans, a / p);
                    break;
                }
            }
        }
        ++p;
    }
    cout << ans << endl;
    return 0;
}
