#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

/*
----------------------------------------------------------

- ,  
- ,     ?

----------------------------------------------------------

       ,
    .

----------------------------------------------------------

    ,    
 

----------------------------------------------------------

      ,
   :
- ,  ?
- , 

----------------------------------------------------------

     ,       ,
        

----------------------------------------------------------

-   
-   
-   
-   
-  ?
-  

----------------------------------------------------------

      
  

----------------------------------------------------------
*/

struct node{
    int to;
    int size;
    int val;
    vector<int> prev;
};

vector<node> a;
int ans = 0;

void dfs(int v) {
    for (int u : a[v].prev) {
        dfs(u);
        a[v].size += a[u].size;
    }
}

int count(int v) {
    vector<int> kektor;
    for (int u : a[v].prev) {
        kektor.push_back(a[u].size);
    }
    sort(kektor.begin(), kektor.end());
    int cnt = 0;
    if (kektor.size() == 3 && kektor[0] == kektor[1] + 1 && kektor[1] == kektor[2]) {
        cnt = 1;
    }
    int l = 0;
    int r = kektor.size() - 1;
    while (r - l > 0) {
        if (kektor[l] < kektor[r]) {
            cnt += kektor[l] * 2;
            kektor[r] -= kektor[l];
            l++;
        }
        else if (kektor[l] == kektor[r]) {
            cnt += kektor[l] * 2;
            l++;
            r--;
        }
        else {
            cnt += kektor[r] * 2;
            kektor[l] -= kektor[r];
            r--;
        }
    }
    if (r == l) {
        cnt += kektor[l] * 2;
    }
    return cnt;
}

void dfs2(int v) {
    for (int u : a[v].prev) {
        dfs2(u);
        //cout << v << " " << count(v) << endl;
    }
    ans += count(v);
}

void main25() {
    int n;
    cin >> n;
    a.resize(n);
    a[0].to = -1;
    a[0].val = 0;
    a[0].size = 1;
    for (int i = 1; i < n; ++i) {
        cin >> a[i].to;
        a[i].to--;
        a[a[i].to].prev.push_back(i);
        a[i].size = 1;
    }
    for (int i = 1; i < n; ++i) {
        cin >> a[i].val;
        if (a[i].val != 1) {
            cout << 25;
            return;
        }
    }
    dfs(0);
    dfs2(0);
    cout << ans;
    return;
}

int main()
{
    main25();
    return 0;
}
