#include <iostream>
#include <string>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <utility>
#include <sstream>
using namespace std;
typedef long long ll;

#define forn(i, n) for (int (i) = 0; (i) < (n); (i)++)
#define fors(i, s, n) for (int (i) = (s); (i) < (n); (i)++)
#define all(v) v.begin(), v.end()

int gcd(int a, int b) {
    if (!b) return a;
    return gcd(b, a % b);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
    string s;
    cin >> s;
    int n = s.size();
    vector<int> cnt(26);
    forn(i, s.size()) {
        cnt[s[i] - 'a']++;
    }
    int g = cnt[s[0] - 'a'];
    forn(i, 26) {
        g = gcd(g, cnt[i]);
    }
    vector<int> vars;
    fors(i, 1, g + 1) {
        if (!(g % i)) {
            vars.push_back(i);
        }
    }
    vector<vector<int>> sums(n + 1, vector<int>(26));
    forn(i, n) {
        sums[i + 1] = sums[i];
        sums[i + 1][s[i] - 'a']++;
    }
    reverse(all(vars));
    forn(i, vars.size()) {
        int v = vars[i];
        if (n % v) continue;
        int l = n / v;
        bool good = true;
        forn(i, v) {
            int lft = i * l;
            int rgh = (i + 1) * l;
            forn(j, 26) {
                int tcnt = sums[rgh][j] - sums[lft][j];
                if (cnt[j] && !tcnt || tcnt && (cnt[j] % tcnt || cnt[j] / tcnt != v)) {
                    good = false;
                    break;
                }
            }
            if (!good) break;
        }
        if (good) {
            cout << v << endl;
            break;
        }
    }
#ifdef _MSC_VER
	system("pause");
#endif
	return 0;
}