#include <iostream>
#include <string>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <utility>
#include <sstream>
using namespace std;
typedef long long ll;

#define forn(i, n) for (int (i) = 0; (i) < (n); (i)++)
#define fors(i, s, n) for (int (i) = (s); (i) < (n); (i)++)
#define all(v) v.begin(), v.end()
vector<vector<int>> g;
vector<vector<int>> sum;
vector<int> c;

int dfs(int v) {
    int s = 1;
    forn(i, g[v].size()) {
        int p = g[v][i];
        int a = dfs(p);
        sum[v][i] = a;
        s += a;
    }
    return s;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
    int n;
    cin >> n;
    g.resize(n);
    sum.resize(n);
    c.resize(n);
    forn(i, n - 1) {
        int a;
        cin >> a;
        a--;
        g[a].push_back(i + 1);
        sum[a].push_back(0);
    }
    forn(i, n - 1) {
        cin >> c[i + 1];
    }
    dfs(0);
    ll answ = 0;
    forn(i, n) {
        sort(all(sum[i]));
        if (sum[i].size()) {
            int t = 0;
            forn(j, (int)sum[i].size() - 1) {
                int v = sum[i][j];
                t += v;
                sum[i][j] = 0;
                sum[i][j + 1] -= v;
            }
            t += sum[i].back();
            answ += t * 2;
        }
    }
    cout << answ << endl;
#ifdef _MSC_VER
	system("pause");
#endif
	return 0;
}