#include <iostream>
#include <bits/stdc++.h>
#define ll long long
using namespace std;

ll gcd(ll a,ll b)
{
    while(b)
    {
        a%=b;
        swap(a,b);
    }
    return a;
}
struct pt{double x,y;};
struct line{ll a,b,c;};

ll det(ll a,ll b,ll c,ll d) {return a*d-b*c;}

bool intr(line n,line m,pt&res)
{
    ll zn=det(m.a,m.b,n.a,n.b);
    if(zn!=0)
    {
        res.x=-1.0*(double)det(m.c,m.b,n.c,n.b)/zn;
        res.y=-1.0*(double)det(m.a,m.c,n.a,n.c)/zn;
        return true;
    }
    return false;
}

line getl(pt p,pt q)
{
    line ans;
    ans.a=p.y-q.y;
    ans.b=q.x-p.x;
    ans.c=-ans.a*p.x-ans.b*p.y;
    if(ans.a<0) ans.a*=-1,ans.b*=-1,ans.c*=-1;
    if((ans.a==0)&&(ans.b<0)) ans.b*=-1,ans.c*=-1;
    ll g=gcd(gcd(labs(ans.a),labs(ans.b)),labs(ans.c));
    ans.a/=g,ans.b/=g,ans.c/=g;
    return ans;
}

bool cmp(const line &p, const line &q)
{
    return ((p.a<q.a)||((p.a==q.a)&&(p.b<q.b))||((p.a==q.a)&&(p.b==q.b)&&(p.c<q.c)));
}


vector<pt>xy;
int n;
pt ans;
bool ok=0;


void check(ll x0,ll y0)
{
    //cout<<x0<<' '<<y0<<'\n';
    pt moon;
    moon.x=x0,moon.y=y0;
    vector<line> mas(n);
    for(int i=0;i<n;++i)
    {
        if((xy[i].x==moon.x)&&(xy[i].y==moon.y)) return;
        mas[i]=getl(moon,xy[i]);
    }
//for(int i=0;i<n;++i) cout<<mas[i].a<<' '<<mas[i].b<<' '<<mas[i].c<<'\n';
    sort(mas.begin(),mas.end(),&cmp);

    bool good=1;
    for(int i=0;i<n;i++)
    {
        if(((mas[i].a!=mas[i+1].a)||(mas[i].b!=mas[i+1].b)||(mas[i].c!=mas[i+1].c))&&(!(i%2))) good=0;
        if(((mas[i].a==mas[i+1].a)&&(mas[i].b==mas[i+1].b)&&(mas[i].c==mas[i+1].c))&&(i%2)) good=0;
    }
    if(good) /*cout<<"^^^",*/ok=1,ans=moon;

    //cout<<"*\n";
}
int main()
{
   cin>>n;
   n*=2;
   xy.resize(n);
   for(int i=0;i<n;++i)
   {
       ll x,y;
       cin>>x>>y;
       xy[i].x=x,xy[i].y=y;
   }

   for(int i=2;i<n;++i)
   {
       for(int j=2;j<n;++j)
       {
           if(i==j) continue;
           line m,n;
           m=getl(xy[0],xy[i]);
           n=getl(xy[1],xy[j]);
           pt q;
           if(!intr(m,n,q)) {continue;}
           ll x0=(ll)q.x, y0=(ll)q.y;
           //cout<<i<<' '<<j<<' '<<n.a<<' '<<n.b<<' '<<n.c<<' '<<m.a<<' '<<m.b<<' '<<m.c<<' ';
           if((abs(q.x-(double)x0)<1e-9)&&(abs(q.x-(double)x0)<1e-9)) /*cout<<i<<' '<<j<<' ',*/check(x0,y0);
           if(ok) break;
          // cout<<" \n";
       }
   }
//cout<<'*';
   for(int i=2;i<n;++i)
   {
       for(int j=i+1;j<n;++j)
       {
           line m,n;
           m=getl(xy[0],xy[1]);
           n=getl(xy[i],xy[j]);
           pt q;
           if(!intr(m,n,q)) continue;
           ll x0=(ll)q.x, y0=(ll)q.y;
           if((abs(q.x-(double)x0)<1e-9)&&(abs(q.x-(double)x0)<1e-9)) check(x0,y0);
           if(ok) break;
       }
   }
   if(!ok) cout<<"No";
   else cout<<"Yes\n"<<(ll)ans.x<<' '<<(ll)ans.y;

    return 0;
}


/*
2
0 100
0 -10
100 0
1 0

*/
