#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 200000 + 20;

int p[MAXN], c[MAXN];
int n;
bool used[MAXN] = {};

vector < vector <int> > g;
vector <int> order;

typedef long long ll;

const ll INF = ll(1e18);

ll ans = 0;

vector <ll> k;
vector <ll> v_min;
vector <ll> sum;

void dfs(int v) {
    used[v] = true;
    for (size_t i = 0; i < g[v].size(); i++) {
        int to = g[v][i];
        if (!used[to])
            dfs(to);
    }
    order.push_back(v);
}

void gen(int v) {
    //cout << "gen" << v << " " << ans << endl;
    if (g[v].size() == 0) {
        sum[v] = c[v]; k[v] = 1;
        v_min[v] = min(v_min[v], 1LL * c[v]);
        return;
    }
    //cout << "kokoko" << v << endl;
    for (size_t i = 0; i < g[v].size(); i++) {
        sum[v] += sum[g[v][i]];
        v_min[v] = min(v_min[v], v_min[g[v][i]]);
        k[v] += k[g[v][i]];
    }
    //cout << sum[v] << " " << v_min[v] << " " << k[v] << " " << endl;
    //cout << "kokoko" << v << endl;
    int ind_min = -1;
    for (size_t i = 0; i < g[v].size(); i++)
        if (v_min[v] == v_min[g[v][i]]) {
            ind_min = i; break;
        }
    //cout << "kokoko" << v << " " << ind_min << endl;
    if (k[v] - k[g[v][ind_min]] < k[g[v][ind_min]]) {
        ll cur_min = INF;
        for (size_t i = 0; i < g[v].size(); i++)
            if (g[v][i] != ind_min)
                cur_min = min(cur_min, v_min[g[v][i]]);
        ll cur_k = k[g[v][ind_min]] * 2LL - k[v];
        ans += cur_min * cur_k;
    }
    else {
        int ind_max = 0;
        for (size_t i = 1; i < g[v].size(); i++)
            if (k[g[v][ind_max]] < k[g[v][i]])
                ind_max = i;
        //cout << "kokoko ind_max" << v << " " << ind_max << endl;
        if (k[v] - k[g[v][ind_max]] < k[g[v][ind_max]]) {
            ll cur_k = k[g[v][ind_max]] * 2LL - k[v];
            ans += v_min[v] * cur_k;
        } else {
            ans += (k[v] % 2) * v_min[v];
        }
    }
    ans += sum[v];
    v_min[v] = min(v_min[v], 1LL * c[v]);
    k[v]++; sum[v] += c[v];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin >> n; g.resize(n);
    for (int x, i = 0; i < n - 1; i++) {
        cin >> x; x--;
        g[x].push_back(i + 1);
    }

    for (int i = 0; i < n - 1; i++) {
        cin >> c[i + 1];
    }

    dfs(0);

    k.assign(n, 0);
    v_min.assign(n, INF);
    sum.assign(n, 0);
    for (int i = 0; i < n; i++)
        gen(order[i]);//,cout << order[i] << " " << ans << endl;;

    cout << ans << endl;
/*
    for (int i = 0; i < n; i++)
        cout << i << " : " << k[i] << " : " << v_min[i] << " " << sum[i] << endl;
*/
    return 0;
}
