#include <algorithm>
#include <cassert>
#include <fstream>
#include <utility>
#include <bitset>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <map>
#include <set>

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, C b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, C b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

ll Solve(ll n, ll i) {
    if (n == 1) return 1;
    if (i % 2) return (i + 1) / 2;
    if (n % 2) return Solve((n + 1) / 2, i / 2 + 1) + n / 2;
    return Solve(n / 2, i / 2) + n / 2;
}

int main() {
    ll n, q;
    cin >> n >> q;
    for (int i = 0; i < q; ++i) {
        ll c;
        cin >> c;
        cout << Solve(n, c) << '\n';
    }
}

