#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fr first
#define sc second
#define pb push_back
#ifdef TDEF
#define __int128 ll
#endif

const int inf = 1e9 + 88;
const ll infll = 1e18 + 88;
const ld eps = 1e-9;

bool ldeq(ld a, ld b){return fabs(a - b) < eps;}

const int maxn = 5e6 + 88;

string s;
int n;

struct pd
{
    int cnt[26];
};

bool operator<(const pd& lhs, const pd& rhs)
{
    bool t = 1;
    for (int i = 0; i < 26; i++)
    {
        t &= (lhs.cnt[i] == rhs.cnt[i]);
    }
    return !t;
}

set<pd> se;

bool check(int sz)
{
    se.clear();
    for (int i = 0; i < n; i += sz)
    {
        pd t;
        for (int j = 0; j < 26; j++)
            t.cnt[j] = 0;
        for (int j = i; j < i + sz; j++)
        {
            t.cnt[s[j] - 'a']++;
        }
        se.insert(t);
    }
    return se.size() == 1;
}

int cnt[maxn][2];

void prepab()
{
    int cnta = 0;
    int cntb = 0;
    for (int i = 0; i < n; i++)
    {
        if (s[i] == 'a')
            cnta++;
        else
            cntb++;
        cnt[i + 1][0] = cnta;
        cnt[i + 1][1] = cntb;
    }
}

pair<int, int> getcountab(int l, int r)
{
    return {cnt[r][0] - cnt[l][0], cnt[r][1] - cnt[l][1]};
}

bool checkab(int sz)
{
    pair<int, int> tcnt = getcountab(0, sz);
    for (int i = sz; i < n; i += sz)
    {
        if (tcnt != getcountab(i, i + sz))
            return false;
    }
    return true;
}

void solve()
{
    cin >> s;
    n = s.size();
    bool ab = true;
    for (int i = 0; i < n; i++)
    {
        if (s[i] != 'a' && s[i] != 'b')
        {
            ab = false;
            break;
        }
    }
    if (ab)
    {
        prepab();
        int maxc = 1;
        for (int i = 1; i * i <= n; i++)
        {
            if (n % i == 0 && (n / i > maxc) && checkab(i))
                maxc = n / i;
            if (n % i == 0 && (i > maxc) && checkab(n / i))
                maxc = i;
        }
        cout << maxc;
        return;
    }
    int maxc = 1;
    for (int i = 1; i * i <= n; i++)
    {
        if (n % i == 0 && (n / i > maxc) && check(i))
            maxc = n / i;
        if (n % i == 0 && (i > maxc) && check(n / i))
            maxc = i;
    }
    cout << maxc;
}

//#define testgen

void testgen()
{

}

int main()
{
    ios_base::sync_with_stdio(0);
    #ifdef testgen
    freopen("input.txt", "w", stdout);
    #else
    freopen("input.txt", "r", stdin);
    #endif // testgen
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
