#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <iterator>
#include <algorithm>
#include <numeric>
#include <list>
#include <queue>
#include <iomanip>
#define fr first
#define sc second
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

const int maxn = 2*1e5+123;
const int inf = 1e9;
const int N = 17;

string s;
vector<int> d[26];
int a[26], n;

bool check(int p)
{
    int dl = 0;
    for(int i=0; i<26; i++) {
        dl += a[i]/p;
    }
    int m = n/dl;
    for(int i=0; i<m; i++) {
        for(int j=0; j<26; j++) {
            int t = 0;
            if(i) t -= d[j][i*dl-1];
            t += d[j][(i+1)*dl-1];
            if(t != a[j]/p) {
                return 0;
            }
        }
    }
    return 1;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin >> s;
    n = s.size();
    for(int i=0; i<26; i++) d[i].resize(n);
    for(int i=0; i<n; i++) {
        a[s[i]-'a']++;
        if(i) {
            for(int j=0; j<26; j++) {
                d[j][i] = d[j][i-1];
            }
        }
        d[s[i]-'a'][i]++;
    }
    int g = -1;
    for(int i=0; i<26; i++) {
        if(!a[i]) continue;
        if(g == -1) g = a[i];
        else g = __gcd(g, a[i]);
    }
    int ans = 0;
    for(int i=1; i*i<=g; i++) {
        if(check(i)) ans = max(ans, i);
        if(check(g/i)) ans = max(ans, g/i);
    }
    cout << ans << endl;
    return 0;
}
