#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <iterator>
#include <algorithm>
#include <numeric>
#include <list>
#include <queue>
#include <iomanip>
#define fr first
#define sc second
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

const int maxn = 5*1e2+123;
const int maxm = 1e2+123;
const int inf = 1e9;
const int N = 17;

string s;
vector<int> del, d;
int mr[maxm][30];
int a[26], n, mx;

bool check(int p, int j)
{
    int dl = 0;
    for(int i=0; i<mx; i++) {
        dl += a[i]/p;
    }
    int m = n/dl;
    for(int i=0; i<m; i++) {
        int t = 0;
        if(i) t -= d[i*dl-1];
        t += d[(i+1)*dl-1];
        if(t != a[j]/p) {
            return 0;
        }
    }
    return 1;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin >> s;
    n = s.size();
    d.resize(n);
    for(int i=0; i<n; i++) {
        a[s[i]-'a']++;
    }
    int g = -1;
    mx = 26;
    for(int i=0; i<mx; i++) {
        if(!a[i]) continue;
        if(g == -1) g = a[i];
        else g = __gcd(g, a[i]);
    }
    for(int i=1; i*i<=g; i++) {
        if(g%i == 0) {
            del.pb(i);
            if(i != g/i) del.pb(g/i);
        }
    }
    sort(del.begin(), del.end());
    mx = 26;
    for(int j=0; j<26; j++) {
        if(!a[j]) continue;
        d.assign(n, 0);
        for(int i=0; i<n; i++) {
            if(i) d[i] = d[i-1];
            if(s[i]-'a' == j) d[i]++;
        }
        for(int i=0; i<del.size(); i++) {
            mr[i][j] = check(del[i], j);
        }
    }
    int ans = 0;
    for(int i=0; i<del.size(); i++) {
        int flag = 1;
        for(int j=0; j<26; j++) {
            if(!a[j]) continue;
            if(!mr[i][j]) {
                flag = 0;
                break;
            }
        }
        if(flag) ans = max(del[i], ans);
    }
    cout << ans << endl;
    return 0;
}
