#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <iterator>
#include <algorithm>
#include <numeric>
#include <list>
#include <queue>
#include <iomanip>
#define fr first
#define sc second
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

const int maxn = 2*1e5+123; ///!!!
const int inf = 1e9;

ll ans, b[maxn], a[maxn], c[maxn], sum[maxn];
int cnt[maxn], p[maxn], n;
vector< vector<int> > g;

void dfs(int v, int pr)
{
    int mt = 0, mn = inf, cn = 0, cur;
    for(int i=0; i<g[v].size(); i++) {
        int to = g[v][i];
        if(to == pr) continue;
        dfs(to, v);
        if(mt == 0) {
            cur = cnt[to]+1;
            mt = 1;
        }
        else {
            ans += (cur+cnt[to])*2;
        }
        mn = min(mn, cnt[to]+1);
        cn++;
        cnt[v] += cnt[to]+1;
    }
    if(cn%2) ans += 2*cur;
}


int main()
{
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> n;
    g.resize(n);
    int u;
    for(int i=1; i<n; i++) {
        cin >> u;
        u--;
        g[u].pb(i);
        g[i].pb(u);
    }
    for(int i=1; i<n; i++) {
        cin >> c[i];
    }
    dfs(0, -1);
    cout << ans;
    return 0;
}
