#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

ll cur = 0;

vector<vector<int> > E;
const int dd = (int)2e5 + 7;
int c[dd], p[dd];

int dfs(int v) {
	int sz = 1;
	int maxC = 0;
	for (int to : E[v]) {
		int t = dfs(to);
		sz += t;
		maxC = max(maxC, t);
	}
	cur += max(maxC, sz / 2) * 2;
	return sz;
}

int main() {
	int n;
	cin >> n;
	
	E.resize(n);
	
	for (int i = 1; i < n; i++) {
		cin >> p[i];
		p[i]--;
		E[p[i]].push_back(i);
	}
	
	int ok = 1;
	for (int i = 1; i < n; i++) {
		cin >> c[i];
		ok &= (c[i] == 1);
	}
	
	dfs(0);
	cout << cur << "\n";
	
	return 0;
} 