#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

#define MAX(a, b) (((a) > (b)) ? (a): (b))
#define MIN(a, b) (((a) < (b)) ? (a): (b))
#define m_p make_pair
#define m_t make_tuple
#define ft first
#define sd second
#define ll long long
#define forn(i, j, n) for(ll i = j; i < n; ++i)
#define forc(i, n, j) for(ll i = n-1; i >= j; --i)
#define forr(i, j, n, d) for(auto i = j; i != n; d)

using namespace std;

vector<long> pos[26];
long cnt_a[26];
long temp_cnt[26];
string s;
long len, gr;

long gcd(long a, long b) {
	while (b != 0) {
		a %= b;
		swap(a, b);
	}
	return a;
}

void build() {
	forn(u, 0, len) {
		pos[s[u]-'a'].push_back(u);
	}
	forn(u, 0, 26) {
		cnt_a[u] = pos[u].size();
	}
	gr = cnt_a[0];
	forn(u, 1, 26) {
		gr = gcd(gr, cnt_a[u]);
	}
}

long bound(long l, long r, long x, long num) {
	if (r == 0) return 0;
	while (l != r - 1) {
		long mid = (l + r) / 2;
		if (pos[num][mid] > x) r = mid;
		else l = mid;
	}
	if (pos[num][l] < x) ++l;
	return l;
}

long cnt(int a, long l, long r) {
	return bound(0, pos[a].size(), r, a) - bound(0, pos[a].size(), l, a);
}

int main()
{
	cin >> s; len = s.size();
	build();

	forc(kol, gr+1, 1) {
		if (len % kol == 0) {
			bool test = true;
			forn(c, 0, 26) {
				if (cnt_a[c] % kol != 0) {
					test = false; break;
				}
			}

			if (test) {
				forn(c, 0, 26) {
					temp_cnt[c] = cnt_a[c] / kol;
				}
				test = true;
				for (long j = 0; j < len; j+=len/kol) {
					forn(c, 0, 26) {
						long prob_c = cnt(c, j, j + len/kol);
						if (prob_c != temp_cnt[c]) {
							test = false; break;
						}
					}
					if (!test) break;
				}
				if (test) {
					cout << kol << endl; break;
				}
			}
		}
	}

	cin >> s;
	return 0;
}