import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class A {

    public int n, q;
    public int[] a;

    public TreeSet<Integer> filled;
    public TreeSet<Integer> empty;

    public void solve() throws IOException {
        n = nextInt();
        q = nextInt();
        filled = new TreeSet<>();
        empty = new TreeSet<>();
        a = new int[2 * n];
        int cur = 1;
        for (int i = 0; i < 2 * n; i++) {
            if (i % 2 == 0) {
                a[i] = cur++;
                filled.add(i);
            } else {
                empty.add(i);
            }
        }
        while (empty.first() < n) {
            int indFrom = filled.pollLast();
            int indTo = empty.lower(indFrom);
            empty.remove(indTo);
            empty.add(indFrom);
            filled.add(indTo);
            a[indTo] = a[indFrom];
            a[indFrom] = 0;
        }
        for (int i = 0; i < q; i++) {
            int x = nextInt() - 1;
            out.println(a[x]);
        }
    }

    public void run() throws IOException {
        br = new BufferedReader(new FileReader("input.txt"));
        out = new PrintWriter(System.out);
        solve();
        br.close();
        out.close();
    }

    public String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(br.readLine());
        }
        return tokenizer.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public BufferedReader br;
    public PrintWriter out;
    public StringTokenizer tokenizer;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new A().run();
    }
}
