//#include "stdafx.h"
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i, n) for (int i = 0; i < n; i++)
#define endl '\n'
#define mp make_pair

const int alph = 26;
const ll mod1 = 999999751ll;
const ll mod2 = 1000000103ll;
const ll p1 = 999907ll;
const ll p2 = 1000121ll;

ll p1_pows[alph];
ll p2_pows[alph];

int main()
{
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
	srand(1373737);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	p1_pows[0] = p1;
	p2_pows[0] = p2;
	for (int i = 1; i < alph; i++)
	{
		p1_pows[i] = (p1_pows[i - 1] * p1) % mod1;
		p2_pows[i] = (p2_pows[i - 1] * p2) % mod2;
	}

	string s;
	cin >> s;

	ll n = (ll)s.size();

	vector <ll> divs;
	for (ll i = 1ll; i * i <= n; i++)
	{
		if (n % i == 0ll)
		{
			divs.push_back(i);
			if (n / i != i)
				divs.push_back(n / i);
		}
	}

	forn(t, (int)divs.size())
	{
		int d = divs[t];
		pair <ll, ll> pat;
		forn(i, d)
		{
			pat.first = (pat.first + p1_pows[s[i] - 'a']) % mod1;
			pat.second = (pat.second + p2_pows[s[i] - 'a']) % mod2;
		}

		pair <ll, ll> now;
		bool flag = true;
		for (int i = d, cur = 0; i < n; i++, cur = (cur + 1) % d)
		{
			now.first = (now.first + p1_pows[s[i] - 'a']) % mod1;
			now.second = (now.second + p2_pows[s[i] - 'a']) % mod2;

			if (cur == d - 1)
			{
				flag &= (now == pat);
				now = mp(0ll, 0ll);
			}

			if (!flag)
				break;
		}
		if (flag)
		{
			cout << n / d;
			return 0;
		}
	}
	cout << "1";

	return 0;
}