#include "stdafx.h"
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i, n) for (int i = 0; i < n; i++)
#define endl '\n'
#define mp make_pair

const int alph = 26;
const int MAXN = (int)5e+3 + 5;
vector <int> h[MAXN];

inline vector <int> sub(const vector <int> &a, const vector<int> &b)
{
	vector <int> res(alph);
	forn(i, alph)
		res[i] = a[i] - b[i];
	return res;
}

inline vector <int> sum(const vector <int> &a, const vector<int> &b)
{
	vector <int> res(alph);
	forn(i, alph)
		res[i] = a[i] + b[i];
	return res;
}

int main()
{
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
	srand(1373737);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	forn(i, MAXN)
		h[i].resize(alph);

	string s;
	cin >> s;
	int n = (int)s.size();
	s = '$' + s;
	for (int i = 1; i <= n; i++)
	{
		h[i] = h[i - 1];
		h[i][s[i] - 'a']++;
	}

	vector <int> pat;
	for (int d = 1; d <= n; d++)
	{
		if (n % d != 0)
			continue;

		bool flag = true;
		pat = h[d];
		for (int i = 2 * d; i <= n; i += d)
		{
			flag &= (sub(h[i], h[i - d]) == pat);
			if (!flag)
				break;
		}
		
		if (flag)
		{
			cout << n / d;
			return 0;
		}
	}

	return 0;
}