//#include "stdafx.h"
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i, n) for (int i = 0; i < n; i++)
#define endl '\n'
#define mp make_pair

const int inf = (int)1e+9;

ll ans = 0ll;
vector <ll> arr, sum;
vector <int> w, minc;
vector < vector<int> > g;

void dfs(int v)
{
	int maxw = 0, imaxw = -1;
	forn(i, (int)g[v].size())
	{
		int to = g[v][i];
		dfs(to);
		if (w[to] + 1 > maxw)
		{
			maxw = w[to] + 1;
			imaxw = to;
		}
		w[v] += w[to] + 1;
		sum[v] += sum[to] + arr[to];
		minc[v] = min(minc[v], min(minc[to], (int)arr[to]));
	}
	if (maxw <= w[v] - maxw)
	{
		if (w[v] % 2 == 0)
			ans += sum[v];
		else
			ans += sum[v] + (ll)minc[v];
	}
	else
	{
		int nowminc = inf;
		forn(i, (int)g[v].size())
		{
			int to = g[v][i];
			if (to == imaxw)
				continue;
			nowminc = min(nowminc, min(minc[to], (int)arr[to]));
		}
		ans += sum[v];
		ans += (ll)(maxw - (w[v] - maxw)) * 1ll * (ll)nowminc;
	}
}

int main()
{
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
	srand(1373737);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n, x;
	cin >> n;

	sum.resize(n);
	minc.resize(n, inf);
	w.resize(n);
	arr.resize(n);
	g.resize(n);

	for (int i = 1; i < n; i++)
	{
		cin >> x;
		g[x - 1].push_back(i);
	}
	for (int i = 1; i < n; i++)
		cin >> arr[i];

	dfs(0);
	cout << ans;

	return 0;
}