#include <bits/stdc++.h>

using namespace std;

void dfs (int u, vector <vector <int>> & g, int & p, vector <int> & c) {
    p++;
    for (auto elem : g[u]) {
        dfs(elem, g, p, c);
    }
}

long long get_res (int i, vector <vector <int>> & g, vector <int> & c) {
     vector <int> p((int)g[i].size());
     int k = 0;
     set <int> unused;
     for (int j = 0; j < (int)g[i].size(); ++j) {
        dfs(g[i][j], g, p[j], c);
     }
     sort(p.rbegin(), p.rend());

     long long res = 0;
     if ((int)p.size() > 0) {
     while (true) {
        if (p[0] == 0)
            break;
        else if (p[1] != 0) {
                res += p[1] + p[1];
                p[0] -= p[1]; p[1] = 0;
                sort(p.rbegin(), p.rend());
        }
        else {
            res += p[0] * 2;
            p[0] = 0;
        }
     }
     }
     return res;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n; cin >> n;
    vector <vector <int>> g(n);
    for (int i = 1; i < n; ++i) {
        int v; cin >> v; --v;
        g[v].push_back(i);
    }

    vector <int> c(n);
    for (int i = 1; i < n; ++i)
        cin >> c[i];

    long long res = 0;
    for (int i = 0; i < n; ++i)
    {
    res += get_res(i, g, c);
    }
    cout << res << endl;

    return 0;
}