#include<bits/stdc++.h>
#define int long long
#define pb push_back
#define ld long double
#define F first
#define S second
using namespace std;

struct Point
{
    int x, y;
};

struct Line
{
    int a, b, c;
    Line(Point x, Point y)
    {
        a = y.y - x.y;
        b = x.x - y.x;
        c = -(a * x.x + b * x.y);
    }
};

Point inter(Line ab, Line cd)
{
    Point moon;
    moon.y = - (cd.c * ab.a - ab.c * cd.a) / (cd.b * ab.a - cd.a * ab.b);
    moon.x = (-ab.b * moon.y - ab.c) / ab.a;
    return moon;
}

inline void solve()
{
    int n;
    cin >> n;
    Point p[2 * n];
    for(int i = 0; i < 2 * n; i++)
    {
        cin >> p[i].x >> p[i].y;
    }
    for(int i = 2; i < 2 * n; i++)
    {
        for(int j = 2; j < 2 * n; j++)
        {
            if(i != j)
            {
                Line ab(p[0], p[i]), cd(p[1], p[j]);
                if((ab.a == cd.a && ab.b == cd.b) || (cd.b * ab.a - cd.a * ab.b != 0 && (cd.c * ab.a - ab.c * cd.a) % (cd.b * ab.a - cd.a * ab.b) != 0))
                {
                    continue;
                }
                else
                {
                    Point moon = inter(ab, cd);
                    bool can = 1;
                    for(int z = 2; z < 2 * n; z++)
                    {
                        if(z != i && z != j)
                        {
                            int am = 0;
                            for(int k = 0; k < 2 * n; k++)
                            {
                                Line now(p[k], p[z]);
                                if(now.a * moon.x + now.b * moon.y + now.c == 0)
                                {
                                    am++;
                                }
                            }
                            can &= (am == 1);
                        }
                    }
                    if(can)
                    {
                        cout << "Yes\n" << moon.x << " " << moon.y << "\n";
                        return;
                    }
                }
            }
        }
    }
    swap(p[1], p[2]);
    for(int i = 2; i < 2 * n; i++)
    {
        for(int j = 2; j < 2 * n; j++)
        {
            if(i != j)
            {
                Line ab(p[0], p[i]), cd(p[1], p[j]);
                if((ab.a == cd.a && ab.b == cd.b) || (cd.b * ab.a - cd.a * ab.b != 0 && (cd.c * ab.a - ab.c * cd.a) % (cd.b * ab.a - cd.a * ab.b) != 0))
                {
                    continue;
                }
                else
                {
                    Point moon = inter(ab, cd);
                    bool can = 1;
                    for(int z = 2; z < 2 * n; z++)
                    {
                        if(z != i && z != j)
                        {
                            int am = 0;
                            for(int k = 0; k < 2 * n; k++)
                            {
                                Line now(p[k], p[z]);
                                if(now.a * moon.x + now.b * moon.y + now.c == 0)
                                {
                                    am++;
                                }
                            }
                            can &= (am == 1);
                        }
                    }
                    if(can)
                    {
                        cout << "Yes\n" << moon.x << " " << moon.y << "\n";
                        return;
                    }
                }
            }
        }
    }
    cout << "No";
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while(t--)
    {
        solve();
    }
    return 0;
}
