#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define ll long long
#define ld long double
#define pii pair <int, int>
#define endl '\n'

using namespace std;

const int N = 2e5 + 5;
const int mod = 1e9 + 7;

vector <int> g[N];
int sz[N];
ll res = 0;

void dfs_sz(int v, int pr){
    sz[v] = 1;
    for (int to : g[v]){
        if (to == pr) continue;
        dfs_sz(to, v);
        sz[v] += sz[to];
    }
}

void dfs(int v, int pr){
    res += (sz[v] - 1) - max(0, (int)g[v].size() - 2);
   // cerr << v << " " << res << " " << sz[v] << " " << g[v].size() << endl;
    for (int to : g[v]){
        if (to == pr) continue;
        dfs(to, v);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n;
    cin >> n;
    g[0].pb(-1);
    for (int i = 0; i < n - 1; i++){
        int x;
        cin >> x;
        x--;
        g[i + 1].pb(x);
        g[x].pb(i + 1);
    }
    for (int i = 0; i < n - 1; i++){
        int x;
        cin >> x;
    }
    dfs_sz(0, -1);
    dfs(0, -1);
    cout << res * 2 << endl;
    return 0;
}


