#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

ll n;

ll calc(ll stage, ll x, ll start_from)
{
    if (stage == 1)
        return start_from;

    if (x % 2 == 0)
        return start_from + (x / 2);
    else if (stage % 2 == 0)
        return calc(stage / 2, (x - 1) / 2, start_from + (stage / 2));
    else
        return calc(stage / 2 + 1, (x - 1) / 2 + 1, start_from + (stage / 2));
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll q, i;
    cin >> n >> q;

    for (i = 0; i < q; i++)
    {
        ll x;
        cin >> x;

        cout << calc(n, x - 1, 1) << endl;
    }

    return 0;
}
