#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

vector<vector<ll>> g;
vector<ll> num, total, sum, minim_val, minim_sub1, minim_sub2;

void count(ll v)
{
    total[v] = 1;
    sum[v] = num[v];
    minim_val[v] = num[v];
    minim_sub1[v] = -1;
    minim_sub2[v] = -1;

    for (ll u : g[v])
    {
        count(u);

        total[v] += total[u];
        sum[v] += sum[u];
        minim_val[v] = min(minim_val[v], minim_val[u]);

        if (minim_sub1[v] == -1 || minim_val[u] < minim_val[minim_sub1[v]])
        {
            minim_sub2[v] = minim_sub1[v];
            minim_sub1[v] = u;
        }
        else if (minim_sub2[v] == -1 || minim_val[u] < minim_val[minim_sub2[v]])
            minim_sub2[v] = u;
    }
}

ll answer(ll v)
{
    for (ll u : g[v])
    {
        if (total[u] > (total[v] - 1 - total[u]))
        {
            if (u == minim_sub1[v])
                return sum[v] - num[v] + (total[u] - (total[v] - 1 - total[u]))
                                           * minim_val[minim_sub2[v]];
            else
                return sum[v] - num[v] + (total[u] - (total[v] - 1 - total[u]))
                                           * minim_val[minim_sub1[v]];
        }
    }

    if ((total[v] - 1) % 2 == 0)
        return sum[v] - num[v];
    else
        return sum[v] - num[v] + minim_val[minim_sub1[v]];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, i;
    cin >> n;

    g.resize(n);
    num.resize(n);
    total.resize(n);
    sum.resize(n);
    minim_val.resize(n);
    minim_sub1.resize(n);
    minim_sub2.resize(n);

    for (i = 0; i < n - 1; i++)
    {
        ll p;
        cin >> p;

        g[p - 1].push_back(i + 1);
    }

    for (i = 0; i < n - 1; i++)
        cin >> num[i + 1];

    count(0);

    ll ans = 0;
    for (i = 0; i < n; i++)
        ans += answer(i);

    cout << ans << endl;

    return 0;
}
