#pragma GCC optimize("Ofast")

//#include "stdafx.h"

#include <fstream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <map>
#include <set>
#include <iomanip>;
#include <stack>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <bitset>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;


#define mp make_pair
#define all(a) a.begin(), a.end()
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)

ll gcd(ll a, ll b) {
    while (b != 0) {
        a %= b;
        swap(a, b);
    }
    return a;
}

const int MAXN = 1e6 + 100;
const int Div = 10;

int n;
int len;
string s;
int cnt[26];
int pref[MAXN / Div][26];

bool check(ll x) {
    vector <int> a(n, -1);
    vector <int> _cnt(26, 0);
    vector <int> num(26, 0);
    for (int i = 0; i < n; i++) {
        int c = s[i] - 'a';
        if (cnt[c] % x != 0) {
            return false;
        }
        if (_cnt[c] % (cnt[c] / x) == 0) {
            num[c]++;
        }
        _cnt[c]++;
        a[i] = num[c];
    }
    for (int i = 1; i < n; i++) {
        if (a[i] < a[i - 1]) {
            return false;
        }
    }
    return true;
}

vector <int> getPref(int x) {
    int t = (x / Div) * Div;
    vector <int> ans(26);
    for (int s = 0; s < 26; s++) {
        ans[s] = pref[t / Div][s];
    }
    for (int i = t + 1; i <= x; i++) {
        int c = s[i - 1] - 'a';
        ans[c]++;
    }
    return ans;
}

int main() {
    i_o;
    cin >> s;
    n = s.size();
    vector <int> now(26);
    for (int i = 0; i < n; i++) {
        int c = s[i] - 'a';
        cnt[c]++;
        now[c]++;
        if (i % Div == 0) {
            for (int j = 0; j < 26; j++) {
                pref[i / Div + 1][j] = now[j];
            }
        }
    }
    int len = n;
    for (int i = 0; i < 26; i++) {
        len = gcd(len, cnt[i]);
    }
    vector <int> d;
    for (int j = 1; j * j <= len; j++) {
        if (len % j == 0) {
            d.push_back(n / j);
            if (j * j != len) d.push_back(n / len * j);
        }
    }
    sort(all(d));
    for (int i = 0; i < d.size(); i++) {
        int add = d[i];
        int cur = 1;
        bool fl = true;
        for (int j = add; j <= n; j += add, cur++) {
            vector <int> a = getPref(j), b = getPref(add);
            for (int s = 0; s < 26; s++) {
                if (a[s] != b[s] * cur) {
                    fl = false;
                    break;
                }
            }
            if (!fl) break;
        }
        if (fl) {
            cout << n / add;
            return 0;
        }
    }
    return 0;
}

