#pragma GCC optimize("Ofast")

//#include "stdafx.h"

#include <fstream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <map>
#include <set>
#include <iomanip>;
#include <stack>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <bitset>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;


#define mp make_pair
#define all(a) a.begin(), a.end()
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)

ll gcd(ll a, ll b) {
    while (b != 0) {
        a %= b;
        swap(a, b);
    }
    return a;
}

int n;
int len;
string s;
int cnt[26];

bool check(ll x) {
    vector <int> a(n, -1);
    vector <int> _cnt(26, 0);
    vector <int> num(26, 0);
    for (int i = 0; i < n; i++) {
        int c = s[i] - 'a';
        if (cnt[c] % x != 0) {
            return false;
        }
        if (_cnt[c] % (cnt[c] / x) == 0) {
            num[c]++;
        }
        _cnt[c]++;
        a[i] = num[c];
    }
    for (int i = 1; i < n; i++) {
        if (a[i] < a[i - 1]) {
            return false;
        }
    }
    return true;
}

void solveAB() {
    n = s.size();
    len = n;
    for (int i = 0; i < 26; i++) {
        len = gcd(len, cnt[i]);
    }

}

int main() {
    i_o;
    bool fl = true;
    cin >> s;
    n = s.size();
    for (int i = 0; i < n; i++) {
        cnt[s[i] - 'a']++;
        if (s[i] != 'a' && s[i] != 'b') {
            fl = false;
        }
    }

    /*
    for (int i = n; i > 0; i--) {
    if (check(i)) {
    cout << i;
    return 0;
    }
    }
    cout << "!!!!!!!!!";
    return 0;
    */
    len = n;
    for (int i = 0; i < 26; i++) {
        len = gcd(len, cnt[i]);
    }

    vector <int> d;
    for (int i = 1; i * i <= len; i++) {
        if (len % i == 0) {
            d.push_back(i);
            if (i * i != len) {
                d.push_back(len / i);
            }
        }
    }
    sort(all(d));
    reverse(all(d));
    for (int i = 0; i < d.size(); i++) {
        if (check(d[i])) {
            cout << d[i];
            return 0;
        }
    }
    return 0;
}

