#pragma GCC optimize("Ofast")

#include "stdafx.h"

#include <fstream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <map>
#include <set>
#include <iomanip>;
#include <stack>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <bitset>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;


#define mp make_pair
#define all(a) a.begin(), a.end()
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)

const ll INF = 1e16;
const int MAXN = 2e5 + 100;
int n;
vector <int> g[MAXN];
ll sz[MAXN], minEl[MAXN], sumC[MAXN], c[MAXN];

void read() {
    cin >> n;
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        g[p - 1].push_back(i);
    }
    for (int i = 1; i < n; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < n; i++) {
        minEl[i] = INF;
    }
}

ll ans = 0;

void dfs(int v, int p = -1) {
    sz[v] = 1, minEl[v] = c[v], sumC[v] = c[v];
    if (g[v].size() == 0) {
        return;
    }
    int heavy = -1;
    for (auto u : g[v]) {
        dfs(u, v);
        sz[v] += sz[u], minEl[v] = min(minEl[v], minEl[u]), sumC[v] += sumC[u];
        if (heavy == -1 || sz[heavy] < sz[u]) {
            heavy = u;
        }
    }
    ll szLight = sz[v] - sz[heavy] - 1;
    if (szLight >= sz[heavy]) {
        ans += sumC[v] - c[v];
        if ((sz[v] - 1) % 2 != 0) {
            ll minV = INF;
            for (auto u : g[v]) {
                minV = min(minV, minEl[u]);
            }
            ans += minV;
        }
        return;
    }
    ans += sumC[v] - c[v];
    ll minV = INF;
    for (auto u : g[v]) {
        if (u != heavy) minV = min(minV, minEl[u]);
    }
    ans += minV * (sz[heavy] - szLight);
    return;
}

void solve() {
    dfs(0);
    cout << ans;
}

int main() {
    i_o;
    read();
    solve();
    return 0;
}

