#include <bits/stdc++.h>

using namespace std;

vector <vector <int> > vec;

bool comp (vector <int> & a, vector <int> & b) {
    for (int j = 0; j < 26; j++) {
        if (a[j] - b[j]) {
            //cout << (char)('a' + j) << ' ' << a[j] << ' ' << b[j] << '\n';
            return false;
        }
    }
    return true;
}

void out(vector <int> & a) {
    for (int j = 0; j < a.size(); j++) {
        cout << a[j] << ' ';
    }
    cout << '\n';
}

void get (int l, int r, vector <int> & a) {
    for (int j = 0; j < 26; j++) {
        if (l)
            a[j] = vec[r][j] - vec[l - 1][j];
        else
            a[j] = vec[r][j];
    }
}

bool ch (int k) {
    vector <int> a(26), b(26);
    //cout << k << ' ';
    k = vec.size() / k;
    //cout << k << '\n';
    get(0, k - 1, a);
    for (int i = k; i <= vec.size() - k; i += k) {
        get(i, i + k - 1, b);
        if (!comp(a, b))
            return false;
    }
    return true;
}

bool god (int i) {
    bool cond = true;
    for (int j = 0; j < 26; j++) {
        if (vec.back()[j] % i) {
            cond = false;
            break;
        }
    }
    if (cond)
        return ch(i);
    return false;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    string s;
    cin >> s;
    int n = s.length();
    vec.resize(n, vector <int> (26, 0));
    vec[0][s[0] - 'a']++;
    for (int j = 1; j < n; j++) {
        for (int i = 0; i < 26; i++) {
            vec[j][i] = vec[j - 1][i];
        }
        vec[j][s[j] - 'a']++;
    }
    int mn = n;
    for (int j = 0; j < 26; j++) {
        if (vec.back()[j])
            mn = min(mn, vec.back()[j]);
    }
    int cnt = 1;
    for (int i = 1; i * i <= n; i++) {
        //cout << i << ' ' << n / i << '\n';
        if (n % i)
            continue;
        if (god(n / i)) {
            cout << n / i;
            return 0;
        }
        else if (god(i))
            cnt = i;
    }
    cout << cnt;
}
