#include <bits/stdc++.h>

using namespace std;

struct point {
    double x, y;
};

struct line {
    double a, b, c;
};

vector <point> p;

line makeln (point a, point b) {
    line l;
    l.a = a.y - b.y;
    l.b = b.x - a.x;
    l.c = -l.a * b.x - l.b * b.y;
    return l;
}

point inter (line l, line t) {
    point p;
    p.x = (l.b * t.c - t.b * l.c) / (l.a * t.b - t.a * l.b);
    p.y = (t.a * l.c - l.a * t.c) / (l.a * t.b - t.a * l.b);
    return p;
}

bool check_point (point a) {
    return ceil(a.x) == a.x && ceil(a.y) == a.y;
}

bool pil (point a, line l) {
    return !(l.a * a.x + l.b * a.y + l.c);
}

void adapt (vector <point> & p, point a, int k) {
    for (int j = 0; j < p.size(); j++) {
        p[j].x += k * a.x ;
        p[j].y += k * a.y;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    set <pair <double, double> > s;
    p.resize(n << 1);
    int m = n << 1;
    for (int j = 0; j < m; j++) {
        cin >> p[j].x >> p[j].y;
    }
    vector <bool> us(m, false);
    us[0] = true;
    for (int j = 1; j < m; j++) {
        us[j] = true;
        line l = makeln(p[0], p[j]);
        point c;
        for (int i = 1; i < m; i++) {
            if (us[i])
                continue;
            bool cond;
            us[i] = true;
            for (int k = 1; k < m; k++) {
                if (us[k])
                    continue;
                line t = makeln(p[i], p[k]);
                c = inter(l, t);
                if (check_point(c)) {
//                    cout << j + 1 << ' ' << i + 1 << ' ' << k + 1 << '\n';
//                    cout << c.x << ' ' << c.y << '\n';
                    adapt(p, c, -1);
                    map <double, int> mp;
                    int zero = 0;
                    for (int j = 0; j < m; j++) {
                        //cout << p[j].x << ' ' << p[j].y << '\n';
                        if (p[j].x) {
                            mp[p[j].y / p[j].x]++;
                        }
                        else {
                            zero++;
                        }
                    }
                    cond = (!zero || zero == 2);
                    for (auto it = mp.begin(); cond && it != mp.end(); it++) {
                        if (it->second != 2)
                            cond = false;
                        //cout << it->first << ' ' << it->second << ' ';
                    }
                    if (cond) {
                        cout << "Yes\n" << c.x << ' ' << c.y << '\n';
                        return 0;
                    }
                    //return 0;
                }
            }
            us[i] = false;
        }
        us[j] = false;
    }
    cout << "No\n";
}
