#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <stack>
#include <map>
#include <algorithm>
#include <functional>
#include <climits>
#include <cmath>
#include <cassert>
#include <fstream>
#include <ctime>
using namespace std;
typedef long long ll;

//#define DEBUG
//#define TIMETEST

#ifdef DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif // DEBUG



#ifdef TIMETEST
#define __test main
#else
#define __main main
#endif // TIMETEST

string s;
int n;
typedef vector<int> vint;
int __main() {
    cin >> s;
    n = s.size();
    for (int i = 0; i < n; i++)s[i] = s[i] - 'a';
    for (int i = 1; i <= n; i++) {
        if (n%i != 0)continue;
        vint orig(26, 0);
        for (int j = 0; j < i; j++) {orig[s[j]]++;}
        bool succ = true;
        for (int b = i; b < n; b += i) {
            vint tec(26, 0);
            for (int j = b; j < b + i; j++) {
                tec[s[j]]++;
            }
            if (tec != orig) {
                succ = false; break;
            }
        }

        if (succ) {
            cout << (n / i);
            return 0;
        }
    }

    assert(false);
    return 0;
}

int __test() {
    clock_t t = clock();
    __main();
    cout << endl;
    cout << (clock() - t) << "ms";

    return 0;
}