#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>
#include <string>
#include <bitset> 
using namespace std;
#define int long long
#define INF 1791791791


tuple<int, int, int, int> dfs(int v, vector<vector<int>> & g, vector<int> & a)
{
	vector<pair<int, int>> ver;
	int s = 0;
	int n = 0;
	int r = 0;
	int mr = INF;
	for (int to : g[v]) {
		auto cr = dfs(to, g, a);
		s += get<0>(cr);
		n += get<1>(cr);
		r += get<2>(cr);
		mr = min(mr, get<3>(cr));
		ver.push_back({ get<1>(cr), get<3>(cr) });
	}
	r += s;
	bool nd = true;
	for (int i = 0; i < ver.size(); ++i) {
		if (ver[i].first > n - ver[i].first) {
			int mv = INF;
			for (int j = 0; j < ver.size(); ++j) {
				if (i != j)
					mv = min(mv, ver[j].second);
			}
			r += mv * (2 * ver[i].first - n);
			nd = false;
			break;
		}
	}
	if (nd && n % 2)
		r += mr;
	++n;
	s += a[v];
	mr = min(mr, a[v]);
	return { s, n, r, mr };
}

signed main()
{
    cin.tie();
    cout.tie();
    ios::sync_with_stdio(false);
	string s;
	//s.reserve(5e6 + 2);
	cin >> s;
	//vector<vector<int>> cnt(s.size() + 1, vector<int>(26));
	int al = 26;
	if (s.size() > 500000)
		al = 2;
	int cnt[s.size() + 1][al] = {};
	for (int i = 0; i < s.size(); ++i) {
		copy(cnt[i], cnt[i] + al, cnt[i + 1]);
		++cnt[i + 1][s[i] - 'a'];
	}
	for (int i = 1; i <= s.size(); ++i) {
		if (s.size() % i)
			continue;
		bool can = true;
		for (int j = 2 * i; j <= s.size() && can; j += i) {
			for (int k = 0; k < al; ++k) {
				if (cnt[j][k] != j / i * cnt[i][k]) {
					can = false;
					break;
				}
			}
		}
		if (can) {
			cout << s.size() / i;
			return 0;
		}
	}
}

