#include <bits/stdc++.h>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int maxn = 2e5 +123;
const ld eps = 1e-9;
const int inf = 1e9 + 1234;
const ll infll = 1e18 + 1243;
const ll mod = 1e9 + 9;

int a[maxn];

void solveBRUT(){
    for(int n = 100; n < 1000; n++){
        for(int i = 1; i <= 2 * n; i++)
            a[i] = 0;
        for(int i = 1; i <= n; i++)
            a[i * 2 - 1] = i;
        for(int i = 1; i < 2 * n; i++)
            cout << a[i] << " ";
        cout << "\n";
        int lp = 2 * n - 1;
        for(int i = n * 2 - 1; i > n; i--){
            if(a[i] > 0){
                while(a[lp] != 0)
                    lp--;
                a[lp] = a[i];
                a[i] = 0;
//                for(int i = 1; i < 2 * n; i++)
//                    cout << a[i] << " ";
//                cout << "\n";
            }
        }
//        return;
        for(int i = 1; i <= n; i++)
            cout << a[i] << " ";
        cout << "\n";
        return;
    }
}

ll go(ll x, ll n, ll pos){
    if(x & 1){
        return (x + 1) / 2;
    }
    if(pos != x){
        return go(x, n - (x - pos)/2, x);
    }
    else{
        return go(x + n - 1, n - 1, x + 2);
    }
}

void solve(){
    ll n, q;
    cin >> n >> q;
    while(q--){
        ll x;
        cin >> x;
        if((x & 1) && (x <= (n + 1)/2)){
            cout << (x + 1) /2 << "\n";
        }
        else{
            cout << go(x, n, 2) << "\n";
        }
    }
}

int main()
{
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    solve();
//    freopen("output.txt", "w", stdout);
//    solveBRUT();
    return 0;
}
