#include <bits/stdc++.h>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int maxn = 5e6 +123;
const ld eps = 1e-9;
const int inf = 1e9 + 1234;
const ll infll = 1e18 + 1243;
const ll mod = 1e9 + 9;

string s;
int n;
ll p[] = {2, 223, 661, 1481, 2803, 5099, 8861, 15077, 25219,
 41801, 68819, 112759, 183949, 299417, 485423, 785777,
  1269733, 2048833, 3300863, 5311391, 8536807, 13704161,
   21973871, 35208269, 56350003, 90120809};
int cnt[30];
int cnt2[30];
ll c[maxn];

bool check(int x){
    for(int i = 0; i < 30; i++){
        cnt[i] = 0;
        cnt2[i] = 0;
    }
    int sz = n / x;
    for(int i = 0; i < sz; i++)
        cnt[s[i] - 'a']++;
    for(int i = sz; i < n; i += sz){
        for(int j = 0; j < sz; j++){
            cnt2[s[i + j] - 'a']++;
        }
        for(int i = 0; i < 30; i++){
            if(cnt[i] != cnt2[i])
                return 0;
            cnt2[i] = 0;
        }

    }
    return 1;
}

bool checkAB(int x){
    int sz = n / x;
    ll a = c[sz];
    for(int i = 2 * sz; i <= n; i += sz){
        if(a != c[i] - c[i - sz])
            return 0;
    }
    return 1;
}

bool checkFast(int x){
    int sz = n / x;
    int a = c[sz];
    for(int i = 2 * sz; i <= n; i += sz){
        if(a != c[i] - c[i - sz])
            return 0;
    }
    return 1;
}

void solve(){
    cin >> s;
    n = s.length();
//    s = "";
//    n = rand();
//    for(int i = 0; i < n; ++i)
//        s += ('a' + rand() % 2);
    char mx = 'a';
    for(int i = 0; i < n; i++)
        mx = max(mx, s[i]);
    if(mx == 'b'){
//        for(int i = n; i >= 1; i--){
//            if(n % i == 0 && check(i)){
//                cout << i << "\n";
//                return;
//            }
//        }
        for(int i = 0; i < n; i++){
            c[i + 1] += c[i];
            if(s[i] == 'a')
                c[i + 1]++;
        }
        for(int i = n; i >= 1; i--){
            if(n % i == 0 && checkAB(i)){
                cout << i << "\n";
                return;
            }
        }
    }
    else if(n < 500000){
        for(int i = n; i >= 1; i--){
            if(n % i == 0 && check(i)){
                cout << i << "\n";
                return;
            }
        }
    }
    else{
        random_shuffle(p, p + 26);
//        for(int i = 0; i < 27; i++)
//            p[i] = rand();
        for(int i = 1; i <= n; i++){
            c[i] = c[i - 1];
            c[i] += p[s[i - 1] - 'a'];
        }
        for(int i = n; i >= 1; i--){
            if(n % i == 0 && checkFast(i) && check(i)){
                cout << i << "\n";
                return;
            }
//            if(checkFast(i) == 0 && check(i) == 1){
//                cout << "KEK" << endl;
//                cout << i << endl;
//                cout << checkFast(i) << " " << check(i);
//                ofstream fout("kek.txt");
//                fout << s;
//                exit(0);
//                return;
//            }
        }
    }
}

int main()
{
//    srand(3);
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    freopen("input.txt", "r", stdin);
    solve();
//    freopen("output.txt", "w", stdout);
//    for(int i = 0; i < 1000000; i++){
//        if(i % 1000 == 0)
//            cout << i << endl;
//        solve();
//    }
    return 0;
}
