#include <bits/stdc++.h>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int maxn = 2e5 + 123;
const ld eps = 1e-9;
const int inf = 1e9 + 1234;
const ll infll = 1e18 + 1243;
const ll mod = 1e9 + 9;

vector<int> g[maxn];
int c[maxn];
ll sum[maxn];
ll cnt[maxn];
ll ans;

void dfsPrecalc(int v){
    cnt[v] = 1;
    sum[v] = c[v];
    for(int to : g[v]){
        dfsPrecalc(to);
        cnt[v] += cnt[to];
        sum[v] += sum[to];
    }
}

bool comp(int a, int b){
    if(cnt[a] > cnt[b])
        return 1;
    else if(cnt[b] > cnt[a])
        return 0;
    return a > b;
}

void dfs1(int v){
    ll cn = 0;
    for(int to : g[v]){
        dfs1(to);
        if(cn > 0){
            if(cn > cnt[to]){
                cn -= cnt[to];
                ans += 2 * cnt[to];
            }
            else{
                cnt[to] -= cn;
                ans += 2 * cn;
                cn = cnt[to];
            }
        }
        else{
            cn += cnt[to];
        }
    }
    ans += 2 * cn;
}

void solve(){
    int n;
    cin >> n;
    for(int i = 2; i <= n; i++){
        int x;
        cin >> x;
        g[x].pb(i);
    }
    int mx = 0;
    for(int i = 2; i <= n; i++){
        cin >> c[i];
        mx = max(mx, c[i]);
    }
    dfsPrecalc(1);
    for(int i = 1; i <= n; i++)
        sort(g[i].begin(), g[i].end(), comp);
    if(mx == 1)
        dfs1(1);
    cout << ans;
}

int main()
{
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    solve();
    return 0;
}
