#include <bits/stdc++.h>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int maxn = 1e4;
const ld eps = 1e-9;
const int inf = 1e9 + 1234;
const ll infll = 1e18 + 1243;
const ll mod = 1e9 + 9;

struct _line{
    ll a,b,c;
    int i, j;
    _line(){}
};

pair<int, int> a[maxn];
vector<_line> ls;
set<pair<int, int> > tchs;
int p[400];
int n;

pair<ll, ll> getPeres(int x, int y){
    pair<ll, ll> res;
    _line a = ls[x], b = ls[y];
    if((a.a * b.b - a.b * b.a) == 0 || (a.c * b.b - b.c * a.b) % (a.a * b.b - a.b * b.a) != 0)
        return {inf, inf};
    res.fr = - (a.c * b.b - b.c * a.b) / (a.a * b.b - a.b * b.a);
    if((a.a * b.c - b.a * a.c) % (a.a * b.b - a.b * b.a) != 0)
        return {inf, inf};
    res.sc = - (a.a * b.c - b.a * a.c) / (a.a * b.b - a.b * b.a);
    return res;
}

void go(int x){
    if(x * 2 == n){
        pair<int, int> ans = getPeres(p[0], p[1]);
        if(abs(ans.fr) > 1e6 || abs(ans.sc) > 1e6)
            return;
        for(int i = 0; i < x; i++){
            if(ans == a[ls[p[i]].i] || ans == a[ls[p[i]].j]){
                return;
            }
        }
        cout << "Yes\n";
        cout << ans.fr << " " << ans.sc;
        exit(0);
    }
    if(x <= 1){
        int st = 0;
        if(x == 1)
            st = p[0] + 1;
        for(int i = st; i < ls.size(); i++){
            p[x] = i;
            if(x == 1){
                if(ls[p[0]].i == ls[i].i || ls[p[0]].i == ls[i].j ||
                   ls[p[0]].j == ls[i].i || ls[p[0]].j == ls[i].j)
                    continue;
            }
            go(x + 1);
        }
    }
    else{
        pair<int, int> f = getPeres(p[0], p[1]);
        if(abs(f.fr) > 1e6 || abs(f.sc) > 1e6 || tchs.count(f))
            return;
        set<int> tch;
        for(int i = 0; i < x; i++){
            tch.insert(ls[p[i]].i);
            tch.insert(ls[p[i]].j);
        }
        for(int i = p[x - 1]; i < ls.size(); i++){
            if(tch.count(ls[i].i) || tch.count(ls[i].j))
                continue;
            p[x] = i;
            pair<int, int> f1 = getPeres(p[0], p[x]);
            if(f1.fr != f.fr || f1.sc != f.sc)
                continue;
            go(x + 1);
        }
    }
}

map<pair<int, int>, vector<int> > f;

void solve(){
    cin >> n;
    n *= 2;
//    n = 100;
    for(int i = 0; i < n; i++){
        cin >> a[i].fr >> a[i].sc;
//        if(i & 1){
//            a[i].fr = 0;
//            a[i].sc = i + 100;
//        }
//        else{
//            a[i].fr = i + 100;
//            a[i].sc = 0;
//        }
        tchs.insert(a[i]);
    }
    for(int i = 0; i < n; i++){
        for(int j = i + 1; j < n; j++){
            _line l;
            l.i = i, l.j = j;
            l.a = a[i].sc - a[j].sc, l.b =  a[j].fr - a[i].fr;
            l.c = -(a[i].fr * l.a + a[i].sc * l.b);
            int f = __gcd(abs(l.a), __gcd(abs(l.b), abs(l.c)));
            l.a /= f;
            l.b /= f;
            l.c /= f;
            ls.pb(l);
        }
    }
    for(int i = 0; i < ls.size(); i++){
        for(int j = i + 1; j < ls.size(); j++){
            pair<int, int> p = getPeres(i, j);
            if(abs(p.fr) <= 1e6 && abs(p.sc) <= 1e6 && !tchs.count(p)){
                f[p].pb(i);
                f[p].pb(j);
            }
        }
    }
    if(n > 50){
        cout << "No";
        return;
    }
    for(auto x : f){
        if(x.sc.size() >= n/2){
            vector<int> s = x.sc;
            sort(s.begin(), s.end());
            set<int> ts;
            int cnt = 0;
            vector<int> pr;
            set<pair<int, int> > prs;
            for(int i = 0; i < s.size(); i++){
                if(i == 0 || s[i] != s[i - 1]){
                    if(!ts.count(ls[s[i]].i) && !ts.count(ls[s[i]].j) &&
                       !prs.count({ls[s[i]].a, ls[s[i]].b})){
                        cnt += 2;
                        ts.insert(ls[s[i]].i);
                        ts.insert(ls[s[i]].j);
                        prs.insert({ls[s[i]].a, ls[s[i]].b});
                        pr.pb(s[i]);
                    }
                }
            }
            if(cnt == n){
                bool cor = 1;
                for(int i : pr){
                    if(ls[i].a * x.fr.fr + ls[i].b * x.fr.sc + ls[i].c != 0)
                        cor = 0;
                }
                if(n <= 50)
                    for(int i : pr)
                        for(int j : pr)
                            if(i != j){
                                pair<int, int> f = getPeres(i, j);
                                if(f.fr != x.fr.fr || f.sc != x.fr.sc)
                                    cor = 0;
                            }
                if(cor){
                    cout << "Yes\n";
                    cout << x.fr.fr << " " << x.fr.sc;
                    return;
                }
            }
        }
    }
//    go(0);
    cout << "No";
}

int main()
{
//    srand(2);
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    solve();
    return 0;
}
