//#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <ctime>
#include <cstdlib>
#include <iomanip>

using namespace std;

typedef int L;

ifstream cin("input.txt");
ofstream cout("output.txt");

void solve() {
	long long n, q;
	cin >> n >> q;
	vector <int> a(2 * n);
	for (int i = 1; i < a.size(); i += 2) {
		a[i] = i / 2 + 1;
	}
	int prog = 1;
	for (int i = a.size() - 1; i >= 1; i--) {
		if (i - prog < 1) {
			break;
		}
		a[i - prog] = a[i];
		prog++;
	}
	for (int i = 0; i < q; i++) {
		int qu;
		cin >> qu;
		cout << a[qu] << '\n';
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(time(0));
	cout.precision(15);
	solve();

	return 0;
}