//#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <ctime>
#include <cstdlib>
#include <iomanip>

using namespace std;

typedef int L;

ifstream cin("input.txt");
ofstream cout("output.txt");

int gfs(int v, vector <vector <int> > &g, vector <int> &count) {
	int sum = 1;
	for (int i = 0; i < g[v].size(); i++) {
		sum += gfs(g[v][i], g, count);
	}
	count[v] = sum;
	return sum;
}
void solve() {
	int n;
	cin >> n;
	vector <vector <int> > g(n);
	for (int i = 1; i < n; i++) {
		int temp;
		cin >> temp;
		temp--;
		g[temp].push_back(i);
	}
	int sum = 0;
	vector <int> c(n);
	for (int i = 0; i < n - 1; i++) {
		cin >> c[i];
		sum += c[i];
	}
	if (sum == n - 1) {
		vector <int> count(n);
		gfs(0, g, count);
		long long ans = 0;
		for (int i = 0; i < n; i++) {
			if (g[i].size() > 1) {
				ans += (count[i] - 2) * 2;
			}
		}
		cout << ans;
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(time(0));
	cout.precision(15);
	solve();

	return 0;
}