#include <iostream>
#include <set>

using namespace std;

typedef unsigned long long ull;


//#define MY

#ifdef MY
    const int MAXN = (int) 5e3 + 3;
#else
    const int MAXN = (int) 5e6 + 3;
#endif
const ull P = 1021;
const int STEP = 8;

struct PrecalcPows {
    ull p[MAXN];

    PrecalcPows() {
        p[0] = 1;
        for (int i = 1; i < MAXN; ++i) {
            p[i] = p[i - 1] * P;
        }
    }
} pp;

const int ALPH = 27;
char s[MAXN];
ull h[MAXN];

int main() {
    scanf("%s", s);
    int n = 0;
    while (s[n] != '\0') ++n;
    h[0] = 0;
    for (int i = 0; s[i] != '\0'; ++i) {
        h[i + 1] = h[i] + pp.p[STEP * (s[i] - 'a')];
    }
    auto get = [&](int l, int r) {
        return h[r] - h[l];
    };
    int cnt[ALPH];
    fill_n(cnt, ALPH, 0);
    for (int i = 0; s[i] != '\0'; ++i) {
        cnt[s[i] - 'a']++;
    }
    auto check = [&](int k) {
        for (int i : cnt) {
            if (i % k) return false;
        }
        return true;
    };
    auto can = [&](int k) {
        ull f = get(0, k);
        int num = 1;
        for (int i = k; s[i] != '\0'; i += k, ++num) {
            if (get(i, i + k) != f) {
                return 0;
            }
        }
        return num;
    };
    for (int i = 1; i < MAXN; ++i) {
        if (!check(n / i)) continue;
        int num = can(i);
        if (!num) continue;
        cout << num << "\n";
        break;
    }
    return 0;
}