#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,sse4,abm,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <memory.h>
#include <cassert>
#include <string>
#include <chrono>
#include <queue>
#include <deque>
#include <numeric>

using namespace std;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pii pair<int, int>
#define x first
#define y second
#define pb push_back
#define eb emplace_back

typedef long long ll;
typedef long double ld;

template <typename T1, typename T2>
bool mini(T1 &a, const T2 &b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T1, typename T2>
bool maxi(T1 &a, const T2 &b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int INF = 1e9;
const int N = 5e5 + 123;
const int M = 20;
const int A = 26;
const int MOD = 1e9 + 7;

int cnt[A];
int pcnt[A][N];

int gcd(int a, int b) {
	if (!a)
		return b;
	return gcd(b % a, a);
}

void run() {
	
	string s;
	cin >> s;
	int n = sz(s);
	for (int i = 0; i < n; i++) {
		cnt[s[i] - 'a']++;
	}

	for (int i = 0; i < A; i++) {
		pcnt[i][0] = 0;
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < A; j++) {
			pcnt[j][i + 1] = pcnt[j][i] + (bool)(s[i] - 'a' == j);
		}
	}

	vector<int> poss;
	for (int i = 1; i * i <= n; i++) {
		if (n % i == 0)
			poss.pb(i);
		if (i * i != n)
			poss.pb(n / i);
	}
	sort(rall(poss));
	for (auto tr : poss) {
		int cur_len = n / tr;

		int ok = true;

		for (int i = 0; i < A; i++) {
			int cc = pcnt[i][cur_len];
			if (!cnt[i])
				continue;
			if (!cc) {
				ok = false;
				break;
			}
			if (cnt[i] % cc) {
				ok = false;
				break;
			}
		}
		if (!ok)
			continue;

		for (int i = 0; i < n && ok; i += cur_len) {
			for (int j = 0; j < A; j++) {
				int cur_cnt = pcnt[j][i + cur_len] - pcnt[j][i];
				int cc = pcnt[j][cur_len];
				if (cur_cnt != cc) {
					ok = false;
					break;
				}
			}
		}
		if (ok) {
			cout << n / cur_len;
			return;
		}
	}


}