#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,sse4,abm,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <memory.h>
#include <cassert>
#include <string>
#include <chrono>
#include <queue>
#include <deque>
#include <numeric>

using namespace std;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pii pair<int, int>
#define x first
#define y second
#define pb push_back
#define eb emplace_back

typedef long long ll;
typedef long double ld;

template <typename T1, typename T2>
bool mini(T1 &a, const T2 &b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T1, typename T2>
bool maxi(T1 &a, const T2 &b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int INF = 1e9;
const int N = 2e5 + 123;
const int M = 20;
const int A = 26;
const int MOD = 1e9 + 7;

int conf[N];
int cnt[N];
vector<int> mat[N];
int ans = 0;

struct Node {
	vector<int> children;
	int sum = 0;
};

Node *dfs(int v) {
	cnt[v] = 1;
	if (!sz(mat[v])) {
		Node *kek = new Node();
		kek->children.pb(v);
		kek->sum += conf[v];
		return kek;
	}
	int cur_ans = 0;
	vector<Node*> chil;
	int mn1 = INF, mn2 = INF;
	for (auto to : mat[v]) {
		chil.push_back(dfs(to));
		cur_ans += chil.back()->sum;
		cnt[v] += cnt[to];
		int cur_val = conf[chil.back()->children.front()];
		if (cur_val <= mn1) {
			mn2 = mn1;
			mn1 = cur_val;
		}
		else if (cur_val < mn2) {
			mn2 = cur_val;
		}
	}
	
	sort(all(chil), [](Node *n1, Node *n2) {
		return n1->children.size() < n2->children.size();
	});

	int cur_add = 0;
	if (cnt[v] % 2 == 0)
		cur_add = mn1 + mn2;

	int delta_size = 2 * sz(chil.back()->children) - cnt[v] + 1;
	
	Node *res = chil.back();
	int cur_sz = res->children.size();
	for (int i = 0; i < sz(chil) - 1; i++) {
		res->sum += chil[i]->sum;
		for (auto it : chil[i]->children)
			res->children.pb(it);
	}

	sort(res->children.begin() + cur_sz, res->children.end());
	
	int cc_add = max(0, delta_size * res->children[cur_sz]);

	cur_add = cc_add;

	ans += cur_add + cur_ans;
	res->children.push_back(v);
	res->sum += conf[v];
	sort(all(res->children));
	return res;
}

void run() {

	int n;
	cin >> n;
	for (int i = 1; i < n; i++) {
		int p;
		cin >> p;
		mat[p - 1].pb(i);
	}

	for (int i = 1; i < n; i++)
		cin >> conf[i];

	dfs(0);
	cout << ans;

}