#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef long double ld;
typedef pair<ll, ll> par;
typedef vector<ll> vll;

#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define sqr(x) ((x)*(x))
#define pw(x) (1ll << (x))
#define _ inline

ll logn(ll n) { return ll(log2(ld(n))); }
ll rnd() { return (rand() << 16) + rand(); }

string s;
ll n;

_ bool f(ll kol, ll len) {
    vll c(26, 0);
    for (int i = 0; i < len; ++i) c[s[i] - 'a']++;
    bool flag = 0;
    for (int i = len; i < n; i += len) {
        vll tmp(26, 0);
        for (int j = 0; j < len; ++j) tmp[s[i + j] - 'a']++;
        if (tmp != c) return 0;
    }
    return 1;
}

int source() {
    cin >> s;
    n = s.size();
    vll C(26, -1);
    ll maxpos = 0;
    for (int i = 0; i < n; ++i) {
        if (C[s[i] - 'a'] == -1) {
            C[s[i] - 'a'] = i;
            maxpos = i;
        }
    }
    maxpos++;
    ll kk = sqrt(n) + 1;
    ll ans = 1;
    for (ll kol = 1; kol < kk; ++kol) {
        if (n % kol) continue;
        ll len = n / kol;
        if (len >= maxpos && f(kol, len)) ans = max(ans,kol);
        if (kol * kol != n &&  kol >= maxpos && f(len, kol)) ans = max(ans, len);
    }
    cout << ans;
    return 0;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    ll test = 1;
#ifdef aokigahara
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
    //cin >> test;
#endif // aokigahara

    for (int i = 0; i < test; ++i) {
        source();
        cout << '\n';
        cerr << '\n';
    }

#ifdef aokigahara
    cerr << fixed << setprecision(12) << "\n\nTIME : " << clock() * 1.0 / CLOCKS_PER_SEC << "\n";
#endif // aokigahara
    return 0;
}
