#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> par;
typedef vector<ll> vll;

#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define sqr(x) ((x)*(x))
#define pw(x) (1ll << (x))
#define _ inline

ll logn(ll n) { return ll(log2(ld(n))); }
ll rnd() { return (rand() << 16) + rand(); }
ll gcd(ll a, ll b) { return (b ? gcd(b, a % b) : a); }

vll p;

vector<vll> g;

vll d;

ll ans = 0;

void dfs(ll v) {
    assert(g[v].size() != 1);
    for (auto to : g[v])  {
        dfs(to);
        d[v] += d[to];
        ans += d[to] * 2;
    }
    if (g[v].size() > 1) ans--;
}

int source() {
    ll n;
    cin >> n;
    p.resize(n);
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        ll pr;
        cin>> pr;
        --pr;
        g[pr].push_back(i);
    }
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        if (p[i] != 1) {
            cout << 25;
            return 0;
        }
    }
    d.assign(n, 1);
    dfs(0);
    cout << ans;
    return 0;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    ll test = 1;
#ifdef aokigahara
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
    //cin >> test;
#endif // aokigahara

    for (int i = 0; i < test; ++i) {
        source();
        cout << '\n';
        cerr << '\n';
    }

#ifdef aokigahara
    cerr << fixed << setprecision(12) << "\n\nTIME : " << clock() * 1.0 / CLOCKS_PER_SEC << "\n";
#endif // aokigahara
    return 0;
}
