#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<map>
#include<stack>
#include<cmath>
#include<list>
#include<ctime>
using namespace std;
#define elif else if
#define int long long
class point
{
public:
    double x, y;
    bool operator ==(point b)
    {
        if (abs(x - b.x) < 1e-6&&abs(y - b.y) < 1e-6)
        {
            return 1;
        }
        return 0;
    }
    point operator +(point a)
    {
        return { a.x + x, a.y + y };
    }
    point operator -(point a)
    {
        return { x - a.x, y - a.y };
    }
    point operator *(double k)
    {
        return { k*x, k*y };
    }
    point operator /(double k)
    {
        return { x / k, y / k };
    }
    double operator *(point a)
    {
        return a.x*x + a.y*y;
    }
    double operator %(point a)
    {
        return x * a.y - y * a.x;
    }
    double lensqr()
    {
        return x * x + y * y;
    }
    double len()
    {
        return sqrt(lensqr());
    }
    point norm()
    {
        return { x / len(), y / len() };
    }
};
int32_t main()
{
    int n;
    cin >> n;
    vector<pair<int,int>>a(n * 2);
    n *= 2;
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i].first >> a[i].second;
    }
    sort(a.begin(), a.end());
    do
    {
        int A = a[0].second - a[1].second;
        int B = a[1].first - a[0].first;
        int C = -a[0].first*A - a[0].second*B;
        int A1= a[0+2].second - a[1+2].second;
        int B1 = a[1+2].first - a[0+2].first;
        int C1 = -a[2].first*A1 - a[2].second*B1;
        int x, y;
        bool f = 1;
        if (A == 0 && A1 == 0)
        {
            f = 0;
        }
        elif (B == 0 && B1 == 0)
        {
            f = 0;
        }
        elif(A == 0)
        {
            if (C%B)
            {
                f = 0;
            }
            else
            {
                x = -C / B;
                if ((B1 * x + C1) % A1)
                {
                    f = 0;
                }
                else y = -(B1 * x + C1) / A1;
            }
        }
        elif(A1 == 0)
        {
            if (C1%B1)
            {
                f = 0;
            }
            else
            {
                x = -C1 / B1;
                if ((B * x + C) % A)
                {
                    f = 0;
                }
                else y = -(B * x + C) / A;
            }
        }
        elif(B == 0)
        {
            if (C%A)
            {
                f = 0;
            }
            else
            {
                y = -C / A; 
                if ((A1 * y + C1) % B1)
                {
                    f = 0;
                }
                else x = -(A1 * y + C1) / B1;
            }
        }
        elif(B1 == 0)
        {
            if (C1%A1)
            {
                f = 0;
            }
            else
            {
                y = -C1 / A1;
                if ((A * y + C) % B)
                {
                    f = 0;
                }
                else x = -(A * y + C) / B;
            }
        }
        else
        {
            int Ash = A;
            A *= A1;
            B *= A1;
            C *= A1;
            A1 *= Ash;
            B1 *= Ash;
            C1 *= Ash;
            if (B == B1)
            {
                f = 0;
            }
            elif ((C - C1) % (B - B1))
            {
                f = 0;
            }
            else
            {
                x = -(C - C1) / (B - B1);
                if ((B * x + C) % A)
                {
                    f = 0;
                }
                else y = -(B * x + C) / A;
            }
        }
        if (!f)
            continue;
        swap(x, y);
        if (x == a[0].first&&y == a[0].second || x == a[1].first&&y == a[1].second || x == a[2].first&&y == a[2].second || x == a[3].first&&y == a[3].second)
        {
            f = 0;
        }
        if (!f)
            continue;
        set<pair<pair<double, double>, double>>s;
        double aa, bb, cc;
        if (A != 0)
        {
            aa = 1, bb = B, cc = C;
            bb /= A, cc /= A;
        }
        else
        {
            aa = A, bb = 1, cc = C;
            aa /= B, cc /= B;
        }
        s.insert({ { aa, bb }, cc });
        if (A1 != 0)
        {
            aa = 1, bb = B1, cc = C1;
            bb /= A1, cc /= A1;
        }
        else
        {
            aa = A1, bb = 1, cc = C1;
            aa /= B1, cc /= B1;
        }
        s.insert({ { aa, bb }, cc });
        for (int i = 4; i < n; i += 2)
        {
            int A = a[0+i].second - a[1+i].second;
            int B = a[1 + i].first - a[0 + i].first;
            int C = -a[0 + i].first*A - a[i + 0].second*B;
            if (A != 0)
            {
                aa = 1, bb = B, cc = C;
                bb /= A, cc /= A;
            }
            else
            {
                aa = A, bb = 1, cc = C;
                aa /= B, cc /= B;
            }
            if (s.find({ { aa, bb }, cc }) != s.end())
            {
                f = 0;
                break;
            }
            if (A*x + B * y != -C)
            {
                f = 0;
                break;
            }
            if (x == a[i].first&&y == a[i].second || x == a[i + 1].first&&y == a[i + 1].second)
            {
                f = 0;
                break;
            }
            s.insert({ { aa, bb }, cc });
        }
        if (f)
        {
            cout << "Yes\n" << x << ' ' << y;
            return 0;
        }
    } while (next_permutation(a.begin(), a.end()));
    cout << "No";
    return 0;
}