#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <bitset>
#include <string>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef vector<int> vi;

#define X first
#define Y second
#define inb push_back
#define all(v) (v).begin(), (v).end()

const int M = 2e5 + 5;

int n, c[M], dp[M];
vi g[M];
ll ans, dd[M];
set<ll> s[M];

bool cmp(int a, int b)
{
	return dp[a] < dp[b];
}

void dfs(int v)
{
	dp[v] = 1;
	dd[v] = c[v];
	if (!g[v].size())
		return;
	for (int u : g[v])
	{
		dfs(u);
		dp[v] += dp[u];
	}
	sort(all(g[v]), cmp);
	int l = 0, r = g[v].size() - 1;
	while (l < r)
	{
		if (dp[g[v][l]] <= dp[g[v][r]])
		{
			dp[g[v][r]] -= dp[g[v][l]];
			ans += dp[g[v][l]] * 2;
			++l;
		}
		else
		{
			dp[g[v][l]] -= dp[g[v][r]];
			ans += dp[g[v][r]] * 2;
			--r;
		}
	}
	int x = dp[g[v][l]], i;
	ans += x * 2;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else
#endif
	int n;
	scanf("%d", &n);
	for (int i = 2, p; i <= n; ++i)
	{
		scanf("%d", &p);
		g[p].inb(i);
	}
	for (int i = 2; i <= n; ++i) scanf("%d", &c[i]);
	dfs(1);
	cout << ans;
}