#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <bitset>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <assert.h>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef vector<int> vi;

#define X first
#define Y second
#define inb push_back
#define all(v) (v).begin(), (v).end()

const int M = 2e5 + 5;

int n, c[M], dp[M];
vi g[M];
ll ans, dd[M];
set<ll> s[M];
set<pii> ss;

bool cmp(int a, int b)
{
	return dp[a] < dp[b];
}

void dfs(int v)
{
	dp[v] = 1;
	dd[v] = c[v];
	if (!g[v].size())
		return;
	set<pii> ss;
	for (int u : g[v])
	{
		dfs(u);
		dp[v] += dp[u];
		ss.insert({ dp[u], u });
	}
	while (ss.size() > 1)
	{
		pii v = *ss.begin();
		pii u = *ss.rbegin();
		ss.erase(v);
		ss.erase(u);
		if (!ss.size() || u.X - v.X >= ss.rbegin()->X)
		{
			ans += v.X * 2;
			u.X -= v.X;
			if (u.X)
				ss.insert(u);
		}
		else
		{
			ans += (u.X - ss.rbegin()->X + 1) * 2;
			v.X -= u.X - ss.rbegin()->X + 1;
			u.X = ss.rbegin()->X - 1;
			if (u.X) 
				ss.insert(u);
			if (v.X)
				ss.insert(v);
		}
	}
	int x = 0, i;
	if (ss.size()) x = ss.begin()->X;
	ans += x * 2;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else
#endif
	int n;
	scanf("%d", &n);
	for (int i = 2, p; i <= n; ++i)
	{
		scanf("%d", &p);
		g[p].inb(i);
	}
	for (int i = 2; i <= n; ++i) scanf("%d", &c[i]);
	dfs(1);
	cout << ans;
}