#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <bitset>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <map>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef vector<int> vi;

#define X first
#define Y second
#define inb push_back
#define all(v) (v).begin(), (v).end()

const int M = 2605;

int n;
pair<ll, ll> a[M];
map<pair<pair<ll, ll>, ll>, int> dd;

ll gcd(ll a, ll b)
{
	if (!b) return a;
	return gcd(b, a % b);
}

void ch(pair<ll, ll> aa, pair<ll, ll> b, pair<ll, ll> c, pair<ll, ll> d)
{
	ll A = (aa.Y - b.Y), B = (b.X - aa.X), C = -A * aa.X - B * aa.Y, xx;
	xx = gcd(gcd(A, B), C);
	A /= xx, B /= xx, C /= xx;
	if (A < 0 || A == 0 && B < 0) A *= -1, B *= -1, C *= -1;

	ll A1 = (c.Y - d.Y), B1 = (d.X - c.X), C1 = -A1 * c.X - B1 * c.Y;
	xx = gcd(gcd(A1, B1), C1);
	A1 /= xx, B1 /= xx, C1 /= xx;
	if (A1 < 0 || A1 == 0 && B1 < 0) A1 *= -1, B1 *= -1, C1 *= -1;

	if (!A) swap(A, A1), swap(B, B1), swap(C, C1);
	if (!(B1 - A1 * B) || (A1 * C - C1) % (B1 - A1 * B)) return;
	ll y = (A1 * C - C1) / (B1 - A1 * B);
	if (!A || (-C - B * y) % A) return;
	ll x = (-C - B * y) / A;
	dd.clear();
	for (int i = 0; i < n; ++i)
	{
		ll A = (a[i].Y - y), B = (x - a[i].X), C = -A * x - B * y;
		if (A < 0 || A == 0 && B < 0) A *= -1, B *= -1, C *= -1;
		xx = gcd(gcd(A, B), C);
		if (!xx) return;
		A /= xx, B /= xx, C /= xx;
		dd[{ {A, B}, C}]++;
	}
	for (auto x : dd)
		if (x.Y != 2) return;
	if (!(abs(x) <= 1e6 && abs(y) <= 1e6)) return;
	cout << "Yes\n";
	cout << x << ' ' << y;
	exit(0);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	n *= 2;
	for (int i = 0; i < n; ++i) cin >> a[i].X >> a[i].Y;
	for (int i = 0; i < n; ++i)
		for (int j = i + 1; j < n; ++j)
			for (int k = 0; k < n; ++k)
				if (k != i && k != j)
					for (int l = k + 1; l < n; ++l)
						if (l != i && l != j)
							ch(a[i], a[j], a[k], a[l]);
	cout << "No";
}