#include <bits/stdc++.h>

const int N = 500100;

int sh = 26;

std::vector<std::vector<int>> globalCnt;
std::vector<int> cnt, curCnt;

void getCnt(std::vector<int>& need, int l, int r) {
    for (int i = 0; i < sh; ++i) {
        need[i] = globalCnt[i][r];
        if (l != 0) {
            need[i] -= globalCnt[i][l - 1];
        }
    }
}

bool eq(std::vector<int>& c1, std::vector<int>& c2) {
    for (int i = 0; i < sh; ++i) {
        if (c1[i] != c2[i]) {
            return false;
        }
    }
    return true;
}

void build(std::string& str) {
    for (int i = 0; i < str.size(); ++i) {
        if (i != 0) {
            for (int j = 0; j < sh; ++j) {
                globalCnt[j][i] = globalCnt[j][i - 1];
            }
        }
        ++globalCnt[str[i] - 'a'][i];
    }
}

int main(void) {
    std::string str;
    std::cin >> str;
    bool fl = true;
    for (auto i: str) {
        if (i != 'a' && i != 'b') {
            fl = false;
            break;
        }
    }
    if (fl) {
        sh = 2;
    }
    globalCnt.resize(sh, std::vector<int> (str.size()));
    cnt.resize(sh);
    curCnt.resize(sh);
    build(str);
    int ans = 1;
    for (int pref = 0; pref < str.size(); ++pref) {
        ++cnt[str[pref] - 'a'];
        if (str.size() % (pref + 1) != 0) {
            continue;
        }
        int curAns = str.size() / (pref + 1);
        bool fl = true;
        int pos = pref + 1;
        while (pos < str.size()) {
            curCnt.assign(sh, 0);
            getCnt(curCnt, pos, pos + pref);
            if (!eq(cnt, curCnt)) {
                fl = false;
                break;
            }
            pos += pref + 1;
        }
        if (fl) {
            ans = std::max(ans, curAns);
        }
    }
    std::cout << ans << '\n';
    return 0;
}