

#include <iostream>
#include <stdio.h>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <math.h>

using namespace std;

typedef long long ll;
typedef long double ld;

string s;
int ans[26];

int gcd(int a, int b)
{
	while (b != 0)
	{
		a %= b;
		swap(a, b);
	}
	return a;
}


bool check(int x)
{
	int qq = s.size() / x;
	int a1[26], a2[26];
	for (int i = 0; i < 26; i++)
		a1[i] = 0;
	for (int i = 0; i < qq; i++)
		a1[int(s[i] - 'a')]++;
	for (int i = qq; i < s.size(); i += qq)
	{
		for (int i = 0; i < 26; i++)
			a2[i] = 0;
		for (int j = 0; j < qq; j++)
			a2[int(s[i + j] - 'a')]++;
		for (int i = 0; i < 26; i++)
			if (a1[i] != a2[i])
				return false;
	}
	return true;
}

vector <int > p;
vector <bool > bp;

void rer(int big)
{
	for (int i = 2; i * i <= big; i++)
		if (big % i == 0)
		{
			p.push_back(i);
			while (big % i == 0)
				big /= i;
		}
	if (big != 1)
		p.push_back(big);
}
/*
vector <bool > arrr;
int answer = 0;

void rere(int big)
{
	arrr.resize(big + 1, 1);
	for (int i = 2; i <= big; i++)
	{
		if (!arrr[i] || check(i))
		{
			if (arrr[i])
				answer = max(answer, i);
			continue;
		}
		arrr[i] = 0;
		for (int j = i * 2; j <= big; j += i)
			arrr[j] = 0;
	}
}
*/
int main()
{
	ifstream cin("input.txt");
	//ofstream cout("output.txt");
	ios_base::sync_with_stdio(0), cin.tie(0);
	cin >> s;
	for (int i = 0; i < s.size(); i++)
		ans[int(s[i] - 'a')]++;
	int gd = ans[0];
	for (int i = 1; i < 26; i++)
		gd = gcd(gd, ans[i]);
	if (gd == s.size() || gd == 1)
	{
		cout << gd;
		return 0;
	}
	rer(gd);
	int flag = 0;
	bp.resize(p.size());
	for (int i = 0; i < p.size(); i++)
		if (gd % p[i] == 0 && check(p[i]))
		{
			flag++;
			bp[i] = true;
		}
	if (!flag)
	{
		cout << 1;
		return 0;
	}
	if (flag == 1)
	{
		for (int i = 0; i < p.size(); i++)
			if (bp[i])
			{
				cout << p[i];
				return 0;
			}
	}
	for (int i = gd; i >= 1; i--)
	{
		flag = 0;
		for (int j = 0; j < p.size(); j++)
			if (i % p[j] == 0 && !bp[j])
			{
				flag = 1;
				break;
			}
			else if (i == p[j])
			{
				cout << i;
				return 0;
			}
			else if (p[j] > i)
				break;
		if (gd % i == 0 && !flag)
			if (check(i))
			{
				cout << i;
				return 0;
			}
	}
	return 0;
}
