#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define ff first
#define ss second
#define Pair pair<node*, node*>

using namespace std;

struct node
{
    int c, val, y;

    node *l, *r;

    node(int _val)
    {
        val = _val;
        c = 1;
        y = rand();
        l = NULL;
        r = NULL;
    }
};

node* root;

int size(node* p)
{
    return (p == NULL ? 0 : p-> c);
}

void update(node* p)
{
    p-> c = 1 + size(p-> l) + size(p-> r);
}

node* merge(node* p1, node* p2)
{
    if(p1 == NULL)
        return p2;
    if(p2 == NULL)
        return p1;
    if(p1-> y < p2-> y)
    {
        p2-> l = merge(p1, p2-> l);
        update(p2);
        return p2;
    }
    else
    {
        p1-> r = merge(p1-> r, p2);
        update(p1);
        return p1;
    }
}

Pair split(node* p, int k)
{
    if(p == NULL)
        return Pair(NULL, NULL);
    int x0 = size(p-> l);
    if(x0 <= k)
    {
        Pair t = split(p-> r, k - x0 - 1);
        p-> r = t.first;
        update(p);
        return Pair(p, t.second);
    }
    else
    {
        Pair t = split(p-> l, k);
        p-> l = t.second;
        update(p);
        return Pair(t.first, p);
    }
}

int get(node* p, int k)
{
    int x0 = size(p-> l);
    if(x0 == k)
        return p-> val;
    else if(x0 < k)
        return get(p-> r, k - x0 - 1);
    else
        return get(p-> l, k);
}

void print(node* p)
{
    if(p == NULL)
        return;
    print(p-> l);
    cout << p-> val << " ";
    print(p-> r);
};

signed main()
{
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;
    vector<int> res;

    for(int i = 0; i < q; i++)
    {
        root = NULL;
        int pos;
        cin >> pos;
        pos--;
        for(int i = 0; i < n; i++)
        {
            node* x = new node(i + 1);
            root = merge(root, x);
        }
        for(int i = 0; i < n - 2; i++)
        {
            Pair t = split(root, n - 2);
            Pair t1 = split(t.first, n - 3 - i);
            root = merge(t1.first, t.second);
            root = merge(root, t1.second);
        }

        //print(root);
        //cout << endl;

        res.push_back(get(root, pos));
    }
    for(int i = 0; i < res.size(); i++)
        cout << res[i] << endl;
}
