#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll Q = 37;
const ll MOD = (int)1e9 + 9;

const int INF = (int)1e9;
const int MAXN = (int)5e6 + 7;
const int LOGN = (int)30;

vector<ll> st;

void init() {
    st.resize(MAXN);
    st[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        st[i] = st[i - 1] * Q % MOD;
    }
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string s;
    cin >> s;
    init();
    int n = s.size();
    for (int i = 1; i <= n; ++i) {
        if (n % i != 0) {
            continue;
        }
        vector<pair<int, int>> cnt(26, {0, -1});
        vector<int> prev(26, 0);
        int all = 0;
        for (int j = 0; j < i; ++j) {
            prev[s[j] - 'a']++;
        }
        for (int j = 0; j < 26; ++j) {
            if (prev[j]) {
                ++all;
            }
        }
        int now = 1, k = 0;
        bool fl = 0;
        for (int j = i; j < n; ++j) {
            int ind = s[j] - 'a';
            if (cnt[ind].second != now) {
                cnt[ind].first = 0;
                cnt[ind].second = now;
            }
            if (cnt[ind].first == prev[ind]) {
                fl = 1;
                break;
            }
            cnt[ind].first++;
            if (cnt[ind].first == prev[ind]) {
                ++k;
            }
            if ((j + 1) % i == 0) {
                if (k != all) {
                    fl = 1;
                    break;
                }
                now++;
                k = 0;
            }
        }
        if (fl) {
            continue;
        } else {
            cout << n / i << "\n";
            return 0;
        }
    }


}