#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <climits>
#include <fstream>

using namespace std;

ifstream fin("input.txt");
ofstream fout("output.txt");


int main() {

    string s;
    cin >> s;
    int ans = 1;
    if (s.size() < 500007) {
        for (int i = 1; i < s.size(); i++) {
            if (s.size() % i != 0)continue;
            vector<int> stalph(26), alph(26);
            for (int j = 0; j < i; j++) {
                stalph[(s[j] - 'a')]++;
            }
            int tempi = 0, outflag = 1;
            while (tempi < s.size()) {
                alph[s[tempi] - 'a']++, tempi++;
                if (tempi % i == 0) {
                    bool flag = 0;
                    for (int ch = 0; ch < 26; ch++) {
                        if (stalph[ch] != alph[ch]) {
                            flag = 1;
                        }
                        alph[ch] = 0;
                    }
                    if (flag) {
                        outflag = 0;
                        break;
                    }
                }
            }
            if (outflag) {
                ans = max(ans, int(s.size() / i));
            }
        }
    } else {

        vector<vector<int>> a(26, vector<int>(s.size() + 1));
        for (int i = s.size() - 1; 0 <= i; i--) {
            for (int j = 0; j < 26; j++) {
                a[j][i] = a[j][i + 1];
            }
            a[s[i] - 'a'][i]++;
        }
        for (int i = 1; i < s.size(); i++) {
            if (s.size() % i != 0)continue;
            vector<int> stalph(2), alph(2);
            stalph[0] = a[0][0] - a[0][i], stalph[1] = a[1][0] - a[1][i];
            int tempi = 0, outflag = 1;
            while (tempi < s.size()) {
                alph[0] = a[0][tempi] - a[0][tempi + i], alph[1] = a[1][tempi] - a[1][tempi + i];
                tempi += i;
                bool flag = 0;
                for (int ch = 0; ch < 2; ch++) {
                    if (stalph[ch] != alph[ch]) {
                        flag = 1;
                    }
                    alph[ch] = 0;
                }
                if (flag) {
                    outflag = 0;
                    break;

                }
            }
            if (outflag) {
                ans = max(ans, int(s.size() / i));
            }
        }
    }
    cout << ans;
    return 0;
}