#include <bits/stdc++.h>
#define ll long long
#define null NULL

using namespace std;

const ll MOD = 1e9 + 7;

ll n, m, q;
vector<pair<ll, ll> > seg;

ll get_num(ll pos, ll seg_num) {
	//cout << "founding " << pos << " " << seg_num << endl;
	if (seg_num == seg.size() - 1) {
		return n;
	}
	ll r = seg[seg_num].second;
	//cout << "r = " << r << endl;
	if ((r - pos) % 2 == 1) {
		//cout << "returning pos / 2 + 1 = " << pos / 2 << endl;
		return pos / 2 + 1;
	}
	else {
		ll diff = (r - pos) / 2;
		return get_num(seg[seg_num + 1].second - diff, seg_num + 1);
	}
}

int main() {
	cin >> n;
	m = 2 * n - 1;
	seg.push_back({m - 1, m - 1});
	ll l = (m - 1), r = (m - 1);
	while (l > 0) {
		int len = (r - l + 1);
		r = l - 1;
		l = max(r - 2 * len + 1, 0LL);
		seg.push_back({l, r});
	}
	reverse(seg.begin(), seg.end());
	/*cout << "seg" << endl;
	for (int i = 0; i < seg.size(); ++i) {
		cout << seg[i].first << " " << seg[i].second << endl;
	}*/
	cin >> q;
	for (int i = 0; i < q; ++i) {
		ll pos;
		cin >> pos;
		pos--;
		ll seg_num = upper_bound(seg.begin(), seg.end(), make_pair(pos, pos)) - seg.begin() - 1;
		cout << get_num(pos, seg_num) << endl;
	}
}