import java.io.*;
import java.lang.reflect.Array;
import java.util.*;

public class Main {
    int gcd(int a, int b) {
        if (b == 0) return a;
        return gcd(b, a % b);
    }

    public void solve() throws IOException {
        String s = nextToken();
        int n = s.length();
        int x = 0;
        int[] d = new int[26];
        for (int i = 0; i < n; i++) {
            d[s.charAt(i) - 'a']++;
        }
        long res = 1;
        int p = 0;
        for (int i = 25; i >= 0; i--) {
            if (d[i] != 0) {
                p++;
                x = gcd(d[i], x);
            }
        }

        boolean[] used = new boolean[x + 1];
        for (int i = 1; i <= x; i++) {
            if (!used[i] && x % i == 0) {
                int p1 = 0;
                int[] d1 = new int[26];
                for (int j = 0; j < 26; j++) {
                    d1[j] = d[j] / i;
                    if (d1[j] != 0) p1++;
                }
                int[] d2 = new int[26];
                int z = 1;
                int p2 = 0;
                boolean t = true;
                for (int j = 0; j < n; j++) {
                    int h = s.charAt(j) - 'a';
                    d2[h]++;
                    if (d2[h] == z * d1[h]) {
                        p2++;
                        if (p2 == p1) {
                            z++;
                            p2 = 0;
                        }
                    } else {
                        if (d2[h] > z * d1[h]) {
                            t = false;
                            break;
                        }
                    }
                }
                if (t) {
                    res = i;
                } else {
                    for (int j = i; j <= x; j += i) {
                        used[j] = true;
                    }
                }
            }
        }
        out.print(res);
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
