#include <bits/stdc++.h>

using namespace std;

vector<int> g[2000], ge[2000];
int p[2000];
set<int> se;
int tin[2000], tout[2000];
int gl = 0;
int up[20][2000];
int c[2000];

void dfs(int v, int p, int d = 0){
    tin[v] = gl++;
    up[0][v] = p;
    for (int i = 1; i < 20; ++i)
        up[i][v] = up[i - 1][up[i - 1][v]];

    for (int i = 0; i < (int)g[v].size(); ++i){
        dfs(g[v][i], v, d + 1);
    }

    tout[v] = gl++;
}

bool is_par(int a, int b){
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b){
    if (is_par(a, b))
        return a;
    if (is_par(b, a))
        return b;

    for (int i = 19; i >= 0; --i)
        if (!is_par(up[i][a], b))
            a = up[i][a];
    return up[0][a];
}

vector<pair<int, int> > ve[2000];

int main()
{
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i){
        cin >> p[i];
        --p[i];
        g[p[i]].push_back(i);
    }
    for (int i = 1; i < n; ++i)
        cin >> c[i];

    dfs(0, 0);

    for (int i = 0; i < n; ++i){
        for (int j = i + 1; j < n; ++j){
            int it = lca(i, j);
            if (it == i || it == j)
                continue;
            ve[it].push_back({i, j});
        }
    }

    long long ans = 0;
    for (int i = 0; i < n; ++i){
        for (int i = 0; i < n; ++i){
            ge[i].clear();
        }

        se.clear();
        for (auto it = ve[i].begin(); it != ve[i].end(); ++it){
            se.insert(it->first);
            se.insert(it->second);
            ge[it->first].push_back(it->second);
            ge[it->second].push_back(it->first);
        }

        bool fl = 0;
        for (auto it = se.begin(); it != se.end(); ++it)
            if(ge[*it].size() == 1)
                fl = 1;
        if (fl){
            ans += (se.size() - 1) * 2;
        }
        else{
            ans += se.size() + (int)se.size() % 2;
        }
    }

    cout << ans << '\n';
    return 0;
}
