#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <queue>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <chrono>

using namespace std;

typedef long long LL;

#define _TEST

#ifdef _DEBUG
const int MAXL = 5050;
#else
const int MAXL = 500050;
#endif

const int SIGMA = 26;
/*
int mindiv[MAXL];
vector<int> primes;
*/

int main() {
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  cin.tie(0);
  cin.sync_with_stdio(0);
/*
  primes.reserve(350000);

#ifdef _TEST
  auto tstart = chrono::high_resolution_clock::now();
#endif
  for (int i = 2; i < MAXL; ++i) {
    if (mindiv[i] == 0) {
      mindiv[i] = i;
      primes.push_back(i);
    }
    for (int j = 0; j < primes.size() && primes[j] <= mindiv[i] && i * 1ll * primes[j] < MAXL; ++j) {
      mindiv[i * 1ll * primes[j]] = primes[j];
    }
  }
#ifdef _TEST
  {
    auto tend = chrono::high_resolution_clock::now();
    chrono::duration<double> tmp = tend - tstart;
    double kek = tmp.count();
    fprintf(stderr, "Primes precalc took %lf s\n", kek);
    fprintf(stderr, "primes: %d\n", (int)primes.size());
  }
#endif
*/
  vector<char> s;
  {
    string _s;
    cin >> _s;
    s.resize(_s.length());
    for (int i = 0; i < _s.length(); ++i) {
      s[i] = _s[i] - 'a';
    }
  }
  
  vector<int> cnt(SIGMA);
  vector<vector<int>> possym(SIGMA);

  for (char c = 0; c < SIGMA; ++c) {
    possym[c].reserve(20000);
  }

  for (int i = 0; i < s.size(); ++i) {
    possym[s[i]].push_back(i);
    cnt[s[i]]++;
  }

  int n = s.size();

  vector<int> possible;

  int bad = 0;
  for (int i = 0; i < SIGMA; ++i)
    if (cnt[i]) bad++;

  const int BAD = bad;

  vector<int> cur(SIGMA);

  for (int i = 0; i < n; ++i) {
    int t = cnt[s[i]];
    int &c = cur[s[i]];

    if (c == 0 || (t % c != 0 && t % (c + 1) == 0)) bad--;
    if (c != 0 && t % c == 0 && t % (c + 1) != 0) bad++;
    ++c;

    if (bad == 0 && n % (i + 1) == 0) possible.push_back(i + 1);
  }

#ifdef _TEST
  fprintf(stderr, "possible size: %d\n", (int)possible.size());
#endif

  for (auto len : possible) {
    bool ok = 1;
    for (int j = 1; j < n / len; ++j) {
      vector<int> cur(SIGMA);
      int bad = BAD;

      for (int i = j * len; i < len * (j + 1); ++i) {
        int t = cnt[s[i]];
        int &c = cur[s[i]];

        if (c == 0 || (t % c != 0 && t % (c + 1) == 0)) bad--;
        if (c != 0 && t % c == 0 && t % (c + 1) != 0) bad++;
        ++c;
      }

      if (bad) {
        ok = 0;
        break;
      }
    }
    if (ok) {
      cout << n / len << '\n';
      return 0;
    }
  }

  return 0;
}