#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <iterator>
#include <time.h>

using namespace std;

const long long MOD = 1e9 + 7 ;


long long kek[28], lol[28], pref1[5123456], pref2[5123456] ;
string s ;
int n, ans ;

void check ( int curr )
{
    long long x, y ;

    x = ( pref1[curr] - pref1[0] + MOD ) % MOD ;
    y = pref2[curr] - pref2[0] ;

    for ( int j=0; j+curr<=n; j += curr )
    {
        if ( ( pref1[j + curr] - pref1[j] + MOD )  % MOD  != x )
            return ;

        if ( pref2[j + curr] - pref2[j] != y )
            return ;
    }

    ans = max ( ans, n / curr ) ;

    return ;
}

int main()
{
    ios_base :: sync_with_stdio ( false ) ;

    int i ;

    srand ( 47 ) ;

    cin >> s ;

    n = s.length() ;
    for ( i=0; i<28; i++ )
    {
        kek[i] = (rand() << 15) + rand() ;
        lol[i] = (rand() << 15) + rand() ;
    }

    pref1[0] = pref2[0] = 0 ;
    for ( i=1; i<=n; i++ )
    {
        pref1[i] = ( pref1[i-1] + kek[ (int)s[i-1] - (int)'a' ] ) % MOD ;
        pref2[i] = pref2[i-1] + lol[ (int)s[i-1] - (int)'a' ] ;
    }

    ans = 0 ;
    for ( i=1; i*i<=n; i++ )
    {
        if ( n % i == 0 )
        {
            check ( i ) ;
            check ( n / i ) ;
        }
    }

    cout << ans ;

    return 0;
}
