#ifndef LOCAL
    #pragma GCC optimize("Ofast")
    #pragma GCC target("sse,sse2,sse3,sse4")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>
#define ll long long
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define F first
#define S second
#define double long double
#define ld double
#define pii pair<int, int>

const int INF = INT_MAX / 2;
const ll LINF = 2e18 + 666, M = 1e9 + 7;
const ld EPS = 1e-10;

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

template<class T, class CMP = less<T>>
using ordered_set = tree<T, null_type, CMP, rb_tree_tag, tree_order_statistics_node_update>;

template<class T1, class T2>
bool mini(T1 &x, T2 y)
{
    if (x > y)
    {
        x = y;
        return 1;
    }
    return 0;
}

template<class T1, class T2>
bool maxi(T1 &x, T2 y)
{
    if (x < y)
    {
        x = y;
        return 1;
    }
    return 0;
}

void run();

int main()
{
    srand(time(0));
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(15) << fixed;
    auto start = clock();
    run();
    #ifdef LOCAL
        cout << "\ntime = " << (ld)(clock() - start) / CLOCKS_PER_SEC;
    #endif
}

#define DEBUG
#if defined DEBUG && defined LOCAL
    #define debugdo(x) x
#else
    #define debugdo(x)
#endif
#define debug(x) debugdo(cout << x << endl);
#define debug2(x) debugdo(cout << x << " ");

// ---SOLUTION--- //

struct line
{
    ll a, b, c;
    line(pii p1 = {0, 0}, pii p2 = {0, 0}): a(p1.F - p2.F), b(p2.S - p1.S), c(p1.F * a + p1.S * b){}
};

pii inter(line a, line b)
{
    if (a.a * b.b == b.a * a.b)
        return {INF, INF};
    int x, y;
    if (a.a == 0)
    {
        if (a.c % a.b)
            return {INF, INF};
        y = a.c / a.b;
        x = b.c - b.b * y;
        return {x, y};
    }
    if (b.a % a.a)
        return {INF, INF};
    int c = b.a / a.a;
    a.a -= c * b.a;
    a.b -= c * b.b;
    a.c -= c * b.c;
    if (a.c % a.b)
        return {INF, INF};
    y = a.c / a.b;
    x = b.c - b.b * y;
    return {x, y};
}

vector<int> p;
int n;
vector<pii> a;

void gen(int x, int c)
{
    if (c == 0)
    {
        vector<line> l;
        for (int i = 0; i < n; i++)
        {
            if (p[i] > i)
            {
                l.pb(line(a[i], a[p[i]]));
            }
        }
        pii p = inter(l[0], l[1]);
        if (p.F == INF)
            return;
        for (int i = 2; i < n; i++)
        {
            if (l[i].a * p.F + l[i].b * p.S + l[i].c != 0)
                return;
        }
        cout << "Yes\n" << p.F << " " << p.S;
        exit(0);
    }
    int nxt1 = x + 1;
    while (nxt1 < n && p[nxt1] != -1)
        nxt1++;
    int nxt2 = nxt1 + 1;
    while (nxt2 < n && p[nxt2] != -1)
        nxt2++;
    for (int i = x + 1; i < n; i++)
    {
        if (p[i] == -1)
        {
            p[x] = i;
            p[i] = x;
            gen(((i == x) ? nxt2 : nxt1), c - 2);
            p[x] = -1;
            p[i] = -1;
        }
    }
}

void run()
{
    cin >> n;
    n *= 2;
    a.resize(n);
    for (auto &x: a)
        cin >> x.F >> x.S;
    p.resize(n, -1);
    if (n == 2)
    {
        int x = a[0].F - a[1].F;
        int y = a[0].S - a[1].S;
        int g = __gcd(x, y);
        x /= g;
        y /= g;
        cout << "Yes\n";
        cout << a[0].F + x << " " << a[0].S + y;
        return;
    }
    gen(0, n);
}
/*

*/
