#include <iostream>
#include <algorithm>
#include <vector>
#include <fstream>
#include <queue>
#include <string>

using namespace std;

const int maxn = 2e5 + 88;
const int inf = 1e9 + 88;

string s;
vector<int> v;
int cnt[26], curcnt[26];
int n;

bool check(int d)
{
    int i, j, k;
    for (i = 0; i < 26; i++)
        curcnt[i] = cnt[i] = 0;
    for (i = 0; i < d; i++)
        cnt[s[i] - 'a']++;
    int all_cnt = n/d;
    for (k = 1; k < all_cnt; k++)
    {
        int fn = (k + 1)*d;
        for (j = k*d; j < fn; j++)
            curcnt[s[j] - 'a']++;
        for (i = 0; i < 26; i++)
        {
            if (curcnt[i] != cnt[i])
                return false;
            curcnt[i] = 0;
        }
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    ifstream cin("input.txt");
    int i, j;
    cin >> s;
    n = s.length();
    for (i = 1; i*i <= n; i++)
        if (n%i == 0)
        {
            v.push_back(i);
            if (i*i != n)
                v.push_back(n/i);
        }
    sort(v.begin(), v.end());
    for (i = 0; i < v.size(); i++)
        if (check(v[i]))
        {
            cout << n/v[i];
            return 0;
        }
    return 0;
}
