//
// Created by olymp on 09.03.2018.
//
#include <iostream>
#include <vector>

using ll = long long;

const ll INF = 1000000000;
ll ans = 0;
std::vector<ll> sum, min, cnt, c;
std::vector< std::vector<int> > G;
int n = 0;

void DFS(int v) {
    if (G[v].empty()) {
        cnt[v] = 1;
        sum[v] = min[v] = c[v];
        return;
    }
    int max_cnt = G[v][0];
    cnt[v] = 0;
    min[v] = INF;
    sum[v] = 0;
    for (auto i : G[v]) {
        DFS(i);
        sum[v] += sum[i];
        min[v] = std::min(min[v], min[i]);
        cnt[v] += cnt[i];
        if (cnt[i] > cnt[max_cnt]) {
            max_cnt = i;
        }
    }
    if (cnt[max_cnt] >= cnt[v] - cnt[max_cnt]) {
        ll min2 = INF;
        for (auto i : G[v]) {
            if (i != max_cnt && min[i] < min2) {
                min2 = min[i];
            }
        }
        ans += sum[v] + (2 * cnt[max_cnt] - cnt[v]) * min2;
        //std::cout << sum[v] << ' ' << cnt[max_cnt] << ' ' << cnt[v] << ' ' << min2 << '\n';
    } else {
        ans += sum[v];
        if (cnt[v] % 2) {
            ans += min[v];
        }
    }
    min[v] = std::min(min[v], c[v]);
    sum[v] += c[v];
    cnt[v] += 1;
}

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cin >> n;
    G.resize(n);
    sum.resize(n);
    min.resize(n);
    c.resize(n);
    cnt.resize(n);
    for (int i = 1; i < n; ++i) {
        int p = 0;
        std::cin >> p;
        G[p - 1].push_back(i);
    }
    for (int i = 1; i < n; ++i) {
        std::cin >> c[i];
    }
    DFS(0);
    std::cout << ans;
    return 0;
}