#include <iostream>
#include <math.h>
#include <vector>
#include <algorithm>
using namespace std;

template<typename T> int countv(T s, int n, char val)
{
    int cnt = 0;
    for (int i = 0; i < n; ++i)
        cnt += s[i] == val;
    return cnt;
}

template<typename T> int countv(T s, int p1, int p2, char val)
{
    int cnt = 0;
    for (int i = p1; i < p2; ++i)
        cnt += s[i] == val;
    return cnt;
}

int main()
{
    string s;
    cin >> s;
    int n = s.length();
    vector<int> chk;
    for (int i = 2; i < sqrt(n); ++i)
        if (n % i == 0)
            chk.push_back(i), chk.push_back(n / i);
    if (int(sqrt(n)) * int(sqrt(n)) == n)
        chk.push_back(sqrt(n));
    sort(chk.begin(), chk.end());
    int K = countv(s, n, 'a') + countv(s, n, 'b') == n ? 2 : 26;
    if (countv(s, n, s[0]) == n)
    {
        cout << n;
        return 0;
    }
    for (int l: chk)
    {
        bool h = true;
        int ans[K];
        for (int i = 0; i < K; ++i)
            ans[i] = countv(s, l, 'a'+i);
        for (int i = l; i < n && h; i += l)
            for (int j = 0; j < K && h; ++j)
                h &= countv(s, i, i + l, 'a'+j) == ans[j];
        if (h)
        {
            cout << n / l;
            return 0;
        }
    }
    cout << 1;
    return 0;
}
