//4324320

#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <cstring>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <ctime>
#include <algorithm>
#include <math.h>
#include <cmath>
//#include <corecrt_math.h>

#pragma warning (disable : 4996)

using namespace std;

const long long MAXN = 3e3 + 10;
const double EPS = 1e-6;

struct point {
	long long x, y;

	point() {}

	point(long long x, long long y) {
		this->x = x;
		this->y = y;
	}

	friend bool operator != (const point p1, const point p2) {
		return p1.x != p2.x || p1.y != p2.y;//fabs(p1.x - p2.x) > EPS || fabs(p1.y - p2.y) > EPS;
	}

	friend bool operator == (const point p1, const point p2) {
		return !(p1 != p2);
	}
};

struct line {
	long long a, b, c;

	line() {}

	line(long long a, long long b, long long c) {
		this->a = a;
		this->b = b;
		this->c = c;
	}

	line(const point p1, const point p2) {
		this->a = p1.y - p2.y;
		this->b = p2.x - p1.x;
		this->c = -p2.x * p1.y + p2.y * p1.x;
	}
};

/*point intersection(line l1, line l2) {
	point ans;
	ans.x = ((double)l1.c * l2.b - (double)l2.c * l1.b) / ((double)l1.b * l2.a - (double)l1.a * l2.b);
	ans.y = ((double)l2.c * l1.a - (double)l1.c * l2.a) / ((double)l1.b * l2.a - (double)l1.a * l2.b);
	return ans;
}*/

istream & operator >> (istream &cin, point &p) {
	cin >> p.x >> p.y;
	return cin;
}

/*long long my(float f) {
	if (f < 0) {
		return int(f - EPS);
	} else {
		return int(f + EPS);
	}
}*/

long long n;
point ps[MAXN];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	/*#ifndef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif*/

	cin >> n;
	for (long long i = 0; i < n * 2; i++) {
		cin >> ps[i];
	}
	//cout << long long(1.5) << "\n" << long long(-1.5);
	for (long long aa = 0; aa < n * 2; aa++) {
		for (long long ab = 0; ab < n * 2; ab++) {
			for (long long ba = 0; ba < n * 2; ba++) {
				for (long long bb = 0; bb < n * 2; bb++) {
					if (aa != ab && aa != ba && aa != bb && ab != ba && ab != bb && ba != bb) {
						line l1 = line(ps[aa], ps[ab]);
						line l2 = line(ps[ba], ps[bb]);
						long long h = (l1.b * l2.a - l1.a * l2.b);
						long long g = (l1.c * l2.b - l2.c * l1.b);
						long long f = (l2.c * l1.a - l1.c * l2.a);
						if (h != 0 && g % h == 0 && f % h == 0) {
							//if (fabs(l1.b * l2.a - l1.a * l2.b) > EPS) {
							//point p = intersection(l1, l2);
							point p(g / h, f / h);
							//if (fabs(p.x - my(p.x)) < EPS && fabs(p.y - my(p.y)) < EPS) {
								if (p != ps[aa] && p != ps[ab] && p != ps[ba] && p != ps[bb]) {
									cout << "Yes\n";
									cout << p.x << " " << p.y;
									return 0;
								}
							//}
							//cout << p.x << " " << p.y << "\n";
						}
						//}

					}
				}
			}
		}
	}
	cout << "No\n";
}