#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define mp make_pair
#define pob pop_back
#define pub push_back
#define S second
#define F first
#define PI acos(-1)

const int N = 1005000;
const int MAXN = 1e9 + 7;
const ll L = 1e12;
const ll MAXL = 1e18 + 9;
const double eps = 1e-12;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string s;
    cin >> s;
    int n = s.size();
    vector<unsigned int> hash1(n);
    vector<short int> hash2(n);
    hash1[0] = int(s[0]) * int(s[0]);
    hash2[0] = int(s[0]);
    for (int i = 1; i < n; ++i) {
        hash1[i] = hash1[i - 1] + (unsigned int)(int(s[i]) * int(s[i]));
        hash2[i] = (hash2[i - 1] ^ (s[i]));
    }
    vector<int> divs;
    int max_div = 0;
    int cnt = 0;
    for (int i = 0; i < 26; ++i) {
        for (auto j : s) {
            if (j == char('a' + i)) {
                cnt++;
            }
        }
        max_div = __gcd(max_div, cnt);
    }
    for (int i = 1; i * i <= n; ++i) {
        if (n % i == 0 && (max_div % i) == 0) {
            divs.push_back(i);
            if (i * i != n && (max_div % (n / i)) == 0) {
                divs.push_back(n / i);
            }
        }
    }
    sort(divs.rbegin(), divs.rend());
    int len;
    unsigned int h1;
    short int h2;
    ll temph;
    bool ok;
    for (auto i : divs) {
        len = n / i;
        h1 = hash1[len - 1];
        h2 = hash2[len - 1];
        ok = true;
        for (int j = 2 * len - 1; j < n; j += len) {
            temph = hash1[j] - hash1[j - len];
            if (temph != h1) {
                ok = false;
                break;
            }
            temph = hash2[j] ^ hash2[j - len];
            if (temph != h2) {
                ok = false;
                break;
            }
        }
        if (ok) {
            cout << i << "\n";
            return 0;
        }
    }
    return 0;
}
/*

*/
