#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int SZ = 2e5 + 10;

int n;
int price[SZ];
vector<int> graph[SZ];

int size_of[SZ];
int res[SZ];

void dfs(int v)
{
    for (int to : graph[v]) {
        dfs(to);
        size_of[v] += size_of[to];
    }
    res[v] = size_of[v];
    bool is = false;
    for (int to : graph[v]) {
        if (size_of[to] * 2 > size_of[v]) {
            res[v] += size_of[to] * 2 - size_of[v];
            is = true;
        }
    }
    if (!is && (size_of[v] & 1))
        res[v]++;
    size_of[v]++;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for (int i = 2; i <= n; i++) {
        int a;
        cin >> a;
        graph[a].push_back(i);
    }
    for (int i = 2; i <= n; i++)
        cin >> price[i];
    dfs(1);
    int ans = 0;
    for (int i = 1; i <= n; i++)
        ans += res[i];
    cout << ans;
    return 0;
}
