#include <bits/stdc++.h>

//#define int long long
#define forn(i, a, b) for (int i = a; i < b; ++i)
#define ford(i, a, b) for (int i = a; i > b; --i)
#define fs first
#define sc second
#define mp(x, y) make_pair(x, y)
#define pb(x) push_back(x)
#define sz(x) (int)x.size()
#define len(x) (int)x.length()
#define pii pair<int, int>
#define vi vector<int>
#define vvi vector<vi>
#define ios ios_base::sync_with_stdio(false); cin.tie(0)
#define dbg(x) forn(i, 0, sz(x)) cerr << x[i] << ' '; cerr << endl;
using namespace std;

const int MAXN = (int)5e5 + 10;
vi pref[MAXN];
int n;
vi get(int l, int r) {
    vi right = pref[r + 1];
    vi left = pref[l];
    vi res(26, 0);
    forn(i, 0, 26)
        res[i] = right[i] - left[i];
    return res;
}

bool check(int m) {
    if (n % m) return 0;
    int step = n / m;
    vi ch = get(0, step - 1);
    /*
    forn(i, 0, sz(ch))
        cerr << ch[i] << ' ';
    cerr << endl;
    */
    for (int i = step; i < n; i += step) {
        vi now = get(i, i + step - 1);
        /*
        forn(i, 0, sz(now))
            cerr << now[i] << ' ';
        cerr << endl;
        */
        if (now != ch) return 0;
    }
    return 1;
}



void solve(string &s, int num_a, int num_b) {

    int res = 1;
    if (num_a == n || num_b == n) {
        cout << n << endl;
        return;
    }
    int mn = min(num_a, num_b);

    forn(j, 2, mn + 1) {
        int nums = 0;
        if (num_a % j || num_b % j) continue;
        int aa = num_a / j, bb = num_b / j;
        int cur_a = 0, cur_b = 0;
        forn(i, 0, n) {
            cur_a += s[i] == 'a';
            cur_b += s[i] == 'b';
            if (cur_a && cur_b && !(cur_a % aa) && !(cur_b % bb) && cur_a / aa == cur_b / bb) nums++;
        }
        if (!(n % nums) && nums > 1) res = j;
    }
    cout << res << endl;
}

signed main()
{

    srand(time(0));
    ios;
    string s;
    cin >> s;
    n = len(s);

    int aa = 0, bb = 0;
    forn(i, 0, n) {
        aa += s[i] == 'a';
        bb += s[i] == 'b';
    }
    if (aa + bb == n) {
        int kek = 0;
        solve(s, aa, bb);
        return 0;
    }
    pref[0] = vi(26, 0);
    forn(i, 0, n) {
        int cur = s[i] - 'a';
        pref[i + 1] = pref[i];
        pref[i + 1][cur]++;
    }

    int l = 1, r = n;
    int mx = -1;

    int d = 2;
    vi div;
    while (d * d <= n) {
        if (!(n % d)) div.pb(d), div.pb(n / d);
        d++;
    }
    div.pb(1);
    div.pb(n);
    dbg(div);

    random_shuffle(div.begin(), div.end());
    random_shuffle(div.begin(), div.end());
    clock_t cl = clock();
    for (int i = 0; i < sz(div) && clock() - cl <= 0.9 * CLOCKS_PER_SEC; ++i) {

        int m = div[i]; //(r + l) / 2;
        if (check(m)) mx = max(mx, m); //l = m;
        //else r = m;
/*
        int cur = i;

        if (check(cur)) mx = cur;
*/
    }

    /*
    forn(i, 0, sz(pref)) {

        forn(j, 0, sz(pref[i]))
            cerr << pref[i][j] << ' ';
        cerr << endl << endl;
    }
    cerr << check(3) << endl;
*/
    cout << mx << endl;


    return 0;
}
