// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pll pair<ll, ll>
#define pii pair<int, int>
#define mp make_pair
#define pb push_back
#define ld long double
#define x first
#define y second
const int deb = 0;
#define pas(x) if (deb) cout << #x << ' ' << x << endl;

ll MX = 1e6;
struct point {
	ll x, y;
};
bool operator== (point a, point b) {
	return mp(a.x, a.y) == mp(b.x, b.y);
}
bool operator!= (point a, point b) {
	return mp(a.x, a.y) != mp(b.x, b.y);
}
bool operator< (point a, point b) {
	return mp(a.x, a.y) < mp(b.x, b.y);
}
point fict = {MX + 1, MX + 1};

struct line {
	ll a, b, c;
	line (point p1, point p2) {
		a = -p1.y + p2.y;
		b = p1.x - p2.x;
		c = -a * p1.x - b * p1.y;
	}
};
ld eps = 1e-9;

bool operator<(line l1, line l2) {
	ld y1, x1, y2, x2;
	if (l1.a == 0) {
		x1 = (MX + 1) * (MX + 1) * 20;
	} else {
		x1 = (ld)(-l1.c) / l1.a;
	}
	if (l2.a == 0) {
		x2 = (MX + 1) * (MX + 1) * 20;
	} else {
		x2 = (ld)(-l2.c) / l2.a;
	}
	if (l1.b == 0) {
		y1 = (MX + 1) * (MX + 1) * 20;
	} else {
		y1 = (ld)(-l1.c) / l1.b;
	}
	if (l2.b == 0) {
		y2 = (MX + 1) * (MX + 1) * 20;
	} else {
		y2 = (ld)(-l2.c) / l2.b;
	}

	if (abs(x1 - x2) < eps) {
		if (abs(y1 - y2) < eps) return 0;
		return y1 < y2;
	}
	return x1 < x2;
}

point is_valid(line l, ll x) {
	if (l.c + l.a * x % l.b != 0) return fict;
	ll y =  l.c + l.a * x / (-l.b);
	if (y > MX || y < -MX) return fict;
	point p = {x, y};
	return p;
}

set<point> ps;

bool is_valid(point p) {
	if (p.x < -MX || p.x > MX || p.y < -MX || p.y > MX) return 0;
	if (ps.count(p)) return 0;
	return 1;
}

point peres(line l1, line l2) {
	if (l1.a * l2.b == l2.a * l1.b) return fict;
	if ((l1.a * l2.c - l2.a * l1.c) % (l2.a * l1.b - l1.a * l2.b) != 0) return fict;
	ll y = (l1.a * l2.c - l2.a * l1.c) / (l2.a * l1.b - l1.a * l2.b);
	ll x;
	if (l1.a == 0) {
		if ((-l2.b * y - l2.c) % (l2.a) != 0) return fict;
		x = (-l2.b * y - l2.c) / l2.a;
	} else {
		if ((-l1.b * y - l1.c) % (l1.a) != 0) return fict;
		x = (-l1.b * y - l1.c) / l1.a;
	}


	point p = {x, y};
	if (is_valid(p)) return p;
	else return fict;
}

vector<point> p;
int main() {
	cout.precision(30);
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int n; cin >> n;
	p.resize(2 * n);
	for (int i = 0; i < 2 * n; i++) {
		cin >> p[i].x >> p[i].y;
		ps.insert(p[i]);
	}

	if (n == 1) {
		line l(p[0], p[1]);
		for (int x = -MX; x <= MX; x++) {
			point po = is_valid(l, x);
			if (po != fict && po != p[0] && po != p[1]) {
				cout << "Yes" << endl;
				cout << po.x << ' ' << po.y << endl;
				return 0;
			}
		}
		cout << "No";
		return 0;
	}

	int na = 0, nb = 1;
	for (int abc = 0; abc < 2; abc++, nb = 2) {

		for (int nc = 0; nc < 2 * n; nc++) {
			if (nc == na || nc == nb) continue;
			for (int nd = 0; nd < 2 * n; nd++) {
				if (nd == na || nd == nb || nd == nc) continue;
				pas(na);
				pas(nb);
				pas(nc);
				pas(nd);
				point a = p[na], b = p[nb], c = p[nc], d = p[nd];
				line l1(a, c);
				line l2(b, d);

				point moon = peres(l1, l2);
				if (moon == fict) continue;
				pas(moon.x);
				pas(moon.y);
				map<line, int> s; 
				bool good = 1;
				for (int i = 0; i < 2 * n; i++) {
					line l(moon, p[i]);
					s[l]++;
					if (s[l] == 3) {
						good = 0;
						break;
					}
				}

				if (good == 0) continue;
				for (auto p : s) {
					if (p.second == 1) {
						good = 0;
						break;
					}
				}

				if (good) {
					cout << "Yes" << endl;
					cout << moon.x << ' ' << moon.y << endl;
					return 0;
				}
			}
		}

	}
	cout << "No" << endl;

	return 0;
}