#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <string>
#include <vector>
#include <random>
#include <ctime>
#include <iostream>
#include <algorithm>

using namespace std;

#define X first
#define Y second

const int MAXN = 200100;
long long n, p, ans = 0;
long long c[MAXN], mik[MAXN], sz[MAXN], su[MAXN];
vector<long long> g[MAXN];

void dfsz(long long v)
{
	sz[v] = 1;
	su[v] = c[v];
	mik[v] = c[v];
	for (long long i : g[v])
	{
		dfsz(i);
		sz[v] += sz[i];
		su[v] += su[i];
		mik[v] = min(mik[v], mik[i]);
	}
}

void dfs(long long v)
{
	long long mi = -1, num = (sz[v] - 1) % 2;
	long long m = (sz[v] - 1) / 2;
	for (long long i : g[v])
	{
		dfs(i);
		if (sz[i] > m)
		{
			num = 2 * sz[i] - (sz[v] - 1);
		}
		else
		{
			if (mi == -1 || mi > mik[i])
			{
				mi = mik[i];
			}
		}
		ans += su[i];
	}
	ans += num * mi;
}

int main()
{
#if _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
	cin >> n;
	for (long long i = 1; i < n; i++)
	{
		cin >> p;
		p--;
		g[p].push_back(i);
	}
	c[0] = 0;
	for (long long i = 1; i < n; i++)
	{
		cin >> c[i];
	}
	dfsz(0);
	dfs(0);
	cout << ans;
    return 0;
}