#include <bits/stdc++.h>

using namespace std;

ifstream in("input.txt");
ofstream out("output.txt");

long long dp(long long x, long long n, map<long long, long long>& m)
{
    if (m.count(x))
    {
        return m[x];
    }
    if (x % 2)
    {
        m[x] = (x + 1) / 2;
        return m[x];
    }
    m[x] = dp(n + x / 2, n, m);
    return m[x];
}

int main()
{
    ios_base::sync_with_stdio(false);
    in.tie(nullptr);
    long long n, q, x;
    in >> n >> q;
    map<long long, long long> m;
    for (int i = 0; i < q; ++i)
    {
        in >> x;
        out << dp(x, n, m) << '\n';
    }
    in.close();
    out.close();
    return 0;
}