#include <bits/stdc++.h>

using namespace std;

ifstream in("input.txt");
ofstream out("output.txt");

long long dfs(int v, vector<vector<int>>& G, long long& result)
{
    long long qua = 0;
    multiset<long long, greater<>> s;
    for (auto u : G[v])
    {
        long long tmp = dfs(u, G, result);
        s.insert(tmp);
        qua += tmp;
    }
    if (s.empty())
    {
        return 1;
    }
    long long maxi = *s.begin();
    s.erase(s.begin());
    if (maxi > qua - maxi)
    {
        result += qua - maxi;
        maxi -= qua - maxi;
        result += maxi;
    }
    else
    {
        result += qua / 2 + qua % 2;
    }
//    while (!s.empty())
//    {
//        while (!s.empty() && *s.begin() <= maxi)
//        {
//            result += *s.begin();
//            maxi -= *s.begin();
//            s.erase(s.begin());
//        }
//        if (!s.empty())
//        {
//            result += maxi;
//            maxi = *s.begin() - maxi;
//            s.erase(s.begin());
//        }
//    }
//    result += maxi;
    return qua + 1;
}

int main()
{
    ios_base::sync_with_stdio(false);
    in.tie(nullptr);
    int n, p;
    in >> n;
    vector<vector<int>> G(static_cast<unsigned int>(n + 1));
    for (int i = 2; i <= n; ++i)
    {
        in >> p;
        G[p].push_back(i);
    }
    vector<int> c(static_cast<unsigned int>(n + 1));
    for (int i = 2; i <= n; ++i)
    {
        in >> c[i];
    }
    long long result = 0;
    dfs(1, G, result);
    out << result * 2 << '\n';
    in.close();
    out.close();
    return 0;
}