#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <time.h>
#include <random>
#include <algorithm>

using namespace std;

const int MAXN = 5e5 + 7;

int pref[MAXN][26];

signed main() {
    ios_base::sync_with_stdio(false);
    freopen("input.txt", "r", stdin);

    string s;
    cin >> s;

    int n = s.size();
    for (int i = 0; i < n; ++i) {
        for (int c = 0; c < 26; ++c) {
            pref[i + 1][c] = pref[i][c];
        }
        ++pref[i + 1][s[i] - 'a'];
    }

    for (int len = 1; len <= n; ++len) {
        if (n % len == 0) {
            bool check = true;

            for (int l = len; l <= n; l += len) {
                for (int c = 0; c < 26; ++c) {
                    check &= (pref[l][c] - pref[l - len][c] == pref[len][c]);
                }
            }

            if (check) {
                cout << n / len << '\n';
                return 0;
            }
        }
    }

    return 0;
}