#include <iostream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <set>
#include <cstdio>

using namespace std;

const int MAXN = 5e6 + 1;

vector <int> d;
vector <int> k[MAXN];
int cnt[1000], all[1000];
vector <bool> solve;

bool check(int i) {
    for (int c = 'a'; c <= 'z'; c++)
        if (all[c] % i != 0)
            return false;
    return true;
}

int32_t main() {
    assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    string s; cin >> s;

    int n = (int)s.length();

    for (int i = 0; i < n; i++)
        all[s[i]]++;

    for (int i = 1; i * i <= n; i++) {
        if (n % i == 0) {
            if (check(n / i))
                d.push_back(i);
            if (i * i != n && check(i))
                d.push_back(n / i);
        }
    }

    for (int i = 0; i < (int)d.size(); i++)
        for (int j = d[i]; j <= n; j += d[i])
            k[j].push_back(i);
    solve.resize((int)d.size(), true);
    for (int i = 'a'; i <= 'z'; i++)
        cnt[i] = 0;
    for (int i = 1; i <= n; i++) {
        cnt[s[i - 1]]++;
        for (int j = 0; j < (int)k[i].size(); j++) {
            int d0 = d[k[i][j]];
            for (int c = 'a'; c <= 'z'; c++)
                if ((long long)cnt[c] * (long long)n != (long long)all[c] * (long long)i)
                    solve[k[i][j]] = false;
        }
    }

    int res = n;
    for (int i = 0; i < (int)d.size(); i++)
        if (solve[i])
            res = min(res, d[i]);

    cout << n / res << endl;

    return 0;
}
