#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>

using namespace std;

struct res
{
    int sz;
    long long best, sum;
    explicit res(int sz, int best, int sum) : sz(sz), best(best), sum(sum) {}
};

vector<int> perf;
vector<vector<int> > ch;

long long ans = 0;

res dfs(int v)
{
    vector<res> ch_res;
    int mx_sz = 0;
    int sz = 0;
    long long sum = 0;
    long long best = 1e9;
    if (ch.empty())
        return res(1, perf[v], perf[v]);
    for (int u : ch[v])
    {
        ch_res.push_back(dfs(u));
        mx_sz = max(mx_sz, ch_res.back().sz);
        sz += ch_res.back().sz;
        sum += ch_res.back().sum;
        best = min(best, ch_res.back().best);
    }
    if (sz < 2 * mx_sz)
    {
        long long my_best = 1e9;
        for (auto &el : ch_res)
            if (el.sz != mx_sz)
                my_best = min(my_best, el.best);
        ans += sum + my_best * (2 * mx_sz - sz);
    }
    else if (sz % 2)
        ans += sum + best;
    else
        ans += sum;
    return res(sz + 1, min((int)best, perf[v]), sum + perf[v]);
}

int main()
{
    ifstream cin("input.txt");
    int n;
    cin >> n;
    ch.resize(n);
    perf.resize(n);
    for (int i = 1; i < n; i++)
    {
        int x;
        cin >> x;
        ch[x - 1].push_back(i);
    }
    for (int i = 1; i < n; i++)
        cin >> perf[i];
    dfs(0);
    cout << ans;
    return 0;
}