#include <bits/stdc++.h>
using namespace std;

#define fst first
#define snd second
#define mp make_pair
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template <typename T1, typename T2>
bool umax(T1& x, const T2& y) {return x<y ? x=y, true : false;}

template <typename T1, typename T2>
bool umin(T1& x, const T2& y) {return x>y ? x=y, true : false;}

template <typename T>
void read(T& x) {
    char ch;
    T p = 1; x = 0;
    do {ch = getchar();} while (ch <= ' ');
    if (ch == '-') p = -1, ch = getchar();
    while ('0' <= ch && ch <= '9') {
        x = x*10+ch-'0';
        ch = getchar();
    }
    x = (p == -1 ? -x : x);
}

void read(char &ch) {
    do {ch = getchar();} while (ch <= ' ');
}

void read(string& x) {
    char ch; x = "";
    do {ch = getchar();} while (ch <= ' ');
    while(ch > ' ') x += ch, ch = getchar();
}

template<typename T, typename... R>
void read(T& x, R&... y) {read(x); read(y...);}

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef long double ld;

const int N = (int)1e6+3;
const int M = (int)5e6+3;
const int INF = (int)1e9+17;
const ll LLINF = (ll)1e18+17;


int n, q;
string s;
int pref[N][27];
int preff[M][3];


bool check(int len) {
    if (n%len != 0) return false;
//    rep(i, 0, ALPH) if (pref[n-1][i]%len != 0) return false;
    for(int pos = len+len-1; pos < n; pos += len) {
        rep(i, 0, 26) {
            if (pref[len-1][i] != pref[pos][i]-pref[pos-len][i]) return false;
        }
    }
    return true;
}

bool check2(int len) {
    if (n%len != 0) return false;
//    rep(i, 0, ALPH) if (pref[n-1][i]%len != 0) return false;
    for(int pos = len+len-1; pos < n; pos += len) {
        if (preff[len-1][0] != preff[pos][0]-preff[pos-len][0]) return false;
        if (preff[len-1][1] != preff[pos][1]-preff[pos-len][1]) return false;
    }
    return true;
}


int main()
{
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr), cout.tie(nullptr);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    read(s);
    n = s.length();
    if (n > 500000) {
        rep(i, 0, n) {
            preff[i][s[i]-'a'] = 1;
            if (i > 0) {
                preff[i][0] += preff[i-1][0];
                preff[i][1] += preff[i-1][1];
            }
        }
        rep(len, 1, n/2+1) {
            if (check2(len)) {
                printf("%d\n", n/len);
                return 0;
            }
        }
    } else {
        rep(i, 0, n) {
            pref[i][s[i]-'a'] = 1;
            if (i > 0) {
                rep(j, 0, 26) pref[i][j] += pref[i-1][j];
            }
        }
        rep(len, 1, n/2+1) {
            if (check(len)) {
                printf("%d\n", n/len);
                return 0;
            }
        }
    }
    printf("%d\n", 1);

    return 0;
}
