#include <iostream>
#include <fstream>
#include <vector>
#include <queue>
using namespace std;

#define pb push_back
#define pii pair<int, int>
#define mp make_pair
#define fi first
#define se second
#define llong long long
#define ullong unsigned long long
#define dlong long double
#define endl '\n'

llong query(llong l, llong r) {
    if (l%2 == 0) l++;
    if (r%2 == 0) r--;
    return (r-l)/2;
}

int main()
{
    ios_base::sync_with_stdio(false);
    ifstream fin("input.txt");
    ofstream fout("output.txt");

    llong n;
    int q;
    fin >> n >> q;

    llong cur;
    for (int i=0; i<q; i++) {
        fin >> cur;
        llong prev;
        if (cur%2 == 1) fout << (cur+1) / 2ll << endl;
        else {
            prev = cur;
            cur = (n+1) + query(1, prev);
            while (cur%2==0) {
                long buf = query(prev, cur);
                prev = cur;
                cur = prev + buf + 1;
            }
            fout << (cur+1) / 2ll << endl;
        }
    }

    fin.close();
    fout.close();
    return 0;
}
