#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second
#define forn(i, n) for(int i = 0; i < int(n); ++i)
#define sz(a) int(a.size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int N = 1e6 + 9;
const int M = 1e3 + 9;
const int INFINT = 1e9 + 9;
const ll INFLL = 1e18 + 9;

vector <int> gr[N];
int perfect[N], used[N], minperfect[N], cnt[N];
ll sum[N], ans;

void dfs(int u) {
   // cout << "DFS: " << u << endl;
    used[u] = 1;
    minperfect[u] = perfect[u];
    int min1 = INFINT, min2 = INFINT, sum1, sum2, cntmax1 = 0, minmax1;
    for (auto i: gr[u]) {
        if (!used[i]) dfs(i);
        if (minperfect[i] < min1) {
            min2 = min1;
            min1 = minperfect[i];
        }
        else if (minperfect[i] < min2) {
            min2 = minperfect[i];
        }
        if (cnt[i] > cntmax1) {
            cntmax1 = cnt[i];
            minmax1 = minperfect[i];
        }
        sum[u] += sum[i];
        minperfect[u] = min(minperfect[u], minperfect[i]);
        cnt[u] += cnt[i];
    }
    if (min1 != INFINT && min2 != INFINT) {
        if (cnt[u] - cntmax1 > cntmax1) ans += sum[u] + (cnt[u] % 2) * min1;
        else if (minmax1 == min1) ans += sum[u] + (cntmax1 - (cnt[u] - cntmax1)) * min2;
        else ans += sum[u] + (cntmax1 - (cnt[u] - cntmax1)) * min1;
    }
   // cout << "QUIT: " << u << " cnt: " << cnt[u] << " minperfect: " << minperfect[u] << " sum: " << sum[u] << ' ';
   // cout << "ADDED: " <<  << endl;
    sum[u] += perfect[u];
    ++cnt[u];
}

int main()
{
    ios::sync_with_stdio(0);
    int n;
    cin >> n;
    forn(i, n - 1) {
        int x;
        cin >> x;
        gr[x - 1].push_back(i + 1);
    }
    forn(i, n - 1) cin >> perfect[i + 1];
    /*
    cout << "=============================" << endl;
    forn(i, n) {
        cout << i << ": ";
        for (auto j: gr[i])
            cout << j << ' ';
        cout << endl;
    }
    */
    dfs(0);
    cout << ans << endl;
    return 0;
}
