#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#define FOR(i, n) for (int i = 0; i < n; ++i)
typedef long long ll;
int n;
ll rec(ll now, ll pos) {
	if (pos % 2 == 1) {
		return (pos + 1) / 2;
	}
	int numHole = pos / 2;
	return rec(now / 2, pos + (n - numHole));
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	int q;
	std::cin >> n >> q;
	std::set<int>cur;
	FOR(i, n - 1) {
		cur.insert(2 * i + 1);
	}
	std::vector<int>a(2 * n + 10), answ(n);
	FOR(i, n) {
		a[2 * i] = i + 1;
	}
	for (int i = 2 * n; i >= 0 && !cur.empty(); --i) {
		if (a[i] > 0) {
			auto it = cur.end();
			--it;
			a[*it] = a[i];
			a[i] = 0;
			cur.erase(it);
		}
	}
	FOR(i, q) {
		int x;
		std::cin >> x;
		std::cout << rec(n, x) << '\n';
	}
	return 0;
}