#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#define FOR(i, n) for (int i = 0; i < n; ++i)
typedef long long ll;
std::set<int> intersect(std::set<int>&a, std::set<int>&b) {
	std::set<int> n;
	for (auto d : b) {
		if (n.find(d) != n.end()) {
			n.insert(d);
		}
	}
	return n;
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::string s;
	std::cin >> s;
	std::set<int> del;
	for (ll i = 1; i * i <= s.size(); ++i) {
		if (s.size() % i == 0) {
			del.insert(i);
			del.insert(s.size() / i);
		}
	}
	std::vector<int>cnt(26);
	FOR(i, s.size()) {
		cnt[s[i] - 'a']++;
	}
	std::vector<int>cnt2(26);
	FOR(i, s.size()) {
		cnt2[s[i] - 'a']++;
		bool fl = true;
		FOR(j, 26) {
			if (cnt2[j] != 0 && cnt[j] % cnt2[j] != 0) {
				fl = false;
				break;
			}
		}
		if (!fl) {
			del.erase(i + 1);
		}
	}
	for (auto d : del) {
		cnt.assign(26, 0);
		FOR(j, d) {
			cnt[s[j] - 'a']++;
		}
		bool fl = false;
		for (int i = d; i < s.size(); i += d) {
			cnt2.assign(26, 0);
			for (int j = i; j < i + d; ++j) {
				cnt2[s[j] - 'a']++;
			}
			FOR(q, 26) {
				if (cnt[q] != cnt2[q]) {
					fl = true;
					break;
				}
			}
		}
		if (!fl) {
			std::cout << s.size() / d;
			return 0;
		}
	}
	return 0;
}