#include <iostream>
#include <string>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#define FOR(i, n) for(int i = 0; i < n; i++)
#define mk(a, b) make_pair(a, b)
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

vector<int> gr[200000];
pair<int, pair<ll, ll>> data[200000];// first - size -> second - minver

int mas[200000];
pair<ll, pair<ll, ll>> dfs(int u){
	data[u] = { 1, { mas[u] , mas[u]} };
	
	for (int v : gr[u]){
		auto p = dfs(v);
		data[u].first += p.first;
		data[u].second.first = min(data[u].second.first, p.second.first);
		data[u].second.second += p.second.second;
	}
	return data[u];
}
bool cmp(int u, int v){
	return data[u].first > data[v].first;
}
ll anss(int u){
	int vmin1 = -1;
	int vmin2 = -1;
	for (auto v : gr[u]){
		if (vmin1 == -1 || data[v].second.first < data[vmin1].second.first){
			vmin2 = vmin1;
			vmin1 = v;
		}
		else if (vmin2 == -1 || data[v].second.first < data[vmin2].second.first)
			vmin2 = v;
	}
	if (vmin1 == -1)
		return 0;
	ll ans = 0;
	int tec = vmin1;
	sort(gr[u].begin(), gr[u].end(), cmp);
	for (auto v : gr[u]){
		if (v == tec || data[v].first == 0)
			continue;
		if (tec == -1)
		{
			tec = v;
			continue;
		}
		if (data[tec].first <= data[v].first){
			ans += data[tec].second.second;
			data[v].first -= data[tec].first;
			data[tec].first = 0;
			if (data[v].first == 0)
			{
				tec = -1;
				ans += data[v].second.second;
			}
			else
				tec = v;
		}
		else{
			ans += data[v].second.second;
			data[tec].first -= data[v].first;
			data[v].first = 0;
		}
	}
	if (data[tec].first){
		if (tec != vmin1)
			ans += data[tec].first * data[vmin1].second.first;
		else
			ans += data[tec].first * data[vmin2].second.first;
		ans += data[tec].second.second;
	}
	return ans;
}
int main(){
	int n;
	cin >> n;
	for (int i = 1; i < n; i++){
		int v;
		cin >> v;
		v--;
		gr[v].push_back(i);
	}
	FOR(i, n - 1){
		cin >> mas[i + 1];
	}
	ll ans = 0;
	
	FOR(i, n){
		dfs(0);
		ans += anss(i);
	}
	cout << ans;
	return 0;
}