#include <iostream>
#include <string>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#define FOR(i, n) for(int i = 0; i < n; i++)
#define mk(a, b) make_pair(a, b)
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

vector<int> gr[200000];
pair<int, pair<ll, ll>> datas[200000];
int vmin1 = -1;
int vmin2 = -1;
int mas[200000];
pair<ll, pair<ll, ll>> dfs(int u){
	datas[u] = { 1, { mas[u] , mas[u]} };
	
	for (int v : gr[u]){
		auto p = dfs(v);
		datas[u].first += p.first;
		datas[u].second.first = min(datas[u].second.first, p.second.first);
		datas[u].second.second += p.second.second;
	}
	return datas[u];
}
bool cmp(int u, int v){
	return datas[u].first > datas[v].first;
}
ll anss(int u){
	vmin1 = -1;
	vmin2 = -1;
	for (auto v : gr[u]){
		if (vmin1 == -1 || datas[v].second.first < datas[vmin1].second.first){
			vmin2 = vmin1;
			vmin1 = v;
		}
		else if (vmin2 == -1 || datas[v].second.first < datas[vmin2].second.first)
			vmin2 = v;
	}
	if (vmin1 == -1 || vmin2 == -1)
		return 0;
	ll ans = 0;
	int tec = -1;
	sort(gr[u].begin(), gr[u].end(), cmp);
	for (auto v : gr[u]){
		if (v == tec || datas[v].first == 0)
			continue;
		if (tec == -1)
		{
			tec = v;
			continue;
		}
		if (datas[tec].first <= datas[v].first){
			ans += datas[tec].second.second;
			datas[v].first -= datas[tec].first;
			datas[tec].first = 0;
			if (datas[v].first == 0)
			{
				tec = -1;
				ans += datas[v].second.second;
			}
			else
				tec = v;
		}
		else{
			ans += datas[v].second.second;
			datas[tec].first -= datas[v].first;
			datas[v].first = 0;
		}
	}
	if (datas[tec].first){
		if (tec != vmin1)
			ans += datas[tec].first * datas[vmin1].second.first;
		else
			ans += datas[tec].first * datas[vmin2].second.first;
		ans += datas[tec].second.second;
	}
	return ans;
}
int main(){
	int n;
	cin >> n;
	for (int i = 1; i < n; i++){
		int v;
		cin >> v;
		v--;
		gr[v].push_back(i);
	}
	FOR(i, n - 1){
		cin >> mas[i + 1];
	}
	ll ans = 0;
	
	FOR(i, n){
		dfs(0);
		ans += anss(i);
	}
	cout << ans;
	return 0;
}