#include <iostream>
#include <string>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

string s;

int n, as = 0;

vector <int> ds;

vector <vector <int> > pc;

vector <int> gc, cc;

int pc2[5000002][2];

int cc2[2], gc2[2];

bool check(int l){
    for (int j = 0; j < as; j++){
        gc[j] = pc[l][j] - pc[0][j];
    }
    for (int i = 2 * l; i <= n; i += l){
        for (int j = 0; j < as; j++){
            cc[j] = pc[i][j] - pc[i - l][j];
            if (cc[j] != gc[j]){
                return false;
            }
        }
    }
    return true;
}

bool check2(int l){
    for (int j = 0; j < 2; j++){
        gc2[j] = pc2[l][j] - pc2[0][j];
    }
    for (int i = 2 * l; i <= n; i += l){
        for (int j = 0; j < 2; j++){
            cc2[j] = pc2[i][j] - pc2[i - l][j];
            if (cc2[j] != gc2[j]){
                return false;
            }
        }
    }
    return true;
}

int main() {
    ios::sync_with_stdio(0);
    cin >> s;
    n = s.length();
    if (n <= 500007) {
        pc.resize(n + 1);
        for (int i = 0; i < n; i++) {
            as = max(as, s[i] - 'a' + 1);
        }
        for (int i = 0; i <= n; i++) {
            pc[i].resize(as);
        }
        gc.resize(as);
        cc.resize(as);
        s = '#' + s;
        for (int i = 1; i <= n; i++) {
            for (int j = 0; j < as; j++) {
                pc[i][j] = pc[i - 1][j];
            }
            pc[i][s[i] - 'a']++;
        }
        for (int i = 1; i <= sqrt(n); i++) {
            if (n % i == 0) {
                ds.push_back(i);
                ds.push_back(n / i);
            }
        }
        sort(ds.begin(), ds.end());
        //reverse(ds.begin(), ds.end());
        for (int i = 0; i < ds.size(); i++) {
            if (check(ds[i])) {
                cout << n / ds[i];
                return 0;
            }
        }
    }else{
        s = '#' + s;
        for (int i = 1; i <= n; i++){
            for (int j = 0; j < 2; j++){
                pc2[i][j] = pc2[i - 1][j];
            }
            pc2[i][s[i] - 'a']++;
        }
        for (int i = 1; i <= sqrt(n); i++){
            if (n % i == 0){
                ds.push_back(i);
                ds.push_back(n / i);
            }
        }
        sort(ds.begin(), ds.end());
        //reverse(ds.begin(), ds.end());
        for (int i = 0; i < ds.size(); i++){
            if (check2(ds[i])){
                cout << n / ds[i];
                return 0;
            }
        }
    }
    return 0;
}