const
  maxN = 100000;
  maxM = 100000;

var
  num, n, i, u2, sum, xxx1, xxx2: longint;
  dest, next: array [1..maxM] of longint;
  head, vis: array [1..maxN] of longint;
  mass: array [1..maxN] of longint;

function minimal(a, b: longint): longint;
begin
  if a < b then minimal := a else minimal := b;
end;

procedure qsort(l, r: int64);
var
  i, j, w, q: int64;
begin
  i := l;
  j := r;
  q := mass[(l + r) div 2];
  repeat
    begin
      while mass[i] < q do inc(i);
      while mass[j] > q do dec(j);
      if i <= j then
      begin
        w := mass[i];
        mass[i] := mass[j];
        mass[j] := w;
        inc(i);
        dec(j);
      end;
    end
  until (i > j);
  if (l < j) then qsort(l, j);
  if (i < r) then qsort(i, r);
end;

procedure add(u, v: longint);
begin
  num := num + 1;
  dest[num] := v;
  next[num] := head[u];
  head[u] := num;
end;

function dfs(u: longint): longint;
var
  j, act, x, y, imass: longint;
begin
  //writeln('in ', u);
  vis[u] := 1;
  x := 0;
  
  imass := 0;
  
  j := head[u];
  while (j <> 0) do
  begin
    act := dest[j];
    if vis[act] = 0 then
    begin
      y := dfs(act);
      imass := imass + 1;
      mass[imass] := y;
      x := x + y;
    end;
    j := next[j];
  end;
  
  //for j := 1 to imass do write(mass[j], ' ');
  //writeln();
  
  while imass >= 2 do
  begin
    qsort(1, imass);
    xxx1 := mass[imass];
    xxx2 := mass[imass - 1];
    imass := imass - 1;
    mass[imass] := abs(xxx1 - xxx2);
    sum := sum + minimal(xxx1, xxx2);
  end;
  
  if imass = 1 then sum := sum + mass[1];
  
  dfs := x + 1;
  vis[u] := 2;
  //writeln('out ', u);
end;

begin
  read(n);
  for i := 2 to n do
  begin
    read(u2);
    add(i, u2);
    add(u2, i);
  end;
  for i := 2 to n do read(u2);
  
  u2 := dfs(1);
  
  writeln(sum * 2);
end.