#include <bits/stdc++.h>

using namespace std;

int n, t;
vector<vector<int>> children;
vector<int> c;
vector<int> ss, mn, mn2, cnt, tin, tout;

void upd(int v, int u) {
    bool ok = false;
    if (mn[v] == -1 || (c[mn[u]] < c[mn[v]])) {
        mn2[v] = mn[v];
        mn[v] = mn[u];
        ok = true;
    }
    if (mn[v] == -1 || (c[u] < c[mn[v]])) {
        mn2[v] = mn[v];
        mn[v] = u;
        ok = true;
    }
    if (ok) return;
    if (mn2[v] == -1 || (c[mn[u]] < c[mn2[v]])) {
        mn2[v] = mn[u];
    }
    if (mn2[v] == -1 || (c[u] < c[mn2[v]])) {
        mn2[v] = u;
    }
}

void build(int v) {
    tin[v] = ++t;
    ss[v] = c[v];
    mn[v] = -1;
    mn2[v] = -1;
    cnt[v] = 1;

    for (int u : children[v]) {
        build(u);
        ss[v] += ss[u];
        cnt[v] += cnt[u];
        upd(v, u);
    }
    tout[v] = ++t;
}

bool isparent(int parent, int child) {
    return tin[parent] < tin[child] && tout[parent] > tout[child];
}

long long solve(int v) {
    long long ans = 0;
    long long ind = 0;
    long long indm = 0;
    for (int u : children[v]) {
        bool f = isparent(u, mn[v]) || (u == mn[v]);
        if (f) {
            indm = cnt[u] - 1;
            break;
        }
    }
    for (int u : children[v]) {
        ans += solve(u);
        ans += ss[u];
        if (isparent(u, mn[v]) || (u == mn[v])) continue;
        int x = cnt[u];
        if (x < indm) {
            indm -= x;
            x = 0;
        } else {
            x -= indm;
            indm = 0;
        }
        if (x < ind) {
            ind -= x;
        } else {
            ind = x - ind;
        }
    }
    if (ind > 0)
        ind--;
    else
        indm++;
    if (indm > 0) {
        ind--;
        indm++;
    }
    if (mn[v] != -1) {
        ans += ind * c[mn[v]];
    }
    if (mn2[v] != -1) {
        ans += indm * c[mn2[v]];
    }
    return ans;
}

int main() {
    t = 0;
    cin >> n;
    children.resize(n);
    ss.resize(n);
    mn.resize(n);
    mn2.resize(n);
    c.resize(n);
    cnt.resize(n);
    tin.resize(n);
    tout.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        children[p - 1].push_back(i);
    }
    for (int i = 1; i < n; ++i) {
        cin >> c[i];
    }

    build(0);
    cout << solve(0) << endl;

    return 0;
}