#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
using namespace std;

#define ft first
#define sd second

const int N = 200005, L = 20;
int n, m, x;
int val[N] = {};

int get(int k, int s)
{
    if (k > s) return 0;
    int l = 0, r = L;
    while (l < r - 1)
    {
        int mid = (l + r) / 2;
        if (k * ((1 << mid) - 1) < s) l = mid;
        else r = mid;
    }

    return k * ((1 << l) - 1);
}

int main()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i++)
    {
        int pos = 2 * i - 1 - get(2 * n - 2 * i + 1, 2 * i - 1);
        val[pos] = i;
    }
    for (int i = 0; i < m; i++)
    {
        cin >> x;
        cout << val[x] << endl;
    }

    return 0;
}
