#include <iostream>
#include <vector>

using namespace std;

#define int long long

const int INF = 1e9;

struct node
{
    vector <node*> l;
    int c = 0;
    int cnt = 1;
    long long sum = 0;
    long long sumc = 0;
    int mini1 = -1, mini2 = -1;
    int maxi = 0;
    int minic1 = INF;
    node() {}

    long long dfs()
    {
        minic1 = c;
        sumc = c;
        if (l.size() == 0)
        {
            return 0;
        }
        for (int i = 0; i < l.size(); ++i)
        {
            l[i]->dfs();
            sum += l[i]->sum;
            cnt += l[i]->cnt;
            sumc += l[i]->sumc;
            if (l[maxi]->cnt < l[i]->cnt)
            {
                maxi = i;
            }
        }
        for (int i = 0; i < l.size(); ++i)
        {
            if (mini1 == -1 || l[i]->minic1 <= l[mini1]->minic1)
            {
                mini2 = mini1;
                mini1 = i;
            }
            else if (mini2 == -1 || l[i]->minic1 <= l[mini2]->minic1)
            {
                mini2 = mini1;
            }
        }
        minic1 = min(l[mini1]->minic1, minic1);
        sum += sumc - c;
        if (l[maxi]->cnt * 2 > cnt - 1)
        {
            if (maxi == mini1)
            {
                sum += l[mini2]->minic1 * (2 * l[maxi]->cnt - cnt + 1);
            }
            else
            {
                sum += l[mini1]->minic1 * (2 * l[maxi]->cnt - cnt + 1);
            }
        }
        else
        {
            if (cnt % 2 == 0)
            {
                sum += l[mini1]->minic1;
            }
        }
        return sum;
    }
};

signed main()
{
    int n;
    cin >> n;
    vector <node> A(n);
    for (int i = 1; i < n; ++i)
    {
        int p;
        cin >> p;
        --p;
        A[p].l.push_back(&A[i]);
    }
    for (int i = 1; i < n; ++i)
    {
        int c;
        cin >> c;
        A[i].c = c;
    }
    cout << A[0].dfs() << endl;
    return 0;
}