#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define mp make_pair
#define pb push_back
#define pf push_front
#define int long long

struct point {
    multiset<int> sz;
    int sum;
    int all;
    int mmin;
};

vector<point> tree;
vector<vector<int> > g;
vector<int> val;

int ans = 0;

void dfs(int v, int last) {
    if (g[v].size() == 0) {
        tree[v].sz.insert(-1);
        tree[v].sum = val[v];
        tree[v].all = 1;
        tree[v].mmin = val[v];

        tree[last].sz.insert(-1);
        tree[last].mmin = min(tree[last].mmin, val[v]);
        return;
    }

    int cnt = 0;
    multiset<pair<int, int> > go;
    for (int i = 0; i < g[v].size(); ++i) {
        int u = g[v][i];
        dfs(u, v);
        go.insert(mp(tree[u].mmin, tree[u].all));
        cnt += tree[u].all;
        tree[v].sum += tree[u].sum;
        //cout << u << " " << tree[u].sum << "\n";
    }

    tree[v].all = cnt + 1;
    int ost = 0;
    //cout << v << " $ " << tree[v].sz.size() << "\n";
    while (!tree[v].sz.empty()) {
        int now = *tree[v].sz.begin();
        now *= -1;

        //cout << "@ " << now << "\n";
        tree[v].sz.erase(tree[v].sz.begin());

        while (now != 0) {
            if (tree[v].sz.empty())
                break;
            int may = *tree[v].sz.begin();
            tree[v].sz.erase(tree[v].sz.begin());
            //cout << tree[v].sz.size() << "\n";

            may *= -1;
            if (may > now) {
                tree[v].sz.insert((may - now) * (-1));
                now = 0;
            }
            else {
                now -= may;
            }
        }

        ost = now;
    }
    //cout << v << " " << tree[v].mmin << " " << tree[v].all << " " << tree[v].sum << "\n";

    ans += tree[v].sum;

    if (ost != 0) {
        /*while (ost != 0) {
            pair<int, int> now = *go.begin();
            go.erase(go.begin());

            int may = cnt - now.second;

            if (may > ost) {
                ans += ost * now.first;
                ost = 0;
            }
            else {
                ost -= may;
                ans += may * now.first;
            }
        }*/
        ans += ost;
    }


    tree[v].sum += val[v];
    //cout << ost << "\n";
    tree[v].mmin = min(tree[v].mmin, val[v]);

    if (last != -1) {
        tree[last].sz.insert((cnt+1) * (-1));
        tree[last].mmin = min(tree[v].mmin, tree[last].mmin);
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    //freopen("1.txt", "r", stdin);
    //freopen("2.txt", "w", stdout);

    int n;
    cin >> n;
    point kek;
    kek.mmin = 1e9;
    kek.sum = 0;

    tree.assign(n+1, kek);
    g.resize(n + 1);
    val.resize(n + 1);

    int x;
    for (int i = 2; i <= n; ++i) {
        cin >> x;
        g[x].pb(i);
    }

    for (int i = 2; i <= n; ++i) {
        cin >> x;
        val[i] = x;
    }

    dfs(1, -1);
    cout << ans;
    return 0;
}
