// #pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define len(v) ((int)v.size())
#define pb push_back

typedef long long ll;
typedef long double ld;

using namespace std;

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b)
{
	if (a > b)
	{
		a = b;
		return false;
	}
	return true;
}

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b)
{
	if (a < b)
	{
		a = b;
		return false;
	}
	return true;
}

void run();

int main()
{
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

ll q(ll n, ll x)
{
	if (!(x & 1))
		return (x >> 1);
	return q(n >> 1, ((x >> 1) - (n & 1) + (n >> 1)) % (n >> 1)) + (n >> 1) + (n & 1);
}

vector<int> gen1(int n)
{
	vector<int> arr(n);
	for (int i = 0; i < n; ++i)
		arr[i] = q(n, i);
	return arr;
}

vector<int> gen2(int n)
{
	vector<int> arr(2 * n - 1, 0);
	for (int i = 0; i < n; ++i)
		arr[2 * i] = i + 1;
	while (len(arr) > n)
	{
		int idx = n - 1;
		while (arr[--idx]);
		swap(arr[idx], arr.back());
		while (!arr.back())
			arr.pop_back();
	}
	return arr;
}

void run()
{
	ll n;
	int m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i)
	{
		ll x;
		cin >> x;
		cout << q(n, x - 1) + 1 << endl;
	}
	// for (int i = 1; ; ++i)
	// {
	// 	cout << i << endl;
	// 	if (gen1(i) != gen2(i))
	// 	{
	// 		for (auto x : gen1(i))
	// 			cout << x << " ";
	// 		cout << endl;
	// 		for (auto x : gen2(i))
	// 			cout << x << " ";
	// 		cout << endl;
	// 	}
	// }
}