// #pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define len(v) ((int)v.size())
#define pb push_back

typedef long long ll;
typedef long double ld;

using namespace std;

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b)
{
	if (a > b)
	{
		a = b;
		return false;
	}
	return true;
}

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b)
{
	if (a < b)
	{
		a = b;
		return false;
	}
	return true;
}

void run();

int main()
{
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

int pr[] = {37482001, 39402859, 93092693, 
86116637, 42442033, 12347611, 26953691, 
37817321, 78992579, 53239999, 10770269, 
65157737, 52547149, 45671147, 25095907, 
87840967, 68049563, 21604829, 41869547, 
35402447, 77974447, 70151999, 88818497, 
72512743, 22498397, 97338673};

void run()
{
	int mod = 1e9 + 7;
	string s;
	cin >> s;
	int n = len(s);
	vector<int> cnt(26, 0);
	for (auto &x : s)
		++cnt[x - 'a'];
	vector<int> pref(n + 1, 0);
	for (int i = 0; i < n; ++i)
		pref[i + 1] = (pref[i] + pr[s[i] - 'a']) % mod;
	int l = n;
	for (int i = 1; i < n; ++i)
	{
		if (n % i)
			continue;
		int k = n / i;
		int hash = 0;
		bool good = true;
		for (int j = 0; j < 26; ++j)
			if (cnt[j] % k)
			{
				good = false;
				break;
			}
		if (!good)
			continue;
		for (int j = 0; j < 26; ++j)
			hash = (1LL * hash + 1LL * pr[j] * (cnt[j] / k)) % mod;
		for (int j = 0; j < n; j += i)
			if (pref[j + i] - pref[j] != hash)
			{
				good = false;
				break;
			}
		if (!good)
			continue;
		l = i;
		break;
	}
	cout << n / l << endl;
}