#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int solve();

int main() {
    ios_base::sync_with_stdio(0);
#ifdef home
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // home
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}

vector<vector<int> > g;

ll c[200005];
ll sum[200005];
ll cnt[200005];
ll mn[200005];
ll dp[200005];


const int inf = (int)1e9;

bool cmp(int a, int b) {
    return cnt[a] > cnt[b];
}

void dfs(int v) {
    cnt[v] = 1;
    sum[v] = c[v], mn[v] = c[v];

    vector<int> p;
    for (int to : g[v]) {
        dfs(to);
        p.push_back(to);
        sum[v] += sum[to];
        cnt[v] += cnt[to];
        dp[v] += sum[to] + dp[to];
    }

    sort(p.begin(), p.end(), cmp);

    int ost = 0;
    for (int to : p) {
        ost = abs(ost - cnt[to]);
    }
    dp[v] += ost * 2;
}
int solve() {
    int n; cin >> n;

    g.resize(n + 1);
    for (int i = 2; i <= n; i++) {
        int p; cin >> p;
        g[p].push_back(i);
    }

    for (int i = 2; i <= n; i++) {
        cin >> c[i];
    }

    fill(mn, mn + n + 1, inf);

    dfs(1);

    //for (int i = 1; i <= n; i++) cout << i << ' ' << dp[i] << ' ' << sum[i] << ' ' << cnt[i] << endl;
    cout << dp[1];
    return 0;
}



