// d2t4.cpp: определяет точку входа для консольного приложения.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <string>

using namespace std;

string s;

bool can(long long i)
{
	vector<long long> bal(26), need(26);
	for (long long j = 0; j < i; j++)
	{
		need[s[j] - 'a']++;
	}
	long long cur = 0;
	bool flag = 0;
	for (long long j = 0; j < s.size(); j++)
	{
		bal[s[j] - 'a']++;
		cur++;
		if (cur == i)
		{
			cur = 0;
			for (long long k = 0; k < 26; k++)
			{
				if (bal[k] != need[k])
				{
					flag = 1;
					break;
				}
				bal[k] = 0;
			}
		}
		if (flag)
		{
			break;
		}
	}
	return flag;
}

int main()
{
	cin >> s;
	long long n = s.size();
	vector<long long> nums;
	for (long long i = 2; i <= n; i++)
	{
		while (!(n % i))
		{
			n /= i;
			nums.push_back(i);
		}
	}
	long long cnt = 0;
	if (!can(1))
		cout << s.size();
	else
	{
		long long cur = 1;
		n = s.size();
		for (long long i = 0; i < nums.size(); i++)
		{
			cur *= nums[i];
			if (can(n / cur))
			{
				cur /= nums[i];
			}
		}
		cout << cur;
	}
	cin >> s;
    return 0;
}

