#include <bits/stdc++.h>
#define x first
#define y second
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
#define ll long long
#define db double
using namespace std;

ll gcd(ll a, ll b){
	while(b){
		a %= b;
		swap(a, b);
	}
	return a;
}

struct pt{
	ll x, y;
	pt() {}
	pt(ll x1, ll y1) { x = x1; y = y1; }
	pt operator- (pt nxt) { return pt(x - nxt.x, y - nxt.y); }
	pt operator+ (pt nxt) { return pt(x + nxt.x, y + nxt.y); }
	ll operator% (pt nxt) { return x * nxt.y - y * nxt.x; }
};

struct line{
	ll a, b, c;
	line() {}
	line(pt w1, pt w2){
		a = (w2.y - w1.y);
		b = -(w2.x - w1.x);
		c = -(a * w1.x + b * w1.y);
	}
};

int n;
pt a[2607 * 2];

bool okDiv(ll a, ll b){
	return abs(a) % abs(b) == 0;
}

pt cross(line l1, line l2, bool &ok){
	ok = 1;
	if (l2.a * l1.b - l2.b * l1.a == 0){
		ok = 0;
		return {};
	}
	if (!okDiv((l2.c * l1.a - l1.c * l2.a), (l2.a * l1.b - l2.b * l1.a))){
		ok = 0;
		return {};
	}
	ll y = (l2.c * l1.a - l1.c * l2.a) / (l2.a * l1.b - l2.b * l1.a);
	if (!okDiv((l2.c * l1.b - l1.c * l2.b), (l2.a * l1.b - l2.b * l1.a))){
		ok = 0;
		return {};
	}
	ll x = (l2.c * l1.b - l1.c * l2.b) / (l2.a * l1.b - l2.b * l1.a);
	return pt(-x, y);
}

map<pair<int, int>, int> was;

void check(line l1, line l2){
	bool ok;
	auto t = cross(l1, l2, ok);
	if (!ok) return;
	if (max(abs(t.x), abs(t.y)) > (ll)1000000) return;
	was.clear();

	for (int i = 0; i < n; i++){
		auto c = a[i] - t;
		if (c.x == 0 && c.y == 0) return;
		if (c.y < 0 || c.y == 0 && c.x < 0) c.x = -c.x, c.y = -c.y;
		ll dd = gcd(abs(c.x), abs(c.y));
		c.x /= dd;
		c.y /= dd;
		was[mp(c.x, c.y)]++;
		if (was[mp(c.x, c.y)] > 2) return;
	}

	for (auto c : was) if (c.y != 2) return;
	cout << "Yes\n";
	cout << t.x << ' ' << t.y;
	exit(0);
}

int main(){
 	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0); cin.tie(0);
	cin >> n; n *= 2;
	for (int i = 0; i < n; i++) cin >> a[i].x >> a[i].y;

	for (int i = 1; i < n; i++){
		line l1 = line(a[0], a[i]);
		for (int j = 2; j < n; j++) if (i != j){
			if (i == 1){
				if (j == 2) continue;
				check(l1, line(a[2], a[j]));
			} else {
				check(l1, line(a[1], a[j]));
			}
		}
	}

	cout << "No\n";
}
