#include <bits/stdc++.h>
#define x first
#define y second
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
#define ll long long
#define db double
using namespace std;

int gcd(int a, int b){
	while(b){
		a %= b;
		swap(a, b);
	}
	return a;
}

struct pt{
	int x, y;
	pt() {}
	pt(int x1, int y1) { x = x1; y = y1; }
	pt operator- (pt nxt) { return pt(x - nxt.x, y - nxt.y); }
	pt operator+ (pt nxt) { return pt(x + nxt.x, y + nxt.y); }
};

struct line{
	ll a, b, c;
	line() {}
	line(pt w1, pt w2){
		a = (w2.y - w1.y);
		b = -(w2.x - w1.x);
		c = -(a * (ll)w1.x + b * (ll)w1.y);
	}
};

int n;
pt a[2607 * 2];

bool okDiv(ll a, ll b){
	return abs(a) % abs(b) == 0;
}

pt cross(line l1, line l2, bool &ok){
	ok = 1;
	if (l2.a * l1.b - l2.b * l1.a == 0){
		ok = 0;
		return {};
	}
	if (!okDiv((l2.c * l1.a - l1.c * l2.a), (l2.a * l1.b - l2.b * l1.a))){
		ok = 0;
		return {};
	}
	ll y = (l2.c * l1.a - l1.c * l2.a) / (l2.a * l1.b - l2.b * l1.a);
	if (!okDiv((l2.c * l1.b - l1.c * l2.b), (l2.a * l1.b - l2.b * l1.a))){
		ok = 0;
		return {};
	}
	ll x = (l2.c * l1.b - l1.c * l2.b) / (l2.a * l1.b - l2.b * l1.a);
	if (max(abs(x), abs(y)) > (ll)1000000){
		ok = 0;
		return {};
	}
	return pt(-x, y);
}


const int INF = (int)1e9 + 7;
const int SZ = 18; 
struct hash_table_pair{
	int kk;
	int st[1 << SZ];
	pair<int, int> t[1 << SZ];
	int d[1 << SZ];
	hash_table_pair() { for (int i = 0; i < (1 << SZ); i++) t[i] = mp(INF, INF); kk = 0; }

	void up(pair<int, int> v){
		int pos = abs((ll)v.x * (ll)(1e9 + 11) + v.y * (ll)7 + 11) & ((1 << SZ) - 1);
		while(1){
			if (t[pos] == mp(INF, INF)){
				st[kk++] = pos;
				t[pos] = v;
				d[pos] = 1;
				return;
			} else if (t[pos] == v){
				d[pos]++;
				return;
			}
			pos++;
			if (pos == (1 << SZ)) pos = 0;
		}
	}

	int get(pair<int, int> v){
		int pos = abs((ll)v.x * (ll)(1e9 + 11) + v.y * (ll)7 + 11) & ((1 << SZ) - 1);
		while(1){
			if (t[pos] == mp(INF, INF)){
				return 0;
			} else if (t[pos] == v){
				return d[pos];
			}
			pos++;
			if (pos == (1 << SZ)) pos = 0;
		}
	}

	void clear(){
		for (int i = 0; i < kk; i++){
			t[st[i]] = mp(INF, INF);
		}
		kk = 0;
	}
} was;

//map<pair<int, int>, int> was;
set<pair<int, int> > se;

void check(line l1, line l2){
	bool ok;
	auto t = cross(l1, l2, ok);
	if (!ok) return;
	was.clear();
	if (se.find(mp(t.x, t.y)) != se.end()) return;
	se.insert(mp(t.x, t.y));

	for (int i = 0; i < n; i++){
		auto c = a[i] - t;
		if (c.x == 0 && c.y == 0) return;
		if (c.y < 0 || c.y == 0 && c.x < 0) c.x = -c.x, c.y = -c.y;
		ll dd = gcd(abs(c.x), abs(c.y));
		c.x /= dd;
		c.y /= dd;
		was.up(mp(c.x, c.y));
		if (was.kk > n / 2) return;
		if (was.get(mp(c.x, c.y)) > 2) return;
	}

	//for (int i = 0; i < was.kk; i++) if (was.d[was.st[i]] != 2) return;
	//cout << clock() / (db)CLOCKS_PER_SEC << endl;
	cout << "Yes\n";
	cout << t.x << ' ' << t.y;
	exit(0);
}

int main(){
	srand(123231);
 	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0); cin.tie(0);
	cin >> n; n *= 2;
	for (int i = 0; i < n; i++) cin >> a[i].x >> a[i].y;
	random_shuffle(a, a + n);

	for (int i = 1; i < n; i++){
		line l1 = line(a[0], a[i]);
		if (clock() / (db)CLOCKS_PER_SEC > 4.7) cout << "No\n", exit(0);
		for (int j = 2; j < n; j++) if (i != j){
			if (i == 1){
				if (j == 2) continue;
				check(l1, line(a[2], a[j]));
			} else {
				check(l1, line(a[1], a[j]));
			}
		}
	}

	//cout << clock() / (db)CLOCKS_PER_SEC << endl;
	cout << "No\n";
}
