package kt
import java.io.InputStreamReader
import java.util.*

private fun readArgs(r: InputStreamReader, n: Int): LongArray {
    val ret = LongArray(n)
    var i = 0
    var curNum: Long = 0
    var neg = false
    while (i < n) {
        val c = r.read().toChar()
        if (c == ' ' || c == '\n') {
            ret[i++] = if (neg) -curNum else curNum
            curNum = 0
            neg = false
        } else if (c == '-') {
            neg = true
        } else {
            curNum *= 10
            curNum += (c - 48).toLong()
        }
    }
    return ret
}

private fun readArgsInt(r: InputStreamReader, n: Int): IntArray {
    val ret = IntArray(n)
    var i = 0
    var curNum = 0
    var neg = false
    while (i < n) {
        val c = r.read().toChar()
        if (c == ' ' || c == '\n') {
            ret[i++] = if (neg) -curNum else curNum
            curNum = 0
            neg = false
        } else if (c == '-') {
            neg = true
        } else {
            curNum *= 10
            curNum += c.toInt() - 48
        }
    }
    return ret
}

fun main(args: Array<String>) {
    val r = InputStreamReader(System.`in`)
    val inp = readArgs(r, 2)
    val n = inp[0].toInt()
    val req = readArgs(r, inp[1].toInt())
    val arr = Array(n * 2 - 1) { i -> if(i % 2 == 0) i / 2 + 1 else 0 }
    var lastItemIdx = arr.size - 1
    while(arr[1] == 0) {
        val elem = arr[lastItemIdx]
        if(elem == 0) { //Usually should not happen
            lastItemIdx--
            continue
        }
        var emptyI = lastItemIdx - 1
        var newLII = 0
        while(arr[emptyI] != 0) {
            if(emptyI > newLII) {
                newLII = emptyI
            }
            emptyI--
        }
        arr[lastItemIdx] = 0
        arr[emptyI] = elem
        if(emptyI > newLII) {
            newLII = emptyI
        }
        lastItemIdx = newLII
    }
    for(i in req) {
        println(arr[(i - 1).toInt()])
    }
}