import java.io.IOException;
import java.io.InputStreamReader;

public class A {


    private static long[] readArgs(InputStreamReader r, int n) throws IOException {
        long[] ret = new long[n];
        int i = 0;
        long curNum = 0;
        boolean neg = false;
        while (i < n) {
            int c = r.read();
            if (c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    private static int[] readArgsInt(InputStreamReader r, int n) throws IOException {
        int[] ret = new int[n];
        int i = 0;
        int curNum = 0;
        boolean neg = false;
        while (i < n) {
            int c = r.read();
            if (c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    public static void main(String[] args) throws IOException {
        InputStreamReader r = new InputStreamReader(System.in);
        long[] in = readArgs(r, 2);
        long n = in[0];
        long[] arr = new long[(int) (2 * n - 1)];
        for (int i = 1; i <= n; i++) {
            arr[2 * i - 2] = i;
        }
        int lastItemIdx = arr.length - 1;
        int iter = 0;
        if (arr.length != 1) {
            while (arr[1] == 0) {
                iter++;
                long elem = arr[lastItemIdx];
                int emptyI = lastItemIdx - iter;
                int newLII = lastItemIdx - 1;
                arr[lastItemIdx] = 0;
                arr[emptyI] = elem;
                if (emptyI > newLII) {
                    newLII = emptyI;
                }
                lastItemIdx = newLII;


            }
        }
        for (int i = 0; i < in[1]; i++) {
            int req = readArgsInt(r, 1)[0];
            System.out.println(arr[req - 1]);
        }
    }

}
