import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;


public class D {

	public static int gcd(int a, int b) {
		if (b == 0) {
			return a;
		}
		if (a == 0) {
			return b;
		}
		return gcd(b, a % b);
	}
	
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter out = new PrintWriter(System.out);
		String s = in.readLine();
		int n = s.length();
		int[] w = new int[n];
		for (int i = 0; i < n; i++) {
			w[i] = s.charAt(i) - 'a';
		}
		int[] number = new int[26];
		for (int i = 0; i < n; i++) {
			number[w[i]]++;
		}
		int gcd = 0;
		for (int i = 0; i < 26; i++) {
			gcd = gcd(gcd, number[i]);
		}
		int[] need = new int[26];
		for (int i = 0; i < need.length; i++) {
			need[i] = number[i] / gcd;
		}
		int[] th = new int[26];
		int max = n / gcd;
		boolean[] div = new boolean[gcd + 1];
		for (int i = 1; i * i <= gcd; i++) {
			if (gcd % i == 0) {
				div[i] = true;
				div[gcd / i] = true;
			}
		}
		int numberOfDivisors = 0;
		for (int i = 0; i < gcd + 1; i++) {
			if (div[i]) {
				numberOfDivisors++;
			}
		}
		int[] divisors = new int[numberOfDivisors];
		int iterator = 0;
		for (int i = 0; i < gcd + 1; i++) {
			if (div[i]) {
				divisors[iterator] = i;
				iterator++;
			}
		}
		boolean[] ans = new boolean[numberOfDivisors];
		for (int i = 0; i < numberOfDivisors; i++) {
			ans[i] = true;
		}
		f :
		for (int i = 0; i < gcd; i++) {
			for (int j = 0; j < max; j++) {
				th[w[i * max + j]]++;
			}
			for (int j = 0; j < 26; j++) {
				if (th[j] != need[j] * (i + 1)) {
					for (int k = 0; k < numberOfDivisors; k++) {
						if ((i + 1) % divisors[k] == 0) {
							ans[k] = false;
						}
					}
					continue f;
				}
			}
		}
		for (int i = 0; i < numberOfDivisors; i++) {
			if (ans[i]) {
				out.print(gcd / divisors[i]);
				break;
			}
		}
		in.close();
		out.close();
	}

}
