#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const int inf = (int)1e9 + 7;
const ll mod = (int)1e9 + 7;
int base[2] = {31, 41};

const int N = (int)5e6 + 100;
const int M = 26;
int p[N][2];
int cur[M];
bool used[M];

int getk(const int &l, const int &r, const int &c) {
    if (l == 0)
        return p[r][c];
    return p[r][c] - p[l - 1][c];
}

bool check(string &s, int it, vector<int> &cnt) {
    int n = s.size();
    bool good = true;
    int k = n / it;
    int i, j;
    for (i = 0; i <= n - k; i += k) {
        for (j = 0; j < 2; ++j) {
            if (used[j]) {
                if (getk(i, i + k - 1, s[i] - 'a') != cnt[s[i] - 'a'] / it)
                    good = false;
            }
        }
    }

    return good;
}

bool check1(string &s, int it, vector<int> &cnt) {
    int n = s.size();
    bool good = true;
    int k = n / it;
    int i, j;
    for (i = 0; i <= n - k && good; i += k) {
        for (j = 0; j < 26; ++j) {
            cur[j] = cnt[j] / it;
        }
        for (j = i; j <= i + k - 1; ++j) {
            cur[s[j] - 'a']--;
        }

        for (j = 0; j < 26; ++j) {
            if (used[j] && cur[j] != 0) {
                good = 0;
            }
        }
    }

    return good;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    string s;
    cin >> s;
    vector<int> cnt(26);

    set<int> dd;
    for (int i = 0; i < s.size(); ++i) {
        cnt[s[i] - 'a']++;
        dd.insert(s[i] - 'a');
        used[s[i] - 'a'] = 1;
    }

    bool ab = 0;
    if (used[0] && used[1] && dd.size() == 2)
        ab = 1;

    if (ab) {
        for (int i = 0; i < s.size(); ++i) {
            if (i == 0)
                p[i][s[i] - 'a']++;
            else {
                for (int j = 0; j < 2; ++j) {
                    p[i][j] += p[i - 1][j];
                }
                p[i][s[i] - 'a']++;
            }
        }
    }

    bool eq = 1;

    vector<int> del;

    for (int i = 1; i <= s.size(); ++i) {
        bool gd = 1;
        for (int j = 0; j < M; ++j) {
            if (cnt[j] % i != 0)
                gd = 0;
        }

        if (gd && s.size() % i == 0) {
            del.push_back(i);
        }
    }

    int res = 1;
    for (const auto it : del) {
        if (ab) {
            if (check(s, it, cnt)) {
                res = it;
            }
        } else {
            if (check1(s, it, cnt)) {
                res = it;
            }
        }
    }

    cout << res;

    return 0;
}