#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const int inf = (int)1e9 + 7;
const ll mod = (int)1e9 + 7;
int base[2] = {31, 41};

const int N = (int)2e5 + 100;
ll sz[N];
int c[N];
ll dp[N], sum[N];
vector<int> g[N];

void dfs(int v) {
    set<pair<int, int>, greater<pair<int, int>>> s, mxs;
    sum[v] = c[v];
    sz[v] = 1;
    for (const auto &to : g[v]) {
        s.insert({c[to], to});
        mxs.insert({c[to], to});
        if (mxs.size() > 2)
            mxs.erase(mxs.begin());
        dfs(to);
        sum[v] += sum[to];
        sz[v] += sz[to];
    }

    if (s.empty())
        return;


    for (const auto &to : g[v]) {
        int ch1 = s.count({c[to], to});
        s.erase({c[to], to});
        bool ch = 0;
        if (mxs.rbegin()->second == to) {
            mxs.erase({c[to], to});
            ch = 1;
        }
        if (s.empty()) {
            dp[v] += 1ll * (sz[to] - 1) * mxs.rbegin()->first;
        } else {
            ll ss = sz[to] - 1;
            while (ss > 0 && !s.empty()) {
                ss--;
                dp[v] += 1ll * s.begin()->first;
                s.erase(s.begin());
            }
            dp[v] += ss * mxs.rbegin()->first;
            if (ss > 0 && s.count(*mxs.rbegin())) {
                s.erase(*mxs.rbegin());
            }
        }
        dp[v] += sum[to] - c[to];
        if (ch) {
            mxs.insert({c[to], to});
        }
        if (ch1) {
            s.insert({c[to], to});
        }
    }

    for (const auto &to : g[v]) {
        if (s.count({c[to], to})) {
            bool ch = 0;
            if (mxs.rbegin()->second == to) {
                mxs.erase({c[to], to});
                ch = 1;
            }
            dp[v] += 1ll * mxs.rbegin()->first + c[to];
            if (s.count(*mxs.rbegin())) {
                s.erase(*mxs.rbegin());
            }
            s.erase({c[to], to});
            if (ch) {
                mxs.insert({c[to], to});
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
    }

    for (int i = 1; i < n; ++i) {
        cin >> c[i];
    }

    dfs(0);
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += dp[i];
    }

    cout << ans;

    return 0;
}