#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <map>
#include <set>
using namespace std;

#define ll long long

bool check(int n, vector<int>&A)
{
    vector<int>S(26, 0);
    for (int i = 0; i < n; i++)
        S[A[i]]++;
    int k = n;
    bool f = 0;
    while (k + n <= A.size())
    {
        vector<int>S1(26, 0);
        for (int i = k; i < k + n; i++)
            S1[A[i]]++;
        for (int i = 0; i < 26; i++)
        {
            if (S[i] != S1[i])
            {
                f = 1;
                break;
            }
        }
        if (f == 1)
            break;
        k = k + n;
    }
    return !f;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _DEBUG
    string s;
    cin >> s;
    vector<int> A(s.size());
    vector<int> K;
    for (int i = 0; i < s.size(); i++)
    {
        A[i] = s[i] - 'a';
    }
    int n = s.size();

    for (int i = 1; i * i <= n; i++)
    {
        if (n % i == 0)
        {
            K.push_back(i);
            if(i != n / i)
                K.push_back(n / i);
        }
    }
    sort(K.begin(), K.end());
    int l = 0, r = K.size();
    //cout << l << " " << r << endl;
    while (l + 1 < r)
    {
        int sr = (l + r) / 2;
        if (check(K[sr], A))
        {
            r = sr;
        }
        else
        {
            l = sr;
        }
       
    }
    
    if (check(K[l], A))
    {
        cout << n / K[l];
    }
    else
    {
        if (r < K.size())
        {
            if (check(K[r], A))
            {
                cout << n / K[r];
            }
        }
    }
	return 0;
}