#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif // _DEV

#if DEV == 0
#pragma GCC optimize("Ofast")
#endif // DEV
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using ll = long long;
void $main(ll i);

int main() {
    int numTests = 1;
    if (DEV) {
        freopen("d.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
        cin >> numTests;
    } else {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (ll i = 0; i < numTests; ++i) {
        $main(i);
        if (DEV) {
            cout << "-----------\n";
        }
    }
}
template<typename ...Args>
void cprint(bool cond, const Args& ...args) {
    if (!cond) return;
    ((cout << args << " "), ...);
    cout <<  endl;
}

template<typename ...Args>
void dprint(const Args& ...args) {
    cprint(DEV == 1, args...);
}

template<typename ...Args>
void aprint(const Args& ...args) {
    cprint(true, args...);
}

void $main(ll testId) {
    string s;

    cin >> s;
    int n = s.size();
        vector<vector<int>> m(26, vector<int>(n));


    set<char> sCharSet(s.begin(), s.end());
    vector<int> schars;
    for (auto c : sCharSet) {
        schars.push_back(c - 'a');
    }

    for (int c : schars) {
        for (int i = 0; i < n; ++i) {
            if (i > 0) m[c][i] = m[c][i-1];
            if (c == s[i] -'a') ++m[c][i];
        }
    }



    for (int k = n; k > 0; --k) {
        if (n % k != 0) continue;
        int l = n / k;
        bool ok = true;
        for (int c : schars) {
            if (!ok) break;
            int expected = m[c][l-1];
            for (int i = 1; i < k; ++i) {
                int p1 = l * (i) - 1;
                int p2 = l * (i+1) -1;
                int act = m[c][p2] - m[c][p1];
                if (act != expected) {
                    ok = false;

                    break;
                }
            }
        }
        if (ok) {
            cout << k << endl;
            return;
        }
    }
}
