#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif // _DEV

#if DEV == 0
#pragma GCC optimize("Ofast")
#endif // DEV
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace std::chrono_literals;
using ll = long long;
void $main(ll i);

int main() {
    int numTests = 1;
    if (DEV) {
        freopen("b.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
        cin >> numTests;
    } else {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (ll i = 0; i < numTests; ++i) {
        $main(i);
        if (DEV) {
            cout << "-----------\n";
        }
    }
}
template<typename ...Args>
void cprint(bool cond, const Args& ...args) {
    if (!cond) return;
    ((cout << args << " "), ...);
    cout <<  endl;
}

template<typename ...Args>
void dprint(const Args& ...args) {
    cprint(DEV == 1, args...);
}

template<typename ...Args>
void aprint(const Args& ...args) {
    cprint(true, args...);
}

using V = ll;

struct Vector {
    V x;
    V y;
    Vector(V x = 0, V y = 0) : x(x), y(y) {}
};

const Vector BASE(0, 0);

Vector operator-(const Vector& u, const Vector& v) {
    return Vector(u.x - v.x, u.y-v.y);
}

V dot(const Vector& u, const Vector& v) {
    return u.x*v.x + u.y*v.y;
}

V cross(const Vector& u, const Vector& v) {
    return u.x*v.y - u.y*v.x;
}

V dot(const Vector& u, const Vector& c, const Vector& v) {
    return dot(u-c, v-c);
}

V cross(const Vector& u, const Vector& c, const Vector& v) {
    return cross(u-c, v-c);
}

pair<V, V> mul(const Vector& u, const Vector& c, const Vector& v) {
    return make_pair(dot(u, c, v), cross(u, c, v));
}

struct Line {
    Vector u;
    Vector v;

    bool has(Vector& p) {

        return cross(u, p, v) == 0;
    }
};




int interection(const Line& l1, const Line& l2, Vector& out) {

}

void $main(ll testId) {
    int n;
    cin >> n;
    n = 2;
    Vector u, v;

    ll x1, y1, x2, y2;
    cin >> x1 >> y1 >>x2 >> y2;
    u = Vector(x1, y1);
    v = Vector(x2, y2);
    ll sx = u.x + v.x;
    ll sy = u.y + v.y;
    if (sx % 2 != 0 || sy % 2 != 0) {
        cout << "No\n";
    } else {
        cout << "Yes\n" << sx/2 <<" " << sy/2 << endl;
    }
}
