#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <cmath>

#define endl '\n'

using namespace std;

typedef long long ll;

struct three {
    ll sum, size, min;
    three(){}
    three(ll sum, ll size, ll min) : sum(sum), size(size), min(min){}
};

three dfs(vector<vector<int>> &g, vector<ll> &v, int cv, int anc, ll &ans) {
    vector<ll> sum(g[cv].size()), minv(g[cv].size()), vsize(g[cv].size());
    int cst = 0;
    ll cursize = 0, cursum = v[cv];
    for (int nv : g[cv]) {
        if (nv == anc) {
            continue;
        }
        auto res = dfs(g, v, nv, cv, ans);
        sum[cst] = res.sum;
        ans += res.sum;
        cursum += res.sum;
        minv[cst] = res.min;
        vsize[cst] = res.size;
        cursize += res.size;
        cst++;
    }
    if (cst < 1) {
        return {v[cv], 1, v[cv]};
    }
    int riskind = -1;
    for (int i = 0; i < cst; ++i) {
        if (vsize[i] * 2 > cursize) {
            riskind = i;
            break;
        }
    }
    if (riskind != -1) {
        int mind = -1;
        for (int i = 0; i < cst; ++i) {
            if (i != riskind) {
                if (mind == -1 || minv[mind] > minv[i]) {
                    mind = i;
                }
            }
        }
        ans += (2 * vsize[riskind] - cursize) * minv[mind];
    }
    else if (cursize % 2 != 0) {
        int mind = -1;
        for (int i = 0; i < cst; ++i) {
            if (mind == -1 || minv[mind] > minv[i]) {
                mind = i;
            }
        }
        ans += minv[mind];
    }
    return {cursum, cursize + 1, min(v[cv], *min_element(minv.begin(), minv.end()))};
//    for (int i = 0; i < cst; ++i) {
//        cursum += sum[i];
//        cursize += vsize[i];
//        if (i != mind) {
//            ans += sum[i] + mn * vsize[i];
//        }
//    }
//    int mind2 = -1;
//    ll mn2 = -1;
//    for (int i = 0; i < cst; ++i) {
//        if (i == mind) {
//            continue;
//        }
//        if (mind2 == -1 || mn2 > minv[i]) {
//            mind2 = i;
//            mn2 = minv[i];
//        }
//    }
//    ans += sum[mind] + mn2 * vsize[mind] - mn2 - mn;
//    mn = min(v[cv], mn);
//    return {cursum, cursize, mn};
}

int main() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int anc;
        cin >> anc;
        g[anc - 1].push_back(i + 1);
    }
    vector<ll> v(n);
    for (int i = 0; i < n - 1; ++i) {
        cin >> v[i + 1];
    }
    ll ans = 0;
    dfs(g, v, 0, 0, ans);
    cout << ans << endl;
}