#include <bits/stdc++.h>

using namespace std;

#define size(s) (ll)(s).size()

typedef long long ll;

const ll INF = 1e9;

void bye() {
    cout << "\n";
    exit(0);
}

string s;

bool check(ll len) {
    vector<ll> cnt(26);
    for (ll i = 0; i < len; i++) {
        cnt[s[i] - 'a']++;
    }
    for (ll k = len; k < size(s); k += len) {
        vector<ll> nowC(26); 
        for (ll i = 0; i < len; i++) {
            nowC[s[k + i] - 'a']++;
        }
        if (nowC != cnt) {
            return 0;
        }
    }
    return 1;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> s;
    ll n = size(s);
    ll ans = INF;
    for (ll len = 1; len <= sqrt(n); len++) {
        if (n % len == 0) {
            if (check(len)) {
                ans = len;
                break;
            }
        }
        if (n % len == 0 && (n % (n / len)) == 0) {
            if (check(n / len)) {
                ans = min(ans, n / len);
            }
        }
    }
    cout << n / ans;
    bye();
}
