#include <bits/stdc++.h>

using namespace std;

#define size(s) (ll)(s).size()

typedef long long ll;

const ll INF = 1e9;

void bye() {
    cout << "\n";
    exit(0);
}

string s;
vector<vector<int> > pref;

bool check(ll len) {
    for (int i = 0; i < size(s); i++) {
        for (int j = 0; j < 26; j++) {
            pref[i][j] = 0;
        }
    }
    pref[0][s[0] - 'a']++;
    for (int i = 1; i < size(s); i++) {
        for (int j = 0; j < 26; j++) {
            pref[i][j] = pref[i - 1][j];
        }
        pref[i][s[i] - 'a']++;
    }
    vector<int> need(26);
    for (int i = 0; i < 26; i++) {
        need[i] = pref[len - 1][i];
    }
    for (int i = 2 * len - 1; i < size(s); i += len) {
        for (int j = 0; j < 26; j++) {
            if (pref[i][j] - (pref[i - len][j]) != need[j]) {
                return 0;
            }
        }
    }
    return 1;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> s;
    ll n = size(s);
    pref.resize(size(s), vector<int>(26));
    ll ans = INF;
    for (ll len = 1; len <= sqrt(n); len++) {
        if (n % len == 0) {
            if (check(len)) {
                ans = len;
                break;
            }
            if (check(n / len)) {
                ans = min(ans, n / len);
            }
        }
    }
    cout << n / ans;
    bye();
}
