#include <bits/stdc++.h>

using namespace std;

#define size(s) (int)(s).size()

typedef long long ll;

const int INF = 1e9;

void bye() {
    cout << "\n";
    exit(0);
}

string s;
int n;
int cnt[26], done[26];

bool check(int len) {
    // cerr << "L";
    // cout << len << "\n";
    for (int i = 0; i < 26; i++) {
        cnt[i] = 0;
        done[i] = 0;
    }
    int sum = 0;
    for (int i = 0; i < len; i++) {
        cnt[s[i] - 'a']++;
        sum++;
    }
    for (int i = len; i < n; i += len) {
        int nowsum = 0;
        for (int j = i; j < i + len && j < n; j++) {
            done[s[j] - 'a']++;
            nowsum += (done[s[j] - 'a'] <= cnt[s[j] - 'a'] * (i / len));
        }
        if (nowsum != sum) {
            return 0;
        }
    }
    return 1;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> s;
    n = size(s);
    int ans = INF;
    for (int i = 1; i <= sqrt(n); i++) {
        if (n % i == 0) {
            if (check(i)) {
                ans = min(ans, i);
            }
            if (n % (n / i) == 0 && check(n / i)) {
                ans = min(ans, n / i);
            }
        }
    }
    cout << n / ans;
    bye();
}
