#include <bits/stdc++.h>

using namespace std;

#define size(s) (ll)(s).size()

typedef long long ll;

const ll INF = 1e9;

void bye() {
    cout << "\n";
    exit(0);
}

vector<vector<ll> > g;
vector<ll> c;
vector<ll> sum;
vector<ll> mn;
vector<ll> sz;
vector<ll> sub;
ll ans = 0;

void dfs(ll v, ll p) {
    ll ch = 0;
    for (auto to : g[v]) {
        if (to != p) {
            ch++;
            dfs(to, v);
        }
    }
    sz[v] = ch;
    mn[v] = c[v];
    sum[v] = c[v];
    sub[v] = 1;
    for (auto to : g[v]) {
        sum[v] += sum[to];
        mn[v] = min(mn[v], mn[to]);
        sub[v] += sub[to];
    }
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll n;
    cin >> n;
    g.resize(n);
    sub.resize(n);
    c.resize(n, 0);
    sum.resize(n);
    sz.resize(n);
    mn.resize(n, INF);
    for (ll i = 1; i < n; i++) {
        ll p;
        cin >> p;
        --p;
        g[p].push_back(i);
    }
    for (ll i = 1; i < n; i++) {
        cin >> c[i];
    }
    dfs(0, -1);
    for (ll i = 0; i < n; i++) {
        ans += (max(sub[i], sub[i] - sz[i]) + 1) / 2;
    }
    cout << ans;
    bye();
}
