#pragma option -O3
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
string s;
bool flag = true;
vector<int> pref;
int n;

bool check(int l) {
    for (int a = 0; a < n; a += l) {
        int b = a + l;
        if (pref[l] != pref[b] - pref[a]) return false;
    }
    if (!flag) {
        int p[26], c[26];
        memset(p, 0, sizeof(p));
        for (int i = 0; i < l; ++i) p[s[i] - 'a']++;
        for (int i = 0; i < n; i += l) {
            memset(c, 0, sizeof(c));
            for (int j = l - 1; j < l; ++j) {
                c[s[i + j] - 'a']++;
                if (c[s[i + j] - 'a'] > p[s[i + j] - 'a']) return false;
            }
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> s;
    reverse(s.begin(), s.end());
    n = s.size();
    pref.resize(n + 1);
    for (int i = 0; i <= n; ++i) {
        if (i < n && s[i] > 'b') flag = false;
        if (i != 0) pref[i] = pref[i - 1] + s[i - 1] - 'a';
    }
    vector<int> d;
    for (int i = 1; i * i <= n; ++i) {
        if (n % i == 0) {
            d.push_back(i);
            d.push_back(n / i);
        }
    }
    sort(d.begin(), d.end());
    d.resize(unique(d.begin(), d.end()) - d.begin());
    int k = d.size();
    for (int i = 0; i < k; ++i) {
        if (i * n > 1e8) {
            cout << 1 << endl;
            return 0;
        }
        if (check(d[i])) {
            cout << n / d[i] << endl;
            break;
        }
    }
    return 0;
}
