#pragma option -O3
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll P = ll(1000003ll);
const ll Q = ll(100000000000031ll);
string s;
bool flag = true;
vector<ll> pref;
ll n;

bool check(ll l) {
    for (ll a = 0; a < n; a += l) {
        ll b = a + l;
        if (pref[l] != ((pref[b] - pref[a]) % Q + Q) % Q) return false;
    }
    //if (!flag) {
        ll p[26], c[26];
        memset(p, 0, sizeof(p));
        for (ll i = 0; i < l; ++i) p[s[i] - 'a']++;
        for (ll i = 0; i < n; i += l) {
            memset(c, 0, sizeof(c));
            for (int j = l - 1; j < l; ++j) {
                c[s[i + j] - 'a']++;
                if (c[s[i + j] - 'a'] > p[s[i + j] - 'a']) return false;
            }
        }
    //}
    return true;
}

ll e(ll v, ll s) {
    if (s == 0) return 1;
    ll ans = e(v, s / 2);
    ans = (ans * ans) % Q;
    if (s % 2) {
        ans = (ans * v) % Q;
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> s;
    reverse(s.begin(), s.end());
    n = s.size();
    pref.resize(n + 1);
    for (ll i = 0; i <= n; ++i) {
        if (i < n && s[i] > 'b') flag = false;
        if (i != 0) pref[i] = (pref[i - 1] + e(P, (s[i - 1] - 'a'))) % Q;
    }
    vector<ll> d;
    for (ll i = 1; i * i <= n; ++i) {
        if (n % i == 0) {
            d.push_back(i);
            d.push_back(n / i);
        }
    }
    sort(d.begin(), d.end());
    d.resize(unique(d.begin(), d.end()) - d.begin());
    ll k = d.size();
    for (ll i = 0; i < k; ++i) {
        if (check(d[i])) {
            cout << n / d[i] << endl;
            break;
        }
    }
    return 0;
}
