#include <iostream>
#include <vector>
#define ff first
#define ss second
#define int long long

using namespace std;

vector<pair<int, int>> p;
vector<bool> used;

bool online(pair<int, int> a, pair<int, int> b, pair<int, int> c) {
    //cout << "! " << (a.ff - c.ff) << " " << (b.ss - c.ss) << " " << (a.ss - c.ss) << " " << (b.ff - c.ff) << endl;
    return (a.ff - c.ff) * (b.ss - c.ss) == (a.ss - c.ss) * (b.ff - c.ff);
}

bool check(pair<int, int> m) {
    used.clear();
    used.resize(p.size());
    if (abs(m.ff) >= (int)1e6 || abs(m.ss) >= (int)1e6) return 0;
    /*cout << "# check" << endl;
    cout << m.ff << " " << m.ss << endl;*/
    for (int i = 0; i < p.size(); i++) {
        if ((m == p[i])) return 0;
        if (used[i]) continue;
        //cout << i << "@ "<< endl;
        bool log = 1;
        int cnt = 0;
        for (int j = i + 1; j < p.size(); j++) {
            if (!used[j] && online(p[i], p[j], m)) {
                used[j] = 1;
                log = 0;
                cnt++;
                if (cnt == 2) {
                    log = 1;
                    break;
                }
                //cout << "j: " << j << endl;
                //break;
            }
        }
        if (log) return 0;
    }
    return 1;
}


signed main() {
    int n;
    cin >> n;
    p.resize(2 * n);
    for (int i= 0; i < 2 * n; i++) {
        cin >> p[i].ff >>  p[i].ss;
    }
    n = p.size();
    for (int i1 = 0; i1 < n; i1++) {
        for (int i2 = i1 + 1; i2 < n; i2++) {
            for (int i3 = i1 + 1; i3 < n; i3++) {
                if (i3 == i2) continue;
                for (int i4 = i3 + 1; i4 < n; i4++) {
                    if (i4 == i2) continue;
                    //cout << online(p[i1], p[i2], p[i3]) << " " << ((p[i1].ff - p[i2].ff) * (p[i3].ss - p[i4].ss) == (p[i3].ff - p[i4].ff) * (p[i1].ss - p[i2].ss) || (p[i1].ff - p[i2].ff) * (p[i3].ss - p[i4].ss) == -(p[i3].ff - p[i4].ff) * (p[i1].ss - p[i2].ss)) << endl;
                    if ((p[i1].ff - p[i2].ff) * (p[i3].ss - p[i4].ss) == (p[i3].ff - p[i4].ff) * (p[i1].ss - p[i2].ss)) {
                        continue;
                    }
                    //cout << (p[i1].ff - p[i2].ff) << " "<< (p[i3].ss - p[i4].ss) << " "<< (p[i3].ff - p[i4].ff) << " " <<  (p[i1].ss - p[i2].ss) << endl;
                    int c1 = p[i1].ff * p[i2].ss - p[i1].ss * p[i2].ff;
                    int c2 = p[i3].ff * p[i4].ss - p[i3].ss * p[i4].ff;
                    int a1 = p[i1].ff - p[i2].ff;
                    int a2 = p[i3].ff - p[i4].ff;

                    int b1 = p[i2].ss - p[i1].ss;
                    int b2 = p[i4].ss - p[i3].ss;
                    /*cout << i1 << " " << i2 << " " << i3 << " " << i4 << endl;
                    cout << p[i1].ff << " " <<p[i1].ss << endl;
                    cout << p[i2].ff << " " << p[i2].ss << endl;
                    cout << p[i3].ff << " "<< p[i3].ss << endl;
                    cout << p[i4].ff << " " << p[i4].ss << endl;
                    cout << endl;
                    cout << "C: " << c1 << " " << c2 << endl;
                    cout << "A: " << a1 << " " << a2 << endl;
                    cout << "B: " << b1 << " " << b2 << endl;*/
                    int x, y;
                    if (b1 == 0) {
                        if (b1 * a2 % a1 != 0 || a2 * c1 % a1 != 0) continue;
                        int q1 = c2 - a2 * c1 / a1;
                        int q2 = b2 - b1 * a2 / a1;
                        ///q2 == q1 * x
                        if (q1 == q2 && q2 == 0) {
                            pair<int, int> v = {p[i1].ff - p[i2].ff, p[i1].ss - p[i2].ss};
                            for (int i = -10; i <= 10; i++) {
                                if (i == 0) continue;
                                if (check({p[i1].ff + i * v.ff, p[i1].ss + i * v.ss})) {
                                    cout << "Yes" << endl;
                                    cout << p[i1].ff + i * v.ff << " " << p[i1].ss + i * v.ss << endl;
                                    return 0;
                                }
                            }
                            continue;
                        } else {
                            if (q2 % q1 != 0) continue;
                            x = q2 / q1;
                            y = (c1 - b1 * x) / a1;
                            if ((c1 - b1 * x) % a1 != 0) continue;
                        }
                    }
                    else {
                        if (b2 * c1 % b1 != 0 || b2 * a1 % b1 != 0) continue;
                        int q1 = c2 - b2 * c1 / b1;
                        int q2 = a2 - b2 * a1 / b1;
                        //cout << q1 << " " << q2 << endl;
                        if (q1 == q2 && q1 == 0) {
                            pair<int, int> v = {p[i1].ff - p[i2].ff, p[i1].ss - p[i2].ss};
                            for (int i = -10; i <= 10; i++) {
                                if (i == 0) continue;
                                if (check({p[i1].ff + i * v.ff, p[i1].ss + i * v.ss})) {
                                    cout << "Yes" << endl;
                                    cout << p[i1].ff + i * v.ff << " " << p[i1].ss + i * v.ss << endl;
                                    return 0;
                                }
                            }
                            continue;
                        } else {
                            if (q1 % q2 != 0) continue;
                            y = q1 / q2;
                            x = (c1 - a1 * y) / b1;
                            if ((c1 - a1 * y) % b1 != 0) continue;
                        }
                    }
                    if (check({x, y})) {
                        cout << "Yes" << endl;
                        cout << x << " " << y << endl;
                        return 0;
                    }
                }
            }
        }
    }
    cout << "No" << endl;
    return 0;
}
