#include <iostream>
#include <fstream>
#include <cstring>
#include <cmath>
#include <vector>

using namespace std;

char s0[1000000];
char s1[1000000];
char s2[1000000];
char s3[1000000];
char s4[1000000];

void put(int pos, char symv){
    switch (pos/1000000){
case 0:
    s0[pos%1000000] = symv;
    break;
case 1:
    s1[pos%1000000] = symv;
    break;
case 2:
    s2[pos%1000000] = symv;
    break;
case 3:
    s3[pos%1000000] = symv;
    break;
case 4:
    s4[pos%1000000] = symv;
    break;
    }
}

char get(int pos){
    char res;
    switch (pos/1000000){
case 0:
    res = s0[pos%1000000];
    break;
case 1:
    res = s1[pos%1000000];
    break;
case 2:
    res = s2[pos%1000000];
    break;
case 3:
    res = s3[pos%1000000];
    break;
case 4:
    res = s4[pos%1000000];
    break;
    }
    return(res);
}

long long takehesh(char x){
    int n = (int) x - 96;
    long long res;
    res = n*99239239716382%10000007;
    return(res);
}

int main()
{
    ifstream fin("input.txt");
    ofstream fout("output.txt");
    char t;
    int l = 0;
    fin >> t;
    while (t!= '0'){
        put(l, t);
        t = '0';
        fin >> t;
        l++;
    }
    int res = 1;
    for (int i = 1; i <= l/2; i++){
        if (l%i == 0){
            bool ab = true;
            long long hesh = 0;
            for (int j = 0; j < i; j++){
                hesh += takehesh(get(j));
            }
            int pos = i;
            while((pos < l)&&(ab)){
                long long tm = 0;
                for (int k = pos; k< pos + i; k++){
                    tm+= takehesh(get(k));
                }
                if (tm!= hesh){
                    ab = false;
                }
                pos+=i;
            }
            if (ab){
                res = max(res, (l/i));
            }
        }
    }
    fout << res;
    fout.close();
    fin.close();
}