#include <bits/stdc++.h>

using namespace std;

struct cmp
{
    bool operator ()(long long i, long long j)
    {
        return i > j;
    }
};

void dfs(long long a, vector <vector <long long> > &children, vector <long long> &num, vector <long long> &sum)
{
    multiset <long long, cmp> vals;
    for (long long i = 0; i < children[a].size(); i++)
    {
        dfs(children[a][i], children, num, sum);
        num[a] += num[children[a][i]];
        if (num[children[a][i]] != 0){
            vals.insert(num[children[a][i]]);
        }
    }

    long long need_give = 0;

    while (vals.size() > 1)
    {
        long long k1 = *vals.begin();
        vals.erase(vals.begin());
        long long k2 = *vals.begin();
        vals.erase(vals.begin());
        sum[a] += min(k2, k1);
        k2 = abs(k2 - k1);

        if (k2 != 0)
        {
            vals.insert(k2);
        }
    }

    if (vals.size() == 1)
    {
        long long k = *vals.begin();
        sum[a] += k;
    }

    sum[a] *= 2;
}

int main()
{
    long long n;
    cin >> n;
    vector <vector <long long> > children(n, vector <long long>());
    vector <long long> sum(n, 0);
    for (long long i = 1; i < n; i++)
    {
        long long p;
        cin >> p;
        p--;
        children[p].push_back(i);
    }
    vector <long long> c(n, 1);
    for (long long i = 1; i < n; i++)
    {
        cin >> c[i];
    }

    vector <long long> num(n, 1);

    dfs(0, children, num, sum);
    long long ans = 0;
    for (long long i = 0; i < n; i++)
    {
        ans += sum[i];
    }

    cout << ans;
    return 0;
}

