#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef pair <ld, ld> pld;

#define int long long
#define x first
#define y second
#define sqr(x) ((x) * (x))

const int INFINT = 1e9 + 20;
const ll INFLL = 1e18 + 20;
const ld pi = acos(-1);
const ld eps = 1e-12;
const int N = 5e6 + 20;
const int M = 1e3 + 20;
const int C = 1e2 + 20;

int cnt[N];
int c[N];
vector <int> g[N];
int val[N];
/*
void dfs(int v) {
    cout << v << endl;

    if (g[v].size() == 0) {
        cnt[v] = 1;
        val[v] = 0;
        return;
    }

    for (int i : g[v])
        dfs(i);

    vector <int> s;
    for (int i : g[v]) {
        cnt[v] += cnt[i];
        s.push_back(cnt[i]);
    }
    int tmp = cnt[v];
    cnt[v]++;
    sort(s.begin(), s.end());
    int p[N] = {0};
    for (int i = 0; i < s.size(); i++)
        p[i] = (i ? p[i - 1] : 0) + s[i];
    int k = INFLL;
    for (int i = 0; i < s.size() - 1; i++)
        k = min(k, p[s.size() - 1] - 2 * p[i]);
    tmp += k;
    val[v] = tmp;
}*/

void dfs(int v) {
    //cout << v << endl;
    if (g[v].size() == 0) {
        cnt[v] = 1;
        val[v] = 0;
        return;
    }
    for (int i : g[v])
        dfs(i);

    vector <int> s;
    for (int i : g[v]) {
        cnt[v] += cnt[i];
        s.push_back(cnt[i]);
    }
    sort(s.begin(), s.end());
    int tmp = cnt[v];
    cnt[v]++;
    vector<int> p(s.size(), 0);
    for (int i = 0; i < s.size(); i++)
        p[i] = (i ? p[i - 1] : 0) + s[i];
    int k = INFLL;
    for (int i = 0; i < s.size() - 1; i++)
        k = min(k, abs(p[s.size() - 1] - 2 * p[i]));
    tmp += k;
    val[v] = tmp;
}

signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
    srand(time(0));
    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        x -= 1;
        g[x].push_back(i);
    }

    for (int i = 1; i < n; i++)
        cin >> c[i];

    dfs(0);
    int ans = 0;
    for (int i = 0; i < n; i++)
        ans += val[i];
    cout << ans << endl;
    return 0;
}
