#define CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF=1e9+9;
const int MAXN=2e5+7;
const int MX=1e6;

void solve();

#define _DEBUG

int main() {
    srand('a'+'l'+'e'+'x'+'X'+'5'+'1'+'2');
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef _DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _DEBUG
    solve();
}

/*----------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------*/

bool correct(string &s, int &n){
    vector<int> v(26);
    for(int i=0;i<n;i++){
        v[s[i]-'a']++;
    }
    for(int i=n;i<s.size();i+=n){
        vector<int> v1(26);
        for(int j=0;j<n;j++){
            v1[s[i+j]-'a']++;
        }
        if(v1!=v) return 0;
    }
    return 1;
}

void solve(){
    string s;
    cin>>s;
    int n=s.size();
    vector<int> ans;
    for(int i=1;i*i<=n;i++){
        if(n%i==0){
            ans.emplace_back(i);
            if(n/i!=i){
                ans.emplace_back(n/i);
            }
        }
    }
    sort(ans.begin(),ans.end());
    for(int i=0;i<ans.size();i++){
        if(correct(s, ans[i])){
            cout<<n/ans[i];
            return;
        }
    }
}

























