#define CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF=1e9+9;
const int MAXN=2e5+7;
const int MX=1e6;

void solve();

#define _DEBUG

int main() {
    srand('a'+'l'+'e'+'x'+'X'+'5'+'1'+'2');
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef _DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _DEBUG
    solve();
}

/*----------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------*/

vector<vector<int>> v(MAXN);
vector<ll> cost;
ll ans=0;

pair<pair<ll,ll>,ll> dfs1(int vert){
    ll mn1=INF, mn2=INF, ind1=-1, ind2=-1;
    ll sm=0, kl=0;
    vector<pair<pair<ll,ll>,pair<ll,ll>>> vec;
    for(int i=0;i<v[vert].size();i++){
        pair<pair<ll,ll>,ll> p=dfs1(v[vert][i]);
        vec.emplace_back(mp(mp(p.first.second, p.first.first), mp(p.second, i)));
        ll mn=p.second;
        sm+=p.first.first;
        kl+=p.first.second;
        if(mn<mn1){
            mn2=mn1;
            mn1=mn;
            ind2=ind1;
            ind1=i;
        }
        else if(mn<mn2){
            mn2=mn;
            ind2=i;
        }
    }
	sort(vec.begin(), vec.end());
	ll dop=INF, uk=vec.size()-1;
	for(int i=uk-1;i>=0;i--){
		if(vec[uk].first.first>vec[i].first.first){
			vec[uk].first.first-=vec[i].first.first;
			vec[i].first.first=0;
		}
		else{
			vec[i].first.first-=vec[uk].first.first;
			vec[uk].first.first=0;
			uk=i;
		}
	}
	if(!v[vert].empty()){
		if(uk==vec.size()-1 && vec.back().second.second==ind1){
			ans+=sm+vec[uk].first.first*mn2;
		}
		else{
			ans+=sm+vec[uk].first.first*mn1;
		}
	}
    return(mp(mp(sm+cost[vert], kl+1), min(cost[vert], mn1)));
}

void solve(){
    int n;
    cin>>n;
	cost.emplace_back(0);
	cost.emplace_back(0);
    for(int i=2;i<=n;i++){
        int a;
        cin>>a;
        v[a].emplace_back(i);
    }
    for(int i=0;i<n-1;i++){
        int a;
        cin>>a;
        cost.emplace_back(a);
    }
    dfs1(1);
    cout<<ans;
}
























