#define _FORTIFY_SOURCE 0
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <math.h>
#include <random>
#include <algorithm>
#define pii pair<int, int>
#define mp make_pair
#define ff first
#define ss second
#define Matrix vector<vector<int> >  
#define kektor vector
#define int long long
#define pb push_back
#define all1(x) x.begin(), x.end() 

using namespace std;             

int RandInt(int min, int max) {
    if (max < min) {
        swap(min, max);    
    }
    random_device rd; 
    mt19937 mt(rd()); 
    uniform_int_distribution<int> dist(min, max);
    return dist(mt); 
}     

typedef long long ll;
const int maxn = 2e5, mod = 1e9 + 7, inf = 1e18;  
int n, cnt[maxn], dp[maxn];
vector<int> gr[maxn]; 

int dfs(int u, int pr) {
    vector<int> all;
    int cur = 0; 
    int ret = 0;
    for (auto v : gr[u]) {
        if (v != pr) {
            all.pb(dfs(v, u));            
            ret += all.back(); 
            cur += dp[v];
        }
    }
    sort(all1(all)); 
    reverse(all1(all)); 
    int l = 0; 
    int r = 1;
    while (l < all.size() - 1 && r < all.size()) {
        while (all[l] > 0 && r < all.size()) {
            if (all[l] >= all[r]) {
                cur += 2 * all[r];  
                all[l] -= all[r]; 
                all[r] = 0;
                ++r;
            } else {
                cur += 2 * all[l];
                all[r] -= all[l];
                all[l] = 0; 
                l = r; 
                r = l + 1;
                break; 
            }
        }  
    }
    for (auto i : all) {
        cur += i * 2;         
    }
    dp[u] = cur; 
    return ret + 1;
}

void solve() {        
    cin >> n;
    int max_el = -1;
    for (int i = 0; i < n; ++i) {
        dp[i] = 0;
    }
    for (int i = 1; i < n; ++i) {
        int a;
        cin >> a; 
        --a;
        gr[a].pb(i);
        gr[i].pb(a);  
    } 
    for (int i = 1; i < n; ++i) {
        cin >> cnt[i];
        max_el = max(max_el, cnt[i]);                 
    }
    if (max_el > 1) {
        cout << 25; 
        return;
    }
    dfs(0, 0);
    cout << dp[0] << endl;
}                              

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    #ifdef offline_judge             
        freopen("TASK.in", "r", stdin); 
        freopen("TASK.out", "w", stdout);
    #endif
    solve();
    return 0; 
}

