#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")
#define DEBUG1

#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <numeric>
#include <stack>
#include <cstring>
#include <cstdlib>
#include <string>

using namespace std;

string s;

int pref[(int)5e+6 + 1][26];
int n;

inline void init(const string &s)
{
	pref[0][s[0] - 'a'] = 1;
	for (int i = 1; i < n; i++) {
		memcpy(pref[i], pref[i - 1], 26 * sizeof pref[0][0]);
		pref[i][s[i] - 'a']++;
	}
}

inline bool check(const int &x)
{
	int cnt = s.size() / x;

	for (int i = 2; i <= x; i++)
		for (int j = 0; j < 26; j++)
			if (pref[cnt - 1][j] != pref[i * cnt - 1][j] - pref[(i - 1) * cnt - 1][j])
				return false;

	return true;
}

bool res[(int)5e+6 + 1];

inline void eratos()
{
	memset(res, true, sizeof(res));
	res[0] = res[1] = false;
	for (long long i = 0; i <= n; i++)
		if (res[i])
			for (long long j = i * i; j <= n; j += i)
				res[j] = false;
}

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0);
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cin >> s;
	n = s.size();
	init(s);
	eratos();

	if (res[n]) {
		cout << 1;
		return 0;
	}

	vector<int> d;
	d.reserve(10000);
	for (int i = 1; i * i <= n; i++)
		if (n % i == 0) {
			
			d.push_back(i);
			if (i * i < n)
				d.push_back(n / i);
		}

	sort(d.begin(), d.end());

	for (int i = d.size() - 1; i >= 0; i--)
		if (check(d[i])) {
			cout << d[i];
			return 0;
		}
}
