#define _CRT_SECURE_NO_WARNINGS
#define REL

#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <cassert>
#include <string>
#include <queue>

#define mp make_pair
#define pii pair<int, int>
#define endl "\n"

const int N = (int)5e6 + 7;
const int INF = (int)2e9;

typedef long long LL;

using namespace std;

int cnt[N][26] = {};
vector <int> d;

void divisor(int x) {
	int cnt = 0;
	for (LL i = 1; i * i <= x; i++) {
		if (x % i == 0) {
			d.push_back(i);
			if (i * i != x)
				d.push_back(x / i);
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
#endif
	string s; cin >> s;
	bool fl = true;
	int n = s.size(), sym[26] = {};
	for (int i = 0; i < n; i++)
		sym[s[i] - 'a']++;
	divisor(n);
	sort(d.begin(), d.end());
	for (int i = 0; i < (int)d.size(); i++) {
		bool f = true;
		for (int j = 0; j < 26; j++)
			if (sym[j] % (n / d[i]) != 0) {
				f = false;
				break;
			}
		if (!f)
			continue;
		int pos = -1;
		for (int j = 0; j < n; j++) {
			if (j % d[i] == 0)
				pos++;
			cnt[pos][s[j] - 'a']++;
		}
		bool can = true;
		for (int j = 0; j < 26; j++) {
			int val = cnt[0][j];
			bool fl = true;
			for (int k = 0; k <= pos; k++) {
				if (val != cnt[k][j])
					fl = false;
				cnt[k][j] = 0;
			}
			if (!fl)
				can = false;
		}
		if (can) {
			cout << n / d[i];
			return 0;
		}
	}
}