#define _CRT_SECURE_NO_WARNINGS
#define REL

#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <cassert>
#include <string>
#include <queue>

#define mp make_pair
#define pii pair<int, int>
#define endl "\n"

const int N = (int)1e6 + 7;
const int INF = (int)2e9;

typedef long long LL;

using namespace std;

int arr[N], mn[N], cnt[N]; 
LL sum[N], ans = 0;
vector <int> gr[N];

void dfs(int v) {
	vector <pair<pair<int, LL>, int>> ch;
	sum[v] = mn[v] = arr[v];
	cnt[v] = 1;
	for (int i = 0; i < (int)gr[v].size(); i++) {
		int to = gr[v][i];
		dfs(to); cnt[v]++;
		sum[v] += sum[to];
		ch.push_back(mp(mp(mn[to], sum[to]), to));
	}
	sort(ch.begin(), ch.end());
	if ((int)ch.size() != 0) {
		auto m1 = ch[0], m2 = ch[1];
		mn[v] = min(mn[v], m1.first.first);
		for (int i = 1; i < (int)ch.size(); i++)
			ans += ch[i].first.second + 1LL * cnt[ch[i].second] * m1.first.first;
		ans += ch[0].first.second - m1.first.first + 1LL * (cnt[ch[0].second] - 1) * m2.first.first;
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
#endif
	int n; cin >> n;
	for (int i = 1; i < n; i++) {
		int fr; cin >> fr; fr--;
		gr[fr].push_back(i);
	}
	for (int i = 1 ; i < n; i++)
		cin >> arr[i];
	dfs(0);
	cout << ans;
}