#define _CRT_SECURE_NO_WARNINGS
#define REL

#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <cassert>
#include <string>
#include <queue>

#define mp make_pair
#define pii pair<int, int>
#define endl "\n"

const int N = (int)1e6;
const int INF = (int)2e9;

typedef long long LL;

using namespace std;

LL gcd(LL a, LL b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
#endif
	int n; cin >> n;
	n *= 2;
	vector <pii> v(n);
	for (int i = 0; i < n; i++)
		cin >> v[i].first >> v[i].second;
	vector <pair<pair<LL, LL>, LL>> line;
	map <pair<pair<LL, LL>, LL>, pii> p;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			LL a = v[i].second - v[j].second;
			LL b = v[j].first - v[i].first;
			LL c = -(a * v[i].first + b * v[i].second);
			LL d = gcd(gcd(abs(a), abs(b)), abs(c));                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    			a /= d, b /= d, c /= d;
			if (a < 0)
				a *= -1, b *= -1, c *= -1;
			auto cur = mp(mp(a, b), c);
			line.push_back(cur);
			p[cur] = mp(i, j);
		}
	}
	sort(line.begin(), line.end());
	int ind = 0;
	vector <pair<pair<LL, LL>, LL>> rest;
	while (ind < (int)line.size()) {
		auto st = line[ind];
		int cnt = 0;
		while (ind < (int)line.size() && st == line[ind]) {
			ind++, cnt++;
		}
		if (cnt == 1)
			rest.push_back(st);
	}
	for (int x = -5; x <= 5; x++) {
		vector <pair<LL,pair<pair<LL, LL>, LL>>> in;
		vector <int> all;
		for (int j = 0; j < (int)rest.size(); j++) {
			LL a = rest[j].first.first, b = rest[j].first.second, c = rest[j].second;
			if (b != 0 && abs(-a * x - c) % abs(b) == 0 && abs((-a * x - c) / b) <= N) {
				auto cur = rest[j];
				in.push_back(mp((-a * x - c) / b, cur));
			}
			if (b == 0 && a * x + c == 0) {
				all.push_back(p[rest[j]].first);
				all.push_back(p[rest[j]].second);
			}
		}
		sort(in.begin(), in.end());
		int ind = 0;
		while (ind < (int)in.size()) {
			vector <int> cur;
			int st = in[ind].first;
			while (ind < (int)in.size() && in[ind].first == st) {
				cur.push_back(p[in[ind].second].first);
				cur.push_back(p[in[ind].second].second);
				ind++;
			}
			bool used[3000] = {};
			for (int k = 0; k < (int)all.size(); k++) {
				if (v[all[k]] == mp(x, st))
					continue;
				used[all[k]] = true;
			}
			for (int k = 0; k < (int)cur.size(); k++) {
				if (v[cur[k]] == mp(x, st))
					continue;
				used[cur[k]] = true;
			}
			bool fl = true;
			for (int k = 0; k < n; k++) {
				if (!used[k]) {
					fl = false;
					break;
				}
			}
			if (fl) {
				cout << "Yes\n";
				cout << x << ' ' << st;
				return 0;
			}
		}
	}
	cout << "No";
}