#include<iostream>
#include<vector>
#include<queue>
#include<cstring>
#include<cstdio>
#include<cstdlib>
#include<set>
#include<map>
#include<algorithm>
#include<cmath>
using namespace std;
struct nz
{
    int x,y;
    nz() {};
    nz(int _x, int _y)
    {
        x=_x;
        y=_y;
    }
};
vector<nz> v;
int n;
double a[5202][5202];
double b[5202][5202];
int fb[5202][5202];
void comp()
{
    int i,j,k;
    for(i=0;i<n;i++)
    {
        for(j=i+1;j<n;j++)
        {
            if(v[j].x-v[i].x==0)
            {
                fb[i][j]=1;
                continue;
            }
            a[i][j]=double(v[j].y-v[i].y)/(double)(v[j].x-v[i].x);
            b[i][j]=double(v[i].y-a[i][j]*v[i].x);
        }
    }
    for(i=0;i<n;i++)
    {
        for(j=i+1;j<n;j++)
        {
            if(fb[i][j]) continue;
            for(k=j+1;k<n;k++)
            {
                if(fb[j][k]||fb[i][k]) continue;
                if(a[i][j]==a[j][k]||b[i][j]==b[j][k])
                {
                    fb[i][j]=fb[i][k]=fb[j][k]=1;
                }
            }
        }
    }
}
nz pres(int i1, int i2, int i3, int i4)
{
    int xx=(b[i3][i4]-b[i1][i2])/(a[i1][i2]-a[i3][i4]);
    if((double)xx*((a[i1][i2]-a[i3][i4]))!=(b[i3][i4]-b[i1][i2])) return nz(1e9,1e9);
    return nz(xx,a[i1][i2]*xx+b[i1][i2]);
}
int used[5200];
int check(int i1, int i2, int i3, int i4)
{
    nz ppr=pres(i1,i2,i3,i4);
    if(ppr.x==1e9&&ppr.y==1e9) return 0;
    int i,j;
    memset(used,0,sizeof(used));
    used[i1]=used[i2]=used[i3]=used[i4]=1;
    for(i=0;i<n;i++)
    {
        if(used[i]) continue;
        for(j=i+1;j<n;j++)
        {
            if(used[j]) continue;
            if(pres(i,j,i1,i2).x==ppr.x&&pres(i,j,i1,i2).y==ppr.y)
            {
                used[i]=used[j]=1;
                break;
            }
        }
        if(!used[i]) return 0;
    }
    return 1;
}
int main()
{
	int i,j;
	cin>>n;
	n*=2;
	int x,y;
	for(i=0;i<n;i++)
    {
        cin>>x>>y;
        v.push_back(nz(x,y));
    }
    comp();
    int k,l;
    for(i=0;i<n;i++)
    {
        for(j=i+1;j<n;j++)
        {
            if(fb[i][j]) continue;
            for(k=i+1;k<n;k++)
            {
                if(k==j) continue;
                for(l=k+1;l<n;l++)
                {
                    if(l==j||fb[k][l]) continue;
                    if(check(i,j,k,l))
                    {
                        cout<<"Yes"<<endl;
                        cout<<pres(i,j,k,l).x<<" "<<pres(i,j,k,l).y<<endl;
                        return 0;
                    }
                }
            }
        }
    }
    cout<<"No"<<endl;
	return 0;
}
