#include <bits/stdc++.h>

using namespace std;

const int maxn = 5e5 + 5;

char s[maxn];
int n, fr[maxn][26];

int gcd(int a, int b) {
    int r;
    while (b) {
        r = a % b;
        a = b;
        b = r;
    }
    return a;
}

bool check(int bucket) {
    int length = n / bucket;
    for (int i = 1; i <= n; i += length) {
        for (int j = 0; j < 26; j++)
            if (fr[i + length - 1][ j ] - fr[i - 1][ j ] != fr[ n ][ j ] / bucket)
                return false;
    }
    return true;
}

int main()
{
    ios::sync_with_stdio( false );
    //freopen( "leonardo.in", "r", stdin);
    //freopen( "leonardo.out","w",stdout);

    cin >> (s + 1);
    n = strlen(s + 1);
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < 26; j++)
            fr[ i ][ j ] = fr[i - 1][ j ];
        fr[ i ][s[ i ] - 'a']++;
    }

    int div = n;
    for (int i = 0; i < 26; i++)
        if (fr[ n ][ i ])
            div = gcd(div, fr[ n ][ i ]);

    if (div == 1) {
        cout << 1;
        return 0;
    }

    if (check(div)) {
        cout << div;
        return 0;
    }

    for (int i = div/2; i > 1; i--)
        if (div % i == 0) {
            if (check( i )) {
                cout << i;
                return 0;
            }
        }

    cout << 1;

    return 0;
}
