#include <iostream>
#include <string>

using namespace std;

const int MAX_N = 5e6 + 1;
const int SGM = 26;
int f[MAX_N][SGM];
int p[SGM];

int main() {
    freopen( "input.txt", "r", stdin );
    string s;
    cin >> s;
    int i = 0, n = s.size();
    for ( int i = 0; i < n; i ++ ) {
        f[i + 1][s[i] - 'a'] ++;
        for ( int j = 0; j < SGM; j ++ )
            f[i + 1][j] += f[i][j];
    }

    int d;
    for ( d = 1; d < n; d ++ ) {
        if ( n % d != 0 )
            continue;

        int i = 0, ad = n / d;
        while ( i < SGM && f[n][i] % ad == 0 )
            i ++;
        if ( i < SGM )
            continue;

        for ( int i = 0; i < SGM; i ++ ) {
            p[i] = f[d][i];
        }

        i = d * 2;
        int j;
        do {
            j = 0;
            while ( j < SGM && f[i][j] - f[i - d][j] == p[j] )
                j ++;
            i += d;
        } while ( i <= n && j == SGM );

        if ( j == SGM )
            break;
    }
    cout << n / d;
    return 0;
}
