#include <iostream>
#include <vector>

using namespace std;

const int MAX_N = 2e5 + 1;
int fat[MAX_N];
int perf[MAX_N];
int sz[MAX_N];
vector<int> fils[MAX_N];

long long ans;
void dfs( int n ) {
    sz[n] = 1;
    if ( fils[n].size() == 0 ) {
        return;
    }

    int mx = 0;
    for ( int i : fils[n] ) {
        dfs( i );
        sz[n] += sz[i];
        mx = max( mx, sz[i] );
    }

    if ( mx * 2 < sz[n] - 1 ) {
        ans += sz[n] - 1 + ( sz[n] - 1 ) % 2;
    } else {
        ans += mx * 2;
    }
}

int main() {
    freopen( "input.txt", "r", stdin );
    int n;
    cin >> n;
    for (int i = 2; i <= n; i ++ ) {
        cin >> fat[i];
        fils[fat[i]].push_back( i );
    }

    int ones = 1;
    for ( int i = 2; i <= n; i ++ ) {
        cin >> perf[i];
        ones += ( perf[i] == 1 );
    }

    if ( ones == n ) {
        dfs( 1 );
        cout << ans;
    }

    return 0;
}
