#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const unsigned long long MOD = 1000 * 1000 * 1000 * 10 + 7;
const int MAX_N = 5 * 1000 * 1000 + 5;
unsigned long long hsh[MAX_N], hsher[50];
int a[50];

int gcd(int a, int b){
    if(a == 0)
        return b;
    return gcd(b % a, a);
}

int main(){
    string s;
    cin >> s;
    fill(a, a + 50, 0);
    for(int i = 0; i < s.size(); i++)
        ++a[s[i] - 'a'];

    if(a[0] + a[1] == s.size()){
        vector< pair<int, int> > xxx(MAX_N);
        if(s[0] == 'a')
            xxx[0] = {1, 0};
        else
            xxx[0] = {0, 1};
        for(int i = 1; i < s.size(); i++){
            if(s[i] == 'a')
                xxx[i] = {xxx[i - 1].first + 1, xxx[i - 1].second};
            else
                xxx[i] = {xxx[i - 1].first, xxx[i - 1].second + 1};
        }
        for(int i = 1; i <= s.size(); i++)
            if(s.size() % i == 0){
                int m = i;
                bool good = true;
                for(int i = 2 * m - 1; i < s.size(); i += m)
                    if(((xxx[i].first - xxx[i - m].first) !=  xxx[m - 1].first) ||
                        (xxx[i].second - xxx[i - m].second != xxx[m - 1].second)){
                        good = false;
                        break;
                    }
                if(good){
                    cout << s.size() / m;
                    return 0;
                }
            }
    }

    int now = s.size(), maxcnt = 0;
    for(int i = 0; i <= 'z' - 'a'; i++)
        if(a[i] > 0){
            now = gcd(now, a[i]);
            //cout << now << ' ';
            maxcnt = max(maxcnt, a[i]);
        }
    ++maxcnt;
    hsher[0] = 1;
    for(int i = 1; i <= 'z' - 'a'; i++){
        if(a[i] == 0)
            hsher[i] = hsher[i - 1];
        else
            hsher[i] = (hsher[i - 1] * maxcnt) % MOD;
    }
    hsh[0] = hsher[s[0] - 'a'];
    for(int i = 1; i < s.size(); i++){
        hsh[i] = (hsh[i - 1] + hsher[s[i] - 'a']) % MOD;
    }
    //vector<int> check;
    for(int i = now; i >= 1; i++)
        if(now % i == 0){
            //check.push_back(s.size() / i);
            int m = s.size() / i;
            bool good = true;
            for(int i = 2 * m - 1; i < s.size(); i += m)
                if(((MOD + (hsh[i] - hsh[i - m])) % MOD) != (long long)hsh[m - 1]){
                    good = false;
                    break;
                }
            if(good){
                cout << s.size() / m;
                return 0;
            }
        }
/*
    int l = 0, r = check.size();
    while(l != r - 1){
        int m = (l + r) / 2;
        bool good = true;
        for(int i = 2 * check[m] - 1; i < s.size(); i += check[m])
        if(((MOD + (hsh[i] - hsh[i - check[m]])) % MOD) != (long long)hsh[check[m] - 1]){
            good = false;
            break;
        }
        if(good) l = m;
        else r = m;
    }
    cout << s.size() / check[l];
*/
    return 0;
}
