#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAX_N = 200 * 1000 + 5, MAX_C = 1000 * 1000 + 5;
struct ver{
    long long sum = 0, cnt = 0;
    int minv;
} vers[MAX_N];
vector< vector<int> > g(MAX_N);
int c[MAX_N];
unsigned long long ans = 0;

void dfs(int v){
    vers[v].minv = MAX_C;
    vector<int> now;
    for(int u: g[v]){
        dfs(u);
        now.push_back(u);
        vers[v].sum += vers[u].sum;
        vers[v].cnt += vers[u].cnt;
        vers[v].minv = min(vers[v].minv, vers[u].minv);
    }
    int k = -1;
    for(int i = 0; i < now.size(); i++)
        if(vers[now[i]].cnt > (vers[v].cnt / 2))
            k = now[i];
    if(k >= 0 && now.size() >= 2){
        int minnow = MAX_C;
        for(int u: g[v])
            if(u != k)
                minnow = min(minnow, vers[u].minv);
        ans += (2 * vers[k].cnt - vers[v].cnt) * minnow + vers[v].sum;
    }
    else if(now.size() >= 2){
            if(vers[v].cnt % 2 == 0)
                ans += vers[v].sum;
            else
                ans += vers[v].sum + vers[v].minv;
        }
    vers[v].minv = min(vers[v].minv, c[v]);
    ++vers[v].cnt;
    vers[v].sum += c[v];
    //cout << v << " : " << ans << '\n';
}

int main()
{
    int n;
    cin >> n;
    for(int i = 1, p; i < n; i++){
        cin >> p;
        g[p - 1].push_back(i);
    }
    for(int i = 1; i < n; i++)
        cin >> c[i];
    c[0] = 0;
    dfs(0);
    cout << ans;
    return 0;
}
