#include<bits/stdc++.h>

using namespace std;
#define x first
#define y second
#define int long long
const int MAXN = 40000, MAXX = 1e6;
const int C = 0;
const long double eps = 1e-6;
pair<int, int> dot[MAXN];
int q[MAXN];
int n;
pair<int, int> star = {-1, -1};
pair<int, int> operator - (pair<int, int> a, pair<int, int> b)
{
    return {a.x - b.x, a.y - b.y};
}
pair<int, int> operator + (pair<int, int> a, pair<int, int> b)
{
    return {a.x + b.x, a.y + b.y};
}
int operator * (pair<int, int> a, pair<int, int> b)
{
    return a.x * b.y - a.y * b.x;
}
struct line
{
    long double a, b, c;
};
pair<int, int> inter(line a, line b)
{
    long double y, x;
    if (a.a != 0)
    {
        y = (b.c - b.a * a.c / a.a) / (b.a * a.b / a.a - b.b);
    }
    else
    {
        y = -a.c / a.b;
    }
    if (a.a != 0)
    {
        x = -(a.c + a.b * y) / a.a;
    }
    else
    {
        x = -(b.c + b.b * y) / b.a;
    }
    return {(int)round(x), (int)round(y)};
}
line get(pair<int, int> a, pair<int, int> b)
{
    line res = {0, 0, 0};
    if (a.y == b.y)
    {
        res.b = 1;
        res.c = -a.y;
    }
    else
    {
        res.a = 1;
        res.b = (long double)(a.x - b.x) / (b.y - a.y);
        res.c = -(res.a * a.x + res.b * a.y);
    }
    return res;
}
bool check()
{
    for (int i = 0; i < n; ++i) q[i] = 0;
    if (abs(star.x) > MAXX || abs(star.y) > MAXX) return false;
    for (int i = 0; i < n; ++i)
    {
        if (dot[i] == star) return false;
        for (int j = i + 1; j < n; ++j)
        {
            if ((dot[i] - star) * (dot[j] - star) == 0)
            {
                q[i]++;
                q[j]++;
            }
        }
    }
    for (int i = 0; i < n; ++i)
    {
        if (q[i] != 1) return false;
    }
    return true;
}
signed main()
{
    std::chrono::time_point<std::chrono::system_clock> start, en;
    start = std::chrono::system_clock::now();
    cin >> n;
    for (int i = 0; i < 2 * n; ++i)
    {
        cin >> dot[i].x >> dot[i].y;
    }
    n = 2 * n;
    if (n == 2)
    {
        cout << "Yes\n";
        cout << (dot[1] + dot[1] - dot[0]).x << " " << (dot[1] + dot[1] - dot[0]).y;
        return 0;
    }
    for (int j = 2; j < n; ++j)
    {
        for (int k = 2; k < n; ++k)
        {
            if (j == k) continue;
            if ((dot[j] - dot[0]) * (dot[k] - dot[1]) == 0) continue;
            line A = get(dot[0], dot[j]);
            line B = get(dot[1], dot[k]);
            star = inter(A, B);
            for (int dx = -C; dx <= C; ++dx)
            {
                for (int dy = -C; dy <= C; ++dy)
                {
                    star = star + make_pair(dx, dy);
                    if (check())
                    {
                        cout << "Yes\n";
                        cout << star.x << " " << star.y << endl;
                        return 0;
                    }
                    star = star - make_pair(dx, dy);
                }
            }
        }
    }
    for (int j = 1; j < n; ++j)
    {
        if (j == 2) continue;
        for (int k = 1; k < n; ++k)
        {
            if (k == 2) continue;
            if (k == j) continue;
            if ((dot[j] - dot[0]) * (dot[k] - dot[2]) == 0) continue;
            line A = get(dot[0], dot[j]);
            line B = get(dot[2], dot[k]);
            star = inter(A, B);
            for (int dx = -C; dx <= C; ++dx)
            {
                for (int dy = -C; dy <= C; ++dy)
                {
                    star = star + make_pair(dx, dy);
                    if (check())
                    {
                        cout << "Yes\n";
                        cout << star.x << " " << star.y << endl;
                        return 0;
                    }
                    star = star - make_pair(dx, dy);
                }
            }
        }
    }
    cout << "No";
}
