#include <bits/stdc++.h>
using namespace std;

int p[] = {65651385, 575638253, 433563458, -419681852, -383133506, 332344006, -383726061, -266393731, -517343897, -147517576, 670477048, 246958482, -178779534, -165986631, 593771846, -334792657, -225443686, -976578314, -666763050, -517215433, -479521305, 343539844, -273681705, -282625404, -551701459, 404019927};

const int MAXN = 5000005;
char s[MAXN];
int n;
int pref[MAXN];

bool check(int len) {
    for (int i = 0; i < n; i += len) {
        if (pref[i + len] - pref[i] != pref[len]) {
            return false;
        }
    }
    return true;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    fread(s, 1, MAXN - 4, stdin);
    n = 0;
    while ('a' <= s[n] && s[n] <= 'z') n++;

    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + p[s[i] - 'a'];
    }

    int mx = 1;
    for (int i = 1; i * i <= n; i++) {
        if (n % i == 0) {
            if (check(i)) {
                mx = max(mx, n / i);
            }

            if (i * i != n && check(n / i)) {
                mx = max(mx, i);
            }
        }
    }

    cout << mx << endl;

    return 0;
}
