#include <bits/stdc++.h>

#define mp make_pair

typedef std::pair<int, int> pii;

const int N = 5000000;


void get_ans(std::string &s)
{
    int n = s.length();
    int cnt[26];
    for (int i = 0; i < 26; ++i)
        cnt[i] = 0;
    for (int i = 0; i < n; ++i)
        ++cnt[s[i] - 'a'];
    int is_good[n + 1];
    for (int i = 0; i <= n; ++i)
        is_good[i] = 0;
    int nxt[n];
    int prev[26];
    for (int i = 0; i < 26; ++i)
        prev[i] = n;
    for (int i = n - 1; i >= 0; --i)
    {
        nxt[i] = prev[s[i] - 'a'];
        prev[s[i] - 'a'] = i;
    }
    int cnt_color = 0;
    for (int i = 0; i < 26; ++i)
    {
        int last = -1;
        int now = prev[i];
        if (now != n)
        {
            int now_cnt = 1;
            while (now != n)
            {
                if (n * 1LL * now_cnt % cnt[i] == 0)
                {
                    int k = n * 1LL * now_cnt / cnt[i];
                    if (now < k && k <= nxt[now])
                        ++is_good[k];
                }               
                now = nxt[now];
                ++now_cnt;
            }            
            ++cnt_color;
        }
    }  
    for (int i = 1; i < n; ++i)
    {
        if (n % i == 0)
        {
            int now_is_good = 1;
            for (int j = i; j <= n; j += i)
            {
                now_is_good = now_is_good && is_good[j] == cnt_color;   
            }
            if (now_is_good)
            {
                printf("%d\n", n / i);
                return;
            }
        }
    } 
    printf("1\n");
}

int main()
{
    std::string s;
    while (std::cin >> s)
        get_ans(s);
    return 0;
}