#include <iostream>
#include <vector>
#include <unordered_set>
#include <algorithm>
#include <string>
#include <map>

using namespace std;
typedef long long ll;

#define all(v) v.begin(), v.end()
#define size(v) ((int)v.size())

vector<map<int, int>> p;
int n;
string s;

map<int, int> g(int l, int r) {
    if (!l)
        return p[r];
    map<int, int> res = p[r];
    for (int i = 0; i < 26; ++i)
        res[i] -= p[l - 1][i];
    return res;
}

int main() {
    //freopen("inp2.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> s;
    n = size(s);
    p.resize(n);
    p[0][s[0] - 'a'] = 1;
    for (int i = 1; i < n; ++i) {
        p[i][s[i] - 'a'] = 1;
        for (int j = 0; j < 26; ++j)
            p[i][j] += p[i - 1][j];
    }
    for (int len = 1; len <= n; ++len) {
        if (n % len)
            continue;
        bool f = true;
        auto x = g(0, len - 1);
        for (int i = len; f && i < n; i += len)
            f = x == g(i, i + len - 1);
        if (f) {
            cout << n / len;
            return 0;
        }
    }
    return 0;
}