#include <iostream>
#include <vector>
#include <unordered_set>
#include <algorithm>
#include <cassert>

using namespace std;
typedef long long ll;

#define all(v) v.begin(), v.end()
#define size(v) ((int)v.size())

const int maxn = 100000;
vector<int> g[maxn];
int n, sz[maxn];

ll ans = 0;

void dfs(int v) {
    sz[v] = 1;
    if (g[v].empty())
        return;
    for (auto u : g[v]) {
        dfs(u);
        sz[v] += sz[u];
    }
    sort(all(g[v]), [] (int a, int b) { return sz[a] > sz[b]; });
    int tmp = sz[g[v][0]];
    for (int i = 1; i < size(g[v]); ++i) {
        ans += tmp * 2;
        if (tmp <= sz[g[v][i]])
            tmp = sz[g[v][i]] - tmp;
        else
            tmp -= sz[g[v][i]];
    }
}

int main() {
    freopen("inp3.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int x; cin >> x;
        g[x - 1].push_back(i + 1);
    }
    dfs(0);
    cout << ans;
    return 0;
}