#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef long double ld;

#define endl "\n"
#define mp make_pair
#define pb push_back

const int mod = 1000000007;
const int INF = 1000000000;

string str;
int cnt[500005][26], n;
vector <int> p;
int result;

int check(int x);

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    cin >> str;
    result = str.size();
    n = str.size();

    for (int i = 1; i <= n; i++) {
        cnt[i][str[i - 1] - 'a']++;

        for (int j = 0; j < 26; j++)
            cnt[i][j] += cnt[i - 1][j];
    }

    for (int i = 0; i < 26; i++) {
        if (cnt[n][i])
            p.push_back(i);
    }

    for (int i = 1; i <= n; i++) {
        if (check(i)) {
            result = i;
            break;
        }
    }

    cout << n / result << endl;

    return 0;
}

int check(int x) {
    if (n % x)
        return 0;

    for (int i = 0; i < p.size(); i++) {
        if (!cnt[x][p[i]] || (cnt[n][p[i]] % cnt[x][p[i]]))
            return 0;
    }

    for (int i = 2 * x; i <= n; i += x) {
        for (int j = 0; j < p.size(); j++) {
            if (cnt[i][p[j]] - cnt[i - x][p[j]] != cnt[x][p[j]])
                return 0;
        }
    }

    return 1;
}
