#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
#include <deque>
#include <iterator>
#include <functional>
#include <ctime>
#include <random>
#include <map>
#include <set>
#include <bitset>
#include <cinttypes>
#include <unordered_map>
#include <unordered_set>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <cmath>
#include <fstream>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define sqr(x) ((x)*(x))
#define cube(x) (sqr(x)*(x))
#define mp make_pair
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define vii vector<int>
#define vll vector<ll>
#define vpii vector<pii>
#define vpll vector<pll>
#define vvii vector<vii>
#define vvll vector<vll>
#define vvpii vector<vpii>
#define vvpll vector<vpll>
#define forn(i,n) for(int i=0;i<n;i++)
#define forab(i,a,b) for(int i=a;i<=b;i++)
#define fornout(i,n,c) for(int i=0;i<n;i++,cout<<c)

const ld PI = acos(-1);
const ll INF = 1e18;
const short int MOD1 = 101;
const short int MOD2 = 103;
const short int MOD3 = 107;
const short int MOD4 = 109;
const int MAXN = 1e5;

struct Vertex {
    vii sub;
    ll sz, sum, ans;
    ll mn, indmn;
    ll qmn, indqmn;
    ll c;
    ll mxsz, indmxsz;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n;
    cin >> n;

    vector <Vertex> g(n);
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;

        g[x - 1].sub.push_back(i);
    }

    g[0].c = 0;
    for (int i = 1; i < n; i++) {
        cin >> g[i].c;
    }

    for (int i = n - 1; i >= 0; i--) {
        if (g[i].sub.size() == 0) {
            g[i].mn = g[i].c;
            g[i].qmn = INF;
            g[i].ans = 0;
            g[i].sz = 1;
            g[i].sum = g[i].c;
        }
        else {
            g[i].mxsz = 0;
            g[i].sz = 1;
            g[i].sum = g[i].c;
            g[i].mn = INF;
            g[i].qmn = INF;
            g[i].ans = 0;

            for (auto to : g[i].sub) {
                g[i].sz += g[to].sz;
                g[i].sum += g[to].sum;

                if (g[to].sz > g[i].mxsz) {
                    g[i].mxsz = g[to].sz;
                    g[i].indmxsz = to;
                }

                if (g[to].mn <= g[i].mn) {
                    g[i].indqmn = g[i].indmn;
                    g[i].qmn = g[i].mn;
                    g[i].indmn = to;
                    g[i].mn = g[to].mn;
                }
                else if (g[to].mn < g[i].qmn) {
                    g[i].qmn = g[to].mn;
                    g[i].indqmn = to;
                }
            }

            if (g[i].mxsz > g[i].sz - 1 - g[i].mxsz) {
                if (g[i].indmxsz != g[i].indmn) {
                    g[i].ans += g[i].sum - g[i].c;
                    g[i].ans += (g[i].mxsz - (g[i].sz - 1 - g[i].mxsz)) * g[i].mn;
                }
                else {
                    g[i].ans += g[i].sum - g[i].c;
                    g[i].ans += (g[i].mxsz - (g[i].sz - 1 - g[i].mxsz)) * g[i].qmn;
                }
            }
            else {
                if ((g[i].sz - 1) % 2 == 0) {
                    g[i].ans = g[i].sum - g[i].c;
                }
                else {
                    g[i].ans = g[i].sum - g[i].c + g[i].mn;
                }
            }
        }
    }

    ll all = 0;

    forn(i, n) all += g[i].ans;

    cout << all;

    return 0;
}