#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e7;

bool good(pair<int, int> a)
{
    return -1e6 <= a.first && -1e6 <= a.second && a.first <= 1e6 && a.second <= 1e6;
}

pair<int, int> intersect(pair<int, int> a, pair<int, int> b, pair<int, int> c, pair<int, int> d, bool flag = false)
{
    int x1 = b.second - a.second;
    int y1 = a.first - b.first;
    int z1 = a.second * b.first - b.second * a.first;
    int x2 = d.second - c.second;
    int y2 = c.first - d.first;
    int z2 = c.second * d.first - d.second * c.first;
    if (x1 == 0 && x2 == 0)
    {
        if (flag) return {INF, INF};
        swap(a.first, a.second);
        swap(b.first, b.second);
        swap(c.first, c.second);
        swap(d.first, d.second);
        pair<int, int> result = intersect(a, b, c, d, true);
        swap(a.first, a.second);
        swap(b.first, b.second);
        swap(c.first, c.second);
        swap(d.first, d.second);
        return {result.second, result.first};
    }
    if (y1 * x2 - y2 * x1 == 0) return {INF, INF};
    if ((z1 * x2 - z2 * x1) % (y1 * x2 - y2 * x1) != 0) return {INF, INF};
    int B = (z2 * x1 - z1 * x2) / (y1 * x2 - x1 * y2);
    if (x1 != 0)
        if ((B * y1 + z1) % x1 != 0) return {INF, INF};
        else return {(-B * y1 - z1) / x1, B};
    else if ((B * y2 + z2) % x2 != 0) return {INF, INF};
    else return {(-B * y2 - z2) / x2, B};
    return {INF, INF};
}

int px, py;

bool cmp(pair<int, int> a, pair<int, int> b)
{
    if (a.first == 0 && b.first == 0)
    {
        return a.second < b.second;
    }
    if (a.first == 0)
    {
        if (a.second < py) return true;
        if (b.first < px) return false;
        return true;
    }
    if (b.first == 0)
    {
        if (b.second < 0) return false;
        if (a.first < 0) return true;
        return false;
    }
    if (a.first < 0 && b.first > 0) return true;
    if (a.first > 0 && b.first < 0) return false;
    if (a.first * b.second - a.second * b.first < 0) return true;
    return false;

}

int GCD(int a, int b)
{
    if (a == 0) return b;
    return GCD(b % a, a);
}

signed main()
{
    cout << res.first << " " << res.second << endl;
    int n;
    cin >> n;
    n <<= 1;
    vector<pair<int, int> > x(n);
    for (int i = 0; i < n; ++i) cin >> x[i].first >> x[i].second;
    if (n == 2)
    {
        int d1 = abs(x[0].first - x[1].first);
        int d2 = abs(x[0].second - x[1].second);
        int d = GCD(d1, d2);
        int dx = (x[1].first - x[0].first) / d;
        int dy = (x[1].second - x[0].second) / d;
        for (int i = -100; i < 100; ++i)
        {
            if (i == 0) continue;
            if (good({x[0].first + i * dx, x[0].first + i * dy}))
            if (x[0].first + i * dx != x[1].first || x[0].second + i * dy != x[1].second)
            {
                cout << "Yes" << endl;
                cout << x[0].first + i * dx << " " << x[0].second + i * dy << endl;
                return 0;
            }
        }
        cout << "No" << endl;
        return 0;
    }
    vector<pair<int, int> > ans;
    for (int j = 2; j < n; ++j)
    {
        for (int k = 2; k < n; ++k)
        {
            if (j == k) continue;
            pair<int, int> res = intersect(x[0], x[j], x[1], x[k]);
            if (res.first != INF && good(res))
            {
                ans.push_back(res);
                for (int i = 0; i < n; ++i)
                    if (ans.back() == x[i])
                    {
                        ans.pop_back();
                        break;
                    }
            }
        }
    }
    swap(x[1], x[2]);
    for (int j = 2; j == 2; ++j)
    {
        for (int k = 2; k < n; ++k)
        {
            if (k == j) continue;
            pair<int, int> res = intersect(x[0], x[j], x[1], x[k]);
            if (good(res))
            {
                ans.push_back(res);
                for (int i = 0; i < n; ++i)
                    if (ans.back() == x[i])
                    {
                        ans.pop_back();
                        break;
                    }
            }
        }
    }
    for (int i = 0; i < ans.size(); ++i)
    {
        px = ans[i].first;
        py = ans[i].second;
        vector<pair<int, int> > cop;
        for (int i = 0; i < n; ++i)
        {
            cop.push_back({x[i].first - px, x[i].second - py});
            if (cop.back().first < 0)
            {
                cop[cop.size() - 1].first *= -1;
                cop[cop.size() - 1].second *= -1;
            }
        }
        sort(cop.begin(), cop.end(), cmp);
        cop.push_back(cop[0]);
        cop.push_back(cop[1]);
        bool flag = true;
        for (int i = 1; i < cop.size() - 1; ++i)
        {
            int wow = 0;
            wow += (cop[i].first * cop[i - 1].second - cop[i - 1].first * cop[i].second == 0);
            wow += (cop[i].first * cop[i + 1].second - cop[i + 1].first * cop[i].second == 0);
            if (wow != 1)
            {
                flag = false;
                break;
            }
        }
        if (!flag) continue;
        cout << "Yes" << endl;
        cout << ans[i].first << " " << ans[i].second << endl;
        return 0;
    }
    cout << "No" << endl;
}
