#include <bits/stdc++.h>

using namespace std;

#define ss second
#define ff first
typedef long long ll;

int solve();

int main(){
#ifdef home
    freopen ("input.txt", "r", stdin);
#endif // home

    solve();
}

const double EPS = 1e-8, INF = 1e9 + 7;;

struct pt{
    double x, y;

    pt() {};
    pt (double _x, double _y): x(_x), y(_y) {};

    bool operator !=(const pt &t){
        return !(fabs(t.x - x) < EPS && fabs(t.y - y) < EPS);
    }
};

struct line{
    double a, b, c;

    line () {};

    line (pt q, pt p){
        a = p.y - q.y;
        b = q.x - p.x;
        c = -q.x * (p.y - q.y) + q.y * (p.x - q.x);
    }

    pt inter (line l){
        if (fabs(a) < EPS && fabs(l.a) < EPS) return pt(INF, INF);
        if (fabs(b) < EPS && fabs(l.b) < EPS) return pt(INF, INF);
        if (fabs(a / l.a - b / l.b) < EPS) return pt(INF, INF);

        pt ans;

        ans.y = (-l.c + l.a * c / a) / (l.b - b * l.a / a);

        if (fabs(l.a) < EPS)
            ans.x = (-c - b * ans.y) / a;
        else
            ans.x = (-l.c - l.b * ans.y) / l.a;
        return ans;
    }
};

const int MAXN = (int)1e5 + 7;

int n;
pt a[MAXN];

bool check (pt t){
    if (fabs(t.x - floor(t.x)) > EPS || fabs(t.y - floor(t.y)) > EPS) return 0;
    return 1;
}

int solve(){

    cin >> n;
    n *= 2;

    for (int i = 0; i < n; ++i) cin >> a[i].x >> a[i].y;

    line l1 = line(a[0], a[1]), l2 = line(a[2], a[3]);

    //cout << l1.a << ' ' << l1.b << ' ' << l1.c << "\n";
    //cout << l2.a << ' ' << l2.b << ' ' << l2.c << "\n";

    pt w = l1.inter(l2);

    if (w != pt(INF, INF) && w != a[0] && w != a[1] && w != a[2] && w != a[3] && check(w)){
        cout << "Yes\n";
        cout << int(round(w.x)) << ' ' << int(round(w.y)) << "\n";
        return 0;
    }

    l1 = line(a[0], a[2]), l2 = line(a[1], a[3]);

    w = l1.inter(l2);

    if (w != pt(INF, INF) && w != a[0] && w != a[1] && w != a[2] && w != a[3] && check(w)){
        cout << "Yes\n";
        cout << int(round(w.x)) << ' ' << int(round(w.y)) << "\n";
        return 0;
    }

    l1 = line(a[0], a[3]), l2 = line(a[2], a[1]);


    w = l1.inter(l2);

    if (w != pt(INF, INF) && w != a[0] && w != a[1] && w != a[2] && w != a[3] && check(w)){
        cout << "Yes\n";
        cout << int(round(w.x)) << ' ' << int(round(w.y)) << "\n";
        return 0;
    }

    cout << "No";
    return 0;
}

