#include <bits/stdc++.h>
using namespace std;
#define all(x) begin(x), end(x)
typedef long ll;
template<class A>void addlog(A a)
{ cerr<<a<<endl; }
template<class A,class... B>void
addlog(A a,B... b){ cerr<<a<<' ';addlog(b...); }

vector<ll> getDivs (ll a) {
    vector<ll> divs;
    for (ll i = 1; i * i <= a; ++ i)
    if (a % i == 0) {
        divs.push_back(i);
        if (i * i != a)
            divs.push_back(a / i);
    } return divs;
}

vector<ll> fastCommonDivs (vector<ll> &arr) {
    assert(arr[0]);
    ll g = arr[0];
    for (ll i : arr) g  = __gcd(g, i);
    return getDivs(g);
}

string s;
ll freq[256], curf[256];
vector<ll> potFrags;

void start () {
    cin >> s;
    for (char c : s)
        ++ freq[(ll)c];
    vector<ll> toCheck;
    toCheck.push_back(s.size());
    for (ll i = 0; i < 256; ++ i)
        if (freq[i])
            toCheck.push_back(freq[i]);
    potFrags = fastCommonDivs(toCheck);
}

bool goodSub (ll b, ll e, ll k) {
    fill(all(curf), 0);
    for (ll i = b; i < e; ++ i) ++ curf[(ll)s[i]];
    for (ll i = 0; i < 256; ++ i)
        if (curf[i] * k != freq[i])
            return false;
    return true;
}

bool check (ll k) {
    ll d = (ll)s.size() / k;
    for (ll i = 0; i < (ll)s.size(); i += d) {
        if (!goodSub(i, i + d, k))
            return false;
    }
    return true;
}

int main () {
    start();
    sort(all(potFrags), greater<ll>());
    potFrags.erase(unique(all(potFrags)), end(potFrags));
    for (ll k : potFrags)
    if (check(k)) {
        cout << k << endl;
        return 0;
    }
    assert(0);
    return 0;
}

