#define NDEBUG
#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
#define all(x) begin(x), end(x)
typedef int ll;
template<class A>void addlog(A a)
{ cerr<<a<<endl; }
template<class A,class... B>void
addlog(A a,B... b){ cerr<<a<<' ';addlog(b...); }

const ll MAX_MEM = 64e6;
char mem[MAX_MEM];
char* curMem = mem;

void *operator new (size_t n) {
    char *res = curMem;
    curMem += n;
    return (void *)res;
}
void operator delete (void *) noexcept {}
void operator delete (void *, size_t) {}

string s;
ll freq[256], curf[256];
deque<ll> potFrags;
vector<ll> frags;

inline
ll gcd (ll a, ll b) {
    while (a) {
        ll t = a % b;
        b = a; a = t;
    } return b;
}

void start () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cin >> s;
    for (char c : s)
        ++ freq[(ll)c];
    /// 1e7
    ll g = s.size();
    for (ll i = 0; i < 256; ++ i)
        if (freq[i])
            g = gcd(g, freq[i]);
    /// 257 * log 1e6 < 1e4
    for (ll i = int(sqrt(g)); i; -- i)
    if (g % i == 0) {
        potFrags.push_back(i);
        if (i * i != g)
            potFrags.push_front(g / i);
    }
    /// 2 * sqrt(1e6) = 1e4
}

inline
bool goodSub (ll b, ll e, ll k) {
    fill(all(curf), 0);
    for (ll i = b; i < e; ++ i) ++ curf[(ll)s[i]];
    for (ll i = 'a'; i <= 'z'; ++ i)
        if (curf[i] * k != freq[i])
            return false;
    return true;
}

bool check (ll k) {
    return false;
    ll d = (ll)s.size() / k;
    for (ll i = 0; i < (ll)s.size(); i += d) {
        if (!goodSub(i, i + d, k))
            return false;
    }
    return true;
}

int main () {
    start();
    vector<ll> rare = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 87, 89};
    ll oldSize = potFrags.size();

    for (ll r : rare) if (!check(r)) {
        for (ll &e : potFrags)
            if (e % r == 0)
                e = 0;
    }

    for (ll e : potFrags)
        if (e)
            frags.push_back(e);


    for (ll k : frags)
    if (check(k)) {
        cout << k << endl;
        return 0;
    }
    assert(0);
    return 0;
}

