#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,tune=native")
#include <bits/stdc++.h>
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
using namespace std;
using ll = long long;
const int maxn = 5e5, INF = 1e9;

vector<int> poses[26];
string s;

inline int get(int c, int x) {
    if(poses[c].empty() || poses[c][0] > x) return 0;
    int lf = 0, rg = sz(poses[c]) - 1;
    while(lf < rg) {
        int md = (lf + rg + 1) >> 1;
        if(poses[c][md] <= x) lf = md;
        else rg = md - 1;
    }
    return lf + 1;
}

inline int get(int c, int l, int r, vector<int> &cnt) {
    int x = cnt[r] - (l ? cnt[l - 1] : 0);
    if(c) x = r - l + 1 - x;
    return x;
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    cin >> s; int n = sz(s);
    vector<int> tot(26, 0);
    bool ab = true;
    for(int i = 0; i < n; i++) {
        poses[s[i] - 'a'].push_back(i);
        tot[s[i] - 'a']++;
        ab &= (s[i] == 'a' || s[i] == 'b');
    }
    if(!ab) {
        for(int len = 1; len <= n; len++) {
            if(n % len) continue;
            bool ok = true;
            vector<int> c(26);
            for(int i = 0; ok && i < 26; i++) {
                c[i] = get(i, len - 1);
                if(!tot[i]) continue;
                if(c[i] == 0 || tot[i] % c[i]) ok = false;
            }
            if(!ok) continue;
            int pos = len;
            while(ok && pos < n) {
                for(int i = 0; ok && i < 26; i++) ok &= (get(i, pos + len - 1) - get(i, pos - 1) == c[i]);
                pos += len;
            }
            if(ok) return cout << n / len, 0;
        }
    } else {
        vector<int> cnt(n, 0);
        for(int i = 0; i < n; i++) {
            cnt[i] = (i ? cnt[i - 1] : 0) + (s[i] == 'a');
        }
        for(int len = 1; len <= n; len++) {
            if(n % len) continue;
            bool ok = true;
            vector<int> c(2);
            for(int i = 0; ok && i < 2; i++) {
                c[i] = get(i, 0, len - 1, cnt);
                if(!tot[i]) continue;
                if(c[i] == 0 || tot[i] % c[i]) ok = false;
            }
            if(!ok) continue;
            int pos = len;
            while(ok && pos < n) {
                for(int i = 0; ok && i < 2; i++) ok &= (get(i, pos, pos + len - 1, cnt) == c[i]);
                pos += len;
            }
            if(ok) return cout << n / len, 0;
        }
    }
}



/*
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,tune=native")
#include <bits/stdc++.h>
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
using namespace std;
using ll = long long;
const int maxn = 2e5, INF = 1e9;

struct segTree {
    int n; vector<int> t;
    segTree(vector<int> &a) {
        n = sz(a);
        t.resize(2 * n);
        for(int i = 0; i < n; i++) t[i + n] = a[i];
        for(int i = n - 1; i; i--) t[i] = min(t[i * 2], t[i * 2 + 1]);
    }
    int get(int l, int r) {
        int ret = INF;
        for(l += n, r += n; l <= r; l = (l + 1) >> 1, r = (r - 1) >> 1) {
            if(l & 1) ret = min(ret, t[l]);
            if(!(r & 1)) ret = min(ret, t[r]);
        }
        return ret;
    }
};

int n, a[maxn], b1[maxn], b2[maxn], tik_tak = -1, tsz[maxn];
vector<int> g[maxn];
vector<int> ord;
ll ans, sum[maxn];

void dfs(int v) {
    b1[v] = ++tik_tak;
    ord.push_back(v);
    sum[v] = a[v];
    tsz[v] = 1;
    for(int to : g[v]) dfs(to), sum[v] += sum[to], tsz[v] += tsz[to];
    b2[v] = tik_tak;
}

void dfs2(int v, segTree &t) {
    if(g[v].empty()) return;
    int kid = g[v][0];
    for(int to : g[v]) {
        dfs2(to, t);
        if(tsz[to] > tsz[kid]) kid = to;
    }
    ans += sum[v] - a[v];
    if(2 * tsz[kid] > tsz[v] - 1) {
        ll lo = min(t.get(b1[v] + 1, b1[kid] - 1), t.get(b2[kid] + 1, b2[v]));
        ans += (2 * tsz[kid] - tsz[v] + 1) * lo;
    } else if((tsz[v] - 1) & 1) ans += t.get(b1[v] + 1, b2[v]);
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    cin >> n;
    for(int i = 1; i < n; i++) {
        int x; cin >> x; x--; g[x].push_back(i);
    }
    for(int i = 1; i < n; i++) cin >> a[i];
    dfs(0);
    vector<int> vals(n);
    for(int i = 0; i < n; i++) vals[i] = a[ord[i]];
    segTree t(vals);
    dfs2(0, t);
    cout << ans;
}
*/
