#include <bits/stdc++.h>

using namespace std;

#define llg long long

const int MAXN = 2 * 1e3 + 7;
const int inf = 1e9 + 7;
const string abc = "abcdefghijklmnopqrstuvwxyz";
const string ABC = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
const string NUM = "0123456789";
ifstream in("input.txt");
ofstream out("output.txt");
string s;


int gcd(int a, int b) {
    while (b > 0) {
        int w = a;
        a = b;
        b = w % b;
    }
    return a;
}

struct Node {
    Node* left;
    Node* right;
    int l;
    int r;
    array < int, 26 > sum;
};

Node* build(int l, int r) {
    array < int, 26 > sum;
    for (int i = 0; i < 26; i++) sum[i] = 0;
    if (l + 1 == r) {
        sum[s[l] - 'a']++;
        return new Node({0, 0, l, r, sum});
    }
    Node* left = build(l, (l + r) / 2);
    Node* right = build((l + r) / 2, r);
    for (int i = 0; i < 26; i++) sum[i] = (left->sum)[i] + (right->sum)[i];
    return new Node({left, right, l, r, sum});
}

array < int, 26 > getsum(Node* root, int l, int r) {
    array < int, 26 > sum;
    for (int i = 0; i < 26; i++) sum[i] = 0;
    if (root->l >= r || root->r <= l) return sum;
    if (root->l >= l && root->r <= r) return root->sum;
    array < int, 26 > sum1 = getsum(root->left, l, r);
    array < int, 26 > sum2 = getsum(root->right, l, r);
    for (int i = 0; i < 26; i++) sum1[i] += sum2[i];
    return sum1;
}


main() {
    int cnt[26];
    for (int i = 0; i < 26; i++) cnt[i] = 0;
    cin >> s;
    int n = s.size();
    for (int i = 0; i < s.size(); i++) cnt[s[i] - 'a']++;
    s = "";
    int d;
    for (int i = 0; i < 26; i++) if (cnt[i] != 0) d = cnt[i];
    for (int i = 0; i < 26; i++) if (cnt[i] != 0) d = gcd(d, cnt[i]);
    Node* root = build(0, n);
    int namlen = d;
    int maxi = 1;
    for (int del = 1; del <= namlen; del++) {
        if (d % del != 0) continue;
        int pos = 0;
        bool f = true;
        while (pos < s.size() && f) {
            array < int, 26 > sum = getsum(root, pos, pos + s.size() / del);
            for (int i = 0; i < 26; i++) if (sum[i] * del != cnt[i]) f = false;
            pos += s.size() / del;
        }
        if (f) maxi = del;
    }
    cout << maxi;
    return 0;
}
