#include <bits/stdc++.h>

using namespace std;

#define llg long long

const int MAXN = 2 * 1e3 + 7;
const int inf = 1e9 + 7;
const string abc = "abcdefghijklmnopqrstuvwxyz";
const string ABC = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
const string NUM = "0123456789";
const double eps = 1e-7;
ifstream in("input.txt");
ofstream out("output.txt");

struct point {
    double x;
    double y;
};

struct vect {
    double x;
    double y;
};

vect make_v(point p1, point p2) {
    vect ans;
    ans.x = p2.x - p1.x;
    ans.y = p2.y - p1.y;
    return ans;
}

double vec(vect v1, vect v2) {
    return (v1.x * v2.y - v2.x * v1.y);
}


main() {
    int n;
    cin >> n;
    n *= 2;
    point p[MAXN];
    for (int i = 0; i < n; i++) cin >> p[i].x >> p[i].y;
    set < pair < int, int > > ost;
    for (int i = 0; i < n; i++) ost.insert({p[i].x, p[i].y});
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < n; k++) {
                for (int e = 0; e < n; e++) {
                    point A = p[i];
                    point B = p[j];
                    point C = p[k];
                    point D = p[e];
                    vect AB = make_v(A, B);
                    vect CD = make_v(C, D);
                    if (vec(AB, CD) < eps) continue;
                    int a1, b1, c1;
                    if (A.x == B.x) {
                        b1 = 0;
                        a1 = 1;
                        c1 = -A.x;
                    }
                    else  {
                        a1 = B.y - A.y;
                        b1 = A.x - B.x;
                        c1 = A.y * (B.x - A.x) - A.x * (B.y - A.y);
                    }
                    int a2, b2, c2;
                    if (C.x == D.x) {
                        b2 = 0;
                        a2 = 1;
                        c2 = -B.x;
                    }
                    else  {
                        a2 = D.y - C.y;
                        b2 = C.x - D.x;
                        c2 = C.y * (D.x - C.x) - C.x * (D.y - C.y);
                    }
                    //cout << a1 << ' ' << b1 << ' ' << c1 << ' ' << a2 << ' ' << b2 << ' ' << c2 << endl;
                    point O;
                    if (b2 != 0 && a1 - (b1 * a2) / b2 != 0) O.x = (int)((b1 * c2 / b2) - c1) / (a1 - (b1 * a2) / b2);
                    else O.x = (int)((b2 * c1 / b1) - c2) / (a2 - (b2 * a1) / b1);
                    if (b1 != 0 && a2 - (b2 * a1) / b1 != 0) O.y = (int)(-c1 - a1 * O.x) / b1;
                    else O.y = (int)(-c2 - a2 * O.x) / b2;
                    bool f = true;
                    for (int t = 0; t < n; t++) {
                        point S;
                        S.x = p[t].x;
                        S.y = p[t].y;
                        vect r = make_v(S, O);
                        S.x += 2 * r.x;
                        S.y += 2 * r.y;
                        if (ost.find({S.x, S.y}) == ost.end()) f = false;
                    }
                    if (f) {
                        cout << "Yes" << endl;
                        cout << O.x << ' ' << O.y;
                        return 0;
                    }
                }
            }
        }
    }
    cout << "No";
    return 0;
}
