#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

typedef long long ll;

mt19937 rnd(228);

int cnt[26];
int ok[26];

string s;
int n;

bool check(int i)
{
    for (int k = 0; k < 26; k++) ok[k] = cnt[k] = 0;
    for (int k = 0; k < i; k++) ok[s[k] - 'a']++;
    bool bad = false;
    for (int j = i; j < n; j += i)
    {
        for (int k = j; k < j + i; k++)
        {
            cnt[s[k] - 'a']++;
        }
        for (int a = 0; a < 26; a++)
        {
            if (cnt[a] != ok[a])
            {
                bad = true;
                break;
            }
            cnt[a] = 0;
        }
        if (bad)
        {
            break;
        }
    }
    return !bad;
}

bool prime[6000000];

int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
   // freopen("a.out", "w", stdout);
#endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> s;
    n = s.size();
    int ans = n;
    for (int i = 2; i <= n; i++)
    {
        if (!prime[i])
        {
            for (int j = i + i; j <= n; j += i)
            {
                prime[j] = true;
            }
            while (ans % i == 0 && check(ans / i))
            {
                ans /= i;
            }
        }
    }
    cout << n / ans << '\n';
}
