#include <fstream>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <math.h>
#include <map>
#include <set>

using namespace std;

ifstream cin("input.txt"); ofstream cout("output.txt");

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    priority_queue <pair<ll, ll> > a;
    for (ll i = n; i >n/2; i--)
        a.push({ i * 2 - 1, i });
    vector <ll> z(n-1);
    for (ll i = 0; i < n - 1; i++)
        z[i] = i * 2+2;
    while (z.size() != 0) {
        ll p = a.top().first, nom = a.top().second;
        a.pop();
        p = z[z.size() - 1];
        a.push({ p, nom });
        z.pop_back();
    }
    vector <ll> ans(n / 2);
    while (!a.empty()) {
        ans[a.top().first/2-1] = a.top().second;
        a.pop();
    }
    int q;
    cin >> q;
    while (q--) {
        ll x;
        cin >> x;
        if (x % 2 == 1)
            cout << (x + 1) / 2 << "\n";
        else
            cout << ans[x/2-1] << "\n";
    }
    return 0;
}

