#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimaze("Ofast");
#pragma target("sse3,sse4");

#define int long long
#define ll long long
#define ld long double
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define pb push_back

const int INF = 1e18;
const int MAXN = 1e18 / 5e6;
const int MOD = 1e9 + 7;
const int P = 424242;

ll power(int a, int n, int MOD = INF) {
    if (n == 0) return 1;
    if (n & 1) {
        return (a * power(a, n - 1, MOD)) % MOD;
    } else {
        int b = power(a, n >> 1, MOD);
        return (b * b) % MOD;
    }
}

ll gcd(int a, int b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}

vector<int> h;

string s;
int n;

bool check(int len) {
    int H = ((h[len] - h[0]) + (5 * MOD)) % MOD;
    for (int i = 1; i < n / len; i++) {
        int ptr = len * (i + 1);
        int H1 = ((h[ptr] - h[ptr - len]) + (5 * MOD)) % MOD;
        if (H != H1) return 0;
    }
    return 1;
}

signed main() {
    cin.tie(0);
    cout.tie(0);
//-------------------------------------------------------------
    cin >> s;
    n = s.size();
    set<int> g;
    h.pb(1);
    for (int i = 0; i < n; i++) {
        h.pb((h[h.size() - 1] + ((s[i] * P) % MOD)) % MOD);
    }
    for (int i = 1; i * i <= n; i++) {
        if (n % i == 0) {
            g.insert(i);
            g.insert(n / i);
        }
    }
    //cout << g.size() << "\n";
    //cout << n * g.size() / (int)(1e7) << "\n";
    for (int x: g) {
        if (check(x)) {
            cout << n / x << '\n';
            return 0;
        }
    }

}