#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimaze("Ofast");
#pragma target("sse3,sse4");

#define int long long
#define ll long long
#define ld long double
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define pb push_back
#define pii pair<int, int>

const int INF = 1e18;
const int MAXN = 1e6;
const int MOD = 1e9 + 7;
const int P = 1336177;

ll power(int a, int n, int MOD = INF) {
    if (n == 0) return 1;
    if (n & 1) {
        return (a * power(a, n - 1, MOD)) % MOD;
    } else {
        int b = power(a, n >> 1, MOD);
        return (b * b) % MOD;
    }
}

ll gcd(int a, int b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}

vector<vector<int>> g;
vector<int> h;

int ans = 0;

int dfs(int v) {
    h[v] = 1;
    for (auto u: g[v]) {
        h[v] += dfs(u);
    }
    int cnt = INF;
    int U = -1;
    for (auto u: g[v]) {
        if (h[u] < cnt) {
            cnt = h[u];
            U = u;
        }
    }
    for (auto u: g[v]) {
        if (U != u) {
            ans += h[u] * 2;
        }
    }
    return h[v];
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    //srand(time(NULL));
//-------------------------------------------------------------
    int n;
    cin >> n;
    g.resize(n); h.resize(n);
    for (int i = 1; i < n; i++) {
        int p; cin >> p; p--;
        g[p].pb(i);
    }
    dfs(0);
    cout << ans << '\n';
}