#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <fstream>
#include <string>
#include <math.h>

using namespace std;

#define int long long

vector< vector<int> > ch;
vector<int> c;
vector<int> p;
vector<long long> mn1, mn2, mn;
int timer = 0;
long long sm = 0;
vector<long long> s;
vector<long long> cnt;

void dfs(int v)
{
    mn[v] = c[v];
    s[v] = c[v];
    cnt[v] = 1;
    int mxi = -1;
    for (int i = 0; i < ch[v].size(); i++) {
        dfs(ch[v][i]);
        mn[v] = min(mn[v], mn[ch[v][i]]);
        cnt[v] += cnt[ch[v][i]];
        if (mxi == -1 || cnt[ch[v][i]] > cnt[mxi]) {
            mxi = ch[v][i];
        }
        s[v] += s[ch[v][i]];
        int k = mn[ch[v][i]];
        if (k < mn1[v]) {
            mn2[v] = mn1[v];
            mn1[v] = k;
        }
        else if (k < mn2[v]) {
            mn2[v] = k;
        }
    }
    //mn[v] = mn1[v] + mn2[v];
    int m = ch[v].size();
    if (m > 0) {
        int d = cnt[mxi] - (cnt[v] - 1 - cnt[mxi]);
        if (d <= 0) {
            sm += s[v] - c[v];
            if (cnt[v] % 2 == 0) {
                sm += mn1[v];
            }
        }
        else{
            sm += s[v] - c[v];
            if (mn[mxi] == mn1[v]) {
                sm += d * mn2[v];
            }
            else {
                sm += d * mn1[v];
            }
        }
    }
    /*
    if (ch[v].size() > 0) {
        for (int i = 0; i < ch[v].size(); i++) {
            int mni = mn[ch[v][i]];
            if (mni == mn1[v]) {
                sm += cnt[ch[v][i]] * mn2[v] + s[ch[v][i]];
            }
            else {
                sm += cnt[ch[v][i]] * mn1[v] + s[ch[v][i]];
            }
        }
        sm = sm - (mn1[v] + mn2[v]);
    }*/
}

main()
{
    ifstream fin("input.txt");
    int n;
    fin >> n;
    p.resize(n);
    c.resize(n);
    mn1.assign(n, 10000000);
    mn2.assign(n, 10000000);
    mn.assign(n, 20000000);
    cnt.assign(n, 0);
    s.assign(n, 0);
    ch.resize(n);
    p[0] = 0;
    for (int i = 0; i < n - 1; i++) {
        int k;
        fin >> k;
        p[i + 1] = k - 1;
        ch[k - 1].push_back(i + 1);
    }
    c[0] = 0;
    for (int i = 0; i < n - 1; i++) {
        fin >> c[i + 1];
    }
    dfs(0);
    cout << sm;
}
