#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <ll, ll> pll;
typedef pair <ld, ld> pld;

#define mp make_pair
#define pb push_back
#define eb emplace_back
#define ALL(a) a.begin(), (a).end()
#define pf push_front
#define ppf pop_front
#define ppb pop_back

const ll MAXN = 1e6;
const ll INF = 1e9;
const ld eps = 1e-9;
const ll M = 1e5;
const ld pi = acos(-1);

set <ll> g[MAXN];
pll c[MAXN];
bool mark[MAXN];
map <ll, set <ll> > nach;
set <ll> q;

void dfs(ll v, ll depth) {
    mark[v] = true;
    nach[v] = q;
    q.emplace(v);
    c[v].second = depth;
    for (auto i : g[v]) {
        if (!mark[i])
            dfs(i, depth + 1);
    }

    q.erase(v);
    return;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n;
    cin >> n;
    for (ll i = 1; i < n; i++) {
        ll x;
        cin >> x;
        x--;
        g[x].emplace(i);
    }

    for (ll i = 1; i < n; i++) {
        cin >> c[i].first;
    }

    dfs(0, 0);
    ll ans = 0;

    for (ll i = 1; i < n; i++) {
        for (ll j = 1; j < n; j++) {
            if (i != j) {
                if (nach[i].find(j) != nach[i].end() || g[i].find(j) != g[i].end())
                    continue;
                else {
                 //   cout << i << ' ' << j << endl;
                    ans += c[i].first;
                }
            }
        }
    }
    cout << ans;
    return 0;
}
