#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <ll, ll> pll;
typedef pair <ld, ld> pld;

#define mp make_pair
#define pb push_back
#define eb emplace_back
#define ALL(a) a.begin(), (a).end()
#define pf push_front
#define ppf pop_front
#define ppb pop_back

const ll MAXN = 1e6;
const ll INF = 1e9;
const ld eps = 1e-9;
const ll M = 1e4;
const ld pi = acos(-1);

set <ll> g[MAXN];
pll c[MAXN];
bool mark[MAXN];
map <ll, set <ll> > nach;
set <ll> q;
bool conf[M][M];
map <ll, ll> vis;
map <ll, ll> d;
map <ll, ll> dps;

void dfs(ll v, ll depth) {
    mark[v] = true;
    nach[v] = q;
    d[v] = depth;
    dps[depth]++;
    q.emplace(v);
    c[v].second = depth;
    for (auto i : g[v]) {
        if (!mark[i])
            dfs(i, depth + 1);
    }

    q.erase(v);
    return;
}

void dfs1(ll v) {
    mark[v] = true;
    vis[v]++;
    for (auto i : g[v]) {
        if (!mark[i] && !vis[i]) {
            dfs1(i);
            vis[v] += vis[i];
        }
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n;
    cin >> n;
    for (ll i = 1; i < n; i++) {
        ll x;
        cin >> x;
        x--;
        g[x].emplace(i);
    }

    for (ll i = 1; i < n; i++) {
        cin >> c[i].first;
    }

    dfs(0, 0);

    ll ans = 0;
    for (auto i : dps) {
        if (i.first)
            for (auto j : dps) {
                if (i.first < j.first)
                    ans += 2 * j.second;
                else
                    if (i.first == j.first)
                        ans += 2 * (j.second - 1);
            }
    }
    cout << ans;
    return 0;
}
