#pragma gcc optimize("OFast")
#pragma target("sse,sse2,sse3,sse4,tune=native")
#pragma gcc optimize("unroll-loops")

#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <string>
#include <cassert>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef long double ld;

const int N = 200000 + 100;
const int M = 26;

vector<int> pos[M];

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	string s;
	cin >> s;
	int n = s.size();
	for (int i = 0; i < n; i++)
	{
		pos[(int)(s[i] - 'a')].push_back(i);
	}

	vector<int> delimiters;

	for (int i = 1; i * i <= n; i++)
	{
		if (n % i == 0)
		{
			delimiters.push_back(i);
			delimiters.push_back(n / i);
		}
	}

	sort(all(delimiters));

	for (int d : delimiters)
	{
		bool good = true;
		for (int c = 0; c < M; c++)
		{
			int ptr = 0;
			int cnt = 0;
			for (int l = 0; l < pos[c].size(); l++)
			{
				if (pos[c][l] >= d)
				{
					break;
				}
				else
				{
					++cnt;
				}
			}
			int cur = 0;
			for (int l = 0; l < n; l += d)
			{
				int r = l + d;
				while (ptr < pos[c].size() && pos[c][ptr] < r)
				{
					++ptr;
					++cur;
				}
				if (cur != cnt)
				{
					good = false;
					break;
				}
				cur = 0;
			}
			if (!good)
			{
				break;
			}
		}
		if (good)
		{
			cout << n / d;
			return 0;
		}
	}
	

#ifdef _DEBUG
	while (1);
#endif
}