#include <bits/stdc++.h>
#define double long double
#define int long long
using namespace std;
vector<pair<int, int> > stars;
struct Line{int a; int b; int c;};
struct Point{int x; int y;};
bool good, ans;
int ra, rb;
double eps = 0.000000001;
int Mx=1e6;
Line per(int a, int b){
    int A = (stars[b].second - stars[a].second);
    int B = - (stars[b].first - stars[a].first);
    int C = - (A*stars[a].first + B*stars[a].second);
    Line l = {A, B, C};
    return l;
}
Point inter(Line a, Line b){
    good = true;
    Point df = {-1, -1};
    int ch = b.c * a.a - a.c * b.a;
    int zn = a.b * b.a - b.b * a.a;
    if (zn==0){
        good = false;
        return df;
    }
    if (ch % zn != 0){
        good = false;
        return df;
    }
    int Y = ch / zn;
    int X = - (a.c + Y * a.b) / a.a;
    Point np = {X, Y};
    return np;
}
void check(int a, int b){
    Line f = per(a, b);
    int c = rand() % stars.size();
    while (c == a || c==b) c = rand() % stars.size();
    vector<Point> what;
    for (int i=0; i < stars.size(); i++){
        if (i==c) continue;
        Line th = per(i, c);
        Point p = inter(f, th);
        if (good) what.push_back(p);
    }
    for (int i=0; i < what.size(); i++){
        if (abs(what[i].x) > Mx || abs(what[i].y) > Mx) continue;
        bool could = true;
        vector<pair<int, int> > na;
        for (int j=0; j < stars.size(); j++){
            int Dy = stars[j].second - what[i].y;
            int Dx = stars[j].first - what[i].x;
            if (Dy==0 && Dx==0){
                could = false;
                break;
            }
            if (Dy <= 0){
                Dx *= -1, Dy *= -1;
            }
            int G = abs(__gcd(Dx, Dy));
            Dx /= G;
            Dy /= G;
            if (Dy==0) Dx = 1;
            if (Dx==0) Dy = 1;
            na.push_back(make_pair(Dy, Dx));
        }
        sort(na.begin(), na.end());
        for (int j=1; j < na.size(); j+=2){
            if (na[j] != na[j-1]) could = false;
            if (j + 1 < na.size()){
                if (na[j] == na[j+1]) could = false;
            }
        }
        if (could){
            ans = true;
            ra = what[i].x, rb = what[i].y;
        }
    }
}
signed main()
{
    //freopen("1.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i=0; i < 2*n; i++){
        int x, y;
        cin >> x >> y;
        stars.push_back(make_pair(x, y));
    }
    int point = rand() % (2*n);
    ans = false;
    for (int i=0; i < 2*n; i++){
        if (i==point) continue;
        check(i, point);
        if (ans){
            cout << "Yes" << endl;
            cout << ra << " " << rb << endl;
            return 0;
        }
    }
    cout << "No" << endl;
}
