#include <bits/stdc++.h>
#define mp make_pair
#define x first
#define y second
#define pb push_back

using namespace std;

typedef long long ll;

ll hs1[5000005], hs2[5000005];
int n;

bool ok(int m)
{
    int len = n / m;
    ll H1 = hs1[len - 1], H2 = hs2[len - 1];
    for (int i = 2 * len - 1; i < n; i += len)
    {
        ll h1 = hs1[i] - hs1[i - len], h2 = hs2[i] - hs2[i - len];
        if (h1 != H1 || h2 != H2) return false;
    }
    return true;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0);
    string s;
    cin >> s;
    n = (int) s.length();

    ll t = s[0] - 'a' + 1;
    hs1[0] = t * t, hs2[0] = t * t * t;
    for (int i = 1; i < n; i++)
    {
        t = s[i] - 'a' + 1;
        hs1[i] = hs1[i - 1] + t * t;
        hs2[i] = hs2[i - 1] + t * t * t;
    }

    int ans = 0;
    for (int i = 1; i * i <= n; i++)
    {
        if (n % i != 0) continue;
        if (ok(i)) ans = max(ans, i);
        if (ok(n / i)) ans = max(ans, n / i);
    }
    cout << ans;
    return 0;
}

