#include <bits/stdc++.h>
#define mp make_pair
#define x first
#define y second
#define pb push_back

using namespace std;

typedef long long ll;

struct line
{
    ll A, B, C;
    line (pair <ll, ll> a, pair <ll, ll> b)
    {
        A = b.y - a.y;
        B = a.x - b.x;
        C = a.y * (b.x - a.x) - a.x * (b.y - a.y);
    }
};

bool inter(line M, line N)
{
    ll t = N.A * M.B - M.A * N.B;
    if (t == 0) return false;
    ll p = N.B * M.C - M.B * N.C;
    if (p % t != 0) return false;
    ll s = M.A * N.C - N.A * M.C;
    if (s % t != 0) return false;
    return true;
}

pair <ll, ll> intersec(line M, line N)
{
    ll t = N.A * M.B - M.A * N.B;
    ll p = N.B * M.C - M.B * N.C;
    ll s = M.A * N.C - N.A * M.C;
    return mp(p / t, s / t);
}

ll nod(ll a, ll b)
{
    if (a > b) swap(a, b);
    if (a == 0) return b;
    return nod(b % a, a);
}

pair <ll, ll> pt[6005];
map <pair <ll, ll>, ll> opa;

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n;
    cin >> n;
    n *= 2;
    for (int i = 1; i <= n; i++)
        cin >> pt[i].x >> pt[i].y;

    for (int i = 2; i <= n; i++)
    {
        int l1 = 1, l2 = i;
        for (int j = 2; j <= n; j++)
        {
            if (j == l2) continue;
            for (int z = j + 1; z <= n; z++)
            {
                if (z == l2) continue;
                int r1 = j, r2 = z;
                line K = line(pt[l1], pt[l2]), L = line(pt[r1], pt[r2]);
                if (!inter(K, L)) continue;
                pair <ll, ll> O = intersec(K, L);
                if (abs(O.x) > (ll) 1e6 || abs(O.y) > (ll) 1e6) continue;

                bool fl = true;
                for (int i1 = 1; i1 <= n; i1++)
                    if (pt[i1] == O) fl = false;
                if (!fl) continue;

                fl = true;
                opa.clear();
                for (int i1 = 1; i1 <= n; i1++)
                {
                    line S = line(pt[i1], O);
                    ll d = nod(abs(S.A), abs(S.B));
                    S.A /= d, S.B/= d;
                    if (S.A < 0) S.A *= -1, S.B *= -1;
                    if (S.A == 0 && S.B < 0) S.A *= -1, S.B *= -1;

                    opa[mp(S.A, S.B)]++;
                }

                for (auto it = opa.begin(); it != opa.end(); it++)
                {
                    if (it->y != 2) {fl = false; break;}
                }

                if (fl)
                {
                    cout << "Yes\n";
                    cout << O.x << ' ' << O.y << '\n';
                    exit(0);
                }
            }
        }
    }
    cout << "No";
    return 0;
}

