#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <string>
#include <set>
#include <map>
#define ll long long
using namespace std;
 int h[5000001], h2[5000001], used[200];
int n;
string s;
int mod = 9973;

inline int get_p(int x, int p) {
	if (p == 0)
		return 1;
	int cur = get_p(x, p / 2);
	cur = (cur * cur) % mod;
	if (p % 2 != 0)
		cur = (cur * x) % mod;
	return cur;
}

inline void get_h() {
	vector <int> p;
	for (int i = 2; i < 200; i++) {
		if (used[i] != 0)
			continue;
		p.push_back(i);
		int x = i;
		for (int x = i; x < 200; x += i)
			used[x] = 1;
		if (p.size() == 26)
			break;
	}
	h[0] = 1;
	h2[0] = 1;
	for (int i = 0; i < n; i++) {
		h[i + 1] = (h[i] * p[(s[i] - 'a')]) % mod;
		h2[i + 1] = get_p(h[i + 1], mod - 2);
	}
}


inline int check(int l) {
	for (int j = 2; j <= n /l; j++) {
		if ((j > 0) && (h[l] != ((h[j * l] * h2[(j - 1) * l])) % mod))
			return 0;
	}
	return 1;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> s;
	n = s.size();
	get_h();
	int ans = 1;
	for (int i = 1; i < n; i++) {
		if ((n % i == 0) && (check(i))) {
			ans = n / i;
			break;
		}
	}
	cout << ans;
	return 0;
}