#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define f first
#define s second
ll sqr(ll a) {
    return a * a;
}

vector < vector < int > > g;
ll ans;

int dfs(int v) {
    vector < int > cnt;
    for (auto to: g[v]) {
        cnt.push_back(dfs(to));
    }
    int sz = 0;
    for (auto p: cnt ) sz += p;
    sort(all(cnt));
    if (!cnt.empty()) {
        int have = cnt[0];
        for (int i = 1; i < cnt.size(); i++) {
            int x = min(cnt[i], have);
            ans += x * 2;
            have -= x;
            cnt[i] -= x;
            have = max(have, cnt[i]);
        }
        ans += have * 2;
    }
    return sz + 1;
}


int main() {
//    freopen("a.txt", "r", stdin);
//    freopen("b.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);


    int n;
    cin >> n;

    g.resize(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        g[--p].push_back(i);
    }

    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
    }

    dfs(0);

    cout << ans;
}
