#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define f first
#define s second
ll sqr(ll a) {
    return a * a;
}

vector < vector < int > > g;
vector < int > sz;
ll ans;

void dfs(int v) {
    if (g[v].empty()) return;
    int cnt = 0;

    for (auto &to: g[v]) {
        to = sz[to];
        cnt = max(cnt, to);
    }

    if (cnt * 2 <= sz[v] + 1) ans += sz[v] - (sz[v] % 2);
    else ans += cnt * 2;
}


int main() {
//    freopen("a.txt", "r", stdin);
//    freopen("b.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);


    int n;
    cin >> n;

    sz.resize(n);
    g.resize(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        g[--p].push_back(i);
        sz[i] = 1;
        sz[p] += sz[i];
    }

    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
    }

    for (int v = 0; v < n; v++) {
        dfs(v);
    }

    cout << ans;
}
