#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <deque>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <cassert>
#include <cstring>
#include <queue>
typedef long long ll;
typedef long double ld;
using namespace std;

const int N = 5000002;
int ps[2][N];
int S = 26;
vector<int> dd;
vector<int> cnt(S);
char s[N];
int n;

bool f(int k) {
    vector<int> cc(S);
    int len = n / k;
    for (int i = 0; i < S; i++)
        if (cnt[i] % k)
            return 0;
    for (int i = 1; i <= n; i++) {
        cc[s[i - 1] - 'a']++;
        if (i % len == 0) {
            for (int j = 0; j < S; j++) {
                if (cc[j] != cnt[j] / k * (i / len))
                    return 0;
            }
        }
    }
    return 1;
}

bool f2(int k) {
    int len = n / k;
    for (int i = len; i <= n; i += len)
        for (int j = 0; j < S; j++)
            if (ps[j][i] != cnt[j] / k * (i / len))
                return 0;
    return 1;
}

void solve1() {
    for (int i : dd)
        if (f(n / i)) {
            printf("%d", n / i);
            return;
        }
}

void solve2() {
    for (int i = 0; i < n; i++)
        for (int j = 0; j < 2; j++)
            ps[j][i + 1] = ps[j][i] + (s[i] - 'a' == j);
    for (int i : dd)
        if (f2(n / i)) {
            printf("%d", n / i);
            return;
        }
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    scanf("%s", &s);
    n = strlen(s);
    for (int i = 0; i < n; i++)
        cnt[s[i] - 'a']++;
    S = 0;
    for (int i = 0; i < 26; i++)
        if (cnt[i])
            S = i + 1;
    for (int k = 1; k * k <= n; k++)
        if (n % k == 0) {
            dd.push_back(k);
            if (k * k != n)
                dd.push_back(n / k);
        }
    sort(dd.begin(), dd.end());
    if (S > 2)
        solve1();
    else
        solve2();
}
