#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <deque>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <cassert>
#include <cstring>
#include <queue>
typedef long long ll;
typedef long double ld;
using namespace std;

const int N = 200001;
int p[N], sz[N], n;
ll c[N], s[N], mn[N], ans = 0;
vector<int> g[N];

void dfs(int v) {
    sz[v] = 1;
    mn[v] = c[v];
    int mv = 0;
    for (int u : g[v]) {
        dfs(u);
        sz[v] += sz[u];
        s[v] += s[u];
        mn[v] = min(mn[v], mn[u]);
        if (mv == 0 || sz[u] > sz[mv])
            mv = u;
    }
    ans += s[v];
    if (mv && sz[mv] * 2 > sz[v] - 1) {
        ll cm = mn[g[v][0]];
        for (int u : g[v])
            if (u != mv)
                cm = min(cm, mn[u]);
        ans += cm * (sz[mv] * 2 - sz[v] + 1);
    }
    s[v] += c[v];
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    scanf("%d", &n);
    for (int i = 2; i <= n; i++) {
        scanf("%d", &p[i]);
        g[p[i]].push_back(i);
    }
    for (int i = 2; i <= n; i++)
        scanf("%lld", &c[i]);
    dfs(1);
    printf("%lld", ans);
}
