#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<queue>
#include<ctime>
#include<cmath>
#include<string>
#include<algorithm>
#include<deque>
using namespace std;
typedef  long long ll;
typedef long double ld;
struct point
{
    ll x, y;
    point() :x(), y() {}
    point(ll x, ll y) :x(x), y(y) {}
    bool operator ==(point a) {
        return (x == a.x &&y==a.y);
    }
};
void get_koef(point a, point b, ld& k, ld& m) {
    k = ld(a.y - b.y) / ld(a.x - b.x);
    m = a.y - k * a.x;
}
point get_pere(ld k, ld m, ld k2, ld m2) {
    point ans;
    if (k == k2)
        return point(-1e18, -1e18);
    if (ll(m2 - m) % ll(k - k2) != 0)
        return point(-1e18, -1e18);
    ans.x = (m2 - m) / (k - k2);
    ans.y = k * ans.x + m;
    if(fabs(ans.y-ll(ans.y))>1e-6)
        return point(-1e18, -1e18);
    return ans;
}
int main() {
    srand(time(NULL));
    ll n;
    cin >> n;
    vector<point>a(n * 2);
    for (int i = 0; i < n * 2; i++) {
        cin >> a[i].x >> a[i].y;
    }
    vector<ll>ind(2 * n);
    for (int i = 0; i < 2 * n; i++)
        ind[i] = i;
    vector<point>b = a;
    do{
        for (int i = 0; i < n * 2; i++)
            a[i] = b[ind[i]];
        vector<pair<ld, ld>>koe(n);
        vector<bool>vert(2*n);
        for (int i = 0; i < n * 2; i += 2) {
            if (a[i].x != a[i+1].x) {
                get_koef(a[i], a[i + 1], koe[i / 2].first, koe[i / 2].second);
            }
            else
                vert[i / 2] = 1;
        }

        set<pair<ll, ll>>ans;
        bool fl = 0;
        for (int i = 0; i < n*2; i++) {
            for (int j = i + 1; j < n*2; j++) {
                if (vert[i] == 0 && vert[j] == 0) {
                    point q = get_pere(koe[i].first, koe[i].second, koe[j].first, koe[j].second);
                    if (q.x == -1e18) {
                        fl = 1;
                        break;
                    }
                    ans.insert({ (q.x), (q.y) });
                    if (ans.size() > 1) {
                        fl = 1;
                        break;
                    }
                }
                else if (vert[i]&&vert[i+1]==0) {
                    if (fabs(ll(koe[i + 1].first*a[i].x + koe[i + 1].second) - (koe[i + 1].first*a[i].x + koe[i + 1].second)) > 1e-6)
                    {
                        fl = 1;
                        break;
                    }
                    ans.insert({ ll(a[i].x), ll((koe[i + 1].first*a[i].x + koe[i + 1].second)) });
                    if (ans.size() > 1) {
                        fl = 1;
                        break;
                    }
                }
                else if(vert[i]==0&&vert[i+1]){
                    if (fabs(ll(koe[i].first*a[i + 1].x + koe[i].second) - (koe[i].first*a[i + 1].x + koe[i].second)) > 1e-6)
                    {
                        fl = 1;
                        break;
                    }
                    ans.insert({ ll(a[i + 1].x), ll((koe[i].first*a[i + 1].x + koe[i].second)) });
                    if (ans.size() > 1) {
                        fl = 1;
                        break;
                    }
                }
                else
                {
                    fl = 1;
                    break;
                }
            }
            if (fl)
                break;
        }
        if (!fl&&ans.size() == 1 && find(a.begin(), a.end(), point( ld(ans.begin()->first), ld(ans.begin()->second) ))==a.end())
        {
            cout << "Yes\n" << ans.begin()->first << " " << ans.begin()->second;
            return 0;
        }
    } while (next_permutation(ind.begin(), ind.end()));
    cout << "No";
    return 0;
}