//By Don4ick
//#define _GLIBCXX_DEBUG

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

typedef long long ll;

#define pb push_back
#define all(x) x.begin(), x.end()
#define y1 rrtwertwe
#define forn(i, n) for (int i = 1; i <= n; i++)

const double PI = acos(-1.0);
const int DIR = 4;
const int X[] = {1, 0, -1, 0};
const int Y[] = {0, 1, 0, -1};

const int N = (int)5e6 + 228;
const int A = 26;

using namespace std;

string s;
unsigned long long h[N], base[A];
int n;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie();
	cout.tie();

	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);

	//~read
	cin >> s;
	n = (int)s.size();
	s = '#' + s;
	//~precalc base
	srand(time(NULL));
	for (int i = 0; i < A; i++)
		base[i] = A + rand();
	//~precalc H
	forn(i, n)
	{
		h[i] = h[i - 1] + base[s[i] - 'a'];
	}
	//~precalc block
	vector < int > blocks;
	for (int block = 1; block * block <= n; block++)
	{
		if (n % block == 0)
		{
			blocks.pb(block);
			if (n / block != block)
				blocks.pb(n / block);
		}
	}
	//~solve
	sort(all(blocks));
	for (auto block : blocks)
	{
		bool good = true;
		for (int i = (block << 1); i <= n; i += block)
		{
			if (h[i] - h[i - block] != h[block])
			{
				good = false;
				break;
			}
		}
		if (good)
		{
			cout << n / block << endl;
			return 0;	
		}
	}

	return 0;
}