#include <iostream>
#include <map>

using namespace std;

map <pair <long long, long long>, long> ans;

long long solve(long long n, long long q) {
    if (q == 0 || n <= 0) {
        cout << "PRESENTATION ERROR";
    }
    if (q % 2) {
        return (q + 1) / 2;
    }
    if (ans.count({n, q})) {
        return ans[{n, q}];
    }
    int t = q / 2;
    return ans[{n, q}] = t + solve(n - t, n - t);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    long long n;
    int q;
    cin >> n >> q;
    for (int i = 0; i < q; i++) {
        long long x;
        cin >> x;
        cout << solve(n, x) << endl;
    }
    return 0;
}
