#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define endl '\n'
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

int alph = 26;

int hashed(vector <int> arr) {
    int64_t hashsh = 0;
    for (int i = 0; i < arr.size(); ++i) {
        hashsh *= 37;
        hashsh += arr[i];
        hashsh %= 1000000007;
    }
    return hashsh % 1000000007;
}

unordered_set <int> mapa;
bool check(string s, int n) {
    int cntt = 0;
    int k = s.size() / n;
    vector <int> cnt(alph);
    for (auto c : s)
        cnt[c - 'a']++;
    for (auto & x : cnt)
        x /= k;
    int need = hashed(cnt);
    for (int i = 1; i <= k; ++i) {
        if (!mapa.count((i * need) % 1000000007)) {
            return false;
        }
    }
    return true;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    string s;
    cin >> s;
    int n = s.size();
    bool flag = true;
    for (auto c : s)
        if (c != 'a' && c != 'b')
            flag = false;
    if (flag)
        alph = 2;
    vector <int> cnt(alph);
    for (auto c : s) {
        cnt[c - 'a']++;
        mapa.insert(hashed(cnt));
    }
    int a = n;
    for (auto x : cnt) {
        a = __gcd(a, x);
    }
    int p = 1;
    int ans = 1;
    while (p * p <= a) {
        if (a % p == 0) {
            if (check(s, n / p)) {
                ans = max(ans, p);
            }
            if (p * p != a) {
                if (check(s, n / (a / p))) {
                    ans = max(ans, a / p);
                    break;
                }
            }
        }
        ++p;
    }
    cout << ans << endl;
    return 0;
}
