#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define fi first
#define se second
#define endl '\n'
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    out << p.fi << " " << p.se;
    //out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

vector <vector <int> > g;
vector <int> mn;
vector <int> sz;
vector <int> sum;
vector <int> c;
int ans = 0;

void dfs(int v) {
    sum[v] = c[v];
    vector <int> now;
    for (auto x : g[v]) {
        dfs(x);
        sz[v] += sz[x];
        now.push_back(sz[x]);
        mn[v] = min(mn[v], min(mn[x], c[x]));
        sum[v] += sum[x];
    }

//cout << "v = " << v << endl;
    if (now.size() > 0) {
        sort(now.begin(), now.end());
        if (2 * now.back() > sz[v] - 1) {
            ans += sum[v] - c[v];
            int mnn = 1000000000;
            for (auto x : g[v]) {
                if (sz[x] != now.back()) {
                    mnn = min(mnn, min(mn[x], c[x]));
                }
            }
            ans += (2 * now.back() - sz[v] + 1) * mnn;
        }
        else if (sz[v] % 2 == 0) {
            ans += sum[v] - c[v];
            ans += mn[v];
        }
        else {
            ans += sum[v] - c[v];
        }
    }
    //cout << "ans = " << ans << endl;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    g.resize(n);
    sz.resize(n, 1);
    mn.resize(n, 1000000000);
    for (int i = 0; i < n - 1; ++i) {
        int a;
        cin >> a;
        --a;
        g[a].push_back(i + 1);
    }
    c.resize(n);
    c[0] = 0;
    for (int i = 1; i < n; ++i)
        cin >> c[i];
    sum.resize(n);
    dfs(0);
    //cout << "sz = " << sz << endl;
    //cout << "mn = " << mn <<endl;
    //cout << "sum = " << sum << endl;
    cout << ans << endl;
    return 0;
}
