#include <iostream>
#include <string>
#include <vector>

using namespace std;

int n;
int alf = 26;
vector<vector<int>> a;

bool strange(string s) {
    for (int i = 1; i < n; ++i) {
        if (s[i] != s[i-1]) {
            return false;
        }
    }
    return true;
}

bool ok(string s, int l1, int r1, int l2, int r2) {
    //cout << l1 << " " << r1 << " " << l2 << " " << r2 << " " << endl;
    for (int i = 0; i < alf; ++i) {
        if (a[i][r1] - a[i][l1-1] != a[i][r2] - a[i][l2-1]) { ///
            return false;
        }
    }
    return true;
}

bool can(string s, int l) {

    for (int i = 0; i < n/l - 1; ++i) {
        if (!ok(s, i * l + 1, (i + 1) * l, (i + 1) * l + 1, (i + 2) * l)) {
            return false;
        }
    }
    return true;
}

bool ab(string s) {
    for (int i = 0; i < n; ++i) {
        if (s[i] != 'a' && s[i] != 'b') {
            return false;
        }
    }
    return true;
}

void main_20() {
    alf = 2;
}

void main30() {
    string s;
    cin >> s;
    n = s.size();

    if (ab(s)) {
        main_20();
    }

    a.resize(alf);

    for (int i = 0; i < alf; ++i) {
        a[i].resize(n + 1, 0);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < alf; ++j) {
            a[j][i+1] = a[j][i];
        }
        a[int(s[i]) - int('a')][i + 1] = a[int(s[i]) - int('a')][i] + 1;
    }

    if (strange(s)) {
        cout << n;
        return;
    }
    for (int i = 1; i < n; ++i) {
        if (n % i == 0 && can(s, i)) {
            cout << n / i;
            return;
        }
    }
    cout << 1;
    return;
}

int main()
{
    main30();
    return 0;
}
