#include <iostream>
#include <string>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <utility>
#include <sstream>
using namespace std;
typedef long long ll;

#define forn(i, n) for (int (i) = 0; (i) < (n); (i)++)
#define fors(i, s, n) for (int (i) = (s); (i) < (n); (i)++)
#define all(v) v.begin(), v.end()
#define int ll

vector<vector<int>> g;
vector<vector<int>> sum;
vector<int> c;

int dfs(int v) {
    int s = 1;
    forn(i, g[v].size()) {
        int a = dfs(g[v][i]);
        sum[v][i] = a;
        s += a;
    }
    return s;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
    int n;
    cin >> n;
    g.resize(n);
    sum.resize(n);
    c.resize(n);
    forn(i, n - 1) {
        int a;
        cin >> a;
        a--;
        g[a].push_back(i + 1);
        sum[a].push_back(0);
    }
    dfs(0);
    int answ = 0;
    forn(i, n) {
        if (sum[i].size() > 0) {
            int t = 0;
            multiset<int> a;
            forn(j, sum[i].size()) {
                a.insert(sum[i][j]);
            }
            while (a.size() > 1) {
                int l = (*a.begin());
                int r = (*prev(a.end()));
                a.erase(a.begin());
                a.erase(prev(a.end()));
                if (r - l > 0) {
                    a.insert(r - l);
                }
                t += l;
            }
            if (a.size()) {
                t += (*a.begin());
            }
            answ += t * 2;
        }
    }
    cout << answ << endl;
#ifdef _MSC_VER
	system("pause");
#endif
	return 0;
}