#include <bits/stdc++.h>

#define int long long
#define ll __int128
#define ld long double
#define fs first
#define sc second
#define pb push_back
#define ppb pop_back
#define pf push_front
#define ppf pop_front
#define mp make_pair
#define len(v) ((int)v.size())
#define vc vector
#define pr pair
#define endd "\n"; return 0;
#define all(v) v.begin(), v.end()
#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#pragma GCC target("avx,tune=native")

using namespace std;

const int MAXN = 2e5;
const int INF = 1e9;
const int MOD = 1e18 + 7;

struct line {
    ll a, b, c;

    line(ll x, ll y, ll x1, ll y1) {
        a = y - y1;
        b = x1 - x;
        c = -(a * x + b * y);
        if (a < 0) {
            a *= -1;
            b *= -1;
            c *= -1;
        }
        ll d = __gcd(c, __gcd(a, b));
        a /= d;
        b /= d;
        c /= d;
    }

    line(pr<int, int> u, pr<int, int> v) {
        ll x = u.fs;
        ll y = u.sc;
        ll x1 = v.fs;
        ll y1 = v.sc;
        a = y - y1;
        b = x1 - x;
        c = -(a * x + b * y);
        if (a < 0) {
            a *= -1;
            b *= -1;
            c *= -1;
        }
        ll d = __gcd(c, __gcd(a, b));
        a /= d;
        b /= d;
        c /= d;
    }

    int to_int() {
        ll ans = a + MOD;
        ans *= 2000033;
        ans %= MOD;
        ans += b + MOD;
        ans *= 2000033;
        ans %= MOD;
        ans += c + MOD;
        ans %= MOD;
        ans += c;
        ans %= MOD;
        return ans;
    }
};


pr<int, int> intersect(line a, line a1) {
    if ((ll) a1.a * a.b == (ll) a.a + a1.b) {
        return mp(INF, INF);
    }
    if ((ll) a1.b * a.a == (ll) a.b * a1.a) {
        return mp(INF, INF);
    }
    ll x = ((ll) a.b * a1.c - (ll) a1.b * a.c);
    x /= (ll) a1.b * a.a - (ll) a.b * a1.a;
    if (abs(x) > 1000000) {
        return mp(INF, INF);
    }
    ll y = ((ll) a.a * a1.c - (ll) a1.a * a.c);
    y /= (ll) a1.a * a.b - (ll) a.a * a1.b;
    if (abs(y) > 1000000) {
        return mp(INF, INF);
    }
    return mp((int) x, (int) y);
}

vc<pr<int, int>> mem;
set<pr<int, int>> lel;

class TaskC {
public:
    void solve(std::istream &in, std::ostream &out) {
        srand(time(NULL));
        int vvv = clock();
        int n;
        in >> n;
        n *= 2;
        for (int i = 0; i < n; i++) {
            pr<int, int> x;
            in >> x.fs >> x.sc;
            mem.pb(x);
            lel.insert(x);
        }
        random_shuffle(all(mem));
        for (int i = 1; i < n; i++) {
            line a(mem[0], mem[i]);
            int m = 0;
            while (m == i || m == 0) {
                m = rand() % n;
            }
            for (int d = 0; d < n; d++) {
                if (d != i && d != 0 && d != m) {
                    line b(mem[m], mem[d]);
                    pr<int, int> x = intersect(a, b);
                    if (x.fs == INF) {
                        continue;
                    }
                    if (lel.find(x) == lel.end()) {
                        unordered_map<int, int> mme;
                        bool prav = 1;
                        for (int v = 0; v < n; v++) {
                            auto ddfd = line(x, mem[v]).to_int();
                            mme[ddfd]++;
                            if (mme[ddfd] > 2) {
                                prav = 0;
                                break;
                            }
                            if (clock() - vvv > 4899) {
                                out << "No";
                                return;
                            }
                        }
                        if (!prav) {
                            continue;
                        }
                        for (auto v : mme) {
                            if (v.sc != 2) {
                                prav = 0;
                                break;
                            }
                        }
                        if (prav) {
                            out << "Yes" << endl;
                            out << x.fs << ' ' << x.sc;
                            return;
                        }
                    }
                }
            }
        }
        out << "No";
    }
};
main() {
    TaskC solver;
    std::istream &in(std::cin);
    std::ostream &out(std::cout);
    in.tie(0);
    ios_base::sync_with_stdio(0);
    solver.solve(in, out);
    return 0;
}