#include <iostream>
#include <bits/stdc++.h>
#define ll long long
using namespace std;

ll gcd(ll a,ll b)
{
    if(a<0) a*=-1;
    if(b<0) b*=-1;
    while(b)
    {
        a%=b;
        swap(a,b);
    }
    return a;
}
struct pt{ll x,y;};
struct line{ll a,b,c;};

ll det(ll a,ll b,ll c,ll d) {return (ll)(a*d-b*c);}

bool intr(line n,line m,pt&res)
{
    ll zn=det(m.a,m.b,n.a,n.b);
    if(zn!=0)
    {
        ll x0=-1*det(m.c,m.b,n.c,n.b);
        ll y0=-1*det(m.a,m.c,n.a,n.c);
        if((x0%zn==0)&&(y0%zn==0))
        {
            res.x=x0/zn,res.y=y0/zn;
            return true;
        }
    }
    return false;
}

line getl(pt p,pt q)
{
    line ans;
    ans.a=p.y-q.y;
    ans.b=q.x-p.x;
    ans.c=-1*(ans.a*p.x+ans.b*p.y);
    if(ans.a<0) ans.a*=-1,ans.b*=-1,ans.c*=-1;
    if((ans.a==0)&&(ans.b<0)) ans.b*=-1,ans.c*=-1;
    ll g=gcd(gcd(ans.a,ans.b),ans.c);
    ans.a/=g,ans.b/=g,ans.c/=g;
    return ans;
}

bool cmp(const line &p, const line &q)
{
    return ((p.a<q.a)||((p.a==q.a)&&(p.b<q.b))||((p.a==q.a)&&(p.b==q.b)&&(p.c<q.c)));
}


vector<pt>xy;
ll n;
pt ans;
bool ok=0;


void check(pt moon)
{
    vector<line> mas(n);
    bool fail=0;
    for(int i=0;i<n;++i)
    {
        if((xy[i].x==moon.x)&&(xy[i].y==moon.y)) fail=1;
        else mas[i]=getl(moon,xy[i]);
    }
    if(fail) return;
    sort(mas.begin(),mas.end(),&cmp);
    bool good=1;
    for(int i=0;i<n;i++)
    {
        if(((mas[i].a!=mas[i+1].a)||(mas[i].b!=mas[i+1].b)||(mas[i].c!=mas[i+1].c))&&(i%2==0)) good=0;
        if(((mas[i].a==mas[i+1].a)&&(mas[i].b==mas[i+1].b)&&(mas[i].c==mas[i+1].c))&&(i%2==1)) good=0;
    }
    if(good) ok=1,ans=moon;

}
int main()
{
    ans.x=0,ans.y=0;
   cin>>n;
   n*=2;
   xy.resize(n);
   for(ll i=0;i<n;++i)
   {
       cin>>xy[i].x>>xy[i].y;
   }

   for(ll i=2;i<n;++i)
   {
       for(ll j=2;j<n;++j)
       {
           if(i==j) continue;
           line m,n;
           m=getl(xy[0],xy[i]);
           n=getl(xy[1],xy[j]);
           pt q;
           if(!intr(m,n,q)) continue;
           check(q);
          // if(ok) break;
       }
   }
   for(ll i=2;i<n;++i)
   {
       for(ll j=i+1;j<n;++j)
       {
           line m,n;
           m=getl(xy[0],xy[1]);
           n=getl(xy[i],xy[j]);
           pt q;
           if(!intr(m,n,q)) continue;
           check(q);
        //   if(ok) break;
       }
   }
   if(!ok) cout<<"No";
   else cout<<"Yes\n"<<ans.x<<' '<<ans.y;

    return 0;
}


/*
2
1 1
2 2
2 3
4 3
*/
