#include <map>
#include <set>
#include <list>
#include <ctime>
#include <deque>
#include <queue>
#include <stack>
#include <tuple>
#include <chrono>
#include <cstdio>
#include <random>
#include <vector>
#include <cassert>
#include <climits>
#include <complex>
#include <cstdlib>
#include <iomanip>
#include <numeric>
#include <iostream>
#include <algorithm>
#include <functional>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using namespace chrono;

const int mod = (int)1e9 + 7;

int main() {
	#ifdef DEBUG
	//	freopen("input.txt", "r", stdin);
	#endif
	ios_base::sync_with_stdio(false);
	
	int n; cin >> n;
	vector< vector<int> > g(n);
	vector<int64_t> c(n);
	for (int i = 1; i < n; i++) {
		int p; cin >> p; p--;
		g[p].push_back(i);
	}
	for (int i = 1; i < n; i++) {
		cin >> c[i];
	}
	vector<int> sz(n);
	vector<int64_t> sum(n);
	vector<int64_t> mv(n);
	int64_t ans = 0;
	
	function<void(int)> dfs = [&](int v) {
		int sonSz = 0;
		sz[v] = 1;
		sum[v] = mv[v] = c[v];
		for (int to: g[v]) {
			dfs(to);
			sz[v] += sz[to];
			sum[v] += sum[to];
			mv[v] = min(mv[v], mv[to]);
			sonSz += sz[to];
			ans += sum[to];
		}
		int large = -1;
		for (int to: g[v]) {
			if (sz[to] * 2 > sonSz) {
				assert(large < 0);
				large = to;
				break;
			}
		}
		if (large >= 0) {
			int64_t mv2 = LLONG_MAX;
			for (int to: g[v]) {
				if (to != large) {
					mv2 = min(mv2, mv[to]);
				}
			}
			assert(mv2 != LLONG_MAX);
			int64_t add = 2*sz[large] - sonSz;
			ans += add * mv2;
		}
	};
	
	dfs(0);
	cout << ans << endl;
	return 0;
}
