#include <iostream>
#include <string>
#include <vector>
#include <cstdlib>

using namespace std;

vector < vector <int> > a(26);
string s;
int n;

typedef long long ll;

vector <int> d;
int cur = 0;
ll ans = 1;

ll gcd(ll a, ll b) { return (b ? gcd(b, a % b) : a); }

ll lcm(ll a, ll b) { return (a / gcd(a, b) * b); }

void print_ans(int x) {
    cout << n / x << endl;
    exit(0);
}

bool check(int i, int dst) {
    //cout << "check" << dst << endl;
    int x = -1, cur_x = 0, k = dst - 1;
    for (size_t j = 0; j < a[i].size(); j++) {
        if (a[i][j] > k) {
            if ((x != cur_x) && (x != -1))
                return false;
            x = cur_x;
            k += dst;
            cur_x = 0;
        }
        cur_x++;
    }
    if ((x != cur_x) && (x != -1))
        return false;
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin >> s; n = s.size();

    for (int i = 1; i <= n; i++)
        if (n % i == 0)
            d.push_back(i);

    for (int i = 0; i < n; i++)
        a[s[i] - 'a'].push_back(i);
/*
    for (int i = 0; i < 26; i++) {
        cout << i << " : ";
        for (size_t j = 0; j < a[i].size(); j++)
            cout << a[i][j] << " ";
        cout << endl;
    }
*/
    for (int i = 0; i < 26; i++) {
        while ((cur < d.size()) && (!check(i, d[cur])))
            cur++;
        //cout << cur << endl;
        if (cur == d.size()) print_ans(n);
        //cout << ans << " : " << d[cur] << endl;
        ans = lcm(ans, d[cur]);
        //cout << "!" << ans << " : " << d[cur] << endl;
        if (ans >= n) print_ans(n);
    }
    print_ans(ans);
    return 0;
}
