#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fr first
#define sc second
#define pb push_back
#ifdef TDEF
#define __int128 ll
#endif

const int inf = 1e9 + 88;
const ll infll = 1e18 + 88;
const ld eps = 1e-9;

bool ldeq(ld a, ld b){return fabs(a - b) < eps;}

const int maxn = 1e5 + 88;

string s;
int n;

struct pd
{
    int cnt[26];
};

bool operator<(const pd& lhs, const pd& rhs)
{
    bool t = 1;
    for (int i = 0; i < 26; i++)
    {
        t &= (lhs.cnt[i] == rhs.cnt[i]);
    }
    return !t;
}

set<pd> se;

bool check(int sz)
{
    se.clear();
    for (int i = 0; i < n; i += sz)
    {
        pd t;
        for (int j = 0; j < 26; j++)
            t.cnt[j] = 0;
        for (int j = i; j < i + sz; j++)
        {
            t.cnt[s[j] - 'a']++;
        }
        se.insert(t);
    }
    return se.size() == 1;
}

void solve()
{
    cin >> s;
    n = s.size();
    int maxc = 1;
    for (int i = 1; i * i <= n; i++)
    {
        if (n % i == 0 && check(i) && (n / i > maxc))
            maxc = n / i;
        if (n % i == 0 && check(n / i) && (i > maxc))
            maxc = i;
    }
    cout << maxc;
}

//#define testgen

void testgen()
{

}

int main()
{
    ios_base::sync_with_stdio(0);
    #ifdef testgen
    freopen("input.txt", "w", stdout);
    #else
    freopen("input.txt", "r", stdin);
    #endif // testgen
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
