#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fr first
#define sc second
#define pb push_back
#ifdef TDEF
#define __int128 ll
#endif

const int inf = 1e9 + 88;
const ll infll = 1e18 + 88;
const ld eps = 1e-9;

bool ldeq(ld a, ld b){return fabs(a - b) < eps;}

const int maxn = 1e5 + 88;

struct pt
{
    ld x, y;
};

struct ln
{
    pt p1, p2;
};

int n;
pt pts[maxn];
int ptt[maxn];
ln lns[maxn];

pt getpt(ln l1, ln l2)
{
    ld a = l1.p1.x;
    ld e = l1.p1.y;

    ld b = (l1.p2.x - l1.p1.x);
    ld f = (l1.p2.y - l1.p1.y);

    ld c = l2.p1.x;
    ld g = l2.p1.y;

    ld d = (l2.p2.x - l2.p1.x);
    ld h = (l2.p2.y - l2.p1.y);

    ld y =  (b * g + f * a - f * c - b * e) / (d * f - b * h);

    ld px1 = a + c + d * y - a;
    ld py1 = e + g + h * y - e;

    return {px1, py1};
}

bool check()
{
    for (int i = 0; i < n; i++)
    {
        lns[i] = {pts[ptt[2 * i + 1]], pts[ptt[2 * i + 2]]};
    }
    pt t = getpt(lns[0], lns[1]);
    if ((!ldeq((int)t.x, t.x)) || (!ldeq((int)t.y, t.y)))
        return false;
    if (fabs(t.x) > 1e6 || fabs(t.y) > 1e6)
        return false;
    for (int j = 0; j < 2 * n; j++)
        if (ldeq(t.x, pts[j].x) && ldeq(t.y, pts[j].y))
            return false;
    for (int i = 2; i < n; i++)
    {
        pt tpt = getpt(lns[0], lns[i]);
        if ((!ldeq(tpt.x, t.x)) || (!ldeq(tpt.y, t.y)))
            return false;
    }
    cout << "Yes\n" << fixed << setprecision(0);
    cout << t.x << " " << t.y << endl;
    return true;
}

void solve()
{
    cin >> n;
    for (int i = 0; i < n * 2; i++)
        cin >> pts[i].x >> pts[i].y;
    if (n == 1)
    {
        cout << "Yes\n" << fixed << setprecision(0);
        cout << pts[1].x + (pts[1].x - pts[0].x) << " " << pts[1].y + (pts[1].y - pts[0].y) << endl;
        return;
    }
    for (int i = 1; i < n * 2; i++)
        ptt[i] = i;
    ptt[0] = -1;
    while (ptt[0] == -1)
    {
        if (check())
            return;
        next_permutation(ptt, ptt + 2 * n);
    }
    cout << "No";
}

//#define testgen

void testgen()
{

}

int main()
{
    ios_base::sync_with_stdio(0);
    #ifdef testgen
    freopen("input.txt", "w", stdout);
    #else
    freopen("input.txt", "r", stdin);
    #endif // testgen
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
