import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class D {

    public String s;

    public int n;

    public int[] a, b;

    public int get(int[] x, int l, int r) {
        l++;
        r++;
        return x[r] - x[l];
    }

    public boolean check(int lenOfDividing) {
        if (n % lenOfDividing != 0)
            return false;
        int i = 0;
        for (int j = 1; j < n / lenOfDividing; j++) {
            int l2 = j * lenOfDividing;
            int r2 = l2 + lenOfDividing - 1;
            int l1 = (j - 1) * lenOfDividing;
            int r1 = l1 + lenOfDividing - 1;
            if (get(a, l1, r1) != get(a, l2, r2) || get(b, l1, r1) != get(b, l2, r2))
                return false;
        }
        return true;
    }

    public void solve() throws IOException {
        s = br.readLine();
        n = s.length();
        a = new int[n + 1];
        b = new int[n + 1];
        for (int i = 0; i < n; i++) {
            a[i + 1] = a[i];
            b[i + 1] = b[i];
            if (s.charAt(i) == 'a') {
                a[i + 1] = a[i] + 1;
            } else {
                b[i + 1] = b[i] + 1;
            }
        }
        for (int i = 1; i <= n; i++) {
            if (check(i)) {
                out.println(n / i);
                return;
            }
        }
    }

    public void run() throws IOException {
        br = new BufferedReader(new FileReader("input.txt"));
        out = new PrintWriter(System.out);
        solve();
        br.close();
        out.close();
    }

    public String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(br.readLine());
        }
        return tokenizer.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public BufferedReader br;
    public PrintWriter out;
    public StringTokenizer tokenizer;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D().run();
    }
}
