#include <bits/stdc++.h>

using namespace std;

string s;
vector<unsigned long long> cnt;
unsigned long long power[26];
int max_char = 0;
	
bool check(int x) {
	for (int i = 1; i < s.size() / x; ++i) {
		if (cnt[(i + 1) * x] - cnt[i * x] != cnt[x]) {
			return false;
		}
	}
	return true;
}

void solve() {
	cin >> s;
	for (char ch : s)
		max_char = max(max_char, (int) ch - 'a');
	cnt.resize(s.size() + 1);
	power[0] = 1;
	for (int i = 1; i < 26; ++i)
		power[i] = power[i - 1] * 179;
	cnt[0] = 0;
	for (int i = 0; i < s.size(); ++i) {
		cnt[i + 1] = cnt[i] + power[s[i] - 'a'];
	}
	int ans = 1;
	for (int i = 1; i * i <= s.size(); ++i) {
		if (s.size() % i == 0) {
			if (check(i)) {
				cout << s.size() / i << endl;
				return;
			} else if (check(s.size() / i)) {
				ans = max(ans, i);
			}
		}
	}
	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}