#include <bits/stdc++.h>

using namespace std;

vector< vector<int> > g;
vector<int> sz;

long long dfs(int v) {
	sz[v] = 1;
	long long ans = 0;
	int cur_sz = 0;
	for (int to : g[v]) {
		ans += dfs(to);
		sz[v] += sz[to];
		if (cur_sz == 0) {
			cur_sz += sz[to];
		} else {
			if (cur_sz > sz[to]) {
				cur_sz -= sz[to];
				ans += 2 * sz[to];
			} else {
				ans += 2 * cur_sz;
				cur_sz = sz[to] - cur_sz;
			}
		}
	}
	ans += 2 * cur_sz;
	return ans;
}

void solve() {
	int n;
	cin >> n;
	g.resize(n);
	sz.resize(n);
	for (int i = 1; i < n; ++i) {
		int p;
		cin >> p;
		g[p - 1].push_back(i);
	}
	cout << dfs(0) << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}