#include <bits/stdc++.h>
using namespace std;

void doRoutine() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

#define DBG(x) cerr << #x << ": " << x << endl;
#define DBG_ARR(arr, a, b) for (int i = a; i < b; ++i) {cerr << #arr << "[" << i << "]: " << arr[i] << endl;}

#ifndef LOCAL
#define cerr if(0) cerr
#define DBG(...) (true)
#endif

#define pii pair<int, int>
#define fi first
#define se second
#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define all(x) x.begin(), x.end()
#define last(x) (--x.end())

#define int long long
#define D double

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> a) {
	out << "(" << a.fi << ", " << a.se << ")" << endl;
	return out;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
	for (auto el : arr) {
		out << el << ", ";
	}
	return out;
}

// ------------------------------------- CODE NOW ---------------------------------------

const int A = 26;
string s;
int n;
int cnt[A];
vi pos[A];

void check_total_fail() {
	return;
}

int power(int a, int n) {
	if (n == 0) {
		return 1ll;
	}
	else if (n % 2 == 1) {
		return a * power(a, n - 1);
	}
	else {
		return power(a * a, n / 2);
	}
}


map<int, int> get_primes(int n) {
	map<int, int> res;
	int d = 2, x = n;
	while (d * d <= n) {
		while (x % d == 0) {
			x /= d;
			++res[d];
		}
		++d;
	}
	if (x > 1) {
		++res[x];
	}
	return res;
}

int get(int l, int r, int c) {
	int k = pos[c].size();
	int L = -1, R = k;
	while (R - L > 1) {
		int m = (L + R) / 2;
		if (pos[c][m] < l) {
			L = m;
		}
		else {
			R = m;
		}
	}
	int from = R;

	L = -1, R = k;
	while (R - L > 1) {
		int m = (L + R) / 2;
		if (pos[c][m] < r) {
			L = m;
		}
		else {
			R = m;
		}
	}
	int to = R;

	return to - from;
}

bool check(int segs_cnt) {
	vi cur_cnt(A);
	for (int c = 0; c < A; ++c) {
		if (cnt[c] % segs_cnt != 0) {
			return false;
		}
		else {
			cur_cnt[c] = cnt[c] / segs_cnt;
		}
	}
	int d = n / segs_cnt;
	for (int i = 0; i < n; i += d) {
		for (int c = 0; c < A; ++c) {
			if (get(i, i + d, c) != cur_cnt[c]) {
				return false;
			}
		}
	}
	return true;
}

signed main() {
	doRoutine();

	cin >> s;
	n = s.size();

	for (int i = 0; i < n; ++i) {
		++cnt[s[i] - 'a'];
		pos[s[i] - 'a'].pb(i);
	}

	map<int, int> primes = get_primes(n);
	int res = 1;
	for (auto el : primes) {
		int L = 0, R = el.se + 1;
		while (R - L > 1) {
			int mid = (L + R) / 2;
			int p = power(el.fi, mid);
			if (check(p)) {
				L = mid;
			}
			else {
				R = mid;
			}
		}
		res *= power(el.fi, L);
	}

	cout << res << endl;

	return 0;
}