#include <bits/stdc++.h>
using namespace std;

void doRoutine() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

#define DBG(x) cerr << #x << ": " << x << endl;
#define DBG_ARR(arr, a, b) for (int i = a; i < b; ++i) {cerr << #arr << "[" << i << "]: " << arr[i] << endl;}

#ifndef LOCAL
#define cerr if(0) cerr
#define DBG(...) (true)
#endif

#define pii pair<int, int>
#define fi first
#define se second
#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define all(x) x.begin(), x.end()
#define last(x) (--x.end())

#define int long long
#define D double

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> a) {
	out << "(" << a.fi << ", " << a.se << ")" << endl;
	return out;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
	for (auto el : arr) {
		out << el << ", ";
	}
	return out;
}

// ------------------------------------- CODE NOW ---------------------------------------

const int INF = 1000000000000000000;
const int MAXN = 200005;
int n;
int p[MAXN];
int c[MAXN];
vi g[MAXN];

int sz[MAXN], sum[MAXN], mx[MAXN], mn[MAXN];

void dfs_prec(int v) {
	sz[v] = 1, sum[v] = c[v], mx[v] = c[v], mn[v] = c[v];
	for (auto u : g[v]) {
		dfs_prec(u);
		sz[v] += sz[u];
		sum[v] += sum[u];
		mx[v] = max(mx[v], mx[u]);
		mn[v] = min(mn[v], mn[u]);
	}
}

int ans = 0;

void dfs(int v) {
	for (auto u : g[v]) {
		dfs(u);
	}
	if (!g[v].empty()) {
		int max_sz = 0, sum_sz = sz[v] - 1;
		for (auto u : g[v]) {
			max_sz = max(max_sz, sz[u]);
		}
		if (max_sz > (sum_sz - max_sz)) {
			int min_rest = INF;
			for (auto u : g[v]) {
				if (sz[u] != max_sz) {
					min_rest = min(min_rest, mn[u]);
				}
			}
			ans += (sum[v] - c[v]) + (max_sz - (sum_sz - max_sz)) * min_rest;
		}
		else {
			if (sum_sz % 2 == 0) {
				ans += (sum[v] - c[v]);
			}
			else {
				int min_all = INF;
				for (auto u : g[v]) {
					min_all = min(mn[u], min_all);
				}
				ans += (sum[v] - c[v]) + min_all;
			}
		}
	}
}

signed main() {
	doRoutine();

	cin >> n;
	for (int i = 1; i < n; ++i) {
		cin >> p[i];
		--p[i];
		g[p[i]].pb(i);
	}
	for (int i = 1; i < n; ++i) {
		cin >> c[i];
	}

	dfs_prec(0);
	dfs(0);

	cout << ans << endl;

	return 0;
}