#include <iostream>

using namespace std;

void sum(const char* data, int len, int* sums)
{
    for(int i = 0; i < len; i++)
        sums[data[i]-'a']++;
}

bool check(const char* data, int n, int frag_len)
{
    int sums[52];
    for(int i = 0; i < 52; i++)
        sums[i] = 0;
    sum(data, frag_len, sums);
    int c = 0;
    for(int i = frag_len; i < n; i += frag_len)
    {
        c++;
        sum(data + i, frag_len, sums + 26);
        for(int i = 0; i < 26; i++)
            if(sums[i + 26] != sums[i] * c)
                return false;
    }
    return true;
}

int main()
{
    string s;
    cin >> s;
    int max_cnt = 1;
    for(int i = 1; i * i <= s.size(); i++)
        if(s.size() % i == 0)
        {
            if(check(s.c_str(), s.size(), i))
            {
                cout << (s.size() / i) << endl;
                return 0;
            }
            if(check(s.c_str(), s.size(), s.size() / i))
                max_cnt = max(max_cnt, i);
        }
    cout << max_cnt << endl;
    return 0;
}
