#include <iostream>
#include <map>

using namespace std;

struct cmp {
bool operator()(pair<long long, long long> a, pair<long long, long long> b)
{
    if(a.second < 0)
    {
        a.first *= -1;
        a.second *= -1;
    }
    if(b.second < 0)
    {
        b.first *= -1;
        b.second *= -1;
    }
    return a.first * b.second < b.first * a.second;
}
};

int main()
{
    long long n;
    cin >> n;
    long long xs[2 * n], ys[2 * n];
    for(long long i = 0; i < 2 * n; i++)
        cin >> xs[i] >> ys[i];
    for(long long a = 0; a < 2 * n; a++)
    for(long long b = a + 1; b < 2 * n; b++)
    for(long long c = a + 1; c < 2 * n; c++)
    if(c != b)
    for(long long d = c + 1; d < 2 * n; d++)
    if(d != b)
    {
        long long n1 = ys[a] - ys[b];
        long long n2 = xs[b] - xs[a];
        long long n3 = n1 * xs[a] + n2 * ys[a];
        long long n4 = ys[c] - ys[d];
        long long n5 = xs[d] - xs[c];
        long long n6 = n4 * xs[c] + n5 * ys[c];
        long long det = n1 * n5 - n2 * n4;
        if(det == 0)
            continue;
        swap(n1, n5);
        n2 = -n2;
        n4 = -n4;
        long long xnew = n3 * n1 + n6 * n2;
        long long ynew = n3 * n4 + n6 * n5;
        if(xnew % det || ynew % det)
            continue;
        xnew /= det;
        ynew /= det;
        if(abs(xnew) > 1000000 || abs(ynew) > 1000000)
            continue;
        map<pair<long long, long long>, long long, cmp> data;
        for(long long e = 0; e < 2 * n; e++)
        {
            long long dx = xs[e] - xnew;
            long long dy = ys[e] - ynew;
            if(dx == 0 && dy == 0)
                goto fail;
            data[make_pair(dx, dy)]++;
        }
        for(const pair<pair<long long, long long>, long long>& it : data)
            if(it.second != 2)
                goto fail;
        cout << "Yes\n" << xnew << ' ' << ynew << endl;
        return 0;
    fail:;
    }
    cout << "No\n";
    return 0;
}
