#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define ll long long
#define ld long double
#define pii pair <int, int>
#define endl '\n'

using namespace std;

const int N = 5e6 + 5;
const int mod = 1e9 + 7;

string s;
int n;
int cnt[150];
int k[N];
int prefa[N], prefb[N];

inline bool can(int mid) {
    vector <int> cur(26, 0);
    for (register int i = 0; i < 26; ++i) {
        if (cnt[i] % mid)
            return 0;
    }
    int curlen = 0;
    int res = 0;
    for (register int i = 0; i < n; ++i) {
        cur[s[i] - 'a']++;
        bool ok = 1;
        curlen++;
        for (int j = 0; j < 26; j++) {
            if (cur[j] > (cnt[j] / mid))
                return 0;
            if (cur[j] < (cnt[j] / mid)) {
                ok = 0;
                break;
            }
        }
        if (curlen == n / mid && ok == 0)
            return 0;
        if (ok) {
            res++;
            cur.assign(26, 0);
            curlen = 0;
        }
    }
    return res >= mid;
}

inline bool can1(int mid) {
    int pr = -1;
    int cur = n / mid;
    ld x = cnt[0], y = cnt[1];
    ld otn = (long double)(x / y);
    int k = 0;
    while (cur <= n) {
        ld ca = prefa[cur - 1], cb = prefb[cur - 1];
        if (pr != -1)
            ca -= prefa[pr], cb -= prefb[pr];
        if (cb == 0)
            continue;
        //cerr << ca << " " << cb << " " << i + 1 << " " << ca / cb << " " << otn << endl;
        if (abs(ca / cb - otn) < 1e-9) {
            k++;
            pr = cur;
            cur += (n / mid);
        } else return 0;
    }
    return k >= mid;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> s;
    n = s.size();
    int le = 0;
    for (register int i = 0; i < n; ++i) {
        if (cnt[s[i] - 'a'] == 0)
            ++le;
        ++cnt[s[i] - 'a'];
    }
    vector <int> check;
    for (register int i = 0; i < 26; ++i) {
        int x = cnt[i];
        for (register int j = 1; j * j <= x; ++j) {
            int y = x / j;
            if (y * j == x) {
                k[j]++;
                if (x / j != j)
                    k[x / j]++;
            }
        }
    }
    int x = n;
    for (register int j = 1; j * j <= x; ++j) {
        int y = x / j;
        if (y * j == x) {
            ++k[j];
            if (x / j != j)
                ++k[x / j];
        }
    }
    for (register int i = 0; i < 5e6 + 5; ++i) {
        if (k[i] == le + 1)
            check.pb(i);
    }
    reverse(check.begin(), check.end());
//    if (le == 2 && check.size() > 500) reverse(check.begin(), check.end());
    int res = 0;
    int fn = 0;
    for (auto mid : check) {
        if (1.0 * clock() / CLOCKS_PER_SEC > 0.8)
            break;
        if (can(mid)) {
            res = max(res, mid);
            fn = 1;
            break;
        }
    }
    if (fn == 1)
        cout << max(1, res);
    else {
        if (le == 2 && cnt[0] && cnt[1]) {
            vector <int> check;
            for (int i = 0; i < n; ++i) {
                prefa[i] = 0;
                prefb[i] = 0;
                if (s[i] == 'a')
                    prefa[i] = 1;
                else
                    prefb[i] = 1;
            }
            for (int i = 1; i < n; i++) {
                prefa[i] += prefa[i - 1];
                prefb[i] += prefb[i - 1];
            }
            ld x = cnt[0], y = cnt[1];
            ld otn = (long double)(x / y);
            int pr = -1;
            int k = 0;
            for (int i = 0; i < n; i++) {
                ld ca = prefa[i], cb = prefb[i];
                if (pr != -1)
                    ca -= prefa[pr], cb -= prefb[pr];
                if (cb == 0)
                    continue;
                //cerr << ca << " " << cb << " " << i + 1 << " " << ca / cb << " " << otn << endl;
                if (abs(ca / cb - otn) < 1e-9 && n % (i + 1) == 0 && rand() % 5 < 3) {
                    check.pb(i + 1);
                }
            }
            random_shuffle(check.begin(), check.end());
            int res = 0;
            for (auto mid : check) {
                if (1.0 * clock() / CLOCKS_PER_SEC > 0.94)
                    break;
                if (can1(n / mid)) {
                    res = max(res, n / mid);
                    fn = 1;
                }
            }
            cout << res << endl;
            return 0;
        }
    }
    return 0;
}

