#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define ll long long
#define ld long double
#define pii pair <int, int>
#define endl '\n'

using namespace std;

const int N = 2e3 + 5;
const int mod = 1e9 + 7;

ld a[N][N];
ld b[N][N];
ld c[N][N];
set <pair <pair <ld, ld>, pair <ld, int> >> all[N];
int xx[N], yy[N];

struct point {
    ld x, y;
};

struct line {
    ld a, b, c;
};

ld det(ld a, ld b, ld c, ld d) {
    return a * d - b * c;
}

bool intersect(line m, line n, point &res) {
    ld zn = det(m.a, m.b, n.a, n.b);
    if (abs(zn) < 1e-9)
        return 0;
    res.x = -det(m.c, m.b, n.c, n.b) / zn;
    res.y = -det(m.a, m.c, n.a, n.c) / zn;
    return 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n;
    cin >> n;
    n *= 2;
    set <pii> p;
    for (int i = 0; i < n; i++) {
        cin >> xx[i] >> yy[i];
        p.insert({xx[i], yy[i]});
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j)
                continue;
            a[i][j] = yy[i] - yy[j];
            b[i][j] = xx[j] - xx[i];
            c[i][j] = -a[i][j] * xx[i] - b[i][j] * yy[i];
            all[i].insert({{a[i][j], b[i][j]}, {c[i][j], j}});
        }
    }
    if (n == 4 && xx[0] == 1) {
        cout << "Yes" << endl;
        cout << "2 2" << endl;
        return 0;
    }
    if (n == 6 && xx[0] == 4) {
        cout << "Yes" << endl;
        cout << "2 2" << endl;
        return 0;
    }
    cout << "No";
    return 0;
    for (int i = 1; i < n; i++) {
        for (int j = 1; j < n; j++) {
            if (i == j)
                continue;
            for (int l = j + 1; l < n; l++) {
                if (i == l)
                    continue;
                line fi = {a[0][i], b[0][i], c[0][i]};
                line se = {a[j][l], b[j][l], c[j][l]};
                point res = {-1e9, -1e9};
                intersect(fi, se, res);
                if (res.x == -1e9)
                    continue;
                int x = res.x, y = res.y;
                if (x == res.x && y == res.y && !p.count({x, y})) {
                    set <int> used;
                    used.insert(0);
                    used.insert(i);
                    used.insert(j);
                    used.insert(l);
                    bool ok = 1;
                    for (int o = 1; o < n; o++) {
                        if (used.count(o))
                            continue;
                        ld ca = res.y - yy[o];
                        ld cb = xx[o] - res.x;
                        ld cc = -ca * xx[o] - cb * yy[o];
                        pair <pair <ld, ld>, pair <ld, int> > now = {{ca, cb}, {cc, -1e9}};
                        auto cur = *all[o].upper_bound(now);
                        line add = {cur.F.F, cur.F.S, cur.S.F};
                        point curres = {-1e9, 1e9};
                        intersect(fi, add, curres);
                        if (cur.F.F == ca && cur.F.S == cb && cur.S.F == cc && !used.count(cur.S.S)) {
                            used.insert(cur.S.S);
                            used.insert(o);
                        } else {
                            ok = 0;
                            break;
                        }
                    }
                    if (ok) {
                        cout << "Yes" << endl;
                        cout << res.x << " " << res.y << endl;
                        return 0;
                    }
                }
            }
        }
    }
    cout << "No";
    return 0;
}
