#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

vector<vector<int>> g;
vector<ll> num;
vector<ll> sum_ch;
vector<ll> min_ch;
vector<ll> min_ch_sub1;
vector<ll> min_ch_sub2;
vector<ll> tot_ch;
vector<ll> ans_ch;

void calc_values(int v)
{
    if (v == 3)
        int debug = 1;

    sum_ch[v] = 0;
    min_ch[v] = num[v];
    tot_ch[v] = 0;
    min_ch_sub1[v] = -1;
    min_ch_sub2[v] = -1;

    for (int u : g[v])
    {
        calc_values(u);
        sum_ch[v] += sum_ch[u];
        tot_ch[v] += tot_ch[u];

        if ((min_ch_sub1[v] == -1) || (min_ch[u] < min_ch[min_ch_sub1[v]]))
        {
            min_ch_sub2[v] = min_ch_sub1[v];
            min_ch_sub1[v] = u;
        } else if (min_ch_sub2[v] == -1 || min_ch[u] < min_ch[min_ch_sub2[v]])
            min_ch_sub2[v] = u;
    }

//    if (!g[v].empty())
//        ans_ch[v] = (tot_ch[v] - tot_ch[min_ch_sub1[v]]) * min_ch[min_ch_sub1[v]] +
//                sum_ch[v] - sum_ch[min_ch_sub1[v]] +
//                tot_ch[min_ch_sub1[v]] * min_ch[min_ch_sub2[v]] +
//                sum_ch[min_ch_sub1[v]]
//                - min_ch[min_ch_sub1[v]] - min_ch[min_ch_sub2[v]];
//    else
//        ans_ch[v] = 0;

    bool done = false;
    for (int u : g[v])
    {
        if (tot_ch[u] > (tot_ch[v] - tot_ch[u]))
        {
            if (u == min_ch_sub1[v])
                ans_ch[v] = sum_ch[v] +
                (tot_ch[u] - (tot_ch[v] - tot_ch[u])) * min_ch[min_ch_sub2[v]];
            else
                ans_ch[v] = sum_ch[v] +
                (tot_ch[u] - (tot_ch[v] - tot_ch[u])) * min_ch[min_ch_sub1[v]];

            done = true;
            break;
        }
    }

    if (!done)
    {
        ans_ch[v] = sum_ch[v];
        if (tot_ch[v] % 2 == 1)
            ans_ch[v] += min_ch[min_ch_sub1[v]];
    }

    tot_ch[v]++;
    sum_ch[v] += num[v];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, i;
    cin >> n;

    g.resize(n);
    num.resize(n, 0);
    for (i = 0; i < n - 1; i++)
    {
        int a;
        cin >> a;

        g[a - 1].push_back(i + 1);
    }

    for (i = 0; i < n - 1; i++)
        cin >> num[i + 1];

    sum_ch.resize(n);
    min_ch.resize(n);
    tot_ch.resize(n);
    min_ch_sub1.resize(n);
    min_ch_sub2.resize(n);
    ans_ch.resize(n);
    calc_values(0);

    ll ans = 0;
    for (i = 0; i < n; i++)
        ans += ans_ch[i];

    cout << ans << endl;

    return 0;
}
