#include "bits/stdc++.h"
#define int long long
#define double long double
#pragma GCC optimize("03")
using namespace std;

const int INF = 1e9;
const int MAXN = 2e5 + 100;

int ans = 0;

vector<vector<int>> g(MAXN);
vector<int> c(MAXN), mins(MAXN), sum(MAXN), sz(MAXN);

void calc(int v, int p = -1) {
    int sum = c[v], curmin = c[v], sz = 1;
    for (auto i : g[v]) {
        if (i != p){
            calc(i, v);
            sum += ::sum[i];
            curmin = min(curmin, mins[i]);
            sz += ::sz[i];
        }
    }
    ::sum[v] = sum;
    ::sz[v] = sz;
    mins[v] = curmin;
}

void dfs(int v, int p = -1) {
    int curmin = INF;
    vector<int> a;
    for (auto i : g[v]) {
        if (i != p) {
            dfs(i, v);
            ans += sum[i];
            curmin = min(curmin, mins[i]);
            a.push_back(i);
        }
    }

    sort(a.begin(), a.end(), [](int a, int b) {return sz[a] == sz[b]? mins[a] < mins[b] : sz[a] > sz[b];});

    int l = 0, n = a.size();
    for (int i = 0; i < n; ++i) {
        if (l == i)
            continue;

        if (sz[a[l]] <= sz[a[i]]) {
            sz[a[i]] = sz[a[i]] - sz[a[l]];
            sz[a[l]] = 0;
            for (int j = 0; j < n; ++j)
                if (a[j]) {
                    l = j;
                    break;
                }
        } else {
            sz[a[l]] -= sz[a[i]];
            sz[a[i]] = 0;
        }
    }

    //cout << v << ' ';


    //if (a.size())
    //    cout << *(minim.begin()) << ' ';

    for (auto i : a) {
        ans += sz[i];
    }

    //cout << '\n';
}

signed main() {
    int n;
    cin >> n;
    for (int i = 2; i <= n; ++i) {
        int temp;
        cin >> temp;
        g[temp].push_back(i);
        g[i].push_back(temp);
    }

    for (int i = 2; i <= n; ++i)
        cin >> c[i];

    calc(1);
    dfs(1);
    cout << ans;

    return 0;
}


