#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unrool-loops")/**/


#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <stdio.h>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <cmath>

#define prev aksdnasd
#define hash askdaksd
#define y1 alsmdasdas
#define y2 alsdnmasds
#define rank asdasdas

using namespace std;

typedef long long ll;
typedef long long dbl;

template<class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << endl;
}

struct Point{
    dbl x, y;
    Point() : x(0), y(0) {}
    Point(dbl x, dbl y) : x(x), y(y) {}
    Point operator-(Point p) { return Point(x - p.x, y - p.y); }
    Point operator+(Point p) { return Point(x + p.x, y + p.y); }
    dbl operator%(Point p) { return x * p.y - y * p.x; }
    dbl len2() { return x * x + y * y; }
    dbl len() { return sqrt(x * x + y * y); }
    void read(){
        dbl a, b;
        cin >> a >> b;
        x = a, y = b;
    }
    void print(){
        cout << x << " " << y << endl;
    }
};

struct Line{
    dbl a, b, c;
    Line() : a(0), b(0), c(0) {}
    Line(dbl a, dbl b, dbl c) : a(a), b(b), c(c) {}
    Line(Point p0, Point p1){
        a = p1.y - p0.y;
        b = p0.x - p1.x;
        c = -(a * p0.x + b * p0.y);
    }
    void read(){
        dbl x, y, z;
        cin >> x >> y >> z;
        a = x, b = y, c = z;
    }
    void print(){
        cout << a << " " << b << " " << c << endl;
    }
};

const dbl EPS = 1e-6;

Point intersection(Line l1, Line l2){
    Point p;
    if ((l2.c * l1.b - l1.c * l2.b) % (l1.a * l2.b - l2.a * l1.b) != 0)
        return Point(-7, 123123);
    p.x = (l2.c * l1.b - l1.c * l2.b) / (l1.a * l2.b - l2.a * l1.b);
    if ((l2.c * l1.a - l1.c * l2.a) % (l1.b * l2.a - l2.b * l1.a) != 0)
        return Point(-7, 123123);
    p.y = (l2.c * l1.a - l1.c * l2.a) / (l1.b * l2.a - l2.b * l1.a);
    return p;
}

bool check(Point a, Point b, Point c, Point d){
    if ((a - b) % (a - c) == 0)
        return false;
    if ((a - b) % (a - d) == 0)
        return false;
    if ((a - c) % (a - d) == 0)
        return false;
    if ((b - c) % (b - d) == 0)
        return false;
    return true;
}


bool comp(Point a, Point b){
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

int main()
{
    #ifdef KEK
        freopen("test.in", "r", stdin);/**/
    #endif // KEK
    /*freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);/**/
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    n *= 2;
    vector<Point> s(n);
    for (int i = 0; i < n; i++)
        s[i].read();
    vector<Point> lst;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < i; j++){
            for (int l = 0; l < n; l++){
                for (int k = 0; k < l; k++){
                    if ((s[i] - s[j]) % (s[l] - s[k]) != 0 && check(s[i], s[j], s[k], s[l])){
                        Point p = intersection(Line(s[i], s[j]), Line(s[k], s[l]));
                        if (p.x != -7 || p.y != 123123)
                            lst.push_back(p);
                    }
                }
            }
        }
    }
    sort(lst.begin(), lst.end(), comp);
    /*for (Point p : lst)
        p.print();*/
    lst.push_back(Point(-7, 123123));
    int last = 0;
    for (int i = 0; i < lst.size(); i++){
        if ((lst[i] - lst[last]).len() > 0){
            if (i - last == n / 2 * (n / 2 - 1)){
                cout << "YES" << endl;
                lst[i - 1].print();
                return 0;
            }
            last = i;
        }
    }
    cout << "NO" << endl;
    return 0;
}
