#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unrool-loops")/**/


#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <stdio.h>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <cmath>

#define prev aksdnasd
#define hash askdaksd
#define y1 alsmdasdas
#define y2 alsdnmasds
#define rank asdasdas

using namespace std;

typedef long long ll;
typedef long long dbl;

template<class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << endl;
}

struct Point{
    dbl x, y;
    Point() : x(0), y(0) {}
    Point(dbl x, dbl y) : x(x), y(y) {}
    Point operator-(Point p) { return Point(x - p.x, y - p.y); }
    Point operator+(Point p) { return Point(x - p.x, y - p.y); }
    Point operator/(dbl d) { return Point(x / d, y / d); }
    dbl operator%(Point p) { return x * p.y - y * p.x; }
    bool operator==(Point p) { return x == p.x && y == p.y; }
    dbl len2() { return x * x + y * y; }
    void read(){
        dbl a, b;
        cin >> a >> b;
        x = a, y = b;
    }
    void print(){
        cout << x << " " << y << endl;
    }
};

dbl gcd(dbl a, dbl b){
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

struct Line{
    dbl a, b, c;
    Line() : a(0), b(0), c(0) {}
    Line(dbl a, dbl b, dbl c) : a(a), b(b), c(c) {}
    Line(Point p0, Point p1){
        a = p1.y - p0.y;
        b = p0.x - p1.x;
        c = -(a * p0.x + b * p0.y);
    }
    void read(){
        dbl x, y, z;
        cin >> x >> y >> z;
        a = x, b = y, c = z;
    }
    void print(){
        cout << a << " " << b << " " << c << endl;
    }
};

vector<Point> s;
const int INF = 1e6 + 1;

Point intersection(Line l1, Line l2){
    Point p;
    if (l1.a * l2.b - l2.a * l1.b == 0 || l1.b * l2.a - l2.b * l1.a == 0)
        return Point(INF, INF);
    if ((l2.c * l1.b - l1.c * l2.b) % (l1.a * l2.b - l2.a * l1.b) != 0)
        return Point(INF, INF);
    p.x = (l2.c * l1.b - l1.c * l2.b) / (l1.a * l2.b - l2.a * l1.b);
    if ((l2.c * l1.a - l1.c * l2.a) % (l1.b * l2.a - l2.b * l1.a) != 0)
        return Point(INF, INF);
    p.y = (l2.c * l1.a - l1.c * l2.a) / (l1.b * l2.a - l2.b * l1.a);
    return p;
}


bool comp(Point a, Point b){
    if (a % b != 0)
        return a % b > 0;
    return a.len2() < b.len2();
}

vector<Point> lst;
void check(Point p){
    int n = s.size();
    for (int i = 0; i < n; i++){
        if (p == s[i])
            return;
        if (p.y < s[i].x || (p.y == s[i].y && p.x < s[i].x))
            lst.push_back(s[i] - p);
        else
            lst.push_back(p - s[i]);
    }
    sort(lst.begin(), lst.end(), comp);
    int cnt = 1;
    for (int i = 1; i < n; i++){
        if (lst[i] % lst[i - 1] != 0)
            cnt++;
    }
    if (cnt != n / 2)
        return;
    for (int i = 1; i < n; i++){
        if (lst[i] % lst[i - 1] != 0 && i != n - 1 && lst[i] % lst[i + 1] != 0)
            return;
    }
    cout << "Yes" << endl;
    p.print();
    exit(0);
}

int main()
{
    #ifdef KEK
        freopen("test.in", "r", stdin);/**/
    #endif // KEK
    /*freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);/**/
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    n *= 2;
    s.resize(n);
    for (int i = 0; i < n; i++)
        s[i].read();
    for (int i = 3; i < n; i++){
        Point p = intersection(Line(s[0], s[1]), Line(s[2], s[i]));
        if (abs(p.x) < INF && abs(p.y) < INF)
            check(p);
    }
    for (int i = 2; i < n; i++){
        for (int j = 2; j < n; j++){
            if (i != j){
                Point p = intersection(Line(s[0], s[i]), Line(s[1], s[j]));
                if (abs(p.x) < INF && abs(p.y) < INF)
                    check(p);
            }
        }
    }
    cout << "No" << endl;
    return 0;
}
