//#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <ctime>
#include <cstdlib>
#include <iomanip>

using namespace std;

typedef int L;

ifstream cin("input.txt");
ofstream cout("output.txt");

int dfs(int v, vector <vector <int> > &g, vector <long long> &ans) {
	int sum_in_node = 1;
	int balance_in_node = 0;
	int ans_for_node = 0;
	for (int i = 0; i < g[v].size(); i++) {
		int cnst = dfs(g[v][i], g, ans);
		sum_in_node += cnst;
		if (cnst > balance_in_node) {
			ans_for_node += cnst - balance_in_node;
		}
		balance_in_node = abs(cnst - balance_in_node);
	}
	ans[v] = ans_for_node;
	return sum_in_node;
}

void solve() {
	int n;
	cin >> n;
	vector <vector <int> > g(n);
	for (int i = 1; i < n; i++) {
		int temp;
		cin >> temp;
		temp--;
		g[temp].push_back(i);
	}
	vector <int> c(n);
	int sum = 0;
	for (int i = 0; i < n - 1; i++) {
		cin >> c[i];
		sum += c[i];
	}
	if (sum == n - 1) {
		vector <long long> ans(n);
		dfs(0, g, ans);
		long long cnt = 0;
		for (int i = 0; i < n; i++) {
			cnt += ans[i] * 2;
		}
		cout << cnt;
	}

}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(time(0));
	cout.precision(15);
	solve();

	return 0;
}