#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,sse4,abm,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <memory.h>
#include <cassert>
#include <string>
#include <chrono>
#include <queue>
#include <deque>
#include <numeric>

using namespace std;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pii pair<int, int>
#define x first
#define y second
#define pb push_back
#define eb emplace_back

typedef long long ll;
typedef long double ld;

template <typename T1, typename T2>
bool mini(T1 &a, const T2 &b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T1, typename T2>
bool maxi(T1 &a, const T2 &b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int INF = 1e9;
const int N = 5e6 + 123;
const int M = 20;
const int A = 26;
const int MOD = 1e9 + 7;

int cnt[A];
int pcnt[N];
vector<int> poss;

int gcd(int a, int b) {
	if (!a)
		return b;
	return gcd(b % a, a);
}

set<int> solve(const string &s, int w) {
	int n = sz(s);
	fill(pcnt, pcnt + n, 0);
	int cnt = count(all(s), w);
	for (int i = 0; i < n; i++) {
		pcnt[i + 1] = pcnt[i] + (bool)(s[i] == w);
	}
	set<int> ans;
	for (auto tr : poss) {
		int cur_len = n / tr;

		int ok = true;

		int cc = pcnt[cur_len];
		if (!cc) {
			continue;;
		}
		if (cnt % cc) {
			continue;
		}
		if (!ok)
			continue;

		for (int i = 0; i < n && ok; i += cur_len) {
			int cur_cnt = pcnt[i + cur_len] - pcnt[i];
			int cc = pcnt[cur_len];
			if (cur_cnt != cc) {
				ok = false;
				break;
			}
		}
		if (ok) {
			ans.insert(tr);
		}
	}
	return ans;
}

void run() {
	
	string s;
	cin >> s;
	int n = sz(s);
	for (int i = 0; i < n; i++) {
		cnt[s[i] - 'a']++;
	}

	
	for (int i = 1; i * i <= n; i++) {
		if (n % i == 0)
			poss.pb(i);
		if (i * i != n)
			poss.pb(n / i);
	}
	sort(rall(poss));
	set<int> cur;
	bool init = false;
	for (int i = 0; i < A; i++) {
		if (cnt[i]) {
			if (!init) {
				cur = solve(s, i + 'a');
			}
			else {
				auto kek = solve(s, i + 'a');
				set<int> ncur;
				for (auto it : cur) {
					if (kek.count(it))
						ncur.insert(it);
				}
				cur.swap(ncur);
			}
			if (sz(cur) == 1)
				break;
		}
	}

	cout << *cur.rbegin();


}