import java.awt.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.sql.Array;
import java.util.*;

public class Main {
    int gcd(int a, int b){
        if(b == 0) return a;
        if(a < b) return gcd(b, a);
        return gcd(b, a % b);
    }
    public void solve() throws IOException {
        char s[] = nextToken().toCharArray();

        int n = s.length;
        int cnt[] = new int[26];
        for (int i = 0; i < n; i++) {
            cnt[s[i] - 'a']++;
        }
        int gccc = 0;
        for (int i = 0; i < 26; i++) {
            gccc = gcd(gccc, cnt[i]);
        }
        for(; gccc > 1; gccc--){
            boolean t = true;
            for(int i  = 0; i + n / gccc <= n && t; i+= n / gccc){
                int cur[] = new int[26];
                for(int j = 0; j < n / gccc; j++){
                    cur[s[i + j] - 'a']++;
                }
                for (int j = 0; j < 26; j++) {
                    if(cur[j] * gccc != cnt[j]) t = false;
                }
            }
            if(t) break;
        }
        out.print(gccc);
    }

    BufferedReader br;
    PrintWriter out;
    StringTokenizer sc;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}