import java.awt.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.sql.Array;
import java.util.*;

public class Main {
    ArrayList<Integer> g[];
    int c[];
    long ans = 0;
    long sum[];
    int cnt[];
    long min[];

    void dfs(int v) {
        long mn = Integer.MAX_VALUE;
        int cur = 0;
        int rt = 0;
        if (g[v].size() == 0) {
            sum[v] = c[v];
            min[v] = c[v];
            return;
        }
        ArrayList<Integer> a = new ArrayList<>();
        for (int u : g[v]) {
            dfs(u);
            sum[v] += sum[u];
            ans += sum[u];
            a.add(cnt[u] + 1);
            int er = cnt[u] + 1;
            if(rt >= er){
                rt -= er;
            }else {
                er -= rt;
                if(er % 2 == 0){
                    if(cnt[v] - rt >= er){
                        rt = 0;
                    }else {
                        rt = er + rt - cnt[v];
                    }
                }else {
                    if (cnt[v] - rt +1 >= er) {
                        rt = 1;
                    } else {
                        rt = er + rt - cnt[v];
                    }
                }
            }

            cnt[v] += cnt[u] + 1;

        }

        ans += rt;
        sum[v] += c[v];

    }

    public void solve() throws IOException {
        int n = nextInt();
        c = new int[n];
        cnt = new int[n];
        min = new long[n];
        sum = new long[n];
        g = new ArrayList[n];
        for (int i = 0; i < n; i++) {
            g[i] = new ArrayList<>();
        }
        for (int i = 1; i <= n - 1; i++) {
            g[nextInt() - 1].add(i);
        }
        for (int i = 1; i < n; i++) {
            c[i] = nextInt();
        }
        dfs(0);
        out.print(ans);
    }

    BufferedReader br;
    PrintWriter out;
    StringTokenizer sc;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}