#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define ll long long

using namespace std;

struct mem {
    vector <int> cnt;
    mem() {
        cnt.resize(27, 0);
    }
};

vector <mem> t;

void modify(int v, int cl, int cr, int p, int x) {
    if (cr - cl == 1) {
        t[v].cnt[x]++;
        return;
    }
    int mid = (cl + cr) / 2;
    if (p >= mid)
        modify(v * 2 + 1, mid, cr, p, x);
    else
        modify(v * 2, cl, mid, p, x);
    for (int i = 0; i < 27; i++) {
        t[v].cnt[i] = t[v * 2].cnt[i] + t[v * 2 + 1].cnt[i];
    }
}

mem query(int v, int cl, int cr, int l, int r) {
    if (cl >= r || cr <= l) {
        mem kek;
        return kek;
    }
    if (cl >= l && cr <= r) {
        return t[v];
    }
    int mid = (cl + cr) / 2;
    mem lol = query(v * 2, cl, mid, l, r);
    mem lor = query(v * 2 + 1, mid, cr, l, r);
    mem res;
    for (int i = 0; i < 27; i++) {
        res.cnt[i] = lol.cnt[i] + lor.cnt[i];
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif //LOCAL
    string s;
    cin >> s;
    int n = s.size();
    int l = 1;
    while (l < n)
        l *= 2;
    t.resize(l * 2);
    vector <int> pr;
    for (int i = 1; i <= n; i++) {
        modify(1, 0, l, i - 1, s[i - 1] - 'a');
        if (n % i == 0) {
            pr.pb(i);
        }
    }
    for (auto k : pr) {
        mem cnt = query(1, 0, l, 0, k);
        bool f = 1;
        for (int i = 0; i < n; i += k) {
            mem cur = query(1, 0, l, i, i + k);
            if (cur.cnt != cnt.cnt) {
                f = 0;
                break;
            }
        }
        if (f) {
            cout << n / k;
            return 0;
        }
    }
    return 0;
}


