#include <bits/stdc++.h>
#define fr first
#define sc second

using namespace std;
#define int long long
typedef pair<int, int> ii;
typedef long long ll;
typedef unsigned long long u64;
const int NMAX = 1e5 + 9, INF = 1e9 + 7, MOD = 1e9 + 7;

struct pnt{
    int x, y;
};

void getLine(pnt a, pnt b, int &A, int &B, int &C) {
    A = (a.y - b.y), B = (b.x - a.x);
    C = -A * a.x -B * a.y;
}

bool isInLine(pnt a, int &A, int& B, int &C) {
    return A * a.x + B * a.y + C == 0;
}

bool getInter(int &A1, int &B1, int &C1, int &A2, int &B2, int &C2, pnt &ans) {
    int denom = -(A1 * B2 - A2 * B1);
    if (denom == 0) {
        return 0;
    }
    int a = (C1 * B2 - C2 * B1),
    b = (A1 * C2 - A2 * C1);
    if (a % denom != 0 || b % denom != 0) {
        return 0;
    }
    ans.x = a / denom;
    ans.y = b / denom;
    return 1;
}

set<ii> havePoint;

main()
{
    #ifdef HOME
        freopen("input.txt", "r", stdin);
    #endif
    ios::sync_with_stdio(0);

    int n;
    cin >> n;
    n *= 2;
    vector<pnt> p;
    for (int i = 0; i < n; ++i) {
        pnt a;
        cin >> a.x >> a.y;
        p.push_back(a);
        havePoint.insert({a.x, a.y});
    }

    int a = 0;
    for (int b = a + 1; b < n; ++b) {

        int A1, B1, C1;
        getLine(p[a], p[b], A1, B1, C1);
        for (int c = a + 1; c < n; ++c) {
            if (c == b || isInLine(p[c], A1, B1, C1)) {
                continue;
            }
            for (int d = c + 1; d < n; ++d) {
                if (d == b || isInLine(p[d], A1, B1, C1)) {
                    continue;
                }
                bool fail = 0;

                int A2, B2, C2;
                getLine(p[c], p[d], A2, B2, C2);
                set<ii> lines;
                lines.insert({A1 / __gcd(A1, B1), B1 / __gcd(A1, B1)});
                lines.insert({A2 / __gcd(A2, B2), B2 / __gcd(A2, B2)});

                pnt ildar;
                if (!getInter(A1, B1, C1, A2, B2, C2, ildar)) {
                    continue;
                }
                if (havePoint.count({ildar.x, ildar.y})) {
                    continue;
                }

                bool used[n];
                memset(used, 0, sizeof(used));
                used[a] = used[b] = used[c] = used[d] = 1;
                for (int k = 0; k < n && !fail; ++k) {
                    if (used[k]) {
                        continue;
                    }
                    int A3, B3, C3;
                    getLine(p[k], ildar, A3, B3, C3);

                    int who = -1;
                    used[k] = 1;

                    for (int h = 0; h < n; ++h) {
                        bool is = isInLine(p[h], A3, B3, C3);
                        if (used[h]) {
                            continue;
                        }

                        if (is) {
                            who = h;
                            break;
                        }
                    }
                    if (who == -1) {
                        fail = 1;
                    } else {
                        used[who] = 1;
                        lines.insert({A3 / __gcd(A3, B3), B3 / __gcd(A3, B3)});
                    }
                }

                if (lines.size() != n / 2) {
                    fail = 1;
                }
                if (!fail) {
                    cout << "Yes\n" << ildar.x << ' ' << ildar.y;
                    return 0;
                }
            }
        }
    }

    cout << "No";
}
