#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef long double ld;
typedef pair<ll, ll> par;
typedef vector<ll> vll;

#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define sqr(x) ((x)*(x))
#define pw(x) (1ll << (x))
#define _ inline

ll logn(ll n) { return ll(log2(ld(n))); }
ll rnd() { return (rand() << 16) + rand(); }

int pref[5000001];


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
#ifdef aokigahara
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
#endif // aokigahara


    string s;
    cin >> s;
    ll n = s.size();
    vll C(26, -1);
    ll maxpos = 0;
    ll kkk = 0;
    for (int i = 0; i < n; ++i) {
        if (C[s[i] - 'a'] == -1) {
            C[s[i] - 'a'] = i;
            maxpos = i;
            kkk++;
        }
    }
    if (kkk == 1) {
        cout << n;
        return 0;
    }
    maxpos++;
    ll kk = sqrt(n) + 1;
    vll good;
    for (ll kol = 2; kol < kk; ++kol) {
        if (n % kol) continue;
        ll len = n / kol;
        if (len >= maxpos) good.push_back(len);
        if (kol * kol != n && kol >= maxpos) good.push_back(kol);
    }
    ll sz = good.size();
    vll isG(sz, 1);
    for (int c = 0; c < 26; ++c) {
        pref[0] = 0;
        for (int i = 0; i < n; ++i) pref[i + 1] = pref[i] + bool(s[i] - 'a' == c);
        for (int i = 0; i < sz; ++i) {
            ll len = good[i];
            if (!isG[i]) continue;
            bool flag = 1;
            ll cc = pref[len];
            for (int j = len * 2; j <= n; j += len) {
                ll tmp = pref[j] - pref[j - len];
                if (tmp != cc) {
                    flag = 0;
                    break;
                }
            }
            isG[i] = flag;
        }
    }
    ll ans = 1;
    for (int i = 0; i < sz; ++i) {
        if (!isG[i]) continue;
        ans = max(ans, n / good[i]);
    }
    cout << ans;

#ifdef aokigahara
    cerr << fixed << setprecision(12) << "\n\nTIME : " << clock() * 1.0 / CLOCKS_PER_SEC << "\n";
#endif // aokigahara
    return 0;
}
