#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <cstdio>
#include <utility>
#include <ostream>
#include <ctime>
#include <cmath>
#include <string>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

bool check(string &s, int fr, vector<int> must, vector<vector<int>> &pcnt) {
	for (int i = 0; i < 26; i++) {
		if (must[i] % fr != 0) return false;
		must[i] /= fr;
	}
	int n = s.size();
	int len = n / fr;
	for (int i = 0; i < 26; i++) {
		for (int j = len; j <= n; j += len) {
			if (pcnt[i][j] - pcnt[i][j - len] != must[i])
				return false;
		}
	}
	return true;
}
int main() {
	ios_base::sync_with_stdio(0);
	string s;
	cin >> s;
	int n = s.size();
	vector<int> cnt(26);
	vector<vector<int>> pcnt(26, vector<int>(n + 1));
	for (int i = 0; i < n; i++) {
		pcnt[s[i] - 'a'][i + 1]++;
		cnt[s[i] - 'a']++;
	}
	for (int i = 0; i < 26; i++) {
		for (int j = 1; j <= n; j++) {
			pcnt[i][j] += pcnt[i][j - 1];
		}
	}
	int ans = 1;
	for (int i = 1; 1ll * i * i <= n; i++) {
		if (n % i == 0) {
			if (check(s, i, cnt, pcnt)) ans = max(ans, i);
			if (check(s, n / i, cnt, pcnt)) ans = max(ans, n / i);
		}
	}
	cout << ans;
}