#include<iostream>
#include<iomanip>
#include<vector>
#include<set>
#include<math.h>
#include<map>
#include<algorithm>
#include <chrono>
#include <ctime>
using namespace std;
struct point{
    long long x, y;
};
point p[3000];
long long n;
bool check(long long x, long long y){
    if (x > 1e6 || y > 1e6 || x < -1e6 || y < -1e6) {
        return false;
    }
    map<double, long long> help;
    double k[n];
    for (long long i = 0; i < n; i++) {
        if (x == p[i].x && y == p[i].y) {
            return false;
        }
        if (p[i].y != y) {
            k[i] = ((double)p[i].x - x) / (p[i].y - y);
        } else {
            k[i] = 1e15;
        }
        //cout << k[i] << endl;
        help[k[i]]++;
    }
    for (auto elem : help) {
        if (elem.second != 2) {
            return false;
        }
    }
    return true;
}
bool sortfunc(point a, point b) {
    if (b.x >= p[0].x && a.x >= p[0].x) {
        long long x1 = -p[0].x + a.x;
        long long y1 = -p[0].y + a.y;
        long long x2 = -p[0].x + b.x;
        long long y2 = -p[0].y + b.y;
        return x1 * y2 - x2 * y1 < 0;
    } else if (b.x < p[0].x && a.x < p[0].x) {
        long long x1 = -p[0].x + a.x;
        long long y1 = -p[0].y + a.y;
        long long x2 = -p[0].x + b.x;
        long long y2 = -p[0].y + b.y;
        return x1 * y2 - x2 * y1 < 0;
    } else if (b.x < p[0].x && a.x >= p[0].x) {
        return true;
    } else {
        return false;
    }
}
int main() {
    cin >> n;
    if (n == 1) {

    }
    n *= 2;
    long long x, y;
    for (long long i = 0; i < n; i++) {
        cin >> x >> y;
        p[i] = {x, y};
    }
    //cout << check(2, 2) << endl;
    //return 0;
    random_shuffle(p, p + n);
    sort(p + 1, p + n, sortfunc);
    std::chrono::time_point<std::chrono::system_clock> start, endd;
    start = std::chrono::system_clock::now();
    vector<int> helpind;
    helpind.push_back(n / 2);
    for (int i = 0; i < n - 2; i++) {
        if (i % 2 == 0) {
            helpind.push_back(helpind.back() - i - 1);
        } else {
            helpind.push_back(helpind.back() + i + 1);
        }
    }
    for (auto elem : helpind) {
        int i = elem;
        //cout << i << endl;
        endd = std::chrono::system_clock::now();
        std::chrono::duration<double> elapsed_seconds = endd-start;
        if (n > 100 && elapsed_seconds.count() > 5) {
            cout << "No";
            return 0;
        }
        int j = 0;
        if (i == 1) {
            j = 2;
        } else {
            j = 1;
        }
            for (long long k = j + 1; k < n; k++) {
                if (k == i) {
                    continue;
                }
                point p1 = p[0];
                point p2 = p[i];
                point p3 = p[j];
                point p4 = p[k];
                long long a1 = (p1.y - p2.y);
                long long b1 = (p1.x - p2.x);
                long long c1 = (p1.x * p2.y - p2.x * p1.y);
                long long a2 = (p3.y - p4.y);
                long long b2 = (p3.x - p4.x);
                long long c2 = (p3.x * p4.y - p4.x * p3.y);
                if (b1 * a2 - b2 * a1 == 0) {
                    continue;
                }
                if ((c1 * b2 - c2 * b1) % (b1 * a2 - b2 * a1) == 0 && (c1 * a2 - c2 * a1) % (b2 * a1 - b1 * a2) == 0) {
                    long long x = (c1 * b2 - c2 * b1) / (b1 * a2 - b2 * a1);
                    long long y = (c1 * a2 - c2 * a1) / (b1 * a2 - b2 * a1);
                    //cout << i << ' ' << j << ' ' << k << ' ' << x << ' ' << y << endl;
                    if (check(x, y)) {
                        cout << "Yes" << endl << x << ' ' << y;
                        return 0;
                    }
                }
            }
    }
    cout << "No" << endl;
}
