#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


using namespace std;
using namespace __gnu_pbds;

#define endl '\n'
#define F first
#define S second
#define llong long long
#define dlong double long
#define pb push_back

// CODE CODE CODE CODE CODE CODE CODE

const int N = 2e5 + 36;
const int MOD = 1e9 + 7;
const int EPS = 1e-10;

//tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>st;

struct point {
    llong x, y;
    point(llong xx, llong yy) {
        x = xx;
        y = yy;
    }
    point() {
        x=0;
        y=0;
    }
};

struct line {
    llong a, b, c;
    line() {}
    line(point p, point q) {
        a = p.y - q.y;
        b = q.x - p.x;
        c = - a * p.x - b * p.y;
    }

};

point inters(line l,line l1) {
    point p;
    if ((l1.a*l.b - l1.b*l.a)<EPS) return p = {MOD, MOD};
    if ((l.a<EPS)) swap(l, l1);
    llong y = (l.a*l1.c - l.c*l1.a)/(l1.a*l.b-l1.b*l.a);
    llong x = (l.b * y + l.c) / (-l.a);
    p= {x, y};
    return p;
}

point x[N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    llong n;
    cin >> n;
    for (int i(0); i<n*2; i++) {
        cin >> x[i].x >> x[i].y;
    }
    line one = line(x[0], x[1]);
    line two = line(x[2], x[3]);
    point H=inters(one, two);
    if (H.x!=MOD) {
        cout << "Yes" << endl;
        cout << H.x << ' ' << H.y << endl;
        return 0;
    }
     one = line(x[2], x[1]);
     two = line(x[0], x[3]);
     H=inters(one, two);
    if (H.x!=MOD) {
        cout << "Yes" << endl;
        cout << H.x << ' ' << H.y << endl;
        return 0;
    }
    cout << "No" << endl;
    return 0;
}
