#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

int all[26];
int good[26];
int cnt[26];
int nice[26];

struct P
{
    ll x, y;
    bool operator ==(const P &b) const
    {
        return x == b.x && y == b.y;
    }
};

void line(P a, P b, ll &a1, ll &b1, ll &c1)
{
    a1 = (b.y - a.y);
    b1 = (a.x - b.x);
    c1 = -a1 * a.x - b1 * a.y;
}

P get(P a, P b, P c, P d, bool &ok)
{
    ll A1, B1, C1;
    line(a, b, A1, B1, C1);
    ll A2, B2, C2;
    line(c, d, A2, B2, C2);

    if (B2 * A1 == A2 * B1)
    {
        ok = 0;
        return {0, 0};
    }

    if ((-C2 * A1 + C1 * A2) % (B2 * A1 - A2 * B1) != 0)
    {
        ok = 0;
        return {0, 0};
    }
    ll y = (-C2 * A1 + A2 * C1) / (B2 * A1 - A2 * B1);

    if ((C2 * B1 - C1 * B2) % (B2 * A1 - A2 * B1) != 0)
    {
        ok = 0;
        return {0, 0};
    }
    ll x = (C2 * B1 - C1 * B2) / (B2 * A1 - A2 * B1);
    return {x, y};
}

P arr[3000];

signed main()
{
#ifdef POSPELOV
    freopen("in.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n;
    for (int i = 0; i < 2 * n; i++)
        cin >> arr[i].x >> arr[i].y;

    for (int p1 = 2; p1 < 2 * n; p1++)
    {
        for (int p2 = 2; p2 < 2 * n; p2++)
        {
            if (p1 == p2)
                continue;
            bool ok = 1;
            P p = get(arr[0], arr[p1], arr[1], arr[p2], ok);
            if (ok)
            {
                map <pair <int, int>, int> used;
                for (int t = 0; t < 2 * n; t++)
                {
                    if (arr[t] == p)
                        ok = 0;
                    ll x = arr[t].x - p.x, y = arr[t].y - p.y;
                    ll g = __gcd(abs(x), abs(y));
                    if (x == 0 || y == 0)
                    {
                        if (x == 0)
                            y = 1;
                        else
                            x = 1;
                    }
                    else
                        x /= g, y /= g;

                    if (x < 0)
                        x *= -1, y *= -1;
                    used[{x, y}]++;
                }
                for (auto &t : used)
                    if (t.second != 2)
                    {
                        ok = 0;
                        break;
                    }
            }
            if (ok)
                return cout << "Yes\n" << p.x << " " << p.y, 0;
        }
    }

    for (int p1 = 1; p1 < 2 * n; p1++)
    {
        if (p1 == 2)
            continue;
        for (int p2 = 1; p2 < 2 * n; p2++)
        {
            if (p1 == 2 || p1 == p2)
                continue;
            bool ok = 1;
            P p = get(arr[0], arr[p1], arr[2], arr[p2], ok);
            if (ok)
            {
                map <pair <int, int>, int> used;
                for (int t = 0; t < 2 * n; t++)
                {
                    if (arr[t] == p)
                        ok = 0;
                    ll x = arr[t].x - p.x, y = arr[t].y - p.y;
                    ll g = __gcd(abs(x), abs(y));
                    if (x == 0 || y == 0)
                    {
                        if (x == 0)
                            y = 1;
                        else
                            x = 1;
                    }
                    else
                        x /= g, y /= g;

                    if (x < 0)
                        x *= -1, y *= -1;
                    used[{x, y}]++;
                }
                for (auto &t : used)
                    if (t.second != 2)
                    {
                        ok = 0;
                        break;
                    }
            }
            if (ok)
                return cout << "Yes\n" << p.x << " " << p.y, 0;
        }
    }

    cout << "No";
    return 0;
}

//51
