#include <bits/stdc++.h>
using namespace std;
#define int int64_t
#define fs first
#define sc second
#define mp make_pair
#define pb push_back
#define pob pop_back
#define sz(v) ((int) (v).size())
#define all(v) (v).begin(), (v).end()
#define forn(i, j, n) for (int (i) = (j); (i) < (n); ++i)
#define forc(i, n, j) for (int (i) = (n) - (1); (i) >= (j); --i)
typedef long long ll;
typedef pair <int, int> pii;
typedef vector <int> vi;
typedef vector <double> vd;
typedef vector <bool> vb;

const int MAX = 5205, C = 1000000;

pii arr[MAX];

int n;

bool ok;

struct Node
{
    int A, B, C;
    Node(int _A = 0, int _B = 0, int _C = 0)
    {
        A = _A;
        B = _B;
        C = _C;
    }
};

Node get_line(int l, int r)
{
    int a = arr[r].fs - arr[l].fs;
    int b = arr[r].sc - arr[l].sc;
    int A = b;
    int B = -a;
    int C = a * arr[r].sc - b * arr[r].fs;
    return Node(A, B, -C);
}

int gcd(int a, int b)
{
    if (!b)
        return a;
    return gcd(b, a % b);
}

bool check(int x, int y)
{
    forn(i, 0, 2 * n)
        if (x == arr[i].fs && y == arr[i].sc)
        {
            ok = false;
            return false;
        }
    map <pii, int> m;
    forn(i, 0, 2 * n)
    {
        int x1 = arr[i].fs - x;
        int y1 = arr[i].sc - y;
        int d = gcd(x1, y1);
        x1 /= d;
        y1 /= d;
        m[mp(x1, y1)]++;
    }
    for (auto el : m)
        if (el.sc != 2)
            return false;
    return true;
}

pii get(int a, int b, int c, int d)
{
    Node A = get_line(a, b);
    Node B = get_line(c, d);
    pii ans = mp(-1, -1);
    int det = A.A * B.B - B.A * A.B;
    if (!det)
    {
        ok = false;
        return ans;
    }
    int cur = A.C * B.B - A.B * B.C;
    if (cur % det != 0)
    {
        ok = false;
        return ans;
    }
    int x = cur / det;
    cur = A.A * B.C - A.C * B.A;
    if (cur % det != 0)
    {
        ok = false;
        return ans;
    }
    int y = cur / det;
    if (abs(x) > C || abs(y) > C)
    {
        ok = false;
        return ans;
    }
    if (!check(x, y))
        ok = false;
    return mp(x, y);
}

int32_t main()
{
    srand(time(nullptr));
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> n;
    forn(i, 0, 2 * n)
        cin >> arr[i].fs >> arr[i].sc;
    random_shuffle(arr, arr + 2 * n);
    forn(i, 2, 2 * n)
        forn(j, 2, 2 * n)
        {
            if (i == j)
                continue;
            ok = true;
            pii cur = get(0, i, 1, j);
            if (ok)
            {
                cout << "Yes" << endl;
                cout << cur.fs << ' ' << cur.sc;
                return 0;
            }
        }
    forn(i, 2, 2 * n)
        forn(j, 2, 2 * n)
        {
            if (i == j)
                continue;
            ok = true;
            pii cur = get(0, 1, i, j);
            if (ok)
            {
                cout << "Yes" << endl;
                cout << cur.fs << ' ' << cur.sc;
                return 0;
            }
        }
    cout << "No";
    return 0;
}
