#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
using namespace std;

#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define mp make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ld, ld> pldld;

const int INF = 1e9, MOD = 1e9 + 7;
const ld EPS = 1e-9, PI = acos(-1);

int n;
string s;

int gcd(int a, int b)
{
    if (a < b)
        swap(a, b);
    if (!b)
        return a;
    return gcd(a % b, a);
}

bool check(int len)
{
    vector<int> counter(26);
    for (int i = 0; i < len; ++i)
        counter[s[i] - 'a']++;
    int pos = len;
    while (pos < n) {
        vector<int> now(26);
        for (int i = pos; i < pos + len; ++i)
            now[s[i] - 'a']++;
        for (int i = 0; i < 26; ++i)
            if (now[i] != counter[i])
                return false;
        pos += len;
    }

    return true;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> s;
    n = s.size();

    vector<int> counter(26);
    for (int i = 0; i < n; ++i)
        counter[s[i] - 'a']++;
    if (count(all(counter), 0) == 25) {
        cout << n << endl;
        return 0;
    }

    int g = 0;
    for (int i = 0; i < 26; ++i)
        g = gcd(g, counter[i]);
    int ans = 1;
    for (int i = 1; i <= g; ++i) {
        if (n % i == 0 && check(i)) {
            ans = n / i;
            break;
        }
    }

    cout << ans << endl;

    return 0;
}
