#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
using namespace std;

#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define mp make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ld, ld> pldld;

const int INF = 1e9, MOD = 1e9 + 7, MAXN = 5e6 + 7;
const ld EPS = 1e-9, PI = acos(-1);

int n, counter[26] = {0}, pref[MAXN][26];
string s;
unordered_set<int> diff;
vector<int> for_check;

int gcd(int a, int b)
{
    if (a < b)
        swap(a, b);
    if (!b)
        return a;
    return gcd(a % b, a);
}

bool check(int len)
{
    //cout << len << endl;
    int pos = len;
    while (pos <= n) {
        for (int elem : for_check) {
            //cout << pos << " " << elem << ' ' << pref[pos + 1][elem] << " " << pref[pos + 1 - len][elem] << endl;
            if (n * (pref[pos][elem] - pref[pos - len][elem]) != len * counter[elem] )
                return false;
        }
        pos += len;
    }

    return true;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> s;
    n = s.size();
    for (int j = 0; j < 26; ++j)
        pref[0][j] = 0;

    for (int i = 0; i < n; ++i) {
        counter[s[i] - 'a']++;
        diff.insert(s[i] - 'a');
        for (int j = 0; j < 26; ++j)
            pref[i + 1][j] = pref[i][j] + (s[i] - 'a' == j);
    }
    for (int elem : diff)
        for_check.pb(elem);
    if (diff.size() == 1) {
        cout << n << endl;
        return 0;
    }

    int g = 0;
    for (int i = 0; i < 26; ++i)
        g = gcd(g, counter[i]);
    int ans = 1;
    for (int i = g; i > 1; --i) {
        if (n % i == 0 && check(n / i)) {
            ans = i;
            break;
        }
    }

    cout << ans << endl;

    return 0;
}
