#include <bits/stdc++.h>
using namespace std;
#define int int64_t
#define rep(i, a, b) for(int i = a; i < b; ++i)
#define gcd __gcd
typedef array <int, 2> dot;
typedef array <int, 3> line;

int debug = 0;

dot operator - (dot A, dot B) { return {{B[0] - A[0], B[1] - A[1]}}; }

const int N = 2700, MX = 1e6;
int n;
dot p[N], NP = {{(int)1e7, (int)1e7}};
map <line, int> many, cnt;

line make_line(dot A, dot B) {
    int a, b, c;
    a = A[1] - B[1];
    b = B[0] - A[0];
    c = -a * A[0] - b * A[1];
    int k = gcd(a, gcd(b, c));
    a /= k, b /= k, c /= k;
    if (a < 0) { a *= -1, b *= -1, c *= -1; }
    return {{a, b, c}};
}

dot intersection(line la, line lb) {
    int a1, b1, c1, a2, b2, c2;
    a1 = la[0], b1 = la[1], c1 = la[2];
    a2 = lb[0], b2 = lb[1], c2 = lb[2];
    int d = a1 * b2 - a2 * b1;
    int dy = c1 * a2 - c2 * a1;
    int dx = c2 * b1 - c1 * b2;
    if (d != 0 && dy % d == 0 && dx % d == 0) {
        return {{dx/d, dy/d}};
    } else {
        return NP;
    }
}

bool check(dot P) {
    cnt.clear();
    if (abs(P[0]) > MX || abs(P[1]) > MX) {
        return 0;
    }
    rep(i, 0, n) {
        if (p[i] == P) {
            return 0;
        }
    }
    rep(i, 0, n) {
        cnt[make_line(P, p[i])]++;
    }
    for (auto i : cnt) {
        if (i.second != 2) {
            return 0;
        }
    }
    cnt.clear();
    return 1;
}

main() {
    int tim = clock();
    cin >> n;
    n *= 2;
    rep(i, 0, n) {
        cin >> p[i][0] >> p[i][1];
    }
    set <line> lines;
    rep(i, 0, n) {
        rep(j, i + 1, n) {
            auto cur_line = make_line(p[i], p[j]);
            if (lines.count(cur_line)==0) {
                lines.insert(cur_line);
            } else {
                many[cur_line] = 1;
            }
        }
    }
    vector <line> lines2;
    for (auto i : lines) {
        if (!many[i]) {
            lines2.push_back(i);
        }
    }
    int sz_l = lines2.size();
    rep(i, 0, sz_l) {
        auto il = lines2[i];
        rep(j, i + 1, sz_l) {
            auto jl = lines2[j];
            auto P = intersection(il, jl);
            if (P != NP) {
                if (check(P)) {
                    puts("Yes");
                    cout << P[0] << ' ' << P[1] << endl;
                    exit(0);
                }
            }
            if (clock() - tim > 8900) {
                puts("No");
                return 0;
            }
        }
    }
    puts("No");
    return 0;
}