#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

mt19937 rnd(1235);

int mysqrt(int x){
    int l = 0, r = 1e4;
    while (r - l > 1){
        int m = (l + r) / 2;
        if (m * m <= x)
            l = m;
        else
            r = m;
    }
    return l;
}

const int maxn = 5e6 + 100, maxw = 1e6 + 100, inf = 1e9 + 100, mod = 1e9 + 7, sq = 300, LG = 18;

int a[26], b[26];

char s[maxn];

int n;

vector<int> del;

char qek[maxn];

int allneed;

void add(int x){
    if (x == 0)
        return;
    allneed++;
    int sqs = mysqrt(x);
    for (int i = 1; i <= sqs; i++)
    if (x % i == 0){
        qek[i]++;
        if (i * i != x)
            qek[x / i]++;
    }
}

int main()
{
    #ifdef ONPC
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
    #endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    scanf("%s", s);
    for (int i = 0; i < maxn; i++)
    if (s[i] == 0){
        n = i;
        break;
    }
    for (int i = 0; i < n; i++)
        s[i] -= 'a', a[s[i]]++;
    for (int i = 0; i < 26; i++)
        add(a[i]);
    del.reserve(2 * ((int)mysqrt(n) + 1));
    for (int i = 1; i <= n; i++)
    if (qek[i] == allneed)
        del.push_back(i);
    reverse(del.begin(), del.end());
    for (auto olen : del){
        int len = n / olen;
        for (int i = 0; i < 26; i++)
            a[i] = 0, b[i] = 0;
        for (int i = 0; i < len; i++)
            a[s[i]]++;
        bool is = 1;
        for (int i = len; i < n; i += len){
            for (int j = 0; j < len; j++){
                b[s[i + j]]++;
                if (b[s[i + j]] > a[s[i + j]]){
                    is = 0;
                    break;
                }
            }
            if (!is)
                break;
            for (int j = 0; j < 26; j++)
                b[j] = 0;
        }
        if (is){
            cout << olen;
            return 0;
        }
    }
}
