#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

mt19937 rnd(1235);

const int maxn = 2e5 + 100, maxw = 1e6 + 100, inf = 1e9 + 100, mod = 1e9 + 7, sq = 300, LG = 18;

int n;

vector<int> e[maxn];

int c[maxn];

ll sum[maxn];

int q[maxn];

int sz[maxn];

ll ans;

bool cmp(int x, int y){
    return sz[x] < sz[y];
}

void dfs(int v){
    int A = inf, B = inf;
    for (auto i : e[v]){
        dfs(i);
        sz[v] += sz[i];
        sum[v] += sum[i];
        if (A > q[i])
            B = A, A = q[i];
        else
        if (B > q[i])
            B = q[i];
    }
    sort(e[v].begin(), e[v].end(), cmp);
    if (e[v].empty() || 2 * sz[e[v].back()] <= sz[v]){
        ans += sum[v];
        if (sz[v] & 1)
            ans += A + B;
    }
    else{
        if (A == q[e[v].back()])
            swap(A, B);
        ans += sum[v] + A * (ll)(sz[e[v].back()] - (sz[v] - sz[e[v].back()]));
    }
    sum[v] += c[v];
    q[v] = min(A, c[v]);
    sz[v]++;
}

int main()
{
    #ifdef ONPC
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
    #endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 1; i < n; i++){
        int par;
        cin >> par;
        e[par - 1].push_back(i);
    }
    for (int i = 1; i < n; i++)
        cin >> c[i];
    dfs(0);
    cout << ans;
}
