#include <stdio.h>
#include <vector>

std::vector<int> *graph;
int *c, *sizes;
long long ans;

int count(int v, int h) {
	ans += (long long)c[v] * h;
	sizes[v] = 1;
	if (graph[v].size() == 0) {
		return c[v];
	}
	int mins[graph[v].size()];
	for (int i = 0; i < graph[v].size(); i++) {
		mins[i] = count(graph[v][i], h + 1);
		sizes[v] += sizes[graph[v][i]];
	}
	int ind = -1;
	for (int i = 0; i < graph[v].size() && ind == -1; i++) {
		if (sizes[graph[v][i]] * 2 > sizes[v] - 1) {
			ind = i;
		}
	}
	int min = 1e9, min2 = 1e9;
	for (int i = 0; i < graph[v].size(); i++) {
		if (mins[i] < min) {
			min = mins[i];
		}
		if (i != ind && mins[i] < min2) {
			min2 = mins[i];
		}
	}
	if (ind != -1) {
		ans += (long long)min2 * (sizes[graph[v][ind]] * 2 - sizes[v] + 1);
	} else if (!(sizes[v] % 2)) {
		ans += min;
	}
	return min < c[v] ? min : c[v];
}

int main() {
	int n;
	scanf("%d", &n);
	graph = new std::vector<int>[n];
	c = new int[n];
	sizes = new int[n]();
	for (int i = 0; i < n - 1; i++) {
		int p;
		scanf("%d", &p);
		graph[p - 1].push_back(i + 1);
	}
	for (int i = 0; i < n - 1; i++) {
		scanf("%d", &c[i + 1]);
	}
	count(0, 0);
	printf("%lld", ans);
	return 0;
}
