#include <stdio.h>
#include <algorithm>
#include <map>

long long x = 0, y = 0;

bool f(long long x0, long long y0, long long x1, long long y1, long long x2, long long y2, long long x3, long long y3) {
	long long a1 = y1 - y0, b1 = x0 - x1, c1 = x1 * y0 - x0 * y1;
	long long a2 = y3 - y2, b2 = x2 - x3, c2 = x3 * y2 - x2 * y3;
	if (a1 == 0) {
		y = -c1 / b1;
		if (a2 != 0) {
			x = -(c2 + b2 * y) / a2;
		}
	} else if (a2 == 0) {
		y = -c2 / b2;
		if (a1 != 0) {
			x = -(c1 + b1 * y) / a1;
		}
	} else {
		if (b1 * a2 != a1 * b2) {
			y = (c2 * a1 - c1 * a2) / (b1 * a2 - b2 * a1);
			if (a1 != 0) {
				x = -(c1 + b1 * y) / a1;
			}
		} else {
			return false;
		}
	}
	if (a1 * x + b1 * y + c1 == 0 && a2 * x + b2 * y + c2 == 0 && x <= 1e6 && x >= -1e6 && y >= -1e6 && y <= 1e6 && (x != x0 || y != y0) && (x != x1 || y != y1) && (x != x2 || y != y2) && (x != x3 || y != y3)) {
		return true;
	}
	return false;
}

int main() {
	int n;
	scanf("%d", &n);
	long long xx[2 * n], yy[2 * n];
	for (int i = 0; i < 2 * n; i++) {
		scanf("%lld%lld", &xx[i], &yy[i]);
	}
	int arr[2 * n];
	for (int i = 0; i < 2 * n; i++) {
		arr[i] = i;
	}
	long long counter = 1;
	for (int i = 2; i <= 2 * n; i++) {
		counter *= i;
	}
	for (int _ = 0; _ < counter; _++) {
		if (f(xx[arr[0]], yy[arr[0]], xx[arr[1]], yy[arr[1]], xx[arr[2]], yy[arr[2]], xx[arr[3]], yy[arr[3]])) {
			bool flag = true;
			for (int i = 2; i < n && flag; i++) {
				if ((x == xx[arr[2 * i]] && y == yy[arr[2 * i]]) || (x == xx[arr[2 * i + 1]] && y == yy[arr[2 * i + 1]]) || (long long)(x - xx[arr[2 * i]]) * (yy[arr[2 * i + 1]] - y) != (long long)(y - yy[arr[2 * i]]) * (xx[arr[2 * i + 1]] - x)) {
					flag = false;
				}
			}
			if (flag) {
				printf("Yes\n%lld %lld", x, y);
				return 0;
			}
		}
		std::next_permutation(arr, arr + 2 * n);
	}
	printf("No");
	return 0;
}
