import java.io.*;
import java.lang.reflect.Array;
import java.util.*;

public class Main {
    int gcd(int a, int b) {
        if (b == 0) return a;
        return gcd(b, a % b);
    }

    public void solve() throws IOException {
        String s = nextToken();
        int n = s.length();
        int[][] d = new int[26][n];
        for (int i = 0; i < n; i++) {
            if (i != 0){
                for (int j = 0; j < 26; j++) {
                    d[j][i] = d[j][i - 1];
                }
            }
            d[s.charAt(i) - 'a'][i]++;
        }
        int x = 0;
        for (int i = 0; i < 26; i++) {
            x = gcd(x,d[i][n - 1]);
        }
        for (int i = x; i > 1; i--) {
            if (x % i == 0){
                boolean f = true;
                for (int j = 1; j < x / i; j++) {
                    int l = 0;
                    int r = n;
                    while (r - l > 1){
                        int m = (r + l) / 2;
                        int c = 0;
                        for (int k = 0; k < 26; k++) {
                            if (d[k][m] < d[k][n - 1] / i * j){
                                if (c == 1){
                                    c = -2;
                                    break;
                                }
                                if (c <= 0){
                                    c = -1;
                                }
                            }
                            if (d[k][m] > d[k][n - 1] / i * j){
                                if (c == -1){
                                    c = -2;
                                    break;
                                }
                                if (c >= 0){
                                    c = 1;
                                }
                            }
                        }
                        if (c == -2){
                            l = -1;
                            break;
                        }
                        if (c <= 0){
                            l = m;
                        }else {
                            r = m;
                        }
                    }
                    if (l == -1){
                        f = false;
                        break;
                    }
                    if (l >= 0){
                        int t = 0;
                        for (int k = 0; k < 26; k++) {
                            if (d[k][l] != d[k][n - 1] / i * j){
                                t++;
                                break;
                            }
                        }
                        if (l != n - 1){
                            l++;
                            for (int k = 0; k < 26; k++) {
                                if (d[k][l] != d[k][n - 1] / i * j){
                                    t++;
                                    break;
                                }
                            }
                        }
                        if (t == 2){
                            f = false;
                        }
                    }
                }
                if (f){
                    out.print(i);
                    return;
                }
            }
        }
        out.print(1);
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
