import java.io.*;
import java.lang.reflect.Array;
import java.util.*;

public class Main {
    int gcd(int a, int b) {
        if (b == 0) return a;
        return gcd(b, a % b);
    }

    public void solve() throws IOException {
        String s = nextToken();
        int n = s.length();
        int[][] d = new int[2][n];
        int[] y = new int[n + 1];
        Arrays.fill(y,n - 1);
        for (int i = 0; i < n; i++) {
            if (i != 0){
                for (int j = 0; j < 2; j++) {
                    d[j][i] = d[j][i - 1];
                }
            }
            d[s.charAt(i) - 'a'][i]++;
            if (s.charAt(i) == 'a'){
                int h = d[s.charAt(i) - 'a'][i];
                y[h] = i;
            }
        }
        int x = 0;
        for (int i = 0; i < 2; i++) {
            x = gcd(x,d[i][n - 1]);
        }
        for (int i = x; i > 1; i--) {
            if (x % i == 0){
                boolean f = true;
                for (int j = 1; j < i; j++) {
                    int z = y[d[0][n - 1] / i * j];
                    if (d[1][z] > d[1][n - 1] / i * j || (d[1][z] < d[1][n - 1] / i * j && d[1][y[x / i * j + 1] - 1] < d[1][n - 1] / i * j)){
                        f = false;
                        break;
                    }
                }
                if (f){
                    out.print(i);
                    return;
                }
            }
        }
        out.print(1);
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
