#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <queue>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>

using namespace std;

typedef long long LL;

const int MAXN = 200500;

vector<int> g[MAXN];
int c[MAXN];

LL ans = 0;

struct SubRes {
  int size;
  LL min;
  LL sum;
  int id;
};

SubRes go(int v) {
  SubRes res{ -1, 0, 0, v };

  vector<SubRes> sons;
  sons.reserve(g[v].size());

  for (int to : g[v]) {
    sons.push_back(go(to));
  }

  int mxsize = 0, sumsize = 0, mxid = 0;

  for (auto s : sons) {
    ans += s.sum;
    if (s.size > mxsize) {
      mxsize = s.size;
      mxid = s.id;
    }
    sumsize += s.size;
  }

  if (mxsize * 2 > sumsize) {
    LL mne = (int)1e6;
    for (auto s : sons) {
      if (s.id != mxid) {
        mne = min(mne, s.min);
      }
    }
    ans += mne * (2 * mxsize - sumsize);
  }

  res.size = 1;
  res.min = c[v];
  res.sum = c[v];

  for (auto s : sons) {
    res.size += s.size;
    res.min = min(res.min, s.min);
    res.sum += s.sum;
  }

  return res;
}

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
#endif
  cin.tie(0);
  cin.sync_with_stdio(0);

  int n;
  cin >> n;

  for (int i = 2; i <= n; ++i) {
    int x;
    cin >> x;
    g[x].push_back(i);
  }

  for (int i = 2; i <= n; ++i) {
    cin >> c[i];
  }

  go(1);

  cout << ans << endl;
  
  return 0;
}