#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)
#define rand_int (abs((rand() << 15) | rand()))

typedef long long ll;
typedef long double ld;

const int BIG = 1e9 + 239;
const ll INF = 1e18;
const ld pi = acos(-1.0);
const ld eps = 1e-8;
const ll MOD = 1e9 + 7;
const int M = 2 * 1e5 + 239;
const int N = 2 * 1e3 + 239;
const int alf = 26;

vector<pair<int, int> > dvd(int n)
{
    vector<pair<int, int> > ans;
    int nn = n;
    for (int i = 2; i * i <= n; i++)
        if (nn % i == 0)
        {
            int kl = 0;
            while (nn % i == 0)
            {
                nn /= i;
                kl++;
            }
            ans.push_back(make_pair(i, kl));
        }
    if (nn != 1) ans.push_back(make_pair(nn, 1));
    return ans;
}

inline int gcd(int a, int b)
{
    return (a ? gcd(b % a, a) : b);
}

inline int power(int a, int k)
{
    int lt = 1;
    while (k > 0)
    {
        lt *= a;
        k--;
    }
    return lt;
}

int n;
string s;
int dt[alf];
int zs[alf];
vector<int> gd;

inline bool check(int d)
{
    for (int i = 0; i < alf; i++)
        zs[i] = 0;
    for (int i = 0; i < n; i++)
    {
        zs[s[i] - 'a']++;
        if ((i + 1) % d == 0)
        {
            for (int x : gd)
                if (((ll)zs[x] * (ll)n != (ll)dt[x] * (ll)(i + 1)))
                    return false;
        }
    }
    return true;
}

int main()
{   /*
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout); /**/
    cin.sync_with_stdio(0);
    getline(cin, s);
    n = s.size();
    if (n == 1)
    {
        cout << 1;
        return 0;
    }
    memset(dt, 0, sizeof(dt));
    for (int i = 0; i < n; i++)
        dt[s[i] - 'a']++;
    for (int i = 0; i < alf; i++)
        if (dt[i] != 0)
            gd.push_back(i);
    vector<pair<int, int> > p = dvd(n);
    int g = 1;
    int l, r, h;
    for (pair<int, int> t : p)
    {
        l = 0;
        r = t.second + 1;
        while (r - l > 1)
        {
            h = (l + r) >> 1;
            if (check(n / power(t.first, h)))
                l = h;
            else
                r = h;
        }
        g *= power(t.first, t.second - l);
    }
    if (g == 1)
    {
        cout << n;
        return 0;
    }
    for (int i = g; i <= n; i += g)
        if (n % i == 0 && check(i))
        {
            cout << n / i;
            return 0;
        }
    return 0;
}
