#include <bits/stdc++.h>

using namespace std;

#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)
#define rand_int (abs((rand() << 15) | rand()))

typedef long long ll;
typedef long double ld;

const int BIG = 1e9 + 239;
const ll INF = 1e18;
const ld pi = acos(-1.0);
const ld eps = 1e-8;
const ll MOD = 1e9 + 7;
const int M = 2 * 1e5 + 239;
const int N = 2 * 1e3 + 239;

vector<vector<int> > v(M);
ll c[M], ans, mn[M], sum[M], kol[M];
int n;

void dfs(int p)
{
    if (v[p].size() == 1) exit(239);
    kol[p] = 1;
    for (int i : v[p])
    {
        dfs(i);
        kol[p] += kol[i];
    }
    int kn = (kol[p] - 1);
    int mx = 0;
    for (int i : v[p])
        mx = max(mx, (int)kol[i]);
    if (2 * mx <= kn)
    {
        ans += 2 * ((kn + 1) / 2);
        return;
    }
    ans += 2 * mx;
}

int main()
{   //*
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout); /**/
    cin.sync_with_stdio(0);
    cin >> n;
    for (int i = 1; i < n; i++)
    {
        int p;
        cin >> p;
        p--;
        v[p].push_back(i);
    }
    for (int i = 1; i < n; i++)
        cin >> c[i];
    ans = 0;
    dfs(0);
    cout << ans;
    return 0;
}
