#include <bits/stdc++.h>

using namespace std;

#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)
#define rand_int (abs((rand() << 15) | rand()))

typedef long long ll;
typedef long double ld;

const int BIG = 1e9 + 239;
const ll INF = 1e18;
const ld pi = acos(-1.0);
const ld eps = 1e-8;
const ll MOD = 1e9 + 7;
const int M = 2 * 1e5 + 239;
const int N = 2 * 1e3 + 239;

vector<vector<int> > v(M);
ll c[M], ans, mn[M], sum[M], kol[M];
int n;

void dfs(int p)
{
    mn[p] = INF;
    sum[p] = c[p];
    kol[p] = 1;
    for (int i : v[p])
    {
        dfs(i);
        mn[p] = min(mn[p], mn[i]);
        sum[p] += sum[i];
        kol[p] += kol[i];
    }
    ll kn = (kol[p] - 1);
    ll mx = 0;
    for (int i : v[p])
        mx = max(mx, kol[i]);
    if (2LL * mx <= kn)
    {
        ans += sum[p] - c[p];
        if (kn & 1LL) ans += mn[p];
        mn[p] = min(mn[p], c[p]);
        return;
    }
    mn[p] = min(mn[p], c[p]);
    ans += sum[p] - c[p];
    ll iz = (2LL * mx - kn);
    ll t = INF;
    for (int i : v[p])
        if (kol[i] != mx)
            t = min(t, mn[i]);
    ans += t * iz;
}

int main()
{   //*
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout); /**/
    cin.sync_with_stdio(0);
    cin >> n;
    for (int i = 1; i < n; i++)
    {
        int p;
        cin >> p;
        p--;
        v[p].push_back(i);
    }
    for (int i = 1; i < n; i++)
        cin >> c[i];
    ans = 0;
    dfs(0);
    cout << ans;
    return 0;
}
