#include <iostream>
#include <vector>
#include <bitset>
#include <cassert>
#include <algorithm>
#include <map>
#include <set>
#pragma GCC optimize("O3")

using namespace std;
typedef unsigned int index;

int main()
{
    //assert(freopen("C:\\Users\\olymp\\Olymp\\a.in", "r", stdin));
    //assert(freopen("C:\\Users\\olymp\\Olymp\\a.out", "w", stdout));
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    vector<long long> base = {999611, 999613, 999623, 999631, 999653, 999667, 999671, 999683, 999721, 999727, 999749, 999763, 999769, 999773, 999809, 999853, 999863, 999883, 999907, 999917, 999931, 999953, 999959, 999961, 999979, 999983};
    string s;
    cin >> s;
    size_t n = s.size();
    vector<long long> pf(n + 1);
    for (index i = 0; i < n; i++)
        pf[i + 1] = pf[i] + base[s[i] - 'a'];
    for (size_t i = 1; i <= n; i++)
    {
        if (n % i == 0)
        {
            bool flag = true;
            for (index j = i; j < n; j += i)
            {
                if (pf[j + i] - pf[j] != pf[i])
                {
                    flag = false;
                    break;
                }
            }
            if (flag)
            {
                cout << n / i << endl;
                return 0;
            }
        }
    }
    assert(false);
}
