#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<set>
#include<climits>

using namespace std;

int bin_search(vector<pair<int, int> > &a, int ind)
{
	int r = a.size(), l = 0;
	while (r - l > 1)
	{
		int mid = (r + l) / 2;
		if (a[mid].second > ind)
			r = mid;
		else
			l = mid;
	}
	return a[l].first;
}

int main()
{
	string s;
	cin >> s;
	int n = s.size();
	vector<vector<pair<int, int> > > a(26, vector<pair<int, int> > (1, {0, -1}));
	for (int i = 0; i < n; ++i)
	{
		for (int j = 'a'; j <= 'z'; ++j)
		{
			if (s[i] == j)
				a[j - 'a'].push_back({a[j - 'a'].back().first + 1, i + 1});
		}
	}
	int maxim = 0;
	for (int i = 1; i * i <= n; ++i)
	{
		if (n % i == 0)
		{
			int cur = n / i;
			vector<int> curr(26);
			for (int k = 0; k < 26; ++k)
			{
				curr[k] = bin_search(a[k], cur);
			}
			int CNT = 1;
			for (int j = cur; j + cur < n + 1; j += cur)
			{
				int cnt = 0;
				for (int k = 0; k < 26; ++k)
				{
					if (bin_search(a[k], cur + j) - bin_search(a[k], j) == curr[k])
						++cnt;
				}
				if (cnt == 26)
					++CNT;
			}
			if (CNT == n / cur)
				maxim = max(maxim, n / cur);


			cur = n / cur;
			fill(curr.begin(), curr.end(), 0);
			for (int k = 0; k < 26; ++k)
			{
				curr[k] = bin_search(a[k], cur);
			}
			CNT = 1;
			for (int j = cur; j + cur < n + 1; j += cur)
			{
				int cnt = 0;
				for (int k = 0; k < 26; ++k)
				{
					if (bin_search(a[k], cur + j) - bin_search(a[k], j) == curr[k])
						++cnt;
				}
				if (cnt == 26)
					++CNT;
			}
			if (CNT == n / i)
				maxim = max(maxim, n / i);
		}
	}
	cout << maxim;
	//system("pause");
	return 0;
}