#ifndef LOCAL
    #pragma GCC optimize("Ofast")
    #pragma GCC target("sse,sse2,sse3,sse4")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>
#define ll long long
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define F first
#define S second
#define double long double
#define ld double
#define pii pair<int, int>

const int INF = INT_MAX / 2;
const ll LINF = 2e18 + 666, M = 1e9 + 7;
const ld EPS = 1e-10;

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

template<class T, class CMP = less<T>>
using ordered_set = tree<T, null_type, CMP, rb_tree_tag, tree_order_statistics_node_update>;

template<class T1, class T2>
bool mini(T1 &x, T2 y)
{
    if (x > y)
    {
        x = y;
        return 1;
    }
    return 0;
}

template<class T1, class T2>
bool maxi(T1 &x, T2 y)
{
    if (x < y)
    {
        x = y;
        return 1;
    }
    return 0;
}

void run();

int main()
{
    srand(time(0));
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(15) << fixed;
    auto start = clock();
    run();
    #ifdef LOCAL
        cout << "\ntime = " << (ld)(clock() - start) / CLOCKS_PER_SEC;
    #endif
}

#define DEBUG
#if defined DEBUG && defined LOCAL
    #define debugdo(x) x
#else
    #define debugdo(x)
#endif
#define debug(x) debugdo(cout << x << endl);
#define debug2(x) debugdo(cout << x << " ");

// ---SOLUTION--- //

vector<vector<int>> g;
vector<ll> s, m, c, sz;
ll ans = 0;

int dfs(int v)
{
    int sz = 1;
    vector<int> szx;
    s[v] = c[v];
    if (g[v].empty())
    {
        m[v] = c[v];
        return 1;
    }
    for (auto x: g[v])
    {
        int a = dfs(x);
        sz += a;
        szx.pb(a);
        s[v] += s[x];
        ans += s[x];
    }
    //sort(all(szx), greater<pii>());
    int q = 0, p = 0;
    vector<char> d((sz - 1) / 2 + 1);
    d[0] = 1;
    for (auto x: szx)
    {
        for (int i = (sz - 1) / 2 - x; i >= 0; i--)
        {
            if (d[i])
                d[i + x] = 1;
        }
    }
    for (int i = (sz - 1) / 2; i >= 0; i--)
    {
        if (d[i])
        {
            q = sz - 1 - i * 2;
            break;
        }
    }
    for (auto x: g[v])
    {
        if (x != p)
            mini(m[v], m[x]);
    }
    debug(v + 1 << " " << q);
    ans += (ll)q * m[v];
    mini(m[v], c[v]);
    return sz;
}

void run()
{
    int n;
    cin >> n;
    g.resize(n);
    s.resize(n);
    c.resize(n);
    c[0] = 1;
    m.resize(n, INF);
    for (int i = 1; i < n; i++)
    {
        int p;
        cin >> p;
        g[p - 1].pb(i);
    }
    for (int i = 1; i < n; i++)
        cin >> c[i];
    dfs(0);
    cout << ans;
}
/*
5
1 2 2 1
1 1 1 1

6
1 1 1 4 4
1 2 3 4 5

4
1 1 1
1 1 1
*/
