#include <bits/stdc++.h>
#define ll long long
#define F first
#define S second

using namespace std;

const int N=2e5+10;
const ll INF=1e18;

vector<int> e[N];
ll c[N], ans, s[N], sum[N], min1[N];
bool used[N];

void dfs(int v)
{

    used[v]=1; bool p=0;
    for (auto x: e[v]){
        if (!used[x]){
            dfs(x); p=1; ans+=sum[x];
        }
    }

    if (!p){
        s[v]=1; sum[v]=c[v]; min1[v]=c[v]; return;
    }

    priority_queue<int, vector<int>, less<int> > q;
    for (auto x: e[v]){
        q.push(s[x]);
    }

    while (q.size()>1){

        int max1=q.top(); q.pop();
        int max2=q.top(); q.pop();

        max1-=max2;

        if (max1!=0){
            q.push(max1);
        }

    }

    if (q.size()==1){
        ans+=q.top();
    }

    min1[v]=c[v];
    for (auto x: e[v]){
        sum[v]+=sum[x]; min1[v]=min(min1[v], min1[x]); s[v]+=s[x];
    }
    sum[v]+=c[v]; s[v]++;

    //cout<<v<<" "<<ans<<"\n";

}

int main()
{

    ios_base::sync_with_stdio(0);

    int n;
    cin>>n;

    for (int i=2; i<=n; i++){
        int p;
        cin>>p;
        e[p].push_back(i);
    }

    for (int i=2; i<=n; i++){
        cin>>c[i];
    }

    dfs(1);

    cout<<ans<<"\n";

    return 0;
}
