#include <iostream>
#include <algorithm>
#include <vector>
#include <fstream>
#include <queue>
#include <string>

using namespace std;

#define int long long

const int maxn = 2e5 + 88;
const long long infll = 1e18 + 88;


long long ans = 0;
vector<int> g[maxn];
int sz[maxn], mn[maxn], c[maxn], sum[maxn];

void dfs(int v, int p)
{
    sz[v] = 1;
    mn[v] = c[v];
    sum[v] += c[v];
    for (int i = 0; i < g[v].size(); i++)
        if (g[v][i] != p)
        {
            dfs(g[v][i], v);
            sz[v] += sz[g[v][i]];
            mn[v] = min(mn[g[v][i]], mn[v]);
            ans += sum[g[v][i]];
            sum[v] += sum[g[v][i]];
        }
    int check = -1, curmn = infll;
    for (int i = 0; i < g[v].size(); i++)
        if (g[v][i] != p)
            if (2*sz[g[v][i]] >= sz[v])
                check = sz[g[v][i]];
            else
                curmn = min(curmn, mn[g[v][i]]);
    if (check != -1)
    {
        ans += 1ll*curmn*(2*check - sz[v] + 1);
        return;
    }
    if (sz[v]%2 == 0)
        ans += curmn;
}

#undef int

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    ifstream cin("input.txt");
    int n, i, p;
    cin >> n;
    for (i = 1; i < n; i++)
    {
        cin >> p;
        p--;
        g[p].push_back(i);
    }
    for (i = 1; i < n; i++)
        cin >> c[i];
    dfs(0, 0);
    cout << ans;
    return 0;
}
