//
// Created by olymp on 09.03.2018.
//
//
// Created by olymp on 09.03.2018.
//
#include <iostream>
#include <string>
#include <vector>

const int SIZE = 'z' - 'a' + 1;

std::string s;

struct Sum{
    int cnt[SIZE];
    Sum() {
        for (int i = 0; i < SIZE; ++i) {
            cnt[i] = 0;
        }
    }

    bool operator==(const Sum &other) {
        for (int i = 0; i < SIZE; ++i) {
            if (cnt[i] != other.cnt[i]) {
                return false;
            }
        }
        return true;
    }
};

bool check(int len) {
    Sum val;
    for (int i = 0; i < len; ++i) {
        val.cnt[s[i] - 'a'] += 1;
    }
    for (int i = len; i < s.size(); i += len) {
        Sum val2;
        for (int j = i; j < i + len; ++j) {
            val2.cnt[s[j] - 'a'] += 1;
        }
        if (!(val == val2)) {
            return false;
        }
    }
    return true;
}

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cin >> s;
    for (int i = 1; i <= s.size(); ++i) {
        if (s.size() % i == 0) {
            if (check(i)) {
                std::cout << s.size() / i;
                return 0;
            }
        }
    }
    return 0;
}
