//
// Created by olymp on 09.03.2018.
//
//
// Created by olymp on 09.03.2018.
//
#include <iostream>
#include <string>
#include <vector>
#include <unordered_map>

const int SIZE = 'z' - 'a' + 1;

std::string s;

bool check(int len) {
    std::unordered_map<char, int> val;
    for (int i = 0; i < len; ++i) {
        val[s[i] - 'a'] += 1;
    }
    for (int i = len; i < s.size(); i += len) {
        std::unordered_map<char, int> val2;
        for (int j = i; j < i + len; ++j) {
            val2[s[j] - 'a'] += 1;
        }
        for (auto k : val) {
            if (k.second != val2[k.first]) {
                return false;
            }
        }
    }
    return true;
}

int GCD(int a, int b) {
    return (b ? GCD(b, a % b) : a);
}

int ch[SIZE];

int main() {
    bool flag = 1;
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cin >> s;
    for (int i = 0; i < s.size(); ++i) {
        ch[s[i] - 'a'] += 1;
    }
    int gcd = 0;
    for (int i = 0; i < SIZE; ++i) {
        gcd = GCD(gcd, ch[i]);
    }
    for (int i = 1; i < s.size() && flag; ++i) {
        if (s[i] != s[i - 1]) {
            flag = false;
        }
    }
    if (flag) {
        std::cout << s.size();
        return 0;
    }
    for (int i = 2; i <= s.size(); ++i) {
        if (s.size() % i == 0) {
            if ((gcd % (s.size() / i) == 0) && check(i)) {
                std::cout << s.size() / i;
                return 0;
            }
        }
    }
    return 0;
}
