#include <iostream>
#include <math.h>
#include <vector>
#include <algorithm>
using namespace std;

int main()
{
    string s;
    cin >> s;
    int n = s.length();
    vector<int> chk;
    int K = count(s.begin(), s.end(), 'a') + count(s.begin(), s.end(), 'b') == n ? 2 : 26;
    if (count(s.begin(), s.end(), s[0]) == n)
    {
        cout << n;
        return 0;
    }
    int gans[K];
    for (int i = 0; i < K; ++i)
        gans[i] = count(s.begin(), s.end(), 'a'+i);
    for (int i = 2; i < sqrt(n); ++i)
    {
        if (n % i)
            continue;
        bool h = true;
        for (int j = 0; j < K && h; ++j)
            h &= gans[j] % i == 0;
        if (h)
            chk.push_back(n / i);
        h = true;
        for (int j = 0; j < K && h; ++j)
            h &= gans[j] % (n / i) == 0;
        if (h)
            chk.push_back(i);
    }
    int d = sqrt(n);
    bool h = d * d == n;
    for (int i = 0; i < K && h; ++i)
        h &= gans[i] % d == 0;
    if (h)
        chk.push_back(sqrt(n));
    sort(chk.begin(), chk.end());
    for (int l: chk)
    {
        bool h = true;
        int ans[K];
        for (int i = 0; i < K; ++i)
            ans[i] = count(s.begin(), s.begin() + l, 'a'+i);
        for (int i = l; i < n && h; i += l)
            for (int j = 0; j < K && h; ++j)
                h &= count(s.begin() + i, s.begin() + i + l, 'a'+j) == ans[j];
        if (h)
        {
            cout << n / l;
            return 0;
        }
    }
    cout << 1;
    return 0;
}
