// ConsoleApplication1.cpp: определяет точку входа для консольного приложения.
#include <stdio.h>
#include <iostream>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <bitset>
typedef long long ll;
typedef long double db;
using namespace std;
#define fs first
#define sc second
#define endl '\n'
#define sz(g) int(g.size())
#define all(g) (g.begin()),(g.end())
#define mp make_pair
#define int ll

vector<vector<int>> Edge;
vector<int> c;
int ans = 0;


struct Node {
	int sum, minn, col;
	Node(int ss, int mm, int cc) :sum(ss), minn(mm), col(cc) {}
};

Node dfs(int v) {
	set<int> s;
	set<int> w;
	int sum = 0;
	int col = 0;
	for (int i = 0; i < Edge[v].size(); i++) {
		Node res = dfs(Edge[v][i]);
		sum += res.sum;
		col += res.col;
		s.insert(res.col);
		w.insert(res.minn);
	}
	if (s.size() == 0)
		return Node(c[v], c[v], 1);
	int del = 0;
	if (col - *s.rbegin() >= *s.rbegin())
		del += sum + (col % 2 == 1 ? *w.begin() : 0);
	else
		del += sum + (*s.rbegin() * 2 - col)*(*w.begin());
	ans += del;
	return Node(sum + c[v], min(c[v], *w.begin()), col + 1);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	Edge.resize(n);
	c.resize(n);
	for (int i = 1; i < n; i++) {
		int p;
		cin >> p;
		p--;
		Edge[p].push_back(i);
	}
	c[0] = 0;
	for (int i = 1; i < n; i++)
		cin >> c[i];
	dfs(0);
	cout << ans << endl;
#ifdef _MSC_VER
	system("pause");
#endif
	return 0;
}


/*
const int siz = 5e6 + 5;
int alp[siz][2];

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	string s;
	cin >> s;
	int n = s.size();
	if (n <= 5e5) {
		vector<int> del;
		for (int i = 1; i*i <= n; i++) {
			if (n%i == 0) {
				del.push_back(i);
				del.push_back(n / i);
			}
		}
		sort(all(del));
		del.resize(unique(all(del)) - del.begin());
		for (int i = 0; i < del.size(); i++) {
			int ans = n / del[i];
			vector<int> al(26, 0);
			bool answ = true;
			for (int j = 0; j < del[i]; j++) {
				al[s[j] - 'a']++;
			}
			for (int j = 1; j < ans; j++) {
				vector<int> al1(26, 0);
				for (int e = j * del[i]; e < (j + 1)*del[i]; e++) {
					al1[s[e] - 'a']++;
				}
				if (al1 != al) {
					answ = false;
					break;
				}
			}
			if (answ) {
				cout << ans << endl;
				return 0;
			}
		}
	}
	else {
		vector<int> del;
		for (int i = 1; i*i <= n; i++) {
			if (n%i == 0) {
				del.push_back(i);
				del.push_back(n / i);
			}
		}
		alp[0][0] = 0;
		alp[0][1] = 0;
		for (int i = 0; i < s.size(); i++) {
			alp[i + 1][0] = alp[i][0];
			alp[i + 1][1] = alp[i][1];
			alp[i + 1][s[i] - 'a']++;
		}
		sort(all(del));
		del.resize(unique(all(del)) - del.begin());
		for (int i = 0; i < del.size(); i++) {
			int ans = n / del[i];
			int al[2];
			al[0] = alp[del[i]][0];
			al[1] = alp[del[i]][1];
			bool answ = true;
			for (int j = 1; j < ans; j++) {
				vector<int> al1(26, 0);
				al1[0] = alp[del[i] * (j + 1)][0] - alp[del[i] * (j)][0];
				al1[1] = alp[del[i] * (j + 1)][1] - alp[del[i] * (j)][1];
				if (al1[0] != al[0] || al1[1] != al[1]) {
					answ = false;
					break;
				}
			}
			if (answ) {
				cout << ans << endl;
				return 0;
			}
		}
	}
#ifdef _MSC_VER
	system("pause");
#endif
	return 0;
}
*/
/*
const int max_n = 1 << 17;
struct Node {
    int x;
    Node(int xx = 0) :x(xx) {}
    Node operator +(Node d) {
        return Node(x + d.x);
    }
};

struct Segment_Tree {
#define tm (tl+tr)/2
    vector<Node> t;
    Segment_Tree() {
        t.resize(max_n * 2, Node());
    }
    void add(int l, int r, int res) {
        add_el(0, max_n - 1, l, r, 1, res);
    }
    int get(int l, int r) {
        get_seg(0, max_n - 1, l, r, 1);
    }
    void add_el(int tl, int tr, int l, int r, int v,int res) {
        if (tl > r || tr < l)
            return;
        if (tl >= l && tr <= r) {
            t[v].x += res;
            return;
        }
        add_el(tl, tm, l, r, v * 2, res);
        add_el(tm + 1, tr, l, r, v * 2 + 1, res);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
    int get_seg(int tl, int tr, int l, int r, int v) {
        if (tl > r || tr < l)
            return 0;
        if (tl >= l && tr <= r)
            return t[v].x;
        return get_seg(tl, tm, l, r, v * 2) + get_seg(tm + 1, tr, l, r, v * 2 + 1);
    }
#undef tm
};
*/
