//4324320

#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <cstring>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <ctime>
#include <algorithm>
#include <math.h>
#include <cmath>
//#include <corecrt_math.h>

#pragma warning (disable : 4996)

using namespace std;

const int MAXN = 3e3 + 10;
const double EPS = 1e-6;

struct point {
	double x, y;

	point() {}

	point(double x, double y){
		this->x = x;
		this->y = y;
	}

	friend bool operator != (const point p1, const point p2) {
		return fabs(p1.x - p2.x) > EPS || fabs(p1.y - p2.y) > EPS;
	}

	friend bool operator == (const point p1, const point p2) {
		return !(p1 != p2);
	}
};

struct line {
	double a, b, c;

	line() {}

	line(double a, double b, double c) {
		this->a = a;
		this->b = b;
		this->c = c;
	}

	line(const point p1, const point p2) {
		this->a = p1.y - p2.y;
		this->b = p2.x - p1.x;
		this->c = -p2.x * p1.y + p2.y * p1.x;
	}
};

point intersection(line l1, line l2) {
	point ans;
	ans.x = (l1.c * l2.b - l2.c * l1.b) / (l1.b * l2.a - l1.a * l2.b);
	ans.y = (l2.c * l1.a - l1.c * l2.a) / (l1.b * l2.a - l1.a * l2.b);
	return ans;
}

istream & operator >> (istream &cin, point &p) {
	cin >> p.x >> p.y;
	return cin;
}

int n;
point ps[MAXN];

int main() {
	#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif
	/*#ifndef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif*/

	cin >> n;
	for (int i = 0; i < n * 2; i++) {
		cin >> ps[i];
	}
	for (int aa = 0; aa < n * 2; aa++) {
		for (int ab = 0; ab < n * 2; ab++) {
			for (int ba = 0; ba < n * 2; ba++) {
				for (int bb = 0; bb < n * 2; bb++) {
					if (aa != ab && aa != ba && aa != bb && ab != ba && ab != bb && ba != bb) {
						line l1 = line(ps[aa], ps[ab]);
						line l2 = line(ps[ba], ps[bb]);
						if (fabs(l1.b * l2.a - l1.a * l2.b) > EPS) {
							point p = intersection(l1, l2);
							if (fabs(p.x - round(p.x + EPS)) < EPS && fabs(p.y - round(p.y + EPS)) < EPS) {
								if (p != ps[aa] && p != ps[ab] && p != ps[ba] && p != ps[bb]) {
									cout << "Yes\n";
									cout << round(p.x + EPS) << " " << round(p.y + EPS);
									return 0;
								}
							}
							//cout << p.x << " " << p.y << "\n";
						}
						
					}
				}
			}
		}
	}
	cout << "No\n";
}