#include <iostream>
#include <vector>
#include <list>
#include <deque>
#include <iomanip>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <set>
#include <map>
#include <functional>
#include <string>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;
typedef vector<bool> vb;
typedef vector<double> vd;
typedef vector<ld> vld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define it(v) v.begin(), v.end()
#define fst first
#define scn second
#define mp make_pair
#define pb push_back 
#define eb emplace_back

const int inf = 1e9 + 9;
const int mod = 1e9 + 7;
const ll linf = 1e18 + 1;

vector<vi> g;
vi par, sz, mn, col;
ll res = 0;

void dfs(int pos)
{
    set<pii> kek;
    for (auto i : g[pos])
    {
        dfs(i);
        sz[pos] += sz[i];
        res += sz[i];
        kek.emplace(sz[i], i);
    }
    while (kek.size() > 1)
    {
        pii a = *kek.rbegin();
        kek.erase(a);
        pii b = *kek.rbegin();
        kek.erase(b);
        if (a.fst != b.fst)
        {
            kek.emplace(a.fst - b.fst, a.scn);
        }
    }
    if (kek.empty())
    {
        return;
    }
    res += kek.begin()->fst;
}

signed main()
{
    int n;
    cin >> n;
    g.assign(n, vi());
    par.assign(n, -1);
    for (int i = 0; i < n - 1; i++)
    {
        int p;
        cin >> p;
        p--;
        g[p].pb(i + 1);
        par[i + 1] = p;
    }
    sz.assign(n, 1);
    col.assign(n, 0);
    for (int i = 0; i < n - 1; i++)
    {
        cin >> col[i + 1];
    }
    dfs(0);
    cout << res;
}

