#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

int n;
string s;

map<char, int> mp;
map<char, int> need;

bool check(int x)
{
    need.clear();
    for (int i = 0; i < x; i++)
        need[s[i]]++;
    mp.clear();
    for (int i = x; i < n; i++) {
        if (i % x == 0 && i != x) {
            for (auto h : mp) {
                if (h.second != need[h.first])
                    return false;
            }
            mp.clear();
        }
        mp[s[i]]++;
    }
    for (auto h : mp) {
        if (h.second != need[h.first])
            return false;
    }
    mp.clear();
    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> s;
    n = s.size();
    int res = n;
    for (int i = 1; i * i <= n; i++) {
        if (n % i == 0) {
            if (check(i))
                res = min(res, i);
            if (check(n / i))
                res = min(res, n / i);
        }
    }
    cout << n / res;
    return 0;
}
