#include <bits/stdc++.h>

#define int long long
#define forn(i, a, b) for (int i = a; i < b; ++i)
#define ford(i, a, b) for (int i = a; i > b; --i)
#define fs first
#define sc second
#define mp(x, y) make_pair(x, y)
#define pb(x) push_back(x)
#define sz(x) (int)x.size()
#define len(x) (int)x.length()
#define pii pair<int, int>
#define vi vector<int>
#define vvi vector<vi>
#define ios ios_base::sync_with_stdio(false); cin.tie(0)
using namespace std;

vvi pref;
int n;
vi get(int l, int r) {
    vi right = pref[r + 1];
    vi left = pref[l];
    vi res(26, 0);
    forn(i, 0, 26)
        res[i] = right[i] - left[i];
    return res;
}

bool check(int m) {
    if (n % m) return 0;
    int step = n / m;
    vi ch = get(0, step - 1);
    forn(i, 0, sz(ch))
        cerr << ch[i] << ' ';
    cerr << endl;
    for (int i = m; i < n; i += step) {
        vi now = get(i, i + step - 1);
        forn(i, 0, sz(now))
            cerr << now[i] << ' ';
        cerr << endl;
        if (now != ch) return 0;
    }
    return 1;
}

signed main()
{

    ios;
    string s;
    cin >> s;
    n = len(s);
    pref.resize(n + 2);
    pref[0] = vi(26, 0);
    forn(i, 0, n) {
        int cur = s[i] - 'a';
        pref[i + 1] = pref[i];
        pref[i + 1][cur]++;
    }

    int l = 1, r = n;
    while(r - l > 1) {
        int m = (r + l) / 2;
        if (check(m)) l = m;
        else r = m;
    }
    /*
    forn(i, 0, sz(pref)) {

        forn(j, 0, sz(pref[i]))
            cerr << pref[i][j] << ' ';
        cerr << endl << endl;
    }
    cerr << check(3) << endl;
*/
    cout << l << endl;


    return 0;
}
