#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

bool check(string & s, int sz) {
    int need[26] = {};
    for (int i = 0; i < sz; ++i) {
        need[s[i] - 'a']++;
    }
    int l = 0;
    while (l < s.size()) {
        int r = l + sz - 1;
        int cur[26] = {};
        for (int i = l; i <= r; ++i) {
            cur[s[i] - 'a']++;
        }
        for (int i = 0; i < 26; ++i) {
            if (cur[i] != need[i])
                return false;
        }
        l = r + 1;
    }
    return true;
}

bool fastCheck(string & s, vector<vector<int> > & cnt, int sz) {
    int l = 0;
    while (l < s.size()) {
        int r = l + sz;
        for (int i = 0; i < 2; ++i) {
            if (cnt[i][r] - cnt[i][l] != cnt[i][sz])
                return false;
        }
        l = r;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    string s;
    cin >> s;
    int n = (int)s.size();
    if ((int)s.size() > (int)5e5) {
        vector<vector<int> > cnt(2, vector<int> (5e6 + 5, 0));
        for (int i = 0; i < s.size(); ++i) {
            cnt[0][i + 1] += cnt[0][i];
            cnt[1][i + 1] += cnt[1][i];
            cnt[s[i] - 'a'][i + 1]++;
        }
        int ans = 1;
        for (int i = 1; i * i <= n; ++i) if (n % i == 0) {
            if (fastCheck(s, cnt, i)) {
                ans = n / i;
                break;
            }
            if (fastCheck(s, cnt, n / i)) {
                ans = max(ans, i);
            }
        }
        cout << ans;
        return 0;
    }
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] < 'a' || s[i] > 'z') {
            assert(0);
        }
    }
    int ans = 1;
    for (int i = 1; i * i <= n; ++i) if (n % i == 0) {
        if (check(s, i)) {
            ans = n / i;
            break;
        }
        if (check(s, n / i)) {
            ans = max(ans, i);
        }
    }
    cout << ans;
    return 0;
}
