#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <string>
#include <vector>
#include <random>
#include <ctime>
#include <iostream>
#include <algorithm>

using namespace std;

#define X first
#define Y second

const int MAXN = 5000100, ALF = 26;

string s;
int n, sh;

int kol[MAXN];
bool used[ALF];

set<int> w;
vector<int> uda;

void solve(int buk)
{
	kol[0] = 0;
	for (int i = 0; i < n; i++)
	{
		if (i)
			kol[i] = kol[i - 1];
		if (s[i] - 'a' == buk)
			kol[i]++;
	}
	for (int i : w)
	{
		sh = (i + 1);
		if ((kol[i] == 0) 
			|| (kol[n - 1] % kol[i] != 0)
			|| (kol[n - 1] / kol[i] != n / sh))
		{
			uda.push_back(i);
			continue;
		}
		for (int j = sh; j < n; j += sh)
		{
			if (kol[j + sh - 1] - kol[j - 1] != kol[i])
			{
				uda.push_back(i);
				break;
			}
		}
	}
	while (uda.size())
	{
		w.erase(uda.back());
		uda.pop_back();
	}
}

int main()
{
#if _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin >> s;
	n = s.size();
	for (int i = 0; i < n; i++)
	{
		if(n % (i + 1) == 0)
			w.insert(i);
		used[s[i] - 'a'] = true;
	}
	for (int buk = 0; buk < ALF; buk++)
	{
		if(used[buk])
			solve(buk);
	}
	cout << n / ((*w.begin()) + 1);
	return 0;
}