#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <string>
#include <vector>
#include <random>
#include <ctime>
#include <iostream>
#include <algorithm>

using namespace std;

#define X first
#define Y second

const int MAXN = 5000100, ALF = 26;
string s;
int n;
bool used[ALF];
set<int> w;
int kol[MAXN];
vector<int> uda;

bool chek(int &tec, int sh)
{
	if (tec == 0)
		return false;
	if ((kol[n - 1] % tec == 0)
		&& (kol[n - 1] / tec == n / sh))
		return true;
	return false;
}

bool cok(int &tec, int sh)
{
	for (int i = sh; i < n; i += sh)
	{
		if (kol[i + sh - 1] - kol[i - 1] != tec)
			return false;
	}
	return true;
}

void solve(int buk)
{
	kol[0] = 0;
	for (int i = 0; i < n; i++)
	{
		if (i)
			kol[i] = kol[i - 1];
		if (s[i] - 'a' == buk)
			kol[i]++;
	}
	for (int i : w)
	{
		if (!chek(kol[i], i + 1))
		{
			uda.push_back(i);
			continue;
		}
		if (!cok(kol[i], i + 1))
		{
			uda.push_back(i);
			continue;
		}
	}
	while (uda.size())
	{
		w.erase(uda.back());
		uda.pop_back();
	}
}

int main()
{
#if _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin >> s;
	n = s.size();
	for (int i = 0; i < n; i++)
	{
		if (n % (i + 1) == 0)
			w.insert(i);
		used[s[i] - 'a'] = true;
	}
	for (int buk = 0; buk < ALF; buk++)
	{
		if (used[buk])
			solve(buk);
	}
	cout << n / ((*w.begin()) + 1);
	return 0;
}