#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INF = 1e9;

vector <vector <int> > gr;
vector <int> val;
vector <int> minn, sz, sum;
int ans = 0;

void dfs(int v) {
    minn[v] = val[v];
    sum[v] = val[v];
    sz[v] = 1;
    if (gr[v].size() == 0) return;
    int id = 0, child_sz = 0;
    for (int i : gr[v]) {
        dfs(i);
        minn[v] = min(minn[v], minn[i]);
        sum[v] += sum[i];
        sz[v] += sz[i];
        if (sz[i] > child_sz) {
            child_sz = sz[i];
            id = i;
        }
    }
    if (child_sz * 2 > sz[v] - 1) {
        int m = INF;
        for (int i : gr[v]) {
            if (i != id) m = min(m, minn[i]);
        }
        int r = sz[v] - 1 - child_sz;
        ans += sum[v] - val[v] + m * (child_sz - r);
    } else {
        ans += sum[v] - val[v];
    }
}

signed main()
{
    int n;
    cin >> n;
    gr.resize(n);
    val.resize(n, 0);
    minn.resize(n);
    sz.resize(n);
    sum.resize(n);
    for (int i = 1; i < n; i++) {
        int u;
        cin >> u;
        u--;
        gr[u].push_back(i);
    }
    for (int i = 1; i < n; i++) {
        cin >> val[i];
    }
    dfs(0);
    cout << ans;
    return 0;
}
