#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int INF = 1e9 + 7;
const int MAXN = 5e6 + 7;
const double EPS = 1e-6;
const int Q = 31;

string s;
int n;

vector <int> d(MAXN, -1);
vector <int> p;

void init() {
    for (int i = 2; i < MAXN; i++) {
        if (d[i] == -1) {
            p.push_back(i);
            d[i] = p.size() - 1;
        }
        for (int j = 0; j <= d[i]; j++) {
            if (i * p[j] >= MAXN) break;
            d[i * p[j]] = j;
        }
    }
}

inline bool check(int len) {
    if (n % len) {
        return false;
    }
    vector <int> cnt(Q, 0);
    for (int i = 0; i < len; i++) {
        cnt[s[i] - 'a']++;
    }
    for (int st = len; st < n; st += len) {
        vector <int> cnt1(Q, 0);
        for (int i = 0; i < len; i++) {
            int k = s[st + i] - 'a';
            cnt1[k]++;
            if (cnt1[k] > cnt[k]) {
                return false;
            }
        }
    }
    return true;
}

void solve1() {
    for (int len = 1; len <= n; len++) {
        if (check(len)) {
            cout << n / len << "\n";
            return;
        }
    }
}

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif // MY
    init();
    cin >> s;
    n = s.size();
//    if (n <= 500000) {
//        solve1();
//        return 0;
//    }
    vector <bool> can(n + 1, true);
    for (int len = 1; len <= n; len++) {
        if (n % len) {
            can[len] = false;
        }
    }
    for (int j = 0; j < Q; j++) {
        //auto &mas = a[j];
        vector <int> pref(n + 1, 0);
        for (int i = 0; i < n; i++) {
            pref[i + 1] = pref[i];
            if (s[i] - 'a' == j) {
                pref[i + 1]++;
            }
        }
        for (int len = 1; len <= n; len++) {
            if (!can[len]) {
                continue;
            }
            for (int i = len; i < n; i += len) {
                if (pref[len] + pref[i] != pref[i + len]) {
                    can[len] = false;
                    break;
                }
            }
        }

    }
    for (int i = 1; i <= n; i++) {
        if (can[i]) {
            cout << n / i << "\n";
            return 0;
        }
    }
}
