#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define A(x) get<0>(x)
#define B(x) get<1>(x)
#define C(x) get<2>(x)
#define D(x) get<3>(x)

#define X first
#define Y second
#define mp make_pair
#define mt make_tuple
#define all(x) (x).begin(), (x).end()

#ifdef REK
#define dbg(...) cout << __VA_ARGS__
#define stddbg(...) printf(__VA_ARGS__)
#else
#define dbg(...) ((void) 0)
#define stddbg(...) ((void) 0)
#endif

constexpr ll MOD = 1000000007;
mt19937 rnd (228);
constexpr ld pi = acos(-1.0);

inline void boost() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
}

constexpr int N = 500005;


struct taskA {
	vector<int> mul;

	int ps [26][N];
	bitset<N> computed;
	int n, nn;

	bool check(int m) {
		for (int i = 2; i <= nn/m; i++) {
			for (int j = 0; j < 26; j++) {
				if (ps[j][i*m] - ps[j][(i-1)*m] != ps[j][(i-1)*m] - ps[j][(i-2)*m]) {
					return false;
				}
				dbg(ps[j][i*m] - ps[j][(i-1)*m] << endl);
				dbg(ps[j][(i-1)*m] - ps[j][(i-2)*m] << endl);
			}
		}

		return true;
	}

	void solve(const string &s) {

		computed.reset();
		memset(ps, 0, sizeof(int) * 26 * N);
		n = nn = (int) s.size();
		int ans = nn;

		for (int i = 1; i <= n; i++) {
			for (int j = 0; j < 26; j++) {
				ps[j][i] = ps[j][i-1];
			}
			ps[s[i-1]-'a'][i]++;
		}

		for (int i = 2; i*i <= n; i++) {
			while (n % i == 0) {
				n /= i;
				mul.push_back(i);
			}
		}
		if (n > 1) mul.push_back(n);

		for (int i = 0; i < (1 << (int) mul.size()); i++) {
			int m = 1;

			for (int j = 0; j < (int) mul.size(); j++) {
				if (i & (1 << j)) {
					m *= mul[j];
				}
			}

			if (!computed[m]) {
				auto b = check(m);
				computed[b] = true;
				if (b)
				ans = min(ans, m);
			}
		}

		cout << nn / ans << endl;
	}
};

struct taskA {
	vector<int> mul;

	int ps [2][5000005];
	bitset<5000005> computed;
	int n, nn;

	bool check(int m) {
		for (int i = 2; i <= nn/m; i++) {
			for (int j = 0; j < 2; j++) {
				if (ps[j][i*m] - ps[j][(i-1)*m] != ps[j][(i-1)*m] - ps[j][(i-2)*m]) {
					return false;
				}
				dbg(ps[j][i*m] - ps[j][(i-1)*m] << endl);
				dbg(ps[j][(i-1)*m] - ps[j][(i-2)*m] << endl);
			}
		}

		return true;
	}

	void solve(const string &s) {

		computed.reset();
		memset(ps, 0, sizeof(int) * 2 * 5000005);
		n = nn = (int) s.size();
		int ans = nn;

		for (int i = 1; i <= n; i++) {
			for (int j = 0; j < 2; j++) {
				ps[j][i] = ps[j][i-1];
			}
			ps[s[i-1]-'a'][i]++;
		}

		for (int i = 2; i*i <= n; i++) {
			while (n % i == 0) {
				n /= i;
				mul.push_back(i);
			}
		}
		if (n > 1) mul.push_back(n);

		for (int i = 0; i < (1 << (int) mul.size()); i++) {
			int m = 1;

			for (int j = 0; j < (int) mul.size(); j++) {
				if (i & (1 << j)) {
					m *= mul[j];
				}
			}

			if (!computed[m]) {
				auto b = check(m);
				computed[b] = true;
				if (b)
				ans = min(ans, m);
			}
		}

		cout << nn / ans << endl;
	}
};

int main(void) {
	boost();

	string s;
	cin >> s;

	bool ab_only = true;

	for (char c : s) {
		if (c != 'a' && c != 'b') {
			ab_only = false;
			break;
		}
	}

	if (ab_only) {
		(new taskB())->solve(s);
	} else {
		(new taskA())->solve(s);
	}

	return 0;
}