#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define A(x) get<0>(x)
#define B(x) get<1>(x)
#define C(x) get<2>(x)
#define D(x) get<3>(x)

#define X first
#define Y second
#define mp make_pair
#define mt make_tuple
#define all(x) (x).begin(), (x).end()

#ifdef REK
#define dbg(...) cout << __VA_ARGS__
#define stddbg(...) printf(__VA_ARGS__)
#else
#define dbg(...) ((void) 0)
#define stddbg(...) ((void) 0)
#endif

constexpr ll MOD = 1000000007;
mt19937 rnd (228);
constexpr ld pi = acos(-1.0);

inline void boost() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
}

ll ans;

constexpr int N = 200005;
vector<int> adj [N];
int val [N];

tuple<int, int, ll> dfs(int v) {

	int cnt = 0;
	multiset<int> mn_s;

	int total_mn = val[v];
	ll sm = 0;

	for (int u : adj[v]) {
		auto res = dfs(u);
		cnt += B(res);
		sm += C(res);
		
		mn_s.insert(A(res));
	}

	if (mn_s.size() > 1) {
		ans += sm;
		if (mn_s.size() % 2 == 1) {
			ans += *mn_s.begin();
		}
	}

	if (mn_s.size() > 0)
		total_mn = min(total_mn, *(mn_s.begin()));

	return mt(total_mn, cnt, sm+val[v]);
}

int main(void) {
	int n;
	scanf("%d", &n);

	for (int i = 2; i <= n; i++) {
		int p;
		scanf("%d", &p);

		adj[p].push_back(i);
	}

	for (int i = 2; i <= n; i++) {
		int c;
		scanf("%d", &c);
		val[i] = c;
	}

	auto res = dfs(1);

	printf("%" PRId64 "\n", ans);

	return 0;
}