#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <time.h>
#include <random>
#include <algorithm>

using namespace std;
#define int long long

signed main() {
    ios_base::sync_with_stdio(false);
    freopen("input.txt", "r", stdin);

    int n;
    cin >> n;

    int q;
    cin >> q;

    for (int i = 0; i < q; ++i) {
        int p;
        cin >> p;

        if (p % 2) {
            cout << (p + 1) / 2 << '\n';
            continue;
        }

        p = n - p;

        int l = -1;
        int r = n - 1;
        while (l < r - 1) {
            int m = (l + r) / 2;

            if (m * 2 + 1 <= n - 2) {
                l = m;
                continue;
            }

            int curr = 2 * m + 2 - n;
            if (curr < p) {
                l = m;
            }
            else {
                r = m;
            }
        }

        while (r % 2 && r != 1) {
            r /= 2;
        }
        r /= 2;

        cout << n - r << '\n';
    }

    return 0;
}