#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <time.h>
#include <random>
#include <algorithm>

using namespace std;

const int MAXN1 = 5e5 + 7;
const int MAXC1 = 26;
const int MAXN2 = 5e6 + 7;
const int MAXC2 = 2;

int pref1[MAXN1][MAXC1];
int pref2[MAXN2][MAXC2];

signed main() {
    ios_base::sync_with_stdio(false);
    freopen("input.txt", "r", stdin);

    string s;
    cin >> s;
    int n = s.size();

    bool ch = true;
    for (char c : s) {
        ch &= (c == 'a' || c == 'b');
    }

    if (!ch) {
        for (int i = 0; i < n; ++i) {
            for (int c = 0; c < MAXC1; ++c) {
                pref1[i + 1][c] = pref1[i][c];
            }
            ++pref1[i + 1][s[i] - 'a'];
        }

        for (int len = 1; len <= n; ++len) {
            if (n % len == 0) {
                bool check = true;

                for (int l = len; l <= n; l += len) {
                    for (int c = 0; c < MAXC1; ++c) {
                        check &= (pref1[l][c] - pref1[l - len][c] == pref1[len][c]);
                    }
                }

                if (check) {
                    cout << n / len << '\n';
                    return 0;
                }
            }
        }
    }
    else {
        for (int i = 0; i < n; ++i) {
            for (int c = 0; c < MAXC2; ++c) {
                pref2[i + 1][c] = pref2[i][c];
            }
            ++pref2[i + 1][s[i] - 'a'];
        }

        for (int len = 1; len <= n; ++len) {
            if (n % len == 0) {
                bool check = true;

                for (int l = len; l <= n; l += len) {
                    for (int c = 0; c < MAXC2; ++c) {
                        check &= (pref2[l][c] - pref2[l - len][c] == pref2[len][c]);
                    }
                }

                if (check) {
                    cout << n / len << '\n';
                    return 0;
                }
            }
        }
    }
    

    return 0;
}