#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <time.h>
#include <random>
#include <algorithm>

using namespace std;
#define int long long

const int MAXN = 2e5 + 7;

vector <int> g[MAXN];

int ans = 0;
int c[MAXN];
int cnt[MAXN];

void dfs(int u, int parent) {
    cnt[u] = 1;
    for (int v : g[u]) {
        if (v == parent) continue;
        
        dfs(v, u);
        cnt[u] += cnt[v];
    }

    int counter = 0;
    for (int v : g[u]) {
        if (v == parent) continue;
        else ++counter;
    }
    if (!counter) return;

    int mx = -1;
    for (int v : g[u]) {
        if (v == parent) continue;
        if (mx == -1 || cnt[mx] < cnt[v]) mx = v;
    }

    int sum = 0;
    for (int v : g[u]) {
        if (v == parent) continue;
        if (v != mx) sum += cnt[v];
    }

    int k = cnt[u] - 1;
    if (cnt[mx] <= sum) {
        ans += k + (k % 2);
    }
    else {
        ans += 2 * cnt[mx];
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    freopen("input.txt", "r", stdin);

    int n;
    cin >> n;

    for (int i = 1; i < n; ++i) {
        int v;
        cin >> v;
        --v;
        g[i].push_back(v);
        g[v].push_back(i);
    }

    for (int i = 1; i < n; ++i) cin >> c[i];

    dfs(0, -1);

    cout << ans << '\n';
    return 0;
}