#include <bits/stdc++.h>
using namespace std;

#define fst first
#define snd second
#define mp make_pair
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template <typename T1, typename T2>
bool umax(T1& x, const T2& y) {return x<y ? x=y, true : false;}

template <typename T1, typename T2>
bool umin(T1& x, const T2& y) {return x>y ? x=y, true : false;}

template <typename T>
void read(T& x) {
    char ch;
    T p = 1; x = 0;
    do {ch = getchar();} while (ch <= ' ');
    if (ch == '-') p = -1, ch = getchar();
    while ('0' <= ch && ch <= '9') {
        x = x*10+ch-'0';
        ch = getchar();
    }
    x = (p == -1 ? -x : x);
}

void read(char &ch) {
    do {ch = getchar();} while (ch <= ' ');
}

void read(string& x) {
    char ch; x = "";
    do {ch = getchar();} while (ch <= ' ');
    while(ch > ' ') x += ch, ch = getchar();
}

template<typename T, typename... R>
void read(T& x, R&... y) {read(x); read(y...);}

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef long double ld;

const int N = (int)1e6+3;
const int INF = (int)1e9+17;
const ll LLINF = (ll)1e18+17;


int n, q;
ll a[N];
ll mn[N];
ll cnt[N];
ll sum[N];
ll res;
vector<int> g[N];


void dfs(int v, int p) {
    mn[v] = a[v];
    for(int to:g[v]) {
        if (to == p) continue;
        dfs(to, v);
        cnt[v] += cnt[to];
        sum[v] += sum[to]+a[to];
        umin(mn[v], min(mn[to], a[to]));
    }
    sort(all(g[v]), [&](int x, int y){
        if (cnt[x] > cnt[y]) return true;
        else if (cnt[y] > cnt[x]) return false;
        return mn[x] < mn[y];
    });
    vector<ll> pref(g[v].size(), 1);
    vector<ll> suff(g[v].size(), 1);
//    rep(i, 0, g[v].size()) {
//        pref[i] = mn[g[v][i]];
//        if (i > 0) umin(pref[i], pref[i-1]);
//    }
//    per(i, 0, g[v].size()) {
//        suff[i] = mn[g[v][i]];
//        if (i < g[v].size()-1) umin(suff[i], mn[g[v][i]]);
//    }
    int r = 1;
//    assert(g[v].size() != 1);
    rep(i, 0, g[v].size()) {
        int to = g[v][i];
        while (r <= i) ++r;
        while (r < g[v].size()) {
            ll x = min(cnt[to], cnt[g[v][r]]);
            cnt[to] -= x;
            cnt[g[v][r]] -= x;
            if (x == 0) ++r;
            if (cnt[to] == 0) break;
        }
        if (cnt[to] > 0) {
            ll add = LLINF;
            if (i > 0) umin(add, pref[i-1]);
            if (i < g[v].size()-1) umin(add, suff[i+1]);
            res += add * cnt[to];
            cnt[to] = 0;
            assert(add < LLINF);
        }
    }
    ++cnt[v];
    res += sum[v];
}

int main()
{
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr), cout.tie(nullptr);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    read(n);
    rep(i, 1, n) {
        int x;
        read(x);
        g[--x].push_back(i);
    }
    rep(i, 1, n) read(a[i]);
    dfs(0, 0);
    printf("%lld\n", res);

    return 0;
}
