#include <iostream>
#include <fstream>
#include <vector>
using namespace std;

#define pb push_back
#define pii pair<int, int>
#define mp make_pair
#define fi first
#define se second
#define llong long long
#define ullong unsigned long long
#define dlong long double
#define endl '\n'

vector<int> g[200500];
int cost[200500];

llong ans;
int dfs(int v, int p=-1) { /// returns size
    vector<int> child;
    for (int i=0; i<g[v].size(); i++) {
        int to = g[v][i];
        if (to != p)
            child.pb(dfs(to, v));
    }
    int cnt = 0;
    for (int i=0; i<child.size(); i++)
        cnt += child[i];

    if (child.empty()) return cnt+1;
    if (child.size() == 1) return cnt+1;

    int l = 0;
    int r = child.size()-1;
    while (l<r) {
        if (child[l] < child[r]) {
            ans += 2ll*child[l];
            child[r]-=child[l];
            l++;
        } else if (child[l] > child[r]) {
            ans += 2ll*child[r];
            child[l]-=child[r];
            r--;
        } else { /// child[l] == child[r]
            ans += 2ll*child[l];
            l++; r--;
        }
    }
    if (l==r) ans += 2ll*child[l];

    return cnt+1;
}

int main()
{
    ios_base::sync_with_stdio(false);
    ifstream fin("input.txt");
    ofstream fout("output.txt");

    int n; fin >> n;
    int p;
    for (int i=1; i<n; i++) {
        fin >> p; p--;
        g[p].pb(i);
        g[i].pb(p);
    }
    cost[0] = 0;
    for (int i=1; i<n; i++)
        fin >> cost[i]; /// all are 1 (LOL!)

    ans = 0;
    dfs(0);
    fout << ans;

    fin.close();
    fout.close();
    return 0;
}
