#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

#define pb push_back
#define pii pair<int, int>
#define mp make_pair
#define fi first
#define se second
#define llong long long
#define ullong unsigned long long
#define dlong long double
#define endl '\n'

const llong inf = 2*1e18 + 2018;

vector<int> g[200500];
int cost[200500];
int _size_[200500];

llong ans;
int dfs(int v, int p=-1) { /// returns sizes
    vector<int> child;
    int go;
    for (int i=0; i<g[v].size(); i++) {
        int to = g[v][i];
        if (to != p) {
            child.pb(dfs(to, v));
            go = to;
        }
    }
    int cnt = 0;
    for (int i=0; i<child.size(); i++)
        cnt += child[i];

    if (!child.empty()) {
        if (child.size() == 1) {
            ans += 2ll*(_size_[go]-1);
            _size_[v] = _size_[go] + 1;
            return _size_[v];
        }

        llong best = inf;
        llong cur;
        for (int i=0; i<child.size(); i++) {
            swap(child[child.size()/2], child[i]);

            cur = 0;
            int l = 0;
            int r = child.size()-1;
            while (l<r) {
                if (child[l] < child[r]) {
                    cur += 2ll*child[l];
                    child[r]-=child[l];
                    l++;
                } else if (child[l] > child[r]) {
                    cur += 2ll*child[r];
                    child[l]-=child[r];
                    r--;
                } else { /// child[l] == child[r]
                    cur += 2ll*child[l];
                    l++; r--;
                }
            }
            if (l==r) cur += 2ll*child[l];

            best = min(best, cur);
            swap(child[child.size()/2], child[i]);
        }
        ans += best;
    }

    _size_[v] = cnt+1;
    return _size_[v];
}

int main()
{
    ios_base::sync_with_stdio(false);
    ifstream fin("input.txt");
    ofstream fout("output.txt");

    int n; fin >> n;
    int p;
    for (int i=1; i<n; i++) {
        fin >> p; p--;
        g[p].pb(i);
        g[i].pb(p);
    }
    cost[0] = 0;
    for (int i=1; i<n; i++)
        fin >> cost[i]; /// all are 1 (LOL!)

    ans = 0;
    dfs(0);
    fout << ans;

    fin.close();
    fout.close();
    return 0;
}
