#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <stdlib.h>
using namespace std;

#define pb push_back
#define pii pair<int, int>
#define mp make_pair
#define fi first
#define se second
#define llong long long
#define ullong unsigned long long
#define dlong long double
#define endl '\n'

vector<int> g[200500];
int cost[200500];
int _size_[200500];

int dp[2010][2010];

bool compare(int a, int b) {return a>b;}

llong ans;
int dfs(int v, int p=-1) { /// returns sizes
    vector<int> child;
    int go;
    for (int i=0; i<g[v].size(); i++) {
        int to = g[v][i];
        if (to != p) {
            child.pb(dfs(to, v));
            go = to;
        }
    }
    int cnt = 0;
    for (int i=0; i<child.size(); i++)
        cnt += child[i];

    if (!child.empty()) {
        if (child.size() == 1) {
            ans += 2ll*(_size_[go]-1);
            _size_[v] = _size_[go] + 1;
            return _size_[v];
        }

        int _sz_ = child.size();
        for (int i=0; i<_sz_; i++)
            for (int j=0; j<=cnt; j++)
                dp[i][j] = 0;

        dp[0][0] = 1;
            dp[0][child[0]] = 1;
        for (int i=1; i<child.size(); i++) {
            for (int j=0; j<=cnt; j++) {
                if (dp[i-1][j])
                    dp[i][j] = 1;
                if (dp[i-1][j-child[i]])
                    dp[i][j] = 1;
            }
        }

        int ind = cnt/2;
        while (!dp[child.size()-1][ind]) ind--;

        int odd = cnt-ind;
        ans += 2ll*min(ind, odd);
        ans += 2ll*abs(ind-odd);
    }

    _size_[v] = cnt+1;
    return _size_[v];
}

int main()
{
    ios_base::sync_with_stdio(false);
    ifstream fin("input.txt");
    ofstream fout("output.txt");

    int n; fin >> n;
    int p;
    for (int i=1; i<n; i++) {
        fin >> p; p--;
        g[p].pb(i);
        g[i].pb(p);
    }
    cost[0] = 0;
    for (int i=1; i<n; i++)
        fin >> cost[i]; /// all are 1 (LOL!)

    ans = 0;
    dfs(0);
    fout << ans;

    fin.close();
    fout.close();
    return 0;
}
