#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#define FOR(i, n) for (int i = 0; i < n; ++i)
typedef long long ll;

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::string s;
	std::cin >> s;
	ll n = s.size();
	std::set<ll> del;
	for (ll i = 1; i * i <= n; ++i) {
		if (n % i == 0) {
			del.insert(i);
			del.insert(n / i);
		}
	}
	std::vector<int> symb[26];
	std::vector<int> cnt(26);
	FOR(i, s.size()) {
		symb[s[i] - 'a'].push_back(i);
	}
	for (auto d : del) {
		bool fl = false;
		FOR(j, 26) {
			if (symb[j].size() == 0) {
				continue;
			}
			auto now = symb[j].begin();
			ll cur = 0;
			if (symb[j].size() % (n / d) != 0) {
				fl = true;
				break;
			}
			ll per = symb[j].size() / (n / d);
			while (cur < n) {
				auto it = std::upper_bound(symb[j].begin(), symb[j].end(), cur + d - 1);
				if (it - now != per) {
					fl = true;
					break;
				}
				cur += d;
				now = (it);
			}
			if (fl) {
				break;
			}
		}
		if (!fl) {
			std::cout << n / d;
			return 0;
		}
	}
	return 0;
}