#include <iostream>
#include <string>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

string s;

int n, as = 0;

vector <int> ds;

vector <vector<int> > pc;

vector <int> gc, cc;

bool check(int l){
    for (int j = 0; j < as; j++){
        gc[j] = pc[l][j] - pc[0][j];
    }
    for (int i = 2 * l; i <= n; i += l){
        for (int j = 0; j < as; j++){
            cc[j] = pc[i][j] - pc[i - l][j];
            if (cc[j] != gc[j]){
                return false;
            }
        }
    }
    return true;
}

int main() {
    ios::sync_with_stdio(0);
    cin >> s;
    n = s.length();
    pc.resize(n + 1);
    for (int i = 0; i < n; i++){
        as = max(as, s[i] - 'a');
    }
    for (int i = 0; i < pc.size(); i++){
        pc[i].resize(as);
    }
    gc.resize(as);
    cc.resize(as);
    s = '#' + s;
    for (int i = 1; i <= n; i++){
        for (int j = 0; j < as; j++){
            pc[i][j] = pc[i - 1][j];
        }
        pc[i][s[i] - 'a']++;
    }
    for (int i = 1; i <= sqrt(n); i++){
        if (n % i == 0){
            ds.push_back(i);
            ds.push_back(n / i);
        }
    }
    sort(ds.begin(), ds.end());
    //reverse(ds.begin(), ds.end());
    for (int i = 0; i < ds.size(); i++){
        if (check(ds[i])){
            cout << n / ds[i];
            return 0;
        }
    }
    return 0;
}