#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

#define all (x).begin(), (x).end()
#define pb push_back
#define ft first
#define st second
#define forn(i, n) for(int i = 0;i < n;i++)
#define int long long
// FAST READ
inline long long readInt(){
	ll read = getchar(), sign = 1, x = 0;
	while (read != '-' && (read < '0' || read > '9')) read = getchar();
	if (read == '-') sign = -1, read = getchar();
	while (read >= '0' && read <= '9') x = 10 * x + read - '0', read = getchar();
	return x * sign;
}

inline void writeInt(long long x){
	if (x < 0) putchar('-'), x = -x;
	long long reverse = 0;
	do{
		reverse = reverse * 10 + (x % 10);
		x /= 10;
	} while (x > 0);
	do{
		putchar(reverse % 10 + '0');
		reverse /= 10;
	} while(reverse > 0);
}
//END FAST READ

struct Solver{
	int n = 0;
	vector<vector<int>> g;
	vector<int> dp, sum, c, sz;
	int dfs(int v, int p = -1){
		sz[v] = 1;
		sum[v] = c[v];
		vector<pii> need, ost;
		int mn = INT_MAX, mn1 = INT_MAX, ind = -1;
		for (int u : g[v]) if (u != p) need.pb({u, c[u]});
		for (int u : g[v]){
			if (u == p) continue;
			int tmo = dfs(u, v);
			if (tmo < mn){
				mn1 = mn;
				ind = u;
				mn = tmo;
			}
			else if (tmo < mn1){
				mn1 = tmo;
			}
			dp[v] += dp[u] + sum[u];
			sum[v] += sum[u];
			sz[v] += sz[u];
			int tmp = sz[u];
			while (need.size() && tmp > 1){
				if (need.back().ft == u){
					if (need.size() == 1) break;
					pii tmp = need.back();
					need.pop_back();
					need.pop_back();
					need.pb(tmp);
				}
				else need.pop_back();
				tmp--;
			}
			if (tmp == 1) continue;
			ost.pb({u, tmp});
		}
//		cout << v << ' ' << dp[v] << '\n';
//		for (auto i : ost){
//			cout << i.ft << ' ' << i.st << '\n';
//		}
//		cout << "need\n";
//		for (auto i : need){
//			cout << i.ft << ' ' << i.st << '\n';
//		}
		bool f = 1;
		if (need.size() & 1)
		for (auto i : need){
			if (i.ft == ind){
				continue;
			}
			else dp[v] += mn;
			f = 0;
			break;
		}
		if (need.size() == 1 && f){
			dp[v] += mn1;
		}
		for (auto& i : ost) i.st--;
		while (ost.size() > 1){
			auto tp = ost.back();
			ost.pop_back();
			auto tp1 = ost.back();
			ost.pop_back();
			if (tp.st < tp1.st) swap(tp, tp1);
			if (tp.st - tp1.st != 0) ost.pb({tp.ft, tp.st - tp1.st});
		}
		if (!ost.size()) return min(mn, c[v]);
		if (ost.back().ft == ind){
			dp[v] += mn1 * ost.back().st;
		}
		else dp[v] += mn * ost.back().st;
		return min(mn, c[v]);
	}

	Solver() {
		cin >> n;
		g.resize(n);
		sz.resize(n);
		sum.resize(n);
		c.resize(n);
		dp.resize(n);

		for (int i = 1;i < n;i++){
			int p;
			cin >> p;
			g[--p].pb(i);
			g[i].pb(p);
		}
		for (int i = 1;i < n;i++) cin >> c[i];
		dfs(0);
//		for (auto i : dp) cout << i << ' ';
//		cout << '\n';
//		for (auto i : sz) cout << i << ' ';
//		cout << '\n';
		cout << dp[0] << '\n';

	}
};

signed main(){
	int t = 1;
#ifdef LOCAL

	assert(freopen("input.txt", "r", stdin));
	cin >> t;
#else
	ios_base::sync_with_stdio(0);
	cout.tie(0);
#endif
	while(t--){
#ifdef LOCAL
		clock_t gg = clock();
#endif
		Solver a = Solver();
#ifdef LOCAL
		cout << setprecision(5) << fixed <<"Elapsed " << fabs(gg - clock()) / CLOCKS_PER_SEC << " sec.\n";
#endif
	}
}

