#include <bits/stdc++.h>

using namespace std;

long long n, t;
vector<vector<long long>> children;
vector<long long> c;
vector<long long> ss, mn, mn2, cnt, tin, tout;

void upd(long long v, long long u) {
    bool ok = false;
    if (mn[v] == -1 || (c[mn[u]] < c[mn[v]])) {
        mn2[v] = mn[v];
        mn[v] = mn[u];
        ok = true;
    }
    if (mn[v] == -1 || (c[u] < c[mn[v]])) {
        mn2[v] = mn[v];
        mn[v] = u;
        ok = true;
    }
    if (ok) return;
    if (mn2[v] == -1 || (c[mn[u]] < c[mn2[v]])) {
        mn2[v] = mn[u];
    }
    if (mn2[v] == -1 || (c[u] < c[mn2[v]])) {
        mn2[v] = u;
    }
}

void build(long long v) {
    tin[v] = ++t;
    ss[v] = c[v];
    mn[v] = -1;
    mn2[v] = -1;
    cnt[v] = 1;

    for (long long u : children[v]) {
        build(u);
        ss[v] += ss[u];
        cnt[v] += cnt[u];
        upd(v, u);
    }
    tout[v] = ++t;
}

bool isparent(long long parent, long long child) {
    return tin[parent] < tin[child] && tout[parent] > tout[child];
}

long long solve(long long v) {
    long long ans = 0;
    long long ind = 0;
    long long indm = 0;
    for (long long u : children[v]) {
        bool f = isparent(u, mn[v]) || (u == mn[v]);
        if (f) {
            indm = cnt[u] - 1;
            break;
        }
    }
    for (long long u : children[v]) {
        ans += solve(u);
        ans += ss[u];
        if (isparent(u, mn[v]) || (u == mn[v])) continue;
        long long x = cnt[u];
        if (x < indm) {
            indm -= x;
            x = 0;
        } else {
            x -= indm;
            indm = 0;
        }
        if (x < ind) {
            ind -= x;
        } else {
            ind = x - ind;
        }
    }
    if (ind > 0)
        ind--;
    else
        indm++;
    if (mn[v] != -1) {
        ans += ind * c[mn[v]];
    }
    if (mn2[v] != -1) {
        ans += indm * c[mn2[v]];
    }
    return ans;
}

long long solve2(long long v) {
    long long ind = 0;
    long long ans = 0;
    vector<long long> xx;
    for (long long u : children[v]) {
        xx.push_back(cnt[u]);
    }
    for (long long u : children[v]) {
        ans += solve2(u);
        ans += ss[u];
    }
    sort(xx.rbegin(), xx.rend());
    for (auto x : xx) {
        if (x > ind) {
            ind = x - ind;
        } else {
            ind -= x;
        }
    }
    ans += ind;
    return ans;
}

int main() {
    t = 0;
    cin >> n;
    children.resize(n);
    ss.resize(n);
    mn.resize(n);
    mn2.resize(n);
    c.resize(n);
    cnt.resize(n);
    tin.resize(n);
    tout.resize(n);
    for (long long i = 1; i < n; ++i) {
        long long p;
        cin >> p;
        children[p - 1].push_back(i);
    }
    bool ones = true;
    for (long long i = 1; i < n; ++i) {
        cin >> c[i];
        if (c[i] != 1) ones = false;
    }

    build(0);
    if (ones)
        cout << solve2(0) << endl;
    else
        cout << solve(0) << endl;

    return 0;
}