#include <bits/stdc++.h>

#define pb push_back
#define pp pop_back
#define sz(x) x.size()
#define all(x) x.begin(), x.end()
#define per(i, a, b) for(int i = a; i <= b; ++i)
#define rep(i, a, b) for(int i = a; i >= b; --i)
#define F first
#define S second
#define mp make_pair
#define FL v + v, tl, tm
#define FR v + v + 1, tm + 1, tr

using namespace std;

template <typename T> T sqr (T a) {return a * a;}
template <typename T> 
void parr (T *a, int start, int end, bool error = 0) {
	if (error) {
		per (i, start, end)
			cerr << a[i] << ' ';
		cerr << endl;
	}
	else {
		per (i, start, end) 
			cout << a[i] << ' ';
		cout << endl;
	}
}
template <typename T> void view(T var) {cerr << " ---> " << var << " <--- " << endl;}
template <typename T> T bpow(T a, int power) {
	T res = 1;
	while (power) {
		if (power & 1) res = (res * a);
		a = (a * a);
		power >>= 1;
	}
	return res;
}
void setpr(int a) {
	cout.fixed;
	cout.precision(a);
	cerr.fixed;
	cerr.precision(a);
}

typedef long long ll;
typedef unsigned long long ull;

typedef pair< int, int > pii;
                                 
const int N = (int)2e5 + 10;
const int inf = (int)1e9;
const ll INF = (ll)1e18;
const long double pi = acos(-1.0);
const double eps = 1e-7;

int n, q, cnt, pos;
int a[N];

set < int > s;

struct seg_tree {
	int t[4 * N];

	void build (int v = 1, int tl = 1, int tr = n) {
		if (tl == tr) {
			t[v] = 1;
			return;
		}
		int tm = (tl + tr) >> 1;
		build(FL), build(FR);
		t[v] = t[v + v] + t[v + v + 1];
	}
	void upd (int pos, int v = 1, int tl = 1, int tr = n) {
		if (tl == tr) {
			t[v] = 0;
			return;
		}
		int tm = (tl + tr) >> 1;
		if (pos <= tm) upd(pos, FL);
		else upd(pos, FR);
		t[v] = t[v + v] + t[v + v + 1];
	}
	int get (int l, int r, int v = 1, int tl = 1, int tr = n) {
		if (l <= tl && tr <= r) return t[v];
		if (tr < l || r < tl) return 0;
		int tm = (tl + tr) >> 1;
		return get(l, r, FL) + get(l, r, FR);
	}
	int getk (int k, int v = 1, int tl = 1, int tr = n) {
		if (tl == tr) return tl;
		int tm = (tl + tr) >> 1;
		if (t[v + v] >= k) return getk(k, FL);
		else return getk(k - t[v + v], FR);
	}
} T;


int main() {
	freopen ("input.txt", "r", stdin);
	freopen ("output.txt", "w", stdout);
	cin >> n;
	T.build ();
	cnt = 1;
	pos = 1;
	while (cnt <= n) {
		a[pos] = cnt++;
		T.upd(pos);
		int counterr = T.get (pos + 1, n);
		int counterl = T.get (1, pos);
		//cerr << pos << ' ' << counterl << ' ' << counterr << endl;
		if (counterr < 2) {
			if (counterr == 1 || T.t[1] == 1) {
				pos = T.getk (1);
			}
			else {
				pos = T.getk (2);
			}
		}
		else {
			pos = T.getk (counterl + 2);
		}
	}
	//parr(a, 1, n, 1);
	//cout << endl;
	cin >> q;
	while (q--) {
		int x;
		cin >> x;
		cout << a[x] << endl;
	} 
}