#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define p_b push_back
#define m_p make_pair
#define endl '\n'

typedef long long ll;
typedef long double ld;

#ifndef LOCAL
    #define cerr if(0)cerr
#endif // LOCAL

random_device rd;
mt19937_64 rnd(rd());

const int N = 200000;
vector < int > g[N];
ll depth[N], a[N];
ll cnt[N], mn[N];
ll under[N];
ll ans = 0;

void precalc(int v) {
    cnt[v] = 1;
    under[v] = a[v];
    mn[v] = a[v];
    for (int to : g[v]) {
        cnt[v] += cnt[to];
        under[v] += under[to];
        mn[v] = min(mn[v], mn[to]);
    }
}

void solve(int v) {
    if (g[v].empty()) return;
    vector < ll > szs;
    ll sum = 0, mx = 0;
    for (int to : g[v]) {
        szs.p_b(cnt[to]);
        sum += cnt[to];
        mx = max(mx, cnt[to]);
    }
    ans += under[v] - a[v];
    if (sum - mx < mx) {
        ll myId;
        for (int to : g[v]) if (cnt[to] == mx) myId = to;
        ll curMin = INT_MAX;
        for (int to : g[v]) {
            if (to == myId) continue;
            curMin = min(curMin, mn[to]);
        }
        ans += 1ll * curMin * (mx - (sum - mx));
    }
    else {
        if (sum & 1) {
            int curMin[2] = {INT_MAX, INT_MAX};
            for (int to : g[v]) {
                if (mn[to] < curMin[0]) {
                    curMin[1] = curMin[0];
                    curMin[0] = mn[to];
                }
                else if (mn[to] < curMin[1]) {
                    curMin[1] = mn[to];
                }
            }
            ans += curMin[0];
        }
        else return;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n;
    cin >> n;
    vector < pair < int, int > > order;
    order.p_b({0, 0});
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        x--;
        g[x].p_b(i);
        depth[i] = depth[x] + 1;
        order.p_b({depth[i], i});
    }
    for (int i = 1; i < n; i++) cin >> a[i];
    sort(order.rbegin(), order.rend());
    for (auto x : order) precalc(x.ss);
    for (auto x : order) solve(x.ss);
    cout << ans << endl;
}
