// #pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define len(v) ((int)v.size())
#define pb push_back

typedef long long ll;
typedef long double ld;

using namespace std;

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b)
{
	if (a > b)
	{
		a = b;
		return false;
	}
	return true;
}

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b)
{
	if (a < b)
	{
		a = b;
		return false;
	}
	return true;
}

void run();

int main()
{
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

void run()
{
	int n;
	cin >> n;
	vector<vector<int>> pos(n);
	vector<int> p(n, -1), mn(n, 1000000000), cnt(n, 0), c(n, 0);
	vector<ll> sm(n, 0);
	for (int i = 1; i < n; ++i)
	{
		cin >> p[i];
		--p[i];
		pos[p[i]].pb(i);
	}
	for (int i = 1; i < n; ++i)
		cin >> c[i];
	for (int i = n - 1; i > -1; --i)
	{
		sm[i] += c[i];
		cmin(mn[i], c[i]);
		++cnt[i];
		if (i > 0)
		{
			sm[p[i]] += sm[i];
			cnt[p[i]] += cnt[i];
			cmin(mn[p[i]], mn[i]);
		}
	}
	ll ans = 0;
	for (int i = 0; i < n; ++i)
	{
		if (!len(pos[i]))
			continue;
		assert(len(pos[i]) > 1);
		sort(all(pos[i]), [&mn](const int &a, const int &b){
			return mn[a] < mn[b];
		});
		ans += sm[i] - c[i];
		bool found = false;
		for (auto &x : pos[i])
			if (cnt[x] > cnt[i] - cnt[x] - 1)
			{
				found = true;
				if (x == pos[i].front())
					ans += 1LL * mn[pos[i][1]] * (2 * cnt[x] + 1 - cnt[i]);
				else
					ans += 1LL * mn[pos[i].front()] * (2 * cnt[x] + 1 - cnt[i]);
			}
		if (cnt[i] % 2 == 0 && !found)
			ans += mn[pos[i].front()];
	}
	cout << ans << endl;
}