// d2t3.cpp: определяет точку входа для консольного приложения.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>

using namespace std;

const long double EPS = 1e-9;

int main()
{
	long long n;
	cin >> n;
	n *= 2;
	vector<pair<long double, long double> > dots(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> dots[i].first >> dots[i].second;
	}
	bool flageq = 0;
	for (long long n1 = 0; n1 < n; n1++)
	{
		for (long long n2 = n1 + 1; n2 < n; n2++)
		{
			for (long long n3 = 0; n3 < n; n3++)
			{
				if (n3 == n2 || n3 == n1)
					continue;
				for (long long n4 = n3 + 1; n4 < n; n4++)
				{
					if (n4 == n2 || n4 == n1)
						continue;
					vector<long double> dts;
					pair<long double, long double> moon;
					long double k1 = (dots[n1].second - dots[n2].second) / (dots[n1].first - dots[n2].first + EPS);
					long double k2 = (dots[n3].second - dots[n4].second) / (dots[n3].first - dots[n4].first + EPS);
					long double b1 = dots[n1].second - k1 * dots[n1].first;
					long double b2 = dots[n3].second - k2 * dots[n3].first;
					if (k1 == k2)
					{
						if (b1 == b2)
						{
							cout << "No";
							cin >> n;
							return 0;
						}
					}
					moon.first = (b2 - b1) / (k1 - k2);
					moon.second = moon.first * k1 + b1;
					pair<long long, long long> tmp = moon;
					if (tmp.first + EPS < moon.first)
						tmp.first++;
					if (tmp.second + EPS < moon.second)
						tmp.second++;
					flageq = 1;
					bool flagch = 0;
					for (long long i = 0; i < n; i++)
					{
						pair<long long, long long> t_cmp = dots[i];
						if (tmp == t_cmp)
						{
							flagch = 1;
							break;
						}
					}
					if (flagch)
						continue;
					if (tmp.first + EPS >= moon.first && tmp.first - EPS <= moon.first && tmp.second + EPS >= moon.second && tmp.second - EPS <= tmp.second)
					{
						for (long long i = 0; i < n; i++)
						{
							if (i != n1 && i != n2 && i != n3 && i != n4)
							{
								dts.push_back((dots[i].second - moon.second) / (dots[i].first - moon.first + EPS));
							}
						}
						sort(dts.begin(), dts.end());
						bool flag = 0;
						for (long long i = 0; i < dts.size(); i += 2)
						{
							if (dts[i] != dts[i + 1])
							{
								flag = 1;
							}
						}
						if (!flag)
						{
							cout << "Yes" << endl;
							cout << tmp.first << " " << tmp.second;
							cin >> n;
							return 0;
						}
					}
				}
			}
		}
	}
	if (!flageq)
	{
		cout << "Yes" << endl;
		pair<long double, long double> s1 = { -1, -1 };
		for (long long i = 0; i < n; i++)
		{
			if (s1.first == -1 || s1.first > dots[i].first)
			{
				s1 = dots[i];
			}
		}
		if (s1 == dots[0])
		{
			cout << s1.first - (dots[1].first - s1.first) << " " << s1.second - (dots[1].second - s1.second);
		}
		else
		{
			cout << s1.first - (dots[0].first - s1.first) << " " << s1.second - (dots[0].second - s1.second);
		}
	}
	else
	{
		cout << "No";
	}
	cin >> n;
    return 0;
}

