#include <bits/stdc++.h>
#define x first
#define y second
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
#define ll long long
#define db double
using namespace std;

const int p1 = 31;
const int p2 = 5000007;
const int mod1 = 1e9 + 7;
const int mod2 = 1e9 + 9;

string s;
int pref1[5000007];
int pref2[5000007];
int step1[26];
int step2[26];


bool ok(int val){
	int len = s.size() / val;
	int f1 = pref1[len];
	int f2 = pref2[len];
 
	for (int i = 2 * len; i <= s.size(); i += len){
		int d1 = pref1[i] - pref1[i - len];
		int d2 = pref2[i] - pref2[i - len];
		if (d1 < 0) d1 += mod1;
		if (d2 < 0) d2 += mod2;
		if (f1 != d1 || f2 != d2) return 0;
	}

	return 1;
}

int main(){
 	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0); cin.tie(0);
	cin >> s;

	step1[0] = step2[0] = 1;

	for (int i = 1; i < 26; i++){
		step1[i] = step1[i - 1] * (ll)p1 % mod1;
		step2[i] = step2[i - 1] * (ll)p2 % mod2;
	}
	
	for (int i = 1; i <= s.size(); i++){
		pref1[i] = pref1[i - 1] + step1[s[i - 1] - 'a'];
		pref2[i] = pref2[i - 1] + step2[s[i - 1] - 'a'];
		if (pref1[i] >= mod1) pref1[i] -= mod1;
		if (pref2[i] >= mod2) pref2[i] -= mod2;
	}

	int ans = 1;
	vector<int> t;
	for (int i = 1; i * i <= s.size(); i++) if (s.size() % i == 0){
		t.pb(i);
		t.pb(s.size() / i);
	}
	sort(all(t));
	for (int i = (int)t.size() - 1; i >= 0; i--) if (ok(t[i])){
		ans = t[i];
		break;
	}
	cout << ans;
}
