#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<string>
#include<set>
#include<map>
#include<iomanip>

using namespace std;

string s;
vector < long long > perebor;
vector < vector < long long > > psum;

long long get_sum(int l, int r,	vector < long long > sum) {
	if (l == 0) {
		return sum[r];
	}
	return sum[r] - sum[l - 1];
}

bool check(int len) {
	if (len == s.size()) {
		return true;
	}
	vector < long long > cnt(26, 0);
	for (int i = 0; i < 26; i++) {
		cnt[i] = get_sum(0, len - 1, psum[i]);
	}
	for (int i = 0; i < s.size() / len; i++) {
		for (int j = 0; j < 26; j++) {
			long long temp = get_sum(len * i, len*i + len - 1, psum[j]);
			if (temp != cnt[j]) return false;
		}
	}
	return true;
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	cin >> s;
	
	vector < long long > cnt(26, 0);

	for (int i = 0; i < s.size(); i++) {
		cnt[s[i] - 'a']++;
	}


	set < long long > ver;

	for (int i = 0; i < 26; i++) {
		set < long long > now;
		if (cnt[i] == 0) continue;

		long long z = cnt[i];
		for (int j = 1; j <= sqrt(z); j++) {
			if (z % j == 0) {
				now.insert(j);
				now.insert(z / j);
			}
		}
		if (ver.size() == 0) {
			ver = now;
			continue;
		}
		set < long long > temp;
		temp = ver;

		for (auto elem : ver) {
			if (now.find(elem) == now.end()) {
				temp.insert(elem);
			}
		}
		ver = temp;
	}

	for (int i = 1; i <= sqrt(s.size()); i++) {
		if (s.size() % i == 0) {
			if (ver.find(i) != ver.end()) {
				perebor.push_back(i);
			}
			if (ver.find(s.size() / i) != ver.end())
				perebor.push_back(s.size() / i);
		}
	}
	

	sort(perebor.begin(), perebor.end());
	psum.assign(26, vector < long long >(s.size(), 0));
	
	psum[s[0] - 'a'][0] = 1;
	for (int i = 1; i < s.size(); i++) {
		for (int j = 0; j < 26; j++) {
			psum[j][i] = psum[j][i - 1];
		}
		psum[s[i] - 'a'][i]++;
	}

	for (int i = 0; i < perebor.size(); i++) {
		long long len = perebor[i];
		if (check(len)) {
			cout << s.size() / len;
			system("pause");
			return 0;
		}
	}

	cout << 1;




	system("pause");
	return 0;
}