#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <map>
#include <set>
using namespace std;

#define ll long long

bool check(int n, int m, vector<vector<int>>&A)
{
    vector<int>S(m, 0);

    for (int i = 0; i < m; i++)
    {
        S[i] = A[i][n - 1];
    }
    int k = n;
    bool f = 0;
    while (k + n <= A[0].size())
    {

        for (int i = 0; i < m; i++)
        {
            if (S[i] != A[i][k + n - 1] - A[i][k - 1])
            {
                f = 1;
                break;
            }
        }
        if (f == 1)
            break;
        k = k + n;
    }
    return !f;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG
    string s;
    cin >> s;
    int m = 0;
    for (int i = 0; i < s.size(); i++)
    {
        m = max(m, s[i] - 'a' + 1);
    }
    vector<int> A(s.size());
    vector<int> K;
    
    vector<vector<int> > P(m, vector<int>(s.size(), 0));
    for (int i = 0; i < s.size(); i++)
    {
        P[s[i] - 'a'][i]++;
        for (int j = 0; j < m; j++)
        {
            if (i != 0)
                P[j][i] += P[j][i - 1];
        }

    }
   /* for (int i = 0; i < 26; i++)
    {
        for (int j = 0; j < s.size(); j++)
        {
            cout << P[i][j] << " ";
        }
        cout << endl;
    }*/


    int n = s.size();

    for (int i = 1; i * i <= n; i++)
    {
        if (n % i == 0)
        {
            K.push_back(i);
            if (i != n / i)
                K.push_back(n / i);
        }
    }
    sort(K.begin(), K.end());
    for (int i = 0; i < K.size(); i++)
    {
        if (check(K[i], m, P))
        {
            cout << n / K[i];
            return 0;
        }
    }
    return 0;
}