// ███▓▓▓▓▓▓▓▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓▓▓╬╬╬╬╬╬▓█
// ███▓███████▓▓╬╬╬╬╬╬╬╬╬╬╬╬▓███▓▓▓▓█▓╬╬╬▓█
// ███████▓█████▓▓╬╬╬╬╬╬╬╬▓███▓╬╬╬╬╬╬╬▓╬╬▓█
// ████▓▓▓▓╬╬▓█████╬╬╬╬╬╬███▓╬╬╬╬╬╬╬╬╬╬╬╬╬█
// ███▓▓▓▓╬╬╬╬╬╬▓██╬╬╬╬╬╬▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// ████▓▓▓╬╬╬╬╬╬╬▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// ███▓█▓███████▓▓███▓╬╬╬╬╬╬▓███████▓╬╬╬╬▓█
// ████████████████▓█▓╬╬╬╬╬▓▓▓▓▓▓▓▓╬╬╬╬╬╬╬█
// ███▓▓▓▓▓▓▓╬╬▓▓▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// ████▓▓▓╬╬╬╬▓▓▓▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// ███▓█▓▓▓▓▓▓▓▓▓▓▓▓▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// █████▓▓▓▓▓▓▓▓█▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// █████▓▓▓▓▓▓▓██▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬██
// █████▓▓▓▓▓████▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬██
// ████▓█▓▓▓▓██▓▓▓▓██╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬██
// ████▓▓███▓▓▓▓▓▓▓██▓╬╬╬╬╬╬╬╬╬╬╬╬█▓╬▓╬╬▓██
// █████▓███▓▓▓▓▓▓▓▓████▓▓╬╬╬╬╬╬╬█▓╬╬╬╬╬▓██
// █████▓▓█▓███▓▓▓████╬▓█▓▓╬╬╬▓▓█▓╬╬╬╬╬╬███
// ██████▓██▓███████▓╬╬╬▓▓╬▓▓██▓╬╬╬╬╬╬╬▓███
// ███████▓██▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓╬╬╬╬╬╬╬╬╬╬╬████
// ███████▓▓██▓▓▓▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓████
// ████████▓▓▓█████▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█████
// █████████▓▓▓█▓▓▓▓▓███▓╬╬╬╬╬╬╬╬╬╬╬▓██████
// ██████████▓▓▓█▓▓▓╬▓██╬╬╬╬╬╬╬╬╬╬╬▓███████
// ███████████▓▓█▓▓▓▓███▓╬╬╬╬╬╬╬╬╬▓████████
// ██████████████▓▓▓███▓▓╬╬╬╬╬╬╬╬██████████
// ███████████████▓▓▓██▓▓╬╬╬╬╬╬▓███████████
#include <bits/stdc++.h>
#define x first 
#define y second
#define pb push_back
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
using namespace std;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) {if (x > y) x = y;} 
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) {if (x < y) x = y;} 

const string FILENAME = "input";
typedef pair<int, int> point;

const int MAXN = 2600;

point operator -(point a, point b) {
	return {a.x - b.x, a.y - b.y};
}

long long cross(point a, point b) {
	return 1LL * a.x * b.y - 1LL * a.y * b.x;
}

int n;
point a[MAXN];
set<point> used;

long long A1, B1, C1, A2, B2, C2;

point v[MAXN];
vector<int> id;

bool cmp(int i, int j) {
	return cross(v[i], v[j]) < 0;
}

void check(int L, int Ln, int R, int Rn) {
	//cout << L + 1 << ' ' << Ln + 1 << ' ' << R + 1 << ' ' << Rn + 1 << endl;
	point v1 = a[Ln] - a[L];
	A1 = v1.y;
	B1 = -v1.x;
	C1 = -(A1 * a[L].x + B1 * a[L].y);
	point v2 = a[Rn] - a[R];
	if (cross(v1, v2) == 0) return;
	A2 = v2.y;
	B2 = -v2.x;
	C2 = -(A2 * a[R].x + B2 * a[R].y);
	point moon;
	long long w1 = C2 * A1 - C1 * A2, k = B1 * A2 - B2 * A1;
	if (w1 % k != 0) return;
	moon.y = w1 / k;
	long long w2 = C2 * B1 - C1 * B2;
	if (w2 % k != 0) return;
	moon.x = w2 / (-k);
	if (used.count(moon) || max(abs(moon.y), abs(moon.x)) > 1e6) return;
	//cout << moon.x << ' ' << moon.y << endl;
	for (int i = 0; i < n; ++i) {
		v[i] = moon - a[i];
		if (v[i].x < 0 || (v[i].x == 0 && v[i].y < 0)) {
			v[i].x *= -1;
			v[i].y *= -1;
		}
		//cout << v[i].x << '?' << v[i].y << endl;
	}
	sort(id.begin(), id.end(), cmp);
	for (int i = 0; i + 1 < n; ++i) {
		if ((cross(v[id[i]], v[id[i + 1]]) != 0) ^ (i & 1)) {
			return;
		}
	}
	cout << "Yes" << endl;
	cout << moon.x << ' ' << moon.y << endl;
	exit(0);

}

int main() {
	ios::sync_with_stdio(0);
	//read(FILENAME);
	cin >> n;
	n *= 2;
	int L = 0;
	int R = 1;
	// /if (R >= L) ++R;
	for (int i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
		used.insert(a[i]);
		id.pb(i);
	}
	for (int Ln = 0; Ln < n; ++Ln) {
		if (Ln == L || Ln == R) continue;
		for (int Rn = 0; Rn < n; ++Rn) {
			if (Rn == Ln || Rn == L || Rn == R) continue;
			check(L, Ln, R, Rn);
			check(L, R, Ln, Rn);
		} 
	}
	cout << "No" << endl;
}

//open-2018-342
