#include <bits/stdc++.h>

#define pii pair<int, int>
#define f first
#define s second
#define ll long long
#define pll pair<ll, ll>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double
#define sz(a) int(a.size())
#define output(a) for (auto el : a) cout << el << ' '; cout << '\n';

using namespace std;

const int INF = 1e9;

void dfs(vector<vector<int>>& g, int v, vector<ll>& c, vector<int>& ssz, vector<int>& mini, vector<ll>& sum, ll& ans) {
    int max = -1, max_of = -1, min1 = INF, min2 = INF, of1 = -1, of2 = -1;
    for (auto u : g[v]) {
        dfs(g, u, c, ssz, mini, sum, ans);
        if (mini[u] <= min1) {
            of2 = of1;
            of1 = u;
            min2 = min1;
            min1 = mini[u];
        }
        else if (mini[u] < min2) {
            of2 = u;
            min2 = mini[u];
        }
        sum[v] += sum[u];
        ssz[v] += ssz[u];
        if (ssz[u] > max) {
            max = ssz[u];
            max_of = u;
        }
        ans += sum[u];
    }
    if (max > ssz[v] - max) {
        if (max_of == of1) {
            ans += (2 * max - ssz[v]) * mini[of2];
        }
        else {
            ans += (2 * max - ssz[v]) * mini[of1];
        }
    }
    else if (ssz[v] % 2 == 1) {
        ans += min1;
    }
    mini[v] = min(min1, int(c[v]));
    sum[v] += c[v];
    ssz[v] += 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        g[p - 1].emplace_back(i);
    }
    vector<ll> c(n);
    for (int i = 1; i < n; ++i) {
        cin >> c[i];
    }
    vector<int> ssz(n), mini(n, INF);
    vector<ll> sum(n);
    ll ans = 0ll;
    dfs(g, 0, c, ssz, mini, sum, ans);
    cout << ans;
    return 0;
}
