#include <bits/stdc++.h>

#define pii pair<int, int>
#define f first
#define s second
#define ll long long
#define pll pair<ll, ll>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double
#define sz(a) int(a.size())
#define output(a) for (auto el : a) cout << el;// << ' '; cout << '\n';

using namespace std;

struct Point {
    int x, y;

    Point() {}

    Point(int x, int y) : x(x), y(y) {}
};

bool operator<(const Point& a, const Point& b) {
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

bool operator==(const Point& a, const Point& b) {
    return a.x == b.x && a.y == b.y;
}

struct Line {
    int a, b, c;

    Line() {}

    Line(Point a, Point b) : a(b.y - a.y), b(a.x - b.x), c(a.y * b.x - b.y * a.x) {}
};

istream& operator>>(istream& in, Point& a) {
    return (in >> a.x >> a.y);
}

ostream& operator<<(ostream& out, Point& a) {
    return (out << a.x << ' ' << a.y << '\n');
}

ostream& operator<<(ostream& out, Line& a) {
    return (out << a.a << ' ' << a.b << ' ' << a.c << '\n');
}

bool intersect(Line& a, Line& b, Point& i) {
    if (b.a * a.b - a.a * b.b != 0 && (a.c * b.b - b.c * a.b) % (b.a * a.b - a.a * b.b) == 0 && (a.c * b.a - b.c * a.a) % (b.a * a.b - a.a * b.b) == 0) {
        i = Point((a.c * b.b - b.c * a.b) / (b.a * a.b - a.a * b.b), -(a.c * b.a - b.c * a.a) / (b.a * a.b - a.a * b.b));
        return 1;
    }
    return 0;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<Point> pts(2 * n);
    for (int i = 0; i < 2 * n; ++i) {
        cin >> pts[i];
    }
    sort(all(pts));
    bool ok = 1;
    while (ok) {
        /*cout << '!';
        output(pts);
        cout << '!';*/
        vector<Line> lines(n);
        for (int i = 0; i < 2 * n; i += 2) {
            lines[i / 2] = Line(pts[i], pts[i + 1]);
        }
        Point x;
        bool st = 1;
        bool h = 1;
        for (int i = 0; i < n - 1 && h; ++i) {
            for (int j = i + 1; j < n; ++j) {
                Point to;
                if (intersect(lines[i], lines[j], to)) {
                    if (st) {
                        x = to;
                        st = 0;
                    }
                    else {
                        if (!(x == to)) {
                            h = 0;
                            break;
                        }
                    }
                }
                else {
                    h = 0;
                    break;
                }
            }
        }
        for (auto& el : pts) {
            if (el == x) {
                h = 0;
                break;
            }
        }
        if (h) {
            cout << "Yes\n";
            cout << x;
            return 0;
        }
        ok = next_permutation(all(pts));
    }
    cout << "No";
    return 0;
}
