#include <bits/stdc++.h>

using namespace std;

#define size(s) (ll)(s).size()

typedef long long ll;

const ll INF = 1e9;

void bye() {
    cout << "\n";
    exit(0);
}

string s;
int n;
ll cnt[26], done[26];

bool check(ll len) {
    // cerr << "L";
    // cout << len << "\n";
    for (int i = 0; i < 26; i++) {
        cnt[i] = 0;
        done[i] = 0;
    }
    int sum = 0;
    for (int i = 0; i < len; i++) {
        cnt[s[i] - 'a']++;
        sum++;
    }
    int nowsum = 0;
    for (int i = len; i < n; i++) {
        done[s[i] - 'a']++;
        nowsum += ((ll)done[s[i] - 'a'] <= (ll)(cnt[s[i] - 'a'] * (ll)i / (ll)len));
        if (i % len == len - 1) {
            if (nowsum != sum) {
                return 0;
            }
            nowsum = 0;
        }
    }
    return 1;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> s;
    n = size(s);
    int ans = INF;
    int m = sqrt(n);
    for (int i = 1; i <= m; i++) {
        if (n % i == 0) {
            if (check(i)) {
                ans = min(ans, i);
            }
            if (check(n / i)) {
                ans = min(ans, n / i);
            }
        }
    }
    cout << n / ans;
    bye();
}
