#pragma option -O3
#include <bits/stdc++.h>
#define P govno
#define Q govnishe

using namespace std;

typedef long double ld;

const ld EPS = 1e-9;

struct point {
    ld x, y;
};

bool check(ld a, ld b, ld c, point v) {
    return abs(a * v.x + b * v.y + c) < EPS;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    n *= 2;
    vector<point> vec(n);
    for (int i = 0; i < n; ++i) cin >> vec[i].x >> vec[i].y;
    if (n <= 3) {
        cout << "No\n";
        return 0;
    }
    point a = vec.back();
    vec.pop_back();
    point c = vec.back();
    vec.pop_back();
    for (int i = 0; i < vec.size(); ++i) {
        point b = vec[i];
        for (int j = 0; j < vec.size(); ++j) {
            if (i == j) continue;
            point d = vec[j];
            ld a1 = a.y - b.y;
            ld a2 = c.y - d.y;
            ld b1 = -a.x + b.x;
            ld b2 = -c.x + d.x;
            ld c1 = -a.x * (a.y - b.y) + a.y * (a.x - b.x);
            ld c2 = -c.x * (c.y - d.y) + c.y * (c.x - d.x);
            cout << a1 << " " << b1 << " " << c1 << endl;
            if (check(a1, b1, c1, c) || check(a1, b1, c1, d)) {
                cout << "No\n";
                return 0;
            } else {
                cout << "Yes\n";
                cout << int(a.x) << " " << int(a.y) << endl;
                cout << int(b.x) << " " << int(b.y) << endl;
                cout << int(c.x) << " " << int(c.y) << endl;
                cout << int(d.x) << " " << int(d.y) << endl;
                return 0;
            }
        }
    }
    return 0;
}
