#include <iostream>
#include <vector>

using namespace std;

void dfs1(vector<vector<int> >& g, int v, vector<long long>& num)
{
    num[v] = 1;
    for (int i = 0; i < g[v].size(); i++)
    {
        dfs1(g, g[v][i], num);
        num[v] += num[g[v][i]];
    }
}

long long dfs(vector<vector<int> >& g, int v, vector<int>& c, vector<long long>& num)
{
    if (g[v].size() == 0)
        return 0;
    long long ma = -1;
    long long sum = 0;
    long long ans = 0;
    for (int i = 0; i < (int) g[v].size(); i++)
    {
        ans += dfs(g, g[v][i], c, num);
        ma = max(ma, num[g[v][i]]);
        sum += num[g[v][i]];
    }
    return ans + max((sum + 1) / 2 * 2, ma * 2);
}

int main()
{
    int n;
    cin >> n;
    vector<vector<int> > g(n);
    vector<long long> num(n);
    for (int i = 1; i < n; i++)
    {
        int a;
        cin >> a;
        a--;
        g[a].push_back(i);
    }
    vector<int> c(n);
    for (int i = 1; i < n; i++)
        cin >> c[i];
    dfs1(g, 0, num);
    cout << dfs(g, 0, c, num);
}
