#include <bits/stdc++.h>

using namespace std;

bool check(int aa, string &s, int n)
{
    int a = n / aa;
    vector <int> alph_best(26, 0);
    vector <int> alph_now(26, 0);
    bool have_best = false;
    for (int i = 0; i < n; i += a)
    {
        for (int j = i; j < i + a; j++)
        {
            alph_now[s[j] - 'a']++;
        }

        if (!have_best)
        {
            have_best = true;
            alph_best = alph_now;
        }
        else{
            for (int k = 0; k < 26; k++)
            {
                if (alph_now[k] != alph_best[k])
                {
                    return false;
                }
            }
        }
        for (int k = 0; k < 26; k++)
        {
            alph_now[k] = 0;
        }
    }
    return true;
}
bool check2(int aa, string &s, int n, vector <int> &pref)
{
    int a = n / aa;

    for (int i = a - 1; i < n; i += a)
    {
        if (pref[i] - pref[i - a + 1] + s[i - a + 1] - 'a' != pref[a - 1])
        {
            return false;
        }
    }
    return true;
}

int main()
{
    string s;
    cin >> s;
    int ans = 1;
    int n = (int)s.size();
    if (n <= 500000){
        for (int i = 1; i <= sqrt(n); i++)
        {
            if (n % i == 0){
                if (check(i, s, n))
                {
                    ans = max(ans, i);
                }
                if (check(n / i, s, n))
                {
                    ans = max(ans, n / i);
                }
            }
        }
    }
    else{
        vector <int> pref(n, 0);
        pref[0] = s[0] - 'a';
        for (int i = 1; i < n; i++)
        {
            pref[i] = pref[i - 1] + s[i] - 'a';
        }
        for (int i = 1; i <= sqrt(n); i++)
        {
            if (n % i == 0){
                if (check2(i, s, n, pref))
                {
                    ans = max(ans, i);
                }
                if (check2(n / i, s, n, pref))
                {
                    ans = max(ans, n / i);
                }
            }
        }
    }

    cout << ans;
    return 0;
}

