#include <bits/stdc++.h>

using namespace std;

struct cmp
{
    bool operator ()(int i, int j)
    {
        return i > j;
    }
};

void dfs(int a, vector <vector <int> > &children, vector <int> &num, vector <int> &sum)
{
    multiset <int, cmp> vals;
    for (int i = 0; i < children[a].size(); i++)
    {
        dfs(children[a][i], children, num, sum);
        num[a] += num[children[a][i]];
        if (num[children[a][i]] != 0){
            vals.insert(num[children[a][i]]);
        }
    }

    int need_give = 0;

    while (vals.size() > 1)
    {
        int k1 = *vals.begin();
        vals.erase(vals.begin());
        int k2 = *vals.begin();
        vals.erase(vals.begin());
        sum[a] += min(k2, k1);
        k2 = abs(k2 - k1);

        if (k2 != 0)
        {
            vals.insert(k2);
        }
        //cout << sum[a] << " " << need_give << "\n";
    }

    if (vals.size() == 1)
    {
        int k = *vals.begin();
        sum[a] += k;
    }

    sum[a] *= 2;
}

int main()
{
    int n;
    cin >> n;
    vector <vector <int> > children(n, vector <int>());
    vector <int> sum(n, 0);
    for (int i = 1; i < n; i++)
    {
        int p;
        cin >> p;
        p--;
        children[p].push_back(i);
    }
    vector <int> c(n, 1);
    for (int i = 1; i < n; i++)
    {
        cin >> c[i];
    }

    vector <int> num(n, 1);

    dfs(0, children, num, sum);
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        cout << sum[i] << " ";
        ans += sum[i];
    }
    cout << "\n";

    cout << ans;
    return 0;
}

