#include <bits/stdc++.h>
#define EPS 0.000001

using namespace std;

struct Point
{
    long long x, y;
};

vector<Point> g(100500);

int cnt = 0;

vector<Point> v(10000);
int n;

vector<int> used(10000);
set<pair<long long, long long>> st;
Point A, a;
long long xk = INT_MIN, yk = INT_MIN;

bool original(Point a)
{
    for(int i = 0; i < cnt; i++)
    {
        Point b = g[i];
        if ((a.x * b.y - a.y * b.x) == 0) return false;
    }
    return true;
}

bool f(int level)
{
    if(level == n * 2) return true;
    if(used[level]) return f(level + 1);
    for(int i = 0; i < n * 2; i++) {
        if (!used[i]) {
            Point b;
            if (level == 0) {
                A = v[level];
                a.x = v[i].x - v[level].x;
                a.y = v[i].y - v[level].y;
                xk = INT_MIN;
                yk = INT_MIN;
                g[cnt] = a;
                cnt++;
            } else if (xk == INT_MIN && yk == INT_MIN) {
                Point B = v[level];
                b.x = v[i].x - v[level].x;
                b.y = v[i].y - v[level].y;
                if(!original(b)) continue;
                if ((a.x * b.y == a.y * b.x)) continue;
                long double k = ((B.x - A.x) * b.y - (B.y - A.y) * b.x) * 1.0 / (a.x * b.y - a.y * b.x);
                long double xkt = A.x + a.x * k;
                long double ykt = A.y + a.y * k;
                if (abs(xkt - (long long) xkt) > EPS || abs(ykt - (long long) ykt) > EPS) {
                    continue;
                }
                if(st.count({(long long)xkt, (long long)ykt})) continue;
                if(abs((long long)xkt) > 1e6 || abs((long long)ykt) > 1e6) continue;
                xk = (long long) xkt;
                yk = (long long) ykt;
                g[cnt] = b;
                cnt++;
            } else {
                Point B = v[level];
                b.x = v[i].x - v[level].x;
                b.y = v[i].y - v[level].y;
                if(!original(b)) continue;
                if ((a.x * b.y - a.y * b.x) == 0) continue;
                long double k = ((B.x - A.x) * b.y - (B.y - A.y) * b.x) * 1.0 / (a.x * b.y - a.y * b.x);
                long double xkt = A.x + a.x * k;
                long double ykt = A.y + a.y * k;
                if (abs(xkt - xk) > EPS || abs(ykt - yk) > EPS) {
                    continue;
                }
                g[cnt] = b;
                cnt++;
            }
            used[i] = true;
            if (f(level + 1)) {
                used[i] = false;
                return true;
            }
            cnt--;
            used[i] = false;
        }
    }
    return false;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.precision(20); cout.tie(); cin.tie();
    cin >> n;
    for(int i = 0; i < n << 1; i++)
    {
        cin >> v[i].x >> v[i].y;
        st.insert({v[i].x, v[i].y});
    }
    bool i = f(0);
    cout << (i ? "Yes" : "No") << endl;
    if(i) cout << xk << " " << yk << endl;
}
