#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll
#define optimaze ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(x) x.begin(), x.end()

typedef vector<int> vint;
typedef pair<int,int> pii;
typedef long double ld;

template<typename T1, typename T2> istream& operator >> (istream& in, pair<T1,T2>& p){ return in >> p.first >> p.second; }
template<typename T1, typename T2> ostream& operator << (ostream& out, pair<T1,T2>& p){ return out << p.first << " " << p.second; }
template<typename T> istream& operator >> (istream& in, vector<T>& v){ for(int i = 0;i<v.size();i++) in >> v[i]; return in; }
template<typename T> ostream& operator << (ostream& out, vector<T>& v){ for(int i = 0;i<v.size();i++) out << v[i] << " "; return out; }

struct G{
	vint to;
	int d = -1, sz = 1;
};

vector<G> g;

int solve(int v){
	int &cur = g[v].d;
	if(cur != -1) return cur;
	cur = 0;
	vector<int> s;
	for(int u : g[v].to) {
		cur += solve(u);
		s.push_back(g[u].sz);
		g[v].sz += g[u].sz;
	}
	for(int l = 0, r = 0;l<s.size();l++){
		r = max(r, l+1);
		while(r < s.size() && s[l] > 0){
			if(s[r] >= s[l]) {
				cur += s[l] * 2;
				s[r] -= s[l]; s[l] = 0; break;
			}else {
				cur += s[r] * 2;
				s[l] -= s[r]; s[r] = 0; r++;
			}
		}
		cur += s[l] * 2;
	}
	return cur;
}

signed main(){
optimaze;
#ifdef _SANYA
	freopen("abc.txt", "r", stdin);
	cout.rdbuf(cerr.rdbuf());
#endif
	int n; cin >> n;
	g.resize(n);
	for(int i = 1;i<n;i++){
		int p; cin >> p; p--;
		g[p].to.push_back(i);
	}

	cout << solve(0) << endl;
	return 0;
}