#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll
#define optimaze ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(x) x.begin(), x.end()

typedef vector<int> vint;
typedef pair<int,int> pii;
typedef long double ld;

template<typename T1, typename T2> istream& operator >> (istream& in, pair<T1,T2>& p){ return in >> p.first >> p.second; }
template<typename T1, typename T2> ostream& operator << (ostream& out, pair<T1,T2>& p){ return out << p.first << " " << p.second; }
template<typename T> istream& operator >> (istream& in, vector<T>& v){ for(int i = 0;i<v.size();i++) in >> v[i]; return in; }
template<typename T> ostream& operator << (ostream& out, vector<T>& v){ for(int i = 0;i<v.size();i++) out << v[i] << " "; return out; }

struct G{
	vint to;
	int d = -1, sz = 1;
};

vector<G> g;

int solve(int v){
	int &cur = g[v].d;
	if(cur != -1) return cur;

	cur = 0;
	vector<int> s;
	for(int u : g[v].to) {
		cur += solve(u);
		s.push_back(g[u].sz);
		g[v].sz += g[u].sz;
	}
	sort(all(s), greater<int>());
	if(s.size() == 0) return cur;
	for(;;){
		int i = 0;
		int c = s[i];
		for(int j = i + 1;j < s.size();j++){
			if(s[i] == 0 || s[j] == 0) break;
			cur += 2;
			s[i]--; s[j]--;
		}
		if(s[i] == c) {
			cur += s[i] * 2;
			break;
		}
		sort(all(s), greater<int>());
	}
	return cur;
}

signed main(){
optimaze;
#ifdef _SANYA
	freopen("abc.txt", "r", stdin);
	cout.rdbuf(cerr.rdbuf());
#endif
	int n; cin >> n;
	g.resize(n);
	for(int i = 1;i<n;i++){
		int p; cin >> p; p--;
		g[p].to.push_back(i);
	}

	vint t(n-1); cin >> t;

	cout << solve(0) << endl;
	return 0;
}