#pragma comment(linker, "/STACK:536870912")
#pragma warning(disable:4996)

//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

#include<iostream>
#include<algorithm>
#include<queue>
#include<string>
#include<vector>
#include<map>
#include<list>
#include<set>
#include<cstring>
#include<ctime>
#include<cmath>
#include<limits>
#include<iterator>
#include<functional>
#include<unordered_map>
#include<unordered_set>
#include<stack>
#include<bitset>
#include<complex>

#define all(v) v.begin(), v.end()
#define setv(ar, val) memset(ar, val, sizeof(ar));
#define ll long long int
#define ull unsigned long long int
#define PI 3.1415926535897932384626433832795
using namespace std;

const int N = 2e5 + 100;
vector<int> v[N];
int sz[N];
int ans = 0;

void dfs(int node) {
	multiset<int> d;
	for (int i = 0; i < v[node].size(); i++) {
		int to = v[node][i];
		dfs(to);
		sz[node] += sz[to];
		d.insert(sz[to]);
	}

	while (d.size() > 1) {
		int t = *d.rbegin();
		d.erase(prev(d.end()));
		while (!d.empty() && t >= *d.rbegin()) {
			t -= *d.begin();
			d.erase(d.begin());
		}
		d.insert(t);
	}
	if (!d.empty())
		ans += *d.begin();
	ans += sz[node];
	sz[node]++;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n;
	scanf("%d", &n);

	for (int i = 1; i < n; i++) {
		int p;
		scanf("%d", &p);
		p--;
		v[p].push_back(i);
	}

	dfs(0);

	printf("%d", ans);



	return 0;
}