#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef pair <ld, ld> pld;

#define int long long
#define x first
#define y second
#define sqr(x) ((x) * (x))

const int INFINT = 1e9 + 20;
const ll INFLL = 1e18 + 20;
const ld pi = acos(-1);
const ld eps = 1e-12;
const int N = 5e6 + 20;
const int M = 1e3 + 20;
const int C = 1e2 + 20;

struct point {
    int x, y;
};

struct line {
    int a, b, c;
};

line getline(point a, point b) {
    line k;
    k.a = b.y - a.y;
    k.b = a.x - b.x;
    k.c = -k.b * a.y - k.a * a.x;
    return k;
}

point getv(point a, point b) {
    point c;
    c.x = b.x - a.x;
    c.y = b.y - a.y;
    return c;
}

void getans(line a, line b) {
    int d = a.a * b.b - a.b * b.a;
    int dx = b.c * a.b - a.c * b.b;
    int dy = b.a * a.c - a.a * b.c;
    if (d == 0)
        return;
    if (dx % d == 0 && dy % d == 0) {
        cout << "Yes\n" << dx / d << ' ' << dy / d;
        exit(0);
    }
}

point a[400];

signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    for (int i = 0; i < 2 * n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    getans(getline(a[0], a[1]), getline(a[2], a[3]));
    getans(getline(a[0], a[2]), getline(a[1], a[3]));
    getans(getline(a[0], a[3]), getline(a[1], a[2]));
    cout << "No";
    return 0;
}
