#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,abm,popcnt,tune=native")

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <queue>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define all(x) x.begin(), x.end()

signed main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	vector <int> A(n * 2);
	for (int i = 1; i <= n; i++)
	{
		A[i * 2 - 1] = i;
	}
	queue<int> Que;
	for (int i = A.size() - 1; i>= 0; i--)
	{
		if (A[i] == 0)
		{
			A[i] = Que.front();
			Que.pop();
			Que.push(A[i]);
		}
		else
		{
			Que.push(A[i]);
		}
	}
	vector <int> Pos(n+1);
	for (int i = 1; i<= n; i++)
	{
		Pos[A[i]] = i;
	}
	int q;
	cin >> q;
	for (int z = 0; z < q; z++)
	{
		int x;
		cin >> x;
		cout << Pos[x]<<endl;
	}
	return 0;
}