
#include <iostream>
#include <vector>
#define ll long long
#define pb push_back

using namespace std;

struct el {
    ll x;
    ll y;
};

bool operator == (el a, el b) {
    return (a.x == b.x && a.y == b.y);
}
el inter(el a, el b, el c, el d) {
    if ((a.x - b.x) * (c.y - d.y) == (c.x - d.x) * (a.y - b.y)) {
        return {100000000, 100000000};
    }
    ll a1 = b.y - a.y, b1 = a.x - b.x;
    ll a2 = d.y - c.y, b2 = c.x - d.x;
    ll c1 = -(a1 * a.x + b1 * a.y);
    ll c2 = -(a2 * c.x + b2 * c.y);
    ll x = 100000000;
    ll y = 100000000;
    if ((c2 * a1 - c1 * a2) % (b1 * a2 - b2 * a1) == 0) y = (c2 * a1 - c1 * a2) / (b1 * a2 - b2 * a1);
    if ((c2 * b1 - c1 * b2) % (a1 * b2 - a2 * b1) == 0) x = (c2 * b1 - c1 * b2) / (a1 * b2 - a2 * b1);
    el res = {x, y};
    if (res == a || res == b || res == c || res == d) res = {100000000, 100000000};
    return res;
}


int main() {
    int n;
    cin >> n;
    vector<el> v;
    n *= 2;
    for (int i = 0; i < n; ++i) {
        ll a, b;
        cin >> a >> b;
        v.pb({a, b});
    }
    int r = 0;
    for (int a = 0; a < n; ++a) {
        for (int b = 0; b < n; ++b) {
            for (int c = 0; c < n; ++c) {
                for (int d = 0; d < n; ++d) {
                    if (a == b || a == c || a == d || b == c || b == d || c == d) continue;

                    el res = inter(v[a], v[b], v[c], v[d]);
                    if (r == 0 && abs(res.x) <= 1000000 && abs(res.y) <= 1000000) {
                        int q = 1;
                        for (int i = 0; i < n; ++i) {
                            if (v[i] == res) {
                                q = 0;
                                break;
                            }
                            ll v_x = res.x - v[i].x, v_y = res.y - v[i].y;
                            int k = 0;
                            for (int j = 0; j < n; ++j) {
                                if (j == i) continue;
                                ll v1_x = res.x - v[j].x, v1_y = res.y - v[j].y;
                                if (v_x * v1_y == v1_x * v_y) ++k;
                            }
                            if (k != 1) q = 0;
                            if (q == 0) break;
                        }
                        if (q == 1) {
                            r = 1;
                            cout << "Yes" << "\n" << res.x << " " << res.y;
                        }
                    }
                }
            }
        }
    }
    if (r == 0) cout << "No";
    return 0;
}



