#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>


using namespace std;

int gcd(int a, int b) {
	while(b != 0) {
		a %= b;
		int tmp = a;
		a = b;
		b = tmp;
	}
	return a;
}
int main() {
	string s;
	cin >> s;
	int n = s.size();
	vector<int> pref[26];
	for (int i = 0; i < 26; ++i)
		pref[i] = vector<int>(n, 0);
	pref[s[0] - 'a'][0] = 1;
	for (int i = 1; i < n; ++i) {
		for (int j = 0; j < 26; ++j)
			pref[j][i] = pref[j][i - 1];
		pref[s[i] - 'a'][i]++;
	}
	int gc = n;
	for (int i = 0; i < 26; ++i)
		gc = gcd(gc, pref[i][n - 1]);
	int max = 1;
	for (int i = 1; i * i <= gc; ++i) {
		int q = n / i;
		bool k = true;
		for (int j = 0; k && j < 26; ++j)
			for (int l = 2 * q - 1; l < n; l += q) {
				if (!(pref[j][l] == pref[j][l - q] + pref[j][q - 1])) {
					k = false;
					break;
				}
			}
		if (k && i > max)
			max = i;
		k = true;
		q = n / (gc / i);
		for (int j = 0; k && j < 26; ++j)
			for (int l = 2 * q - 1; l < n; l += q) {
				if (!(pref[j][l] == pref[j][l - q] + pref[j][q - 1])) {
					k = false;
					break;
				}
			}
		if (k && (gc / i) > max)
			max = gc / i;
	}
	cout << max;
	return 0;
}