#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>


using namespace std;

vector<int> sump, mins;
vector<long long> a, sumv;
vector<bool> used;
vector<vector<int>> g;

void dfs(int v) {
	used[v] = true;
	mins[v] = v;
	for (size_t to = 0; to < g[v].size(); ++to) {
		int u = g[v][to];
		if (!used[u]) {
			dfs(u);
			sump[v] += sump[u];
			sumv[v] += (long long)(sumv[u] + a[u]);
			if (a[mins[u]] < a[mins[v]])
				mins[v] = mins[u];
		}
	}
}
int main() {
	int n;
	cin >> n;
	sump.assign(n, 1);
	sumv.assign(n, 0);
	mins.assign(n, -1);
	used.assign(n, false);
	a.resize(n);
	g.resize(n);
	for (int i = 1; i < n; ++i) {
		int tmp;
		cin >> tmp;
		--tmp;
		g[tmp].push_back(i);
	}
	for (int i = 1; i < n; ++i)
		cin >> a[i];
	dfs(0);
	vector<long long> c(n, 0);
	for (int i = 0; i < n; ++i) {
		if (g[i].empty())
			continue;
		int maxn = -1;
		for (size_t to = 0; to < g[i].size(); ++to) {
			int u = g[i][to];
			if (maxn == -1 || sump[u] > sump[maxn])
				maxn = u;
		}
		if ((sump[maxn] << 1) > (sump[i] - 1)) {
			int min = -1;
			for (size_t to = 0; to < g[i].size(); ++to) {
				int u = g[i][to];
				if (u != maxn && (min == -1 || a[mins[u]] < a[min]))
					min = mins[u];
			}
			c[i] = sumv[i] + (a[min] * ((sump[maxn] << 1) - sump[i] + 1));
		}
		else {
			if (!(sump[i] & 1)) {
				int min = -1;
			for (size_t to = 0; to < g[i].size(); ++to) {
				int u = g[i][to];
				if (min == -1 || a[mins[u]] < a[min])
					min = mins[u];
			}
			c[i] = sumv[i] + a[min];
			}
			else
				c[i] = sumv[i];
		}
	}
	long long sim = 0;
	for (int i = 0; i < n; ++i)
		sim += c[i];
	cout << sim;
	return 0;
}