#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")
#define DEBUG1

#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <numeric>
#include <stack>
#include <cstring>
#include <cstdlib>
#include <string>

using namespace std;

string s;

bool check(int x)
{
	int cnt = s.size() / x;
	int obr[26] = { 0 };
	for (int i = 0; i < cnt; i++)
		obr[s[i] - 'a']++;

	for (int i = 1; i < x; i++) {
		int a[26] = { 0 };
		for (int j = 0; j < cnt; j++)
			a[s[cnt * i + j] - 'a']++;

		for (int j = 0; j < 26; j++)
			if (obr[j] != a[j])
				return false;
	}
	return true;
}

bool res[(int)5e+6 + 1];

void eratos(int n)
{
	memset(res, true, sizeof(res));
	res[0] = res[1] = false;
	for (int i = 0; i <= n; i++)
		if (res[i])
			for (int j = i * i; j <= n; j += i)
				res[j] = false;
}

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0);
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cin >> s;
	int n = s.size();
	eratos(n);

	if (res[n]) {
		cout << 1;
		return 0;
	}

	vector<int> d;
	d.reserve(10000);
	for (int i = 1; i * i <= n; i++)
		if (n % i == 0) {
			d.push_back(i);
			if (i * i < n)
				d.push_back(n / i);
		}

	sort(d.begin(), d.end());

	int l = 0, r = d.size();
	while (r - l > 1) {
		int m = (l + r) >> 1;
		if (check(d[m]))
			l = m;
		else
			r = m;
	}

	if (check(d[l]))
		cout << d[l];
	else
		cout << d[r];
}
