// v o4erednoy raz sosyom na ture, RABOTYAGI

#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define f first
#define s second
#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

struct node {
    ll x;
    ll minx;
    int minv, val;
    ll sumx;
    ll sz;
    int y;
    node *l, *r;
    node() {}
    node(ll x1) {
        x = x1;
        y = RAND_MAX * rand() + rand();
        l = r = nullptr;
        minx = x;
        sumx = x;
        sz = 1;
    }
    node(ll x1, int val1) {
        x = x1;
        y = RAND_MAX * rand() + rand();
        l = r = nullptr;
        minx = x;
        sumx = x;
        sz = 1;
        val = val1;
        minv = val;
    }
};

void upd(node *&t) {
    if (t == nullptr) return;
    t->minx = t->x;
    t->minv = t->val;
    t->sumx = t->x;
    t->sz = 1;
    if (t->l != nullptr) {
        if (t->l->minx < t->minx) {
            t->minx = t->l->minx;
            t->minv = t->l->minv;
        }
        t->sumx += t->l->sumx;
        t->sz += t->l->sz;
    }
    if (t->r != nullptr) {
        if (t->r->minx < t->minx) {
            t->minx = t->r->minx;
            t->minv = t->r->minv;
        }
        t->sumx += t->r->sumx;
        t->sz += t->r->sz;
    }
}

node *merge(node *a, node *b) {
    if (a == nullptr) return b;
    if (b == nullptr) return a;
    if (a->y > b->y) {
        a->r = merge(a->r, b);
        upd(a);
        return a;
    } else {
        b->l = merge(a, b->l);
        upd(b);
        return b;
    }
}

pair <node*, node*> split(node *t, int x) {
    if (t == nullptr) return {t, t};
    if (t->x < x) {
        auto p = split(t->r, x);
        t->r = p.first;
        upd(t);
        return mp(t, p.s);
    } else {
        auto p = split(t->l, x);
        t->l = p.second;
        upd(t);
        return mp(p.first, t);
    }
}

void add(node *&t, ll x) {
    auto p = split(t, x);
    t = merge(p.f, merge(new node(x), p.s));
}

void add(node *&t, ll x, ll v) {
    auto p = split(t, x);
    t = merge(p.f, merge(new node(x, v), p.s));
}

ll gMin(node *t) {
    return t->minx;
}

ll gSum(node *t) {
    return t->sumx;
}

ll tsz(node *t) {
    return t->sz;
}

void dfs_treap(vector <ll> &vtx, node *t) {
    if (t != nullptr) {
        dfs_treap(vtx, t->l);
        vtx.pb(t->x);
        dfs_treap(vtx, t->r);
        delete t;
    }
}

const ll INF = 6e18;
const int N = 200005;
int n;
vector <int> g[N];
vector <ll> ad[N];
int c[N];
int sz[N];
vector <node*> t;

ll ans;
void dfs(int v) {
    sz[v] = 1;
    for (int i = 0; i < (int)g[v].size(); ++i) {
        int u = g[v][i];
        dfs(u);
        sz[v] += sz[u];
        if (i && sz[u] > sz[g[v][0]])
            swap(g[v][0], g[v][i]);
    }
    if (!g[v].empty()) {
        int mn1 = 0, mn2 = 1;
        if (gMin(t[g[v][mn1]]) > gMin(t[g[v][mn2]])) swap(mn1, mn2);
        for (int i = 2; i < (int)g[v].size(); ++i) {
            int u = g[v][i];
            if (gMin(t[u]) <= gMin(t[g[v][mn1]])) {
                mn2 = mn1;
                mn1 = i;
            } else if (gMin(t[u]) < gMin(t[g[v][mn2]]))
                mn2 = i;
        }
        /*ad[v][mn1] -= gMin(t[g[v][mn1]]);
        if (sz[g[v][mn1]] > 1 && (sz[g[v][mn2]] > 1 || (int)g[v].size() > 2)) ad[v][mn2] -= gMin(t[g[v][mn2]]);
        cout << v << ' ' << mn1 << ' ' << mn2 << endl;*/

        if ((int)g[v].size() == 2) {
            ad[v][mn1] -= gMin(t[g[v][mn1]]);
        } else {
            ad[v][mn1] -= gMin(t[g[v][mn1]]);
            if (sz[g[v][mn1]] > 1) ad[v][mn2] -= gMin(t[g[v][mn2]]);
        }

        for (int i = 0; i < (int)g[v].size(); ++i) {
            int u = g[v][i];
            ll mn;
            if (i != mn1) {
                mn = g[v][mn1];
            } else {
                mn = g[v][mn2];
            }

            ll sum = gSum(t[u]) + ad[v][i];
            ll sz = tsz(t[u]) - (ad[v][i] < 0 ? 1ll : 0ll);
            ans += sum + sz * (ll)gMin(t[mn]);
        }

        // mrg
        swap(t[v], t[g[v][0]]);
        for (int i = 1; i < (int)g[v].size(); ++i) {
            int u = g[v][i];
            vector <ll> vtx;
            dfs_treap(vtx, t[u]);
            t[u] = nullptr;
            for (auto x : vtx) {
                add(t[v], x);
            }
        }
    }
    add(t[v], c[v]);
}

bool cmp(int v, int u) {
    return v > u;
}

vector <ll> ord[N];
vector <int> tail[N];
vector <char> bad[N];

void dfs2(int v) {
    sz[v] = 1;
    for (auto u : g[v]) {
        dfs2(u);
        sz[v] += sz[u];
    }
    ll oldans = ans;
    if (!g[v].empty()) {
        while (true) {
            int mx1 = -1, mx2 = -1;
            for (int i = 0; i < (int)g[v].size(); ++i) {
                if (bad[v][i]) continue;
                int u = g[v][i];
                if (mx1 == -1 || ord[g[v][mx1]][tail[v][mx1]] <= ord[u][tail[v][i]]) {
                    mx2 = mx1;
                    mx1 = i;
                } else if (mx2 == -1 || ord[g[v][mx2]][tail[v][mx2]] <= ord[u][tail[v][i]]) {
                    mx2 = i;
                }
            }

            if (mx1 == -1) break;
            if (mx2 == -1) {
                int mn = -1;
                for (int i = 0; i < (int)g[v].size(); ++i) {
                    if (i == mx1) continue;
                    if (mn == -1 || ord[g[v][i]].back() < mn)
                        mn = ord[g[v][i]].back();
                }
                while (tail[v][mx1] != (int)ord[g[v][mx1]].size()) {
                    ans += ord[g[v][mx1]][tail[v][mx1]] + mn;
                    tail[v][mx1]++;
                }
                break;
            }
            else {
                ans += ord[g[v][mx1]][tail[v][mx1]] + ord[g[v][mx2]][tail[v][mx2]];
                tail[v][mx1]++;
                tail[v][mx2]++;
                bad[v][mx1] = (tail[v][mx1] == (int)ord[g[v][mx1]].size() ? true : false);
                bad[v][mx2] = (tail[v][mx2] == (int)ord[g[v][mx2]].size() ? true : false);
            }
        }
        for (auto u : g[v]) {
            for (auto el : ord[u]) {
                ord[v].pb(el);
            }
        }
    }

    ord[v].pb(c[v]);
    sort(all(ord[v]), cmp);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL), cout.tie(NULL);

    cin >> n;
    for (int v = 2; v <= n; ++v) {
        int p; cin >> p;
        g[p].pb(v);
        ad[p].pb(0ll);
        tail[p].pb(0);
        bad[p].pb(false);
    }

    bool good = true;
    for (int v = 2; v <= n; ++v) {
        cin >> c[v];
        good &= c[v] == 1;
    }
    if (good && false) {

        t.assign(n + 1, nullptr);

        ans = 0;
        dfs(1);
        cout << ans << endl;
    }
    else {
        dfs2(1);
        cout << ans << endl;
    }

    return 0;
}
/*
5
1 2 2 1
1 1 1 1

6
1 1 1 4 4
1 2 3 4 5

*/
