#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <stack>
#include <cmath>
#include <cassert>
#include <iomanip>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const int Inf = 1e9;
const double eps = 1e-9;
const ll Linf = 2e18;

const int N = 1e5 + 3;

vector <int> g[N];

ll ans = 0;

int dfs(int u) {
    multiset <int> sz;
    int s = 0;
    for (auto v : g[u]) {
        int cur = dfs(v);
        s += cur;
        sz.insert(cur);
    }
    for (auto e : sz) {
        ans += e;
    }
    while (sz.size() > 0) {
        int cur = *sz.begin();
        sz.erase(sz.begin());
        if (sz.empty()) {
            ans += cur;
            break;
        }
        else {
            int tmp = *sz.begin();
            tmp -= cur;
            sz.erase(sz.begin());
            if (tmp) {
                sz.insert(tmp);
            }
        }
    }
    return s + 1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    #endif
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        g[p].push_back(i);
    }
    vector <int> c(n);
    for (int i = 1; i < n; ++i) {
        cin >> c[i];
    }
    dfs(0);
    cout << ans << endl;
}
